<?php
namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;


class RelatorioFreqVooGlobal extends \Zeedhi\Framework\Controller\Report {
    
    protected $environment;
    
    public function __construct(ReportService $reportService, $environment) {
        $this->environment  = $environment;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'ATE02500' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL" => "P_CDFILIAL",
              "DATAREF"  => "DATAREF",
              "NRORG"    => "NRORG"
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $row['NRORG']  = $this->environment->getNrOrgTrab();
    }
}
