// FILE: ./assets/js/services/AlteracaoPlanoDeVooService.js
function AlteracaoPlanoDeVooService(restEngine) {

    this.cancela_plano_voom = function(currentRow) {
        return restEngine.post("ate#/cancela_plano_voom", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.troca_equipamentom = function(currentRow) {
        return restEngine.post("ate#/troca_equipamentom", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.inclui_classe_voom = function(currentRow) {
        return restEngine.post("ate#/inclui_classe_voom", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.exclui_planovoom = function(currentRow) {

        return restEngine.post("ate#/exclui_planovoom", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.RETORNA_CICLOM = function(currentRow) {

        return restEngine.post("ate#/retorna_ciclom", {
            "requestType": "Row",
            "row": currentRow
        });

    };

    this.retorna_agrupamento = function(row) {

        return restEngine.post("ate#/ate015000_retorna_agrupamento", {
            "requestType": "Row",
            "row": row
        });

    };

    this.validaNotaGerada = function(cdfilial, cdcia, nrvoo, cdtrecho, dthrplavoopv, nrorg, cdclasse) {
        return restEngine.post("ate#/crud/servplanom_notafiscal_delivery", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": cdcia
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": nrvoo
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": cdtrecho
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": dthrplavoopv
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				},
                {
                    "name": "CDCLASSE",
                    "operator": "=",
                    "value": cdclasse
				}
			]
        });
    };

    this.paramsComissaria = function(cdfilial, nrorg) {
        return restEngine.post("ate#/crud/paramcomis", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.validaOperador = function(cdoperador, cdgrupoaltdel, nrorg) {
        return restEngine.post("ate#/crud/opergrupop", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": cdoperador
				},
                {
                    "name": "CDGRUPOPER",
                    "operator": "=",
                    "value": cdgrupoaltdel
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.paramsPax = function(cdfilial, cdcia, dthrplavoopv, nrvoo, cdtrecho, nrorg) {
        return restEngine.post("ate#/crud/planovoom_equipamento_vootrecho", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": cdcia
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": dthrplavoopv
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": nrvoo
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": cdtrecho
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.findVRQTOTAL = function(cdfilial, cdcia, nrvoo, cdtrecho, sgprefixo, cdequip, nrorg) {
        return restEngine.post("ate#/configvoo_configpref_configequi", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": cdcia
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": nrvoo
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": cdtrecho
				},
                {
                    "name": "SGPREFIXO",
                    "operator": "=",
                    "value": sgprefixo
				},
                {
                    "name": "CDEQUIP",
                    "operator": "=",
                    "value": cdequip
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.confi_pax_voo = function(filter) {
        return restEngine.post("ate#/crud/config_pax_voo", {
            "requestType": "FilterData",
            "filter": filter
        }).then(
            function(success) {
                return success.dataset.config_pax_voo[0] || false;
            }
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register("AlteracaoPlanoDeVooService", AlteracaoPlanoDeVooService);
});

// FILE: ./assets/js/services/ate00900_configura_servico_vooService.js
var ate00900_configura_servico_vooService = function(restEngine, localStorageEngine) {

    this.returnProduto = function(CDFILIAL, CDCIA, NRSERVICOCIAFILI, CDCLASSE, CDCICLO, CDSUBGRU) {
        return restEngine.post("ate#/crud/prodsubsemam_produto", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": CDFILIAL
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": CDCIA
				},
                {
                    "name": "NRSERVICOCIAFILI",
                    "operator": "=",
                    "value": NRSERVICOCIAFILI
				},
                {
                    "name": "CDCLASSE",
                    "operator": "=",
                    "value": CDCLASSE
				},
                {
                    "name": "CDCICLO",
                    "operator": "=",
                    "value": CDCICLO
				},
                {
                    "name": "CDSUBGRU",
                    "operator": "=",
                    "value": CDSUBGRU
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				}
			]
        });
    };

    this.returnReceita = function(CDFILIAL, CDCIA, NRSERVICOCIAFILI, CDCLASSE, CDCICLO, CDSUBGRU) {
        return restEngine.post("ate#/crud/recsubsemam_receita", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": CDFILIAL
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": CDCIA
				},
                {
                    "name": "NRSERVICOCIAFILI",
                    "operator": "=",
                    "value": NRSERVICOCIAFILI
				},
                {
                    "name": "CDCLASSE",
                    "operator": "=",
                    "value": CDCLASSE
				},
                {
                    "name": "CDCICLO",
                    "operator": "=",
                    "value": CDCICLO
				},
                {
                    "name": "CDSUBGRU",
                    "operator": "=",
                    "value": CDSUBGRU
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				}
			]
        });
    };

    this.exportaConfiguracaoVoo = function(cdfilial, cdcia, nrvooori, cdtrechoori, sequencial, nrvoodes, datavigencia) {
        return restEngine.post("ate#/proce_exporta_configuracao_voo", {
            "requestType": "Row",
            "row": {
                "CDFILIAL": cdfilial,
                "CDCIA": cdcia,
                "NRVOOORI": nrvooori,
                "CDTRECHOORI": cdtrechoori,
                "DTINIVIGENCIA": datavigencia,
                "NRSEQPADVOOTREMDATA": sequencial,
                "NRVOODES": nrvoodes,
                "CDOPERADOR": getLocalVar("CDOPERADOR"),
                "NRORG": getLocalVar("NRORG")
            }
        });
    };

    this.importaConfiguracaoVoo = function(cdfilial, cdcia, nrvooori, cdtrechoori, sequencial, nrvoodes, cdtrechodes, datavigencia) {
        return restEngine.post("ate#/proce_importa_configuracao_voo", {
            "requestType": "Row",
            "row": {
                "CDFILIAL": cdfilial,
                "CDCIA": cdcia,
                "NRVOOORI": nrvooori,
                "CDTRECHOORI": cdtrechoori,
                "DTINIVIGENCIA": datavigencia,
                "NRSEQPADVOOTREMDATA": sequencial,
                "NRVOODES": nrvoodes,
                "CDTRECHODES": cdtrechodes,
                "CDOPERADOR": getLocalVar("CDOPERADOR"),
                "NRORG": getLocalVar("NRORG")
            }
        });
    };

    this.exportaConfiguracaoEquipamento = function(cdfilial, cdcia, cdequipori, cdequipdes, sequencial, vigencia) {
        return restEngine.post("ate#/proce_exporta_configuracao_equipamento", {
            "requestType": "Row",
            "row": {
                "CDFILIAL": cdfilial,
                "CDCIA": cdcia,
                "CDEQUIPORI": cdequipori,
                "CDEQUIPDES": cdequipdes,
                "DTINIVIGENCIA": vigencia,
                "NRSEQPADEQUIPMDATAORI": sequencial,
                "CDOPERADOR": getLocalVar("CDOPERADOR"),
                "NRORG": getLocalVar("NRORG")
            }
        });
    };

    this.importaConfiguracaoEquipamento = function(cdfilial, cdcia, cdequipori, cdequipdes, sequencial, vigencia) {
        return restEngine.post("ate#/proce_importa_configuracao_equipamento", {
            "requestType": "Row",
            "row": {
                "CDFILIAL": cdfilial,
                "CDCIA": cdcia,
                "CDEQUIPORI": cdequipori,
                "CDEQUIPDES": cdequipdes,
                "DTINIVIGENCIA": vigencia,
                "NRSEQPADEQUIPMDATAORI": sequencial,
                "CDOPERADOR": getLocalVar("CDOPERADOR"),
                "NRORG": getLocalVar("NRORG")
            }
        });
    };

    this.saveItensFaturamento = function(dataset) {
        return restEngine.post("ate#/crud/padvootrem/save", {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };

    this.salvaVigencia = function(row) {
        return restEngine.post("ate#/crud/padvootremdata/save", {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveItensHandling = function(dataset) {
        return restEngine.post("ate#/crud/padequipm/save", {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate00900_configura_servico_vooService", ate00900_configura_servico_vooService);
});

// FILE: ./assets/js/services/ate03600_tabelaprecos_manualService.js
var ate03600_tabelaprecos_manualService = function(ScreenService, templateManager, restEngine, localStorageEngine) {

    this.returnProduto = function(cdfilial, cdcia, CDMANCIA, nrservicociafili, cdclasse, cdciclo, cdsubgru) {

        return restEngine.post("ate#/crud/prodsubsemam_produto_precosesubgru_servicociafili_precoseciam", {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			}, {
                "name": "CDCIA",
                "operator": "=",
                "value": cdcia
			}, {
                "name": "CDMANCIA",
                "operator": "=",
                "value": CDMANCIA
			}, {
                "name": "NRSERVICOCIAFILI",
                "operator": "=",
                "value": nrservicociafili
			}, {
                "name": "CDCLASSE",
                "operator": "=",
                "value": cdclasse
			}, {
                "name": "CDCICLO",
                "operator": "=",
                "value": cdciclo
			}, {
                "name": "CDSUBGRU",
                "operator": "=",
                "value": cdsubgru
			}, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			}]
        });

    };

    this.returnReceita = function(cdfilial, cdcia, CDMANCIA, nrservicociafili, cdclasse, cdciclo, cdsubgru) {

        return restEngine.post("ate#/crud/recsubsemam_receita_precosesubgru_servicociafili_precoseciam", {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			}, {
                "name": "CDCIA",
                "operator": "=",
                "value": cdcia
			}, {
                "name": "CDMANCIA",
                "operator": "=",
                "value": CDMANCIA
			}, {
                "name": "NRSERVICOCIAFILI",
                "operator": "=",
                "value": nrservicociafili
			}, {
                "name": "CDCLASSE",
                "operator": "=",
                "value": cdclasse
			}, {
                "name": "CDCICLO",
                "operator": "=",
                "value": cdciclo
			}, {
                "name": "CDSUBGRU",
                "operator": "=",
                "value": cdsubgru
			}, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			}]
        });

    };

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate03600_tabelaprecos_manualService", ate03600_tabelaprecos_manualService);
});

// FILE: ./assets/js/services/ate21100_geracao_plano_vooService.js
var ate21100_geracao_plano_vooService = function(ScreenService, templateManager, restEngine, localStorageEngine) {

    this.executeProcedure = function(data) {
        return restEngine.post("ate#/gerar_plano_voo_procedure", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    //previsao maxima
    this.executeProcedureHistorico = function(data) {
        return restEngine.post("ate#/gerar_plano_voo_procedure_alteracao_classe", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.executeProcedureClasse = function(data) {
        return restEngine.post("ate#/gerar_plano_voo_procedure_ater_class", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.executeTrocaEquipamento = function(data) {
        return restEngine.post("ate#/gerar_plano_voo_procedure_alteracao_equipamento", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.executeProcedureGerados = function(data) {
        return restEngine.post("ate#/gerar_plano_voo_procedure_gerados", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    //cancela plano de voo gerado
    this.executeProcedureCancelados = function(data) {
        return restEngine.post("ate#/gerar_plano_voo_procedure_cancelados", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.getEquipamento = function(cdfilial, cdcia) {
        return restEngine.post("ate#/crud/equipcia_equipamento", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": cdcia
				}
			]
        });
    };
    this.getClasse = function(row) {
        return restEngine.post("ate#/crud/gerar_plano_voo_classe_not_instr", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": row.CDFILIAL
				},
                {
                    "name": "CDCIAPPT",
                    "operator": "=",
                    "value": row.CDCIA
				},
                {
                    "name": "NRVOOPPT",
                    "operator": "=",
                    "value": row.NRVOO
				},
                {
                    "name": "CDTRECHOPPT",
                    "operator": "=",
                    "value": row.CDTRECHO
				},
                {
                    "name": "DTHRPLAPPT",
                    "operator": "=",
                    "value": row.DTDECOLVOO
				}
			]
        });
    };

    this.retornaParamcomis = function(cdfilial) {
        return restEngine.post("ate#/crud/paramcomis", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				}
			]
        });
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate21100_geracao_plano_vooService", ate21100_geracao_plano_vooService);
});

// FILE: ./assets/js/services/CalculoRetrobillService.js
var CalculoRetrobillService = function(General, restEngine) {

    this.findFilial = function() {

        return restEngine.post("ate#/crud/unidades", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				},
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_CDFILIAL")
				}
			]
        });
    };

    this.executeProcedure = function(data) {

        return restEngine.post("ate#/gerar_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.relatorioRetrobill = function(row) {

        return General.openReport("ate#/viewretrobill", null, row);
    };

    this.descontoProcedure = function(data) {

        return restEngine.post("ate#/desconto_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.executePlanoVooProcedure = function(data) {

        return restEngine.post("ate#/gerar_planovoo_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.deleteProcedure = function(data) {

        return restEngine.post("ate#/apaga_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("CalculoRetrobillService", CalculoRetrobillService);
});

// FILE: ./assets/js/services/EmissaoDeliveryService.js
function EmissaoDeliveryService(restEngine) {

    this.findTotalServ = function(filter) {
        return restEngine.post("ate#/total_servicos", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.calculaDeliverym = function(currentRow, id) {
        currentRow.ID = id;
        return restEngine.post("ate#/emissao_delivery", {
            "requestType": "Row",
            "row": currentRow
        }, null, null, null, null, 600000);
    };

    this.callProcedure = function(currentRow, id) {
        currentRow.ID = id;
        return restEngine.post("ate#/emissao_delivery", {
            "requestType": "Row",
            "row": currentRow
        }, null, null, null, null, 600000);
    };

    this.calcDesc = function(currentRow) {
        return restEngine.post("ate#/calcDesc", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.sendAnswer = function(Row) {
        return restEngine.post("ate#/serv_estoque", {
            "requestType": "Row",
            "row": Row
        });
    };

    this.saveRow = function(Row) {
        return restEngine.post("ate#/servplanom_servicociafili_classe_ciclo_ciafili/save", {
            "requestType": "Row",
            "row": Row
        });
    };

    this.saveRowObs = function(Row) {
        return restEngine.post("ate#/agrdelivery_obsdelivtmp_servplano/save", {
            "requestType": "Row",
            "row": Row
        });
    };

    this.findObs = function(filter) {
        return restEngine.post("ate#/crud/obsdelivtmpm", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.findServplanom = function(mainData) {

        return restEngine.post("ate#/crud/servplanom", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": mainData.CDFILIAL
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": mainData.CDCIA
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": mainData.NRVOO
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": mainData.CDTRECHO
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": mainData.DTHRPLAVOOPV
				}
			]
        });
    };

    this.findNrservicociafili = function(mainData) {

        return restEngine.post("ate#/crud/emissao_delivery_servplanom_nrservicociafili", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": mainData.CDFILIAL
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": mainData.CDCIA
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": mainData.NRVOO
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": mainData.CDTRECHO
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": mainData.DTHRPLAVOOPV
				}
			]
        });
    };

    this.findVerificaNac = function(mainData) {

        return restEngine.post("ate#/crud/emissao_delivery_servplanom_verifica_nac", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": mainData.CDFILIAL
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": mainData.CDCIA
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": mainData.NRVOO
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": mainData.CDTRECHO
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": mainData.DTHRPLAVOOPV
				}
			]
        });
    };

    this.findComissaria = function(cdfilial) {

        return restEngine.post("ate#/crud/paramcomis", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				}
			]
        });
    };

    this.findOperador = function() {

        return restEngine.post("ate#/crud/operador", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_CDOPERADOR")
				}
			]
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("EmissaoDeliveryService", EmissaoDeliveryService);
});

// FILE: ./assets/js/services/FaturamentoRetrobillService.js
var FaturamentoRetrobillService = function(General, restEngine) {

    this.findFilial = function() {

        return restEngine.post("ate#/crud/unidades", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				},
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_CDFILIAL")
				}
			]
        });
    };

    this.executeProcedure = function(data) {

        return restEngine.post("ate#/gerar_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.relatorioRetrobill = function(row) {

        return General.openReport("ate#/viewfaturetrobill", null, row);
    };

    this.validaFaturamento = function(filtro) {

        return restEngine.post("ate#/crud/faturamento_faturamentoretrobill", {
            "requestType": "FilterData",
            "filter": filtro
        });
    };

    this.executePlanoVooProcedure = function(data) {

        return restEngine.post("ate#/gerar_planovoo_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.deleteProcedure = function(data) {

        return restEngine.post("ate#/apaga_retrobill", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("FaturamentoRetrobillService", FaturamentoRetrobillService);
});

// FILE: ./assets/js/services/ManutencaoDeliveryService.js
function ManutencaoDeliveryService(restEngine) {

    this.autenticar = function(user, senha) {

        return restEngine.request("ate#/autenticarPorAd", {
            "requestType": "FilterData",
            "filter": [
                {
                    name: "user",
                    operator: "=",
                    value: user
				},
                {
                    name: "senha",
                    operator: "=",
                    value: senha
				}
			]
        });
    };

    this.paramsPax = function(cdfilial, cdcia, dthrplavoopv, nrvoo, cdtrecho, nrorg) {
        return restEngine.post("ate#/crud/planovoom_equipamento_vootrecho", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": cdcia
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": dthrplavoopv
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": nrvoo
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": cdtrecho
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.retorna_agrupamento = function(currentRow) {

        return restEngine.post("ate#/retorna_agrupamento", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.cancela_delivery = function(currentRow) {

        return restEngine.post("ate#/cancela_delivery", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.valida_exportacaoSAP = function(currentRow) {

        return restEngine.post("ate#/deliverym_exportacaosap", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": currentRow.CDFILIAL
				},
                {
                    "name": "NRDELIVERY",
                    "operator": "=",
                    "value": currentRow.NRDELIVERY
				}
			]
        });
    };

    this.calcula_delivery = function(currentRow) {
        return restEngine.post("ate#/calcula_delivery", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.calcula_precom = function(currentRow) {
        return restEngine.post("ate#/calcula_preco", {
            "requestType": "Row",
            "row": currentRow
        });
    };

    this.validaParamDelivery = function(cdfilial, nrorg) {
        return restEngine.post("ate#/crud/paramcomis", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.validaOperador = function(cdoperador, cdgrupoaltdel, nrorg) {
        /*09/01/2018*/
        /*Retirando validação de Grupo de Operadores*/
        return restEngine.post("ate#/crud/opergrupop", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": cdoperador
				},
                {
                    "name": "CDGRUPOPER",
                    "operator": "=",
                    "value": cdgrupoaltdel
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };

    this.retornaOperador = function(nmacesso, nrorg) {
        return restEngine.post("ate#/crud/retornaOperadorNmacesso", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NMACESSO",
                    "operator": "=",
                    "value": nmacesso
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
				}
			]
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("ManutencaoDeliveryService", ManutencaoDeliveryService);
});

// FILE: ./assets/js/services/PrevisaoPAXService.js
var PrevisaoPAXService = function(General, restEngine) {

    this.findFilial = function() {

        return restEngine.post("ate#/crud/unidades", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				},
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_CDFILIAL")
				}
			]
        });
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("PrevisaoPAXService", PrevisaoPAXService);
});

// FILE: ./assets/js/services/UnidadeDeafultService.js
var UnidadeDeafultService = function(General, restEngine) {

    this.findFilial = function() {

        return restEngine.post("ate#/crud/unidades", {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
				},
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": getLocalVar("INFLIGHTOR_CDFILIAL")
				}
			]
        });
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("UnidadeDeafultService", UnidadeDeafultService);
});

// FILE: ./assets/js/controllers/AlteracaoPlanoDeVooController.js
let AlteracaoPlanoDeVooController = function(ZhFilterPreferences, AlteracaoPlanoDeVooService, templateManager, Colors, ScreenService, restEngine, InflightorGeneral, ZHPromise, metaDataFactory, ValidationEngine, localStorageEngine, $timeout, MessageService, EmissaoDeliveryService) {

    let self = this;

    let changeQtproduzirNeedsRecalc = true;
    let changeQtfaturarNeedsRecalc = true;

    let trataMensagem = function(mensagem) {
        if (mensagem && mensagem.length) {
            if (!InflightorGeneral.mensagemErroProcedure(mensagem)) {
                if (mensagem.indexOf("ATE01500_") >= 0) {
                    if (mensagem.indexOf("ATE01500_SERV_EMIT") >= 0 ||
                        mensagem.indexOf("ATE01500_SERV_CANCEL") >= 0) {
                        let code_params = mensagem.split("#_#");
                        MessageService.showMessageByCode(code_params[0], {
                            "0": code_params[1]
                        });
                    } else
                        MessageService.showMessageByCode(mensagem);
                } else {
                    MessageService.showMessageByCode(mensagem);
                }
            }
        }
    };

    this.preventQtfaturarRecalc = function() {
        changeQtfaturarNeedsRecalc = false;
    };

    this.preventQtproduzirRecalc = function() {
        changeQtproduzirNeedsRecalc = false;
    };

    this.retornaParametrosUnidade = function(row) {
        AlteracaoPlanoDeVooService.paramsComissaria(row.CDFILIAL, localStorageEngine.getLocalVar('INFLIGHTOR_NRORGTRAB')).then(function(paramcomis) {
            self.paramsComissariaVar = paramcomis.dataset.paramcomis[0];
        });
    };

    this.onEnterTabItemFaturamento = function(widget) {
        // $timeout(function() {
        //     widget.redraw();
        // }, 500);
    };

    this.filtraFilhosUnidade = function(widgetServicos) {
        if (!widgetServicos.currentRow.CDFILIAL) {
			[widgetServicos.getField("NMCIA"), widgetServicos.getField("NRVOO")].forEach(function(field) {
                if (field) {
                    field.setValue(null);
                    self.filterCia(field);
                    field.readOnly = true;
                }
            });
        } else {
        	[widgetServicos.getField("NMCIA"), widgetServicos.getField("NRVOO")].forEach(function(field) {
                if (field) {
                    field.setValue(null);
                    self.filterCia(field);
                    field.readOnly = false;
                }
            });
        }
    };

    this.gridFilterAfterApply = function(widget) {

        let row = widget.currentRow;

        AlteracaoPlanoDeVooService.paramsComissaria(row.CDFILIAL, localStorageEngine.getLocalVar('INFLIGHTOR_NRORGTRAB')).then(function(paramcomis) {
            self.paramsComissariaVar = paramcomis.dataset.paramcomis[0];
            self.filterPax(widget);
            //self.hideStripe(widget);
        });
    };

    this.hideStripe = function(widget) {
        widget.container.getWidget('widgetStripe').getField('StripeHeader').isVisible = false;
    };

    this.voltaTela = function(widget) {
        ScreenService.goBack();
        widget.getAction('VOLTARTELA').isVisible = false;
    };
    let validNumber;
    this.verifyOnEnter = function(widget, args) {
        if (!validNumber) {
            MessageService.getMessageByCode("ATE01500_NUMERO_NEGATIVO").then(function(msg) {
                let validNumber = function(value) {
                    let isValid = false;
                    let val = value ? parseFloat(value) : 0;
                    if (val >= 0) {
                        isValid = true;
                    }
                    return {
                        "valid": isValid,
                        "message": msg
                    };
                };
                try {
                    ValidationEngine.registerValidation('denyNegative', validNumber);
                } catch (e) {}
            });
        }
        let flag;
        let widget_selecionados;
        let widget_gerados;
        let widgetPred = widget.container.getWidget('previsaodepax');

        try {
            widget_selecionados = templateManager.currentWidget.container.getWidget('geracao_plano_voo_selecionados');
            widget_gerados = templateManager.currentWidget.container.getWidget('geracao_plano_voo_gerados');
            flag = widget_gerados.currentRow.FLAG || false;
        } catch (error) {
            flag = false;
        }

        if (flag) {

            widgetPred.getAction('VOLTARTELA').isVisible = true;
            widgetPred.getField('NRVOO').readOnly = false;
            let widgetPredFilterRow = {};
            widgetPredFilterRow.NMFILIAL = widget_selecionados.appliedFilter.FILTER_ROW.NMFILIAL;
            widgetPredFilterRow.CDFILIAL = widget_selecionados.appliedFilter.FILTER_ROW.CDFILIAL;
            widgetPredFilterRow.CDCIA = widget_gerados.currentRow.CDCIA;
            widgetPredFilterRow.NRVOO = widget_gerados.currentRow.NRVOO;
            widgetPredFilterRow.CDTRECHO = widget_gerados.currentRow.CDTRECHO;
            widgetPredFilterRow.DTHRPLAVOOPV = widget_gerados.currentRow.DTHRPLAVOOPV.slice(0, 10);
            widgetPredFilterRow.NMCIA = widget_gerados.currentRow.NMCIA;
            widgetPredFilterRow.DSTRECHO = widget_gerados.currentRow.SGBASEORI + ' - ' + widget_gerados.currentRow.SGBASEDES;
            ZhFilterPreferences.setOriginalFilter(widgetPred.id, widgetPredFilterRow);
            ZhFilterPreferences.openFilterWidget(widgetPred, widgetPredFilterRow);
            widget_gerados.currentRow.FLAG = false;
            setTimeout(function() {
                let action_filtro = $('.zh-footer-right ul li')[0];
                action_filtro.click();
            }, 300);
        } else {
            InflightorGeneral.openFilterOnEnter(widgetPred, ['CDFILIAL', 'NMFILIAL', 'DTHRPLAVOOPV']);
            widget.container.getWidget('widgetStripe').getField('StripeHeader').isVisible = false;
            widgetPred.activate();
            widgetPred.getField('CDFILIAL').applyDefaultValue();
            widgetPred.getField('NMFILIAL').applyDefaultValue();
            widgetPred.getField('DTHRPLAVOOPV').applyDefaultValue();
        }
    };

    this.openFilter = function(action, container) {
        if (container.getActiveWidget().mode !== "edit") {
            ZhFilterPreferences.openFilterWidget(action.widget.container.getWidget('previsaodepax'));
        }
    };

    this.carregaTrecho = function(field) {
        let widget = field.widget;

        widget.getField("DSTRECHO").setValue(widget.getField("SGBASEORI").value() + '-' + widget.getField("SGBASEDES").value());

        if (widget.getField("NRVOO").value() === "" || !widget.getField("NRVOO").value()) {
            widget.getField("DSTRECHO").setValue(null);
        }
    };

    this.filterPax = function(widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (widget.appliedFilter) {
            let filterPopup = widget.appliedFilter.FILTER_ROW;
            let wServ = widget.container.getWidget('itensDeFaturamento');
            let wPrefixo = widget.container.getWidget('manutencaoVoo');

            let wClasseDif = widget.getField('SGCLASSE');

            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filterPopup.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": filterPopup.CDCIA
                },
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": filterPopup.NRVOO
                },
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": filterPopup.DTHRPLAVOOPV
                },
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": filterPopup.CDTRECHO
                }
            ];

            let filter2 = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filterPopup.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": filterPopup.CDCIA
                }
            ];

            wClasseDif.dataSourceFilter = filter;
            wPrefixo.dataSourceFilter = filter;
            wServ.dataSourceFilter = filter;

            widget.dataSourceFilter = filter;
            widget.reload();
            self.setCurrentRowManutPlanoVoo(wPrefixo);
        }
    };

    this.openInfoAdicionais = function(widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (typeof event !== 'undefined') {
            if (event.target.className.indexOf('inline-editable') < 0 && event.target.className.indexOf('editable-content') < 0) {
                let widgetInformacoesAdicionais = widget.container.getWidget('informacoes');
                let widgetAddPrevpax = widget.container.getWidget('addPrevPax');
                let currentRow = widget.currentRow;
                currentRow.DSTRECHO = widget.appliedFilter.FILTER_ROW.DSTRECHO;
                widgetInformacoesAdicionais.isVisible = true;
                widgetAddPrevpax.isVisible = false;
                widget.widgets[0].defaultTab = widgetInformacoesAdicionais.name;
                let filter = {
                    CDFILIAL: currentRow.CDFILIAL,
                    CDCIA: currentRow.CDCIA,
                    NRVOO: currentRow.NRVOO,
                    CDCLASSE: currentRow.CDCLASSE,
                    DTHRPLAVOOPV: currentRow.DTHRPLAVOOPV,
                    CDTRECHO: currentRow.CDTRECHO
                };
                InflightorGeneral.buildDataSourceFilter(widgetInformacoesAdicionais.dataSourceFilter, filter);
                if (widgetInformacoesAdicionais.active) {
                    widgetInformacoesAdicionais.reload();
                } else {
                    ScreenService.openSwipe(widget.widgets[0]).then(
                        function() {
                            widgetInformacoesAdicionais.list();
                        }
                    );
                }
            }
        }
    };

    this.closeSonWidgetPrevPax = function(widget) {
        widget.isVisible = false;
        ScreenService.closeSwipe().then(
            function() {
                widget.container.getWidget('previsaodepax').list();
                widget.container.getWidget('previsaodepax').activate();
            }
        );
    };

    this.addPrevPax = function(widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget.container.getWidget('previsaodepax'))) {
            let widgetInformacoesAdicionais = widget.container.getWidget('informacoes');
            let widgetAddPrevpax = widget.container.getWidget('addPrevPax');
            let currentRow = widget.appliedFilter.FILTER_ROW;
            widgetInformacoesAdicionais.isVisible = false;
            widgetAddPrevpax.isVisible = true;
            widget.widgets[0].defaultTab = widgetAddPrevpax.name;
            let filter = {
                CDFILIAL: currentRow.CDFILIAL,
                CDCIA: currentRow.CDCIA,
                NRVOO: currentRow.NRVOO,
                DTHRPLAVOOPV: currentRow.DTHRPLAVOOPV,
                CDTRECHO: currentRow.CDTRECHO
            };
            InflightorGeneral.buildDataSourceFilter(widgetAddPrevpax.getField('SGCLASSE').dataSourceFilter, filter);
            ScreenService.openSwipe(widget.widgets[0]).then(
                function() {
                    widgetAddPrevpax.newRow();
                    addClassePopulateCurrentRow(widgetAddPrevpax, filter);
                    widgetAddPrevpax.edit();
                }
            );
        }
    };

    function addClassePopulateCurrentRow(widget, filterRow) {
        widget.currentRow.CDFILIAL = filterRow.CDFILIAL;
        widget.currentRow.CDCIA = filterRow.CDCIA;
        widget.currentRow.NRVOO = filterRow.NRVOO;
        widget.currentRow.CDCLASSE = filterRow.CDCLASSE;
        widget.currentRow.DTHRPLAVOOPV = filterRow.DTHRPLAVOOPV;
        widget.currentRow.CDTRECHO = filterRow.CDTRECHO;
    }

    this.validDate = function(widget) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let dataBloqueioDelivery = null;
        if (this.paramsComissariaVar) {
            dataBloqueioDelivery = this.paramsComissariaVar.DTBLOQDEL;
        }
        let dataDecolagemVoo = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW.DTHRPLAVOOPV;
        dataBloqueioDelivery = dataBloqueioDelivery ? moment(dataBloqueioDelivery, "DD/MM/YYYY") : null;
        dataDecolagemVoo = dataDecolagemVoo ? moment(dataDecolagemVoo, "DD/MM/YYYY") : null;

        if (dataDecolagemVoo > dataBloqueioDelivery) {
            return true;
        } else {
            MessageService.showMessageByCode("ATE01500_DTBLOQDEL", {
                "0": dataBloqueioDelivery.format("DD/MM/YYYY")
            });
            return false;
        }
    };

    this.carregaServico = function(field) {
        if (!field.widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (field.value()) {
            let filtroRow = field.widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;
            let currentRow = field.widget.currentRow;
            field.widget.getField('IDSITSERSP').applyDefaultValue();
            field.widget.getField('IDTIPSCBOSP').applyDefaultValue();

            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filtroRow.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": filtroRow.CDCIA
                },
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": filtroRow.NRVOO
                },
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": filtroRow.DTHRPLAVOOPV
                },
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": filtroRow.CDTRECHO
                }
            ];

            InflightorGeneral.callRestEngine('ate#/servplanom_classe_ciclo_servciclo_servicociafili_servicogen', "FilterData", filter).then(function(success) {
                    let database = success.dataset.servplanom_classe_ciclo_servciclo_servicociafili_servicogen;
                    let maiorItem = 0;
                    database.forEach(function(data) {
                        if (parseFloat(data.NRITEMPLANSP) > maiorItem) maiorItem = parseFloat(data.NRITEMPLANSP);
                    });
                    field.widget.currentRow.NRITEMPLANSP = maiorItem + 1;
                },
                function(error) {

                });

            field.widget.currentRow.QTSESBYUTSP = 0;
        } else {
            field.widget.getField('IDTIPSCBOSP').setValue('');
            this.visualizeProporcao(field.widget);
        }
    };

    this.selectServico = function(field) {
        if (!field.widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let filterRow = field.widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filterRow.CDFILIAL
            },
            {
                "name": "CDCIA",
                "operator": "=",
                "value": filterRow.CDCIA
            },
            {
                "name": "NRVOO",
                "operator": "=",
                "value": filterRow.NRVOO
            },
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": filterRow.CDTRECHO
            },
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": filterRow.DTHRPLAVOOPV
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('INFLIGHTOR_NRORGTRAB')
            }
        ];

        field.dataSourceFilter = filter;
        field.reload();
    };

    this.alteraQtpax = function(row, fieldName) {
        if (!row.STSERVICO) {
            MessageService.showMessageByCode("ATE01500_CLASSE_CANCELADA");
            row[fieldName] = row['changed_' + fieldName] || row[fieldName];
            delete row.changed;
        } else if (row.IDCLASSE == '2' || row.IDCLASSE == '3' || row.IDCLASSE == '5') {
            MessageService.showMessageByCode("ATE01500_ALT_PREV_CLASSE_BLOQ");
            row[fieldName] = row['changed_' + fieldName] || row[fieldName];
            delete row.changed;
        }
    };

    this.goToDelivery = function(widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget)) {
            widget.currentRow.CDCIA = widget.appliedFilter.FILTER_ROW.CDCIA;
            widget.currentRow.NMCIA = widget.appliedFilter.FILTER_ROW.NMCIA;
            widget.currentRow.NRVOO = widget.appliedFilter.FILTER_ROW.NRVOO;
            widget.currentRow.DTHRPLAVOOPV = widget.appliedFilter.FILTER_ROW.DTHRPLAVOOPV;
            widget.currentRow.CDTRECHO = widget.appliedFilter.FILTER_ROW.CDTRECHO;
            widget.currentRow.SGBASEORI = widget.appliedFilter.FILTER_ROW.SGBASEORI;
            widget.currentRow.SGBASEDES = widget.appliedFilter.FILTER_ROW.SGBASEDES;
            widget.currentRow.ALTERACAOPV = true;
            widget.currentRow.FLAG = true;
            TELA_ANTERIOR = true;
            setLocalVar('lastWidgetDelivery', 'ate#' + widget.container.name);
            ScreenService.openWindow('ate#ate02200_emissao_delivery');
        }
    };

    this.selectClasse = function(field) {
        let cdfilial = field.widget.currentRow.CDFILIAL;
        let cdcia = field.widget.currentRow.CDCIA;
        let nrvoo = field.widget.currentRow.NRVOO;
        let cdtrecho = field.widget.currentRow.CDTRECHO;
        let dthrplavoopv = field.widget.currentRow.DTHRPLAVOOPV;
        let cdclasse = field.widget.currentRow.CDCLASSE;
        let nrservicociafili = null;

        AlteracaoPlanoDeVooService.RETORNA_CICLOM(field.widget.currentRow).then(
            function(success) {
                let cdciclo = success.dataset.response.CDCICLO;
                field.widget.currentRow.CDCICLO = cdciclo;
            },

            function(error) {
                if (error.data)
                    trataMensagem(error.data.error);
                else {
                    MessageService.showMessageByCode("ERRO_INESPERADO");
                    console.log(error);
                }
            }
        );

        let id = field.widget.currentRow.IDCLASSE;
        if ((id === '2') || (id === '3') || (id === '5')) {
            field.widget.getField('QTPAXSBY').readOnly = true;
            field.widget.currentRow.QTPAXSBY = '';
        } else {
            field.widget.getField('QTPAXSBY').readOnly = false;
        }
    };

    this.retornaAgrupamento = function(widget, dataSave) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let deferred = ZHPromise.defer();
        let firstRow = dataSave[0];
        let row = Object.assign({}, widget.currentRow, widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW);
        if (firstRow.__is_new) {
            return AlteracaoPlanoDeVooService.retorna_agrupamento(row).then(
                function(success) {
                    firstRow.CDAGRDECO = success.dataset.response.CDAGRDECO;
                    deferred.resolve();
                    return deferred.promise;
                }
            );
        } else {
            return deferred.resolve();
        }
    };

    this.excluirItem = function(widget) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget.container.getWidget('previsaodepax'))) {
            widget.currentRow.DTHRPLAVOOPV = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW.DTHRPLAVOOPV;
            MessageService.confirmMessageByCode("ATE01500_CONFIRM_EXCL_ITEM").then(
                function(success) {
                    InflightorGeneral.callRestEngine('ate#/ate01500_delete_item', "DataSet", getWidgetData(widget)).then(
                        function(success) {
                            if (success.dataset && success.dataset.errorMessages) {
                                if (!widget.isMasterDetailPopup) {
                                    widget.list();
                                    widget.unSelectAll();
                                }
                                widget.reload();
                                if (success.dataset.errorMessages && success.dataset.errorMessages.length) {
                                    MessageService.getMessagesByCode(['ATE01500_SERV_EMIT', 'ATE01500_SERV_CANCEL']).then(function(msgs) {
                                        for (let i = 0; i < success.dataset.errorMessages.length; i++) {
                                            let code_params = success.dataset.errorMessages[i].split("#_#");
                                            let msg = (code_params[0].indexOf('ATE01500_SERV_EMIT') >= 0) ? msgs[0] : msgs[1];
                                            msg = ScreenService.i18n(msg, {
                                                "0": code_params[1]
                                            });
                                            success.dataset.errorMessages[i] = msg;
                                        }
                                        InflightorGeneral.showErrorMessages(widget, success.dataset.errorMessages);
                                    });
                                } else {
                                    if (widget.isMasterDetailPopup) {
                                        ScreenService.closeSwipe();
                                    }
                                    MessageService.showMessageByCode("SUCESSO");
                                }
                            }
                        },
                        function(error) {
                            if (error.data)
                                trataMensagem(error.data.error);
                            else {
                                MessageService.showMessageByCode("ERRO_INESPERADO");
                                console.log(error);
                            }
                        }
                    );
                });
        }
    };

    function getWidgetData(widget) {
        let data = [];
        if (widget.isMasterDetailPopup) {
            data.push(widget.currentRow);
        } else {
            data = widget.getCheckedRows();
        }
        return data;
    }

    this.cancelarItem = function(widget) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget.container.getWidget('previsaodepax'))) {
            widget.currentRow.DTHRPLAVOOPV = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW.DTHRPLAVOOPV;
            MessageService.confirmMessageByCode("ATE01500_CONF_CANCEL_ITEM").then(
                function(success) {
                    // widget.currentRow.IDSITSERSP = "3";
                    widget.currentRow.DTHRCANCSESP = moment().format("DD/MM/YYYY");
                    InflightorGeneral.callRestEngine('ate#/ate01500_cancel_item', "DataSet", getWidgetData(widget)).then(function(success) {
                            if (success.dataset && success.dataset.errorMessages && success.dataset.errorMessages.length) {
                                MessageService.getMessagesByCode(['ATE01500_SERV_EMIT', 'ATE01500_SERV_CANCEL']).then(function(msgs) {
                                    for (let i = 0; i < success.dataset.errorMessages.length; i++) {
                                        let code_params = success.dataset.errorMessages[i].split("#_#");
                                        let msg = (code_params[0].indexOf('ATE01500_SERV_EMIT') >= 0) ? msgs[0] : msgs[1];
                                        msg = ScreenService.i18n(msg, {
                                            "0": code_params[1]
                                        });
                                        success.dataset.errorMessages[i] = msg;
                                    }
                                    InflightorGeneral.showErrorMessages(widget, success.dataset.errorMessages);
                                });

                            } else {
                                MessageService.showMessageByCode("SUCESSO");
                                if (widget.isMasterDetailPopup) {
                                    ScreenService.closeSwipe();
                                } else {
                                    widget.list();
                                    widget.unSelectAll();
                                }
                                widget.reload();
                            }
                        },
                        function(error) {
                            if (error.data)
                                trataMensagem(error.data.error);
                            else {
                                MessageService.showMessageByCode("ERRO_INESPERADO");
                                console.log(error);
                            }
                        });
                });
        }
    };

    function canEditItem(row) {
        let valid = true;
        if (row.IDSITSERSP == '3') {
            valid = false;
            MessageService.showMessageByCode("ATE01500_EDIT_SERV_CANCEL");
        } else if (row.IDSITSERSP == '2' && row.NRDELIVERY) {
            valid = false;
            MessageService.showMessageByCode("ATE01500_EDIT_SERV_EMIT");
        } else {
            valid = true;
        }
        return valid;
    }

    this.editarItem = function(widget) {
        if (this.validDate(widget.container.getWidget('previsaodepax')) && canEditItem(widget.currentRow)) {
            let QTANTAPRODSP = widget.currentRow.QTANTAPRODSP;
            widget.backupRow = angular.copy(widget.currentRow);
            widget.edit();
        }
    };

    this.addServico = function(widget) {
        if (this.validDate(widget.container.getWidget('previsaodepax'))) {
            widget.newRow();
        }
    };

    this.calculaQtdeProduzir = function(field) {
        field.widget.currenRow.QTATUAPRODSP += field.value();
    };

    this.setValueConfig = function(field) {
        field.setValue(
            parseInt(
                field.value().split(":")[1]
            )
        );
    };

    this.setCicloColor = function(element, row) {
        setTimeout(function() {
            if (row.NRCORCICLO.toString().charAt(0) != '#')
                row.NRCORCICLO = Colors.TColorToHex(row.NRCORCICLO);
            element.css('background-color', row.NRCORCICLO);
        }, 100);
    };

    this.setCicloColorView = function(row) {
        setTimeout(function() {
            if (row.NRCORCICLO) {
                if (row.NRCORCICLO.toString().charAt(0) != '#')
                    row.NRCORCICLO = Colors.TColorToHex(row.NRCORCICLO);
                $('.idciclo-custom  > div > p').css('background-color', row.NRCORCICLO);
            }
        }, 1000);
    };

    this.changeCia = function(filterWidget) {
        let nrvoo = filterWidget.getField('NRVOO');

        filterWidget.getField("NRVOO").setValue(null);
        filterWidget.getField("DSTRECHO").setValue(null);

        if (filterWidget.getField("NMCIA").value() != "" && filterWidget.getField("NMCIA").value() != null) {
            nrvoo.readOnly = false;
        } else {
            nrvoo.readOnly = true;
        }
        // this.filterVoo(nrvoo);
    };

    this.changeData = function(widget) {
        widget.getField("NMCIA").setValue(null);
        self.filterCia(widget.getField("NMCIA"));
    };

    this.filterEquipDefault = function(widget) {
        if (!widget.getParent().widgets[0].appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (widget.mode == 'view') {
            let filtro = widget.getParent().widgets[0].appliedFilter.FILTER_ROW;
            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filtro.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": filtro.CDCIA
                },
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": filtro.NRVOO
                },
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": filtro.DTHRPLAVOOPV
                },
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": filtro.CDTRECHO
                }
            ];

        } else if (widget.mode == 'list') {
            widget.view();
        }
    };

    this.filterPrefixo = function(field) {
        field.dataSourceFilter = [];
        field.dataSourceFilter.push(field.widget.dataSourceFilter[0]);
        field.dataSourceFilter.push(field.widget.dataSourceFilter[1]);
        field.reload();
    };

    this.filterEquip2 = function(widget) {
        if (!widget.getParent().widgets[0].appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let filtro = widget.getParent().widgets[0].appliedFilter.FILTER_ROW;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filtro.CDFILIAL
            },
            {
                "name": "CDCIA",
                "operator": "=",
                "value": filtro.CDCIA
            }
        ];
        widget.getField('DSEQUIP').dataSourceFilter = filter;
        widget.getField('SGPREFIXO').dataSourceFilter = filter;
    };

    this.filterCia = function(field) {
        let widget = field.widget;
        field.widget.getField("SGCIA").setValue("T");
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.getField("CDFILIAL").value()
            },
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": widget.getField("DTHRPLAVOOPV").value()
            }
        ];

        field.dataSourceFilter = filter;
        self.filterVoo(field.widget.getField("NRVOO"));
    };

    this.filterVoo = function(field) {
        let widget = field.widget;
        let currentRow = widget.currentRow;

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": currentRow.CDFILIAL
            },
            {
                "name": "CDCIA",
                "operator": "=",
                "value": currentRow.CDCIA
            },
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": currentRow.DTHRPLAVOOPV
            }
        ];

        field.dataSourceFilter = filter;
        self.carregaTrecho(field);
    };

    function getQtProporcao(row) {
        let value;
        if (row.IDTIPSCBOSP == '4')
            value = row.VRLOADSESP;
        else if (row.IDTIPSCBOSP == '2')
            value = row.NRPROPAXSP;
        else if (row.IDTIPSCBOSP == '3')
            value = null;

        return value;
    }

    function mountRowCalcQtM(widget) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let row = widget.currentRow;
        let rowFilter = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;
        let procedureRow = {
            CDFILIAL: rowFilter.CDFILIAL,
            CDCIA: rowFilter.CDCIA,
            CDTRECHO: rowFilter.CDTRECHO,
            NRVOO: rowFilter.NRVOO,
            CDCLASSE: row.CDCLASSE,
            NRSERVICOCIAFILI: row.NRSERVICOCIAFILI,
            CDCICLO: row.CDCICLO,
            QTTOTPAXAT: row.QTTOTPAXAT,
            NRPROPAXSP: row.NRPROPAXSP || null,
            VRLOADSESP: row.VRLOADSESP || null,
            IDTIPSCBOSP: row.IDTIPSCBOSP,
            QTSESBYPRSP: row.QTSESBYPRSP ? InflightorGeneral.valueToFloat(row.QTSESBYPRSP) : 0,
            QTSERVFIXSP: row.QTSERVFIXSP ? InflightorGeneral.valueToFloat(row.QTSERVFIXSP) : 0,
            DTHRPLAVOOPV: rowFilter.DTHRPLAVOOPV
        };
        return procedureRow;
    }

    function changeQuantidades(widget) {
        let row = widget.currentRow;
        row.QTSESOLICSP = InflightorGeneral.valueToFloat(row.QTTOTPAX_PAXSBY);
        self.changeQtproduzirSwipeOpen(row);
        self.changeQtfaturarSwipeOpen(row);
    }

    this.visualizeProporcao = function(widgetServicos) {
        let field = widgetServicos.getField('NRPROPAXSP');
        field.isVisible = false;
        field.showOnForm = false;
        field.showOnView = false;
        field.validations = {
            denyNegative: true
        };

        field = widgetServicos.getField('VRLOADSESP');
        field.isVisible = false;
        field.showOnForm = false;
        field.showOnView = false;
        field.validations = {
            denyNegative: true
        };

        let maskAtual = "" + widgetServicos.currentRow.IDTIPSCBOSP;
        field = {
            validations: {}
        };
        switch (maskAtual) {
            case '2':
                field = widgetServicos.getField('NRPROPAXSP');
                break;
            case '4':
                field = widgetServicos.getField('VRLOADSESP');
                break;
            default:
                break;
        }
        field.isVisible = true;
        field.showOnForm = true;
        field.showOnView = true;
        field.validations.required = true;
    };

    this.alteraProporcaoServico = function(widgetServicos, fieldList) {
        let field = widgetServicos.getField('NRPROPAXSP');
        field.isVisible = false;
        field.showOnForm = false;
        field.showOnView = false;
        field.validations = {
            denyNegative: true
        };
        field.value('');

        field = widgetServicos.getField('VRLOADSESP');
        field.isVisible = false;
        field.showOnForm = false;
        field.showOnView = false;
        field.validations = {
            denyNegative: true
        };
        field.value('');

        fieldList.forEach(function(fieldName) {
            widgetServicos.getField(fieldName).setValue(0);
        });

        let maskAtual = "" + widgetServicos.currentRow.IDTIPSCBOSP;
        field = {
            validations: {}
        };
        switch (maskAtual) {
            case '1':
                changeQuantidades(widgetServicos);
                break;
            case '2':
                field = widgetServicos.getField('NRPROPAXSP');
                break;
            case '4':
                field = widgetServicos.getField('VRLOADSESP');
                break;
            default:
                break;
        }
        field.isVisible = true;
        field.showOnForm = true;
        field.showOnView = true;
        field.validations.required = true;
    };
    //-----------------------

    this.saveInlineEditClass = function(widget) {
        if (this.validDate(widget) && validaClasse(widget)) {
            let dataSave = [];
            let data = widget.dataSource.data;
            for (let index in data) {
                if (data[index].changed) {
                    if (data[index].QTPAXSBY == "") {
                        data[index].QTPAXSBY = 0;
                        data[index].QTPAXSBY_inline = 0;
                    }
                    if (data[index].QTTOTPAXAT == "") {
                        data[index].QTTOTPAXAT = 0;
                        data[index].QTTOTPAXAT_inline = 0;
                    }
                    InflightorGeneral.setFloatAttrOnCurrentRow(data[index], 'QTTOTPAXAT');
                    InflightorGeneral.setFloatAttrOnCurrentRow(data[index], 'QTPAXSBY');
                    data[index].ignoreMaxPax = false;
                    dataSave.push(data[index]);
                }
            }
            InflightorGeneral.callRestEngine('ate#/saveClassOnManutencaoPlanoVoo', 'DataSet', dataSave).then(
                function(success) {
                    let response = success.dataset.previsaopaxm;
                    if (response.length) {
                        saveClassePassageirosExcedentes(widget, response);
                    } else {
                        widget.list();
                        widget.activate();
                        widget.reload();
                    }
                },
                function(error) {
                    if (error.data)
                        trataMensagem(error.data.error);
                    else {
                        MessageService.showMessageByCode("ERRO_INESPERADO");
                        console.log(error);
                    }
                }
            );
        }
    };

    let validaClasse = function(widget) {
        let rows = widget.dataSource.data;
        for (let i = 0; i < rows.length; i++) {
            if (rows[i].changed && !rows[i].STSERVICO) {
                MessageService.showMessageByCode("ATE01500_CLASSE_CANCELADA");
                return false;
            } else if (rows[i].changed && (rows[i].IDCLASSE == '2' || rows[i].IDCLASSE == '3' || rows[i].IDCLASSE == '5')) {
                MessageService.showMessageByCode("ATE01500_ALT_PREV_CLASSE_BLOQ");
                return false;
            }
        }
        return true;
    };

    function saveClassePassageirosExcedentes(widget, dataSave) {
        MessageService.confirmMessageByCode("ATE01500_CONFIRM_QTPAX_EXTRAPOLA").then(
            function(sim) {
                InflightorGeneral.callRestEngine('ate#/saveClassOnManutencaoPlanoVoo', 'DataSet', dataSave).then(
                    function(success) {
                        widget.list();
                        widget.activate();
                        widget.reload();
                    },
                    function(error) {
                        if (error.data)
                            trataMensagem(error.data.error);
                        else {
                            MessageService.showMessageByCode("ERRO_INESPERADO");
                            console.log(error);
                        }
                    }
                );
            }).catch(function(nao) {
            widget.list();
            widget.activate();
            widget.reload();
        });
    }

    this.savePrevPax = function(widget) {
        if (widget.isValid()) {
            InflightorGeneral.setFloatAttrOnCurrentRow(widget.currentRow, 'QTTOTPAXAT');
            InflightorGeneral.setFloatAttrOnCurrentRow(widget.currentRow, 'QTPAXSBY');
            widget.currentRow.QTTOTPAXAN = 0;
            widget.currentRow.CDOPERADOR = localStorageEngine.getLocalVar('INFLIGHTOR_CDOPERADOR');
            widget.currentRow.CDUSRRESPPP = localStorageEngine.getLocalVar('INFLIGHTOR_CDOPERADOR');
            widget.currentRow.ignoreMaxPax = false;
            InflightorGeneral.callRestEngine('ate#/saveClassOnManutencaoPlanoVoo', 'DataSet', [widget.currentRow]).then(
                function(success) {
                    let response = success.dataset.previsaopaxm;
                    if (response.length) {
                        MessageService.confirmMessageByCode("ATE01500_CONFIRM_QTPAX_EXTRAPOLA_CLASSE").then(
                            function(sim) {
                                InflightorGeneral.callRestEngine('ate#/saveClassOnManutencaoPlanoVoo', 'DataSet', response).then(
                                    function(success) {
                                        self.closeSonWidgetPrevPax(widget);
                                        widget.container.getWidget('previsaodepax').reload();
                                    }.bind(this),
                                    function(error) {
                                        if (error.data)
                                            trataMensagem(error.data.error);
                                        else {
                                            MessageService.showMessageByCode("ERRO_INESPERADO");
                                            console.log(error);
                                        }
                                    }
                                );
                            }).catch(function(nao) {
                            self.closeSonWidgetPrevPax(widget);
                            widget.container.getWidget('previsaodepax').reload();
                        });
                    } else {
                        self.closeSonWidgetPrevPax(widget);
                        widget.container.getWidget('previsaodepax').reload();
                    }
                }.bind(this),
                function(error) {
                    if (error.data)
                        trataMensagem(error.data.error);
                    else {
                        MessageService.showMessageByCode("ERRO_INESPERADO");
                        console.log(error);
                    }
                }
            );
        } else {
            MessageService.showMessageByCode("CAMPOSOBRIGATORIOS");
        }
    };

    this.salvarManutencao = function(widget) {
        if (this.validDate(widget.container.getWidget('previsaodepax')) && widget.isValid()) {
            if ((widget.bkpRow.CDEQUIP != widget.currentRow.CDEQUIP) ||
                (widget.bkpRow.SGPREFIXO != widget.currentRow.SGPREFIXO)) {
                self.salvarManutencaoAlterado(widget);
            } else {
                widget.currentRow.ATUALIZAR = false;
                saveManutencao(widget);
            }
        }
    };

    function saveManutencao(widget) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let filtro = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;
        widget.currentRow.__is_new = false;
        widget.currentRow.CDCIA = filtro.CDCIA;
        widget.currentRow.CDFILIAL = filtro.CDFILIAL;
        widget.currentRow.NRVOO = filtro.NRVOO;
        widget.currentRow.CDTRECHO = filtro.CDTRECHO;
        widget.currentRow.DTHRPLAVOOPV = filtro.DTHRPLAVOOPV;
        InflightorGeneral.callRestEngine('ate#/ate01500_manutencao_planovoo', 'Row', widget.currentRow).then(
            function(success) {
                self.backToSaveManutencao(widget);
            },
            function(error) {
                if (error.data)
                    trataMensagem(error.data.error);
                else {
                    MessageService.showMessageByCode("ERRO_INESPERADO");
                    console.log(error);
                }
            }
        );
    }

    this.salvarManutencaoAlterado = function(widget) {
        let msg = "ATE01500_COFIG_NOVO_EQUIP_OU_MANTER";

        self.confirmMessageAlteracao(msg, "question",
            function(success) {
                if (success == 'atualizar') {
                    widget.currentRow.ATUALIZAR = true;
                    saveManutencao(widget);
                    // promises.push(InflightorGeneral.callRestEngine('ate#/crud/planovoom/save', 'Row', widget.currentRow));
                } else if (success == 'manter') {
                    // Apenas salva as modificações feitas
                    widget.currentRow.ATUALIZAR = false;
                    saveManutencao(widget);
                    // InflightorGeneral.callRestEngine('ate#/crud/planovoom/save', 'Row', widget.currentRow)
                }
            },
            function(cancelar) {
                // Aborta operação e volta para a tela
            });
    };

    this.cancelManutencaoPlanoVoo = function(widget) {
        this.backToSaveManutencao(widget);
    };

    this.backToSaveManutencao = function(widget) {
        widget.getParent().widgets[0].enabled = true;
        widget.getParent().widgets[1].enabled = true;
        widget.getParent().widgets[3].enabled = true;
        widget.container.showMenu = true;
        widget.template = "widget/form-view.html";
        widget.view();
        widget.activate();
        self.setCurrentRowManutPlanoVoo(widget);
    };

    this.editManutencaoVoo = function(widget) {
        if (this.validDate(widget.container.getWidget('previsaodepax')) && (widget.currentRow)) {
            widget.bkpRow = angular.copy(widget.currentRow);

            widget.getParent().widgets[0].enabled = false;
            widget.getParent().widgets[1].enabled = false;
            widget.getParent().widgets[3].enabled = false;

            widget.template = "widget/form.html";
            InflightorGeneral.edit(widget);
            widget.edit();
            widget.container.showMenu = false;
        }
    };

    this.confirmMessageAlteracao = function(message, type, success, fail, icon, variables) {
        icon = icon ? icon : self.getIconFromTypeAlteracao(type, 'question');
        MessageService.getMessagesByCode([message, "ATE01500_ATUALIZAR", "ATE01500_MANTER", "ATE01500_CANCELAR"]).then(function(mensagens) {
            ScreenService.showCustomDialog(mensagens[0], type, icon, [{
                    label: mensagens[1],
                    "default": true,
                    code: function(e, deferred) {
                        if (Util.isFunction(success)) {
                            success('atualizar');
                        }
                        deferred.resolve(e);
                    }
            }, {
                    label: mensagens[2],
                    code: function(e, deferred) {
                        if (Util.isFunction(success)) {
                            success('manter');
                        }
                        deferred.resolve(e);
                    }
            }, {
                    label: mensagens[3],
                    code: function(e, deferred) {
                        if (Util.isFunction(fail)) {
                            fail(e);
                        }
                        deferred.reject(e);
                    }
            }
            ], variables);
        });
    };

    this.getIconFromTypeAlteracao = function(type, defaultIcon) {
        let icon = defaultIcon;
        if (type) {
            switch (type.toUpperCase()) {
                case 'ERROR':
                case 'E':
                    icon = 'error';
                    break;
                case 'ALERT':
                case 'W':
                    icon = 'exclamation';
                    break;
                case 'INFORMATION':
                    icon = 'information';
                    break;
                case 'CONFIRMATION':
                    icon = 'question';
                    break;
                case 'SUCCESS':
                case 'M':
                    icon = 'checked';
                    break;
            }
        }
        return icon;
    };

    this.regerarPlanoVoo = function(widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget)) {
            let row = widget.appliedFilter.FILTER_ROW;
            let rowProcedure = {
                CDFILIAL: row.CDFILIAL,
                CDCIA: row.CDCIA,
                NRVOO: row.NRVOO,
                CDTRECHO: row.CDTRECHO,
                CDCLASSE: 'TODA',
                DTHRPLAVOOPV: row.DTHRPLAVOOPV
            };

            MessageService.confirmMessageByCode("ATE01500_CONFIRM_REGER_PLANOVOO").then(
                function(success) {
                    AlteracaoPlanoDeVooService.inclui_classe_voom(rowProcedure).then(function(success) {
                            widget.reload();
                            MessageService.showMessageByCode("ATE01500_PLANOVOO_REGERADO");
                        },
                        function(error) {
                            if (error.data)
                                trataMensagem(error.data.error);
                            else {
                                MessageService.showMessageByCode("ERRO_INESPERADO");
                                console.log(error);
                            }
                        });
                },
                function(error) {}
            );
        }
    };

    this.excluirPlanoVoo = function(widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget)) {

            let row = widget.appliedFilter.FILTER_ROW;
            let rowProcedure = {
                CDFILIAL: row.CDFILIAL,
                CDCIA: row.CDCIA,
                NRVOO: row.NRVOO,
                CDTRECHO: row.CDTRECHO,
                DTHRPLAVOOPV: row.DTHRPLAVOOPV
            };

            MessageService.confirmMessageByCode("ATE01500_CONFIRM_EXCL_PLANO_VOO").then(
                function(succes) {
                    AlteracaoPlanoDeVooService.exclui_planovoom(rowProcedure).then(function(success) {
                            MessageService.showMessageByCode("ATE01500_PLANOVOO_EXCLUIDO");
                            widget.appliedFilter.FILTER_ROW.CDCIA = undefined;
                            widget.appliedFilter.FILTER_ROW.NMCIA = undefined;
                            widget.appliedFilter.FILTER_ROW.NRVOO = undefined;
                            widget.appliedFilter.FILTER_ROW.DSTRECHO = undefined;
                            //widget.reload();
                            ZhFilterPreferences.openFilterWidget(widget);
                            widget.reload();
                        },
                        function(error) {
                            if (error.data)
                                trataMensagem(error.data.error);
                            else {
                                MessageService.showMessageByCode("ERRO_INESPERADO");
                                console.log(error);
                            }
                        });
                },
                function(error) {}
            );
        }
    };

    this.deleteClasse = function(widget) {
        if (this.validDate(widget)) {
            let deleteData = widget.getCheckedRows();
            MessageService.confirmMessageByCode("ATE01500_CONFIRM_EXCL_CLASSES").then(
                function(success) {
                    InflightorGeneral.callRestEngine('ate#/ate01500_delete_classe', 'DataSet', deleteData).then(
                        function(success) {
                            widget.unSelectAll();
                            widget.reload();
                        },
                        function(error) {
                            if (error.data)
                                trataMensagem(error.data.error);
                            else {
                                MessageService.showMessageByCode("ERRO_INESPERADO");
                                console.log(error);
                            }
                        }
                    );
                }
            );
        }
    };

    this.cancelarClasse = function(widget) {
        if (this.validDate(widget)) {
            let deleteData = widget.getCheckedRows();
            MessageService.confirmMessageByCode("ATE01500_CONFIRM_CANCEL_CLASSES").then(
                function(success) {
                    if (validaClasse(widget)) {
                        InflightorGeneral.callRestEngine('ate#/ate01500_cancel_classe', 'DataSet', deleteData).then(
                            function(success) {
                                widget.unSelectAll();
                                widget.reload();
                            },
                            function(error) {
                                if (error.data)
                                    trataMensagem(error.data.error);
                                else {
                                    MessageService.showMessageByCode("ERRO_INESPERADO");
                                    console.log(error);
                                }
                            }
                        );
                    }
                }
            );
        }
    };

    this.mudaPrefEquip = function(field) {
        let pref = field.value();
    };

    this.validaHorarios = function(field) {
        let um = field.value().substring(0, 2);
        let dois = field.value().substring(2, 4);

        if ((um < 0) || (um > 23) || (dois < 0) || (dois > 59)) {
            MessageService.showMessageByCode("ATE01500_HORARIO_INVALIDO");
            field.setValue(undefined);
        }
    };

    this.cancelarVoo = function(widget, tipooper) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (this.validDate(widget.container.getWidget('previsaodepax'))) {
            let filtro = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;
            let row = {
                CDCIA: filtro.CDCIA,
                CDFILIAL: filtro.CDFILIAL,
                NRVOO: filtro.NRVOO,
                CDTRECHO: filtro.CDTRECHO,
                DTHRPLAVOOPV: filtro.DTHRPLAVOOPV,
                TIPOOPER: tipooper
            };

            MessageService.confirmMessageByCode("ATE01500_CONFIRM_CANCEL_PLANOVOO").then(
                function(success) {
                    AlteracaoPlanoDeVooService.cancela_plano_voom(row).then(function(success) {
                        if (tipooper == 1) {
                            MessageService.showMessageByCode("ATE01500_PLANOVOO_CANCELADO");
                        } else if (tipooper == 2) {
                            MessageService.showMessageByCode("ATE01500_PLANOVOO_CANCELADO");
                        }
                        widget.reload();
                    }, function(error) {
                        if (error.data)
                            trataMensagem(error.data.error);
                        else {
                            MessageService.showMessageByCode("ERRO_INESPERADO");
                            console.log(error);
                        }
                    });
                }
            );
        }
    };

    function convertData(row) {
        row.QTSESOLICSP = row.QTSESOLICSP ? InflightorGeneral.valueToFloat(row.QTSESOLICSP) : 0;
        row.QTSESBYPRSP = row.QTSESBYPRSP ? InflightorGeneral.valueToFloat(row.QTSESBYPRSP) : 0;
        row.QTCORTSERVSP = row.QTCORTSERVSP ? InflightorGeneral.valueToFloat(row.QTCORTSERVSP) : 0;
        row.QTSERVFIXSP = row.QTSERVFIXSP ? InflightorGeneral.valueToFloat(row.QTSERVFIXSP) : 0;
        row.QTREALPROD = row.QTATUAPRODSP;
        row.VRPESOSESP = row.VRPESOSE || 0;
        row.IDTPPRECOSP = row.IDTPPRECO;
        row.IDINDICE = 'N';

        switch (row.IDTIPSCBOSP) {
            case '2':
                row.QTSERVFIXSP = 0;
                row.VRLOADSESP = 100;
                row.NRPROPAXSP = InflightorGeneral.valueToFloat(row.NRPROPAXSP);
                break;
            case '4':
                row.QTSERVFIXSP = 0;
                row.VRLOADSESP = InflightorGeneral.valueToFloat(row.VRLOADSESP);
                row.NRPROPAXSP = 1;
                break;
            default:
                row.VRLOADSESP = 100;
                row.NRPROPAXSP = 1;
                break;
        }
    }

    function validaItensAlterados(dataWidget) {
        let itens = angular.copy(dataWidget);
        let errorReturn = [];
        let dataReturn = [];
        let noError = true;
        for (let item in itens) {
            let row = itens[item];
            if (row.changed) {
                if (row.IDTIPSCBOSP == 5 && !row.QTSERVFIXSP && !row.QTSESBYPRSP) {
                    let msg = row.DSSERVICOCIAFILI;
                    errorReturn.push(msg);
                } else if (noError) {
                    convertData(row);
                    dataReturn.push(row);
                }
            }
        }
        return {
            error: errorReturn,
            data: dataReturn
        };
    }

    function isExcecao(currentRow) {
        if (currentRow.IDEXCECAO)
            return -1 != currentRow.IDEXCECAO.indexOf('S');
    }

    this.saveItemOnSwipe = function(widget) {
        if (widget.currentRow.IDTIPSCBOSP == 5 && !widget.currentRow.QTSERVFIXSP && !widget.currentRow.QTSESBYPRSP) {
            MessageService.showMessageByCode("ATE01500_QTFIXA_STBY_VAZIA_SERV", {
                "0": widget.currentRow.DSSERVICOCIAFILI
            });
        } else if (widget.isValid()) {
            //Validação se o item foi uma exceção quando incluído. Se sim, a observação é obrigatória e não pode ser apagada (validação apenas para UPDATE).
            if (isExcecao(widget.currentRow)) {
                if (!widget.currentRow.TXOBSUSRSP) {
                    MessageService.showMessageByCode("ATE01500_ITEM_INS_COM_EXCECAO");
                    return 0;
                }
            }
            if (widget.currentRow.__is_new) {
                if (!mountNewRow(widget)) {
                    return 0;
                }
            } else {
                convertData(widget.currentRow);
            }
            saveItensFaturamento(widget, [widget.currentRow], false);
        } else
            MessageService.showMessageByCode("CAMPOSOBRIGATORIOS");
    };

    function mountNewRow(widget) {
        if (!widget.container.getWidget('previsaodepax').appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }

        let filterRow = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;

        let row = widget.currentRow;

        //Determina se o item é uma exceção ou não
        let cicloPermitido = (row.CICLO_VIGENTE === row.IDCICLO || row.CICLO_UNICO === 'S' || row.EXCECAO_FREQUENCIA === 'S');
        let estaNaConfiguracao = (row.EXISTE_NA_CONFIGURACAO === 'S');
        let justificativaVazia = (!row.TXOBSUSRSP);
        row.IDEXCECAO = 'N';

        if (!estaNaConfiguracao) {
            if (justificativaVazia) {
                MessageService.showMessageByCode("ATE01500_ITEM_INS_N_CONFIGVOO");
                return 0;
            } else {
                row.IDEXCECAO = 'S';
            }
        } else {
            if (!cicloPermitido) {
                if (justificativaVazia) {
                    MessageService.showMessageByCode("ATE01500_ITEM_INS_CICLO_N_VIGENTE");
                    return 0;
                } else {
                    row.IDEXCECAO = 'S';
                }
            }
        }

        row.NRVOO = filterRow.NRVOO;
        row.CDTRECHO = filterRow.CDTRECHO;
        row.CDAGRDEDE = row.CDCLASSE;
        row.IDTIPMANUALSP = row.IDTIPMANUAL;
        row.DTHRPLAVOOPV = filterRow.DTHRPLAVOOPV;
        row.IDFATSESP = row.IDFATSE;
        row.CDUSRRESPSP = localStorageEngine.getLocalVar('INFLIGHTOR_CDOPERADOR');
        row.IDSITSERSP = "1";
        row.IDSTKDTSP = "1";
        row.QTANTAPRODSP = 0;
        row.IDSEREXTSP = "1";
        row.IDTPMANUTSP = "1A";
        row.DTHRINCSESP = moment().format("DD/MM/YYYY HH:mm:ss");

        convertData(row);

        return true;

    }

    this.saveInlineItensFaturamento = function(widget) {
        if (widget.currentRow.QTSERFATSP == "" || widget.currentRow.QTSERFATSP == null || widget.currentRow.QTSERFATSP == undefined || isNaN(parseInt(widget.currentRow.QTSERFATSP))) {
            widget.currentRow.QTSERFATSP = 0;
        }
        if (widget.currentRow.QTSERVFIXSP == "" || widget.currentRow.QTSERVFIXSP == null || widget.currentRow.QTSERVFIXSP == undefined || isNaN(parseInt(widget.currentRow.QTSERVFIXSP))) {
            widget.currentRow.QTSERVFIXSP_inline = 0;
            widget.currentRow.QTSERVFIXSP = 0;
        }
        if (widget.currentRow.QTSESOLICSP == "" || widget.currentRow.QTSESOLICSP == null || widget.currentRow.QTSESOLICSP == undefined || isNaN(parseInt(widget.currentRow.QTSESOLICSP))) {
            widget.currentRow.QTSESOLICSP = 0;
        }
        if (widget.currentRow.QTSESBYPRSP == "" || widget.currentRow.QTSESBYPRSP == null || widget.currentRow.QTSESBYPRSP == undefined || isNaN(parseInt(widget.currentRow.QTSESBYPRSP))) {
            widget.currentRow.QTSESBYPRSP_inline = 0;
            widget.currentRow.QTSESBYPRSP = 0;
        }
        if (widget.currentRow.QTCORTSERVSP == "" || widget.currentRow.QTCORTSERVSP == null || widget.currentRow.QTCORTSERVSP == undefined || isNaN(parseInt(widget.currentRow.QTCORTSERVSP))) {
            widget.currentRow.QTCORTSERVSP = 0;
        }

        if (widget.isMasterDetailPopup) {
            this.changeQtproduzirSwipeOpen(widget.currentRow, changeQtproduzirNeedsRecalc);
            this.changeQtfaturarSwipeOpen(widget.currentRow, changeQtfaturarNeedsRecalc);
            changeQtproduzirNeedsRecalc = true;
            changeQtfaturarNeedsRecalc = true;
            this.saveItemOnSwipe(widget);
        } else {
            if (this.validDate(widget.container.getWidget('previsaodepax'))) {
                let changedItens = validaItensAlterados(widget.dataSource.data);
                if (changedItens.error.length) {
                    MessageService.getMessageByCode("ATE01500_QTFIXA_STBY_VAZIA_SERV").then(function(msg) {
                        for (let i = 0; i < changedItens.error.length; i++) {
                            changedItens.error[i] = ScreenService.i18n(msg, {
                                "0": changedItens.error[i]
                            });
                        }
                        if (changedItens.error.length > 1)
                            InflightorGeneral.showErrorMessages(widget, changedItens.error);
                        else
                            ScreenService.showMessage(changedItens.error[0]);
                    });

                } else {
                    this.changeQtproduzir(widget.currentRow, changeQtproduzirNeedsRecalc);
                    this.changeQtfaturar(widget.currentRow, changeQtfaturarNeedsRecalc);
                    changeQtproduzirNeedsRecalc = true;
                    changeQtfaturarNeedsRecalc = true;
                    saveItensFaturamento(widget, changedItens.data, true);
                }
            } else {
                this.cancelInlineEdit(widget);
            }
        }
    };

    function saveItensFaturamento(widget, dataSave, useInlineEdit) {
        InflightorGeneral.callRestEngine('ate#/ate01500_save_itens_faturamento', 'DataSet', dataSave).then(
            function(success) {
                if (useInlineEdit) {
                    widget.list();
                } else {
                    if (widget.currentRow.__is_new) {
                        widget.list();
                        ScreenService.goBack();
                    } else {
                        widget.view();
                    }
                }
                widget.reload();
            },
            function(error) {
                if (error.data) {
                    if (error.data.error && error.data.error.indexOf("ORA-20501") !== -1) {
                        MessageService.showMessageByCode("ATE01500_N_HA_AGRUP_DEL_CLASSE");
                    } else
                        trataMensagem(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERRO_INESPERADO");
                    console.log(error);
                }
            }
        );
    }

    this.changeQtproduzirSwipeOpen = function(currentRow, shouldRecalc = true) {
        if (shouldRecalc) {
            let qtSolcitada = currentRow.QTSESOLICSP ? InflightorGeneral.valueToFloat(currentRow.QTSESOLICSP) : 0;
            let qtFixa = currentRow.QTSERVFIXSP ? InflightorGeneral.valueToFloat(currentRow.QTSERVFIXSP) : 0;
            let qtSby = currentRow.QTSESBYPRSP ? InflightorGeneral.valueToFloat(currentRow.QTSESBYPRSP) : 0;
            let qtCortesia = currentRow.QTCORTSERVSP ? InflightorGeneral.valueToFloat(currentRow.QTCORTSERVSP) : 0;
            currentRow.QTATUAPRODSP = qtSolcitada + qtFixa + qtSby + qtCortesia;
        }
    };

    this.changeQtproduzir = function(currentRow, shouldRecalc = true) {
        if (shouldRecalc) {
            let qtSolcitada = currentRow.QTSESOLICSP ? InflightorGeneral.valueToFloat(currentRow.QTSESOLICSP) : 0;
            let qtFixa = currentRow.QTSERVFIXSP ? InflightorGeneral.valueToFloat(currentRow.QTSERVFIXSP) : 0;
            let qtSby = currentRow.QTSESBYPRSP ? InflightorGeneral.valueToFloat(currentRow.QTSESBYPRSP) : 0;
            let qtCortesia = currentRow.QTCORTSERVSP ? InflightorGeneral.valueToFloat(currentRow.QTCORTSERVSP) : 0;
            if (currentRow.changed_QTATUAPRODSP == undefined) {
                currentRow.changed_QTATUAPRODSP = angular.copy(currentRow.QTATUAPRODSP);
            }
            currentRow.QTATUAPRODSP = qtSolcitada + qtFixa + qtSby + qtCortesia;
        }
    };

    this.changeQtfaturarSwipeOpen = function(currentRow, shouldRecalc = true) {
        if (shouldRecalc) {
            let qtSolcitada = currentRow.QTSESOLICSP ? InflightorGeneral.valueToFloat(currentRow.QTSESOLICSP) : 0;
            let qtFixa = currentRow.QTSERVFIXSP ? InflightorGeneral.valueToFloat(currentRow.QTSERVFIXSP) : 0;

            currentRow.QTSERFATSP = qtSolcitada + qtFixa;
        }
    };

    this.changeQtfaturar = function(currentRow, shouldRecalc = true) {
        if (shouldRecalc) {
            let qtSolcitada = currentRow.QTSESOLICSP ? InflightorGeneral.valueToFloat(currentRow.QTSESOLICSP) : 0;
            let qtFixa = currentRow.QTSERVFIXSP ? InflightorGeneral.valueToFloat(currentRow.QTSERVFIXSP) : 0;

            currentRow.changed_QTSERFATSP = currentRow.QTSERFATSP;
            currentRow.QTSERFATSP = qtSolcitada + qtFixa;
        }
    };

    this.cancelInlineEdit = function(widget) {
        if (widget.isMasterDetailPopup) {
            if (widget.currentRow.__is_new) {
                widget.dataSource.data.pop();
                widget.currentRow = {};
                //widget.getField('IDTIPSCBOSP').readOnly = true;
                ScreenService.closeSwipe().then(
                    function() {
                        widget.list(true);
                    }
                );
            } else {
                widget.currentRow = angular.copy(widget.backupRow);
                this.visualizeProporcao(widget);
                widget.view();
                widget.activate();
            }
        } else {
            let data = widget.dataSource.data;
            for (let index in data) {
                if (data[index].changed) {
                    data[index].QTATUAPRODSP = data[index].changed_QTATUAPRODSP || data[index].QTATUAPRODSP;
                    data[index].QTATUAPROD = data[index].changed_QTATUAPROD || data[index].QTATUAPROD;
                }
            }
            widget.rollbackInlineEdit();
            widget.list();
        }
    };

    this.fieldOnChangeQuantidades = function(field) {
        let widget = field.widget;
        if (widget.isMasterDetailPopup) {
            this.changeQtproduzirSwipeOpen(widget.currentRow);
            if (field.name == 'QTSERVFIXSP' || field.name == 'QTSESOLICSP') {
                this.changeQtfaturarSwipeOpen(widget.currentRow);
            }
        } else {
            this.changeQtproduzir(widget.currentRow);
            if (field.name == 'QTSESOLICSP' || field.name == 'QTSERVFIXSP') {
                this.changeQtfaturar(widget.currentRow);
            }
        }
    };

    this.validRowItem = function(currentRow, fieldName) {
        if (currentRow.IDSITSERSP == '2' || currentRow.IDSITSERSP == '3') {
            MessageService.getMessagesByCode(['ATE01500_EMITIDO', 'ATE01500_CANCELADO']).then(function(mensagens) {
                let msg = {
                    '2': mensagens[0],
                    '3': mensagens[1]
                };
                MessageService.showMessageByCode("ATE01500_EDIT_SERV_CANCEL_OR_EMIT", {
                    "0": msg[currentRow.IDSITSERSP]
                });
                currentRow.changed = false;
                currentRow[fieldName] = currentRow['changed_' + fieldName] == undefined ? currentRow[fieldName] : angular.copy(currentRow['changed_' + fieldName]);
            });
        }
    };

    this.setCurrentRowManutPlanoVoo = function(widget) {
        widget.reload([], false).then(function() {
            if (widget.dataSource.data && widget.dataSource.data.length)
                widget.setCurrentRow(widget.dataSource.data[0]);
        });
    };

    this.getAgrupamentoDelManutencao = function() {
        let widget = templateManager.container.getWidget("previsaodepax");
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let filter = widget.appliedFilter.FILTER_ROW;
        let row = {};
        row.CDFILIAL = filter.CDFILIAL;
        row.CDCIA = filter.CDCIA;
        row.NRVOO = filter.NRVOO;
        row.CDTRECHO = filter.CDTRECHO;
        row.DTHRPLAVOOPV = filter.DTHRPLAVOOPV;

        InflightorGeneral.callRestEngine('ate#/getAgrupamentoDelManutencao', "Row", row).then(function(success) {
                let wid = templateManager.container.getWidget("emissao_delivery_agrupamento_plavoo");
                wid.dataSource.data = success.dataset.getAgrupamentoDelManutencao;
            },
            function(error) {

            });
    };

    this.setTotalDelFooter = function() {
        let widget = templateManager.container.getWidget("emissao_delivery_agrupamento_plavoo");
        let stripeFooter = templateManager.container.getWidget("stripefooter_totais_plavoo");
        if (widget.currentRow) {
            stripeFooter.currentRow.VRTXAEROR = widget.currentRow.VRTXAEROR;
            stripeFooter.currentRow.TOTALSERV = widget.currentRow.TOTALSERV;
            stripeFooter.currentRow.TOTALDELIVERY = widget.currentRow.TOTALDEL;

            let widgetServAgrDel = templateManager.container.getWidget("emissao_delivery_servicos_plavoo");
            let filter = [
                {
                    "name": "CDAGRDECO",
                    "operator": "=",
                    "value": widget.currentRow.CDAGRDECO
    			},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": widget.currentRow.CDCIA
    			},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": widget.currentRow.NRVOO
    			},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": widget.currentRow.CDTRECHO
    			},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": widget.currentRow.DTHRPLAVOOPV
    			},
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
    			}
    		];

            widgetServAgrDel.dataSourceFilter = filter;
        }
    };

    this.calcDelivery = function(cdfilial, cdcia, nrvoo, cdtrecho, dtplanovoo) {
        let row = {};
        row.CDFILIAL = cdfilial;
        row.CDCIA = cdcia;
        row.NRVOO = nrvoo;
        row.CDTRECHO = cdtrecho;
        row.DTHRPLAVOOPV = dtplanovoo;

        let stripeFooter = templateManager.container.getWidget("stripefooter_totais_plavoo");
        let widget = templateManager.container.getWidget("emissao_delivery_agrupamento_plavoo");

        EmissaoDeliveryService.calculaDeliverym(row, 1).then(
            function(success) {
                let result = success.dataset.calcula_delivery[0];

                widget.currentRow.VRDESCDESV = result.VRDESCDESV;
                widget.currentRow.DESCDESV = result.PEDESCDESV;
                widget.currentRow.VRDESCFIXO = result.VRDESCFIXO;
                widget.currentRow.DESCFIXO = result.PEDESCFIXO;
                widget.currentRow.VRDESCCOND = result.VRDESCCOND;
                widget.currentRow.DESCCOND = result.PEDESCCOND;
                widget.currentRow.VRTOTDESC = result.VRTOTDESC;
                widget.currentRow.VRUTIDESC = result.VRUTIDESC;
                stripeFooter.currentRow.VRTXAEROR = result.VRTAXA;
                stripeFooter.currentRow.TOTALSERV = result.TOTALGERALSERV;

                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRTAXA");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "DESCNOTA");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "DESCSERV");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRDESCDESV");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRDESCFIXO");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRDESCCOND");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "PEDESCDESV");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "PEDESCFIXO");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "PEDESCCOND");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "TOTALGERALSERV");

                // widget.currentRow.VRDESCCOND = result["VRTOTDESC"] - result["VRUTIDESC"];
                let totalDelivery = ((result.TOTALGERALSERV + result.VRTAXA) - result.DESCNOTA - result.DESCSERV - result.VRDESCDESV - result.VRDESCFIXO - result.VRDESCCOND);
                totalDelivery = ("" + totalDelivery);
                totalDelivery = totalDelivery.substr(0, totalDelivery.indexOf(".") + 3);
                stripeFooter.currentRow.TOTALDELIVERY = totalDelivery;
                // stripeFooter.currentRow.TOTALSREV = totalDelivery;

                self.findObs(widget);
            },
            function(error) {
                self.findObs(widget);
            }
        ).catch(function(error) {
            ScreenService.showMessage(error.data.error, "error");

            widget.currentRow.VRDESCDESV = "0";
            widget.currentRow.DESCDESV = "0";
            widget.currentRow.VRDESCFIXO = "0";
            widget.currentRow.DESCFIXO = "0";
            widget.currentRow.VRDESCCOND = "0";
            widget.currentRow.DESCCOND = "0";
            widget.currentRow.VRTOTDESC = "0";
            widget.currentRow.VRUTIDESC = "0";

            stripeFooter.currentRow.VRTXAEROR = "0";
            stripeFooter.currentRow.TOTALSERV = "0";
            stripeFooter.currentRow.TOTALDELIVERY = "0";

            this.findObs(widget);
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('AlteracaoPlanoDeVooController', AlteracaoPlanoDeVooController);
});

// FILE: ./assets/js/controllers/ate00002_quantidade_passageiros_por_classe_controller.js
let ate00002_quantidade_passageiros_por_classe_controller = function(ScreenService, General, ZhFilterPreferences, templateManager, InflightorGeneral, MessageService) {

    this.abrePopupRelatorio = function(widget) {
        ScreenService.openPopup(widget.container.getWidget("formatoRelatorio"));
    };

    function getMainWidget() {
        return templateManager.container.getWidget('quantidadepassageirosporclasse');
    }

    this.gridFilterAfterApply = function(args) {
        const mainWidget = getMainWidget();
        let filterRow = mainWidget.appliedFilter.FILTER_ROW;
        filterRow.DSCLASSECIA = mainWidget.DSCLASSECIA_backup;
        mainWidget.DSCLASSECIA_backup = [];
        mainWidget._filterInfo = mainWidget._filterInfo.filter(f => f.label !== 'Classe');
    };

    this.gridFilterBeforeApply = function(args, widget) {
        const filterRow = args.e.preference.FILTER_ROW;
        if (!isValidDates(filterRow)) {
            args.e.preventDefault();
            MessageService.showMessageByCode("ATE00002_PERIODO_INVALIDO");
        }

        let classe = "";
        if (filterRow.DSCLASSECIA.length == 0) {
            filterRow.CDCLASSE = "T";
        } else {
            if (Array.isArray(filterRow.DSCLASSECIA)) {
                classe = filterRow.DSCLASSECIA.join('_');
                filterRow.CDCLASSE = classe;

            }
        }

        let CDCLASSEDataFilterReferenceArray = widget.dataSourceFilter.filter(condition => condition.name === 'CDCLASSE');
        let operator = (filterRow.DSCLASSECIA.length == 0) ? '=' : 'IN';
        let filterValue = (filterRow.DSCLASSECIA.length == 0) ? 'T' : classe;
        if (CDCLASSEDataFilterReferenceArray.length > 0) {
            CDCLASSEDataFilterReferenceArray[0].value = filterValue;
            CDCLASSEDataFilterReferenceArray[0].operator = operator;
        } else {

            widget.dataSourceFilter.push({
                "name": "CDCLASSE",
                "operator": operator,
                "value": filterValue
            });
        }

        widget.DSCLASSECIA_backup = filterRow.DSCLASSECIA;
        filterRow.DSCLASSECIA = [];
    };

    function isValidDates(currentRow) {
        let format = "DD/MM/YYYY";
        return moment(currentRow.DTINICIAL, format).isSameOrBefore(moment(currentRow.DTFINAL, format));
    }

    this.relatorio = function(widget, formato) {
        widget.currentRow.REPORTNAME = "ATE00002";
        widget.currentRow.REPORTFORMAT = formato;
        Object.assign(widget.currentRow, widget.appliedFilter.FILTER_ROW);
        if (widget.isValid()) {
            let row = ajustaRowParaRelatorio(widget.currentRow);
            if (moment(widget.currentRow.DTFINAL, "DD/MM/YYYY").isBefore(moment(widget.currentRow.DTINICIAL, "DD/MM/YYYY"))) {
                MessageService.showMessageByCode("ATE00002_PERIODO_INVALIDO");
            } else {
                General.openReport("ate#/relatorioquantidadepassageirosclasse", widget.currentRow.REPORTNAME, widget.currentRow).then(function(callback) {
                    ScreenService.closePopup();
                    widget.parent.activate();
                    widget.parent.reload();
                }, function(error) {
                    let errorMessage = "Timeout";
                    if (error.data)
                        errorMessage = error.data.error;
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
    };

    let ajustaRowParaRelatorio = function(row) {
        let newRow = angular.copy(row);

        if (row.DSCLASSECIA.length == 0) {
            newRow.CDCLASSE = "T";
        } else {
            newRow.CDCLASSE = "_" + row.DSCLASSECIA.join("_") + "_";
        }

        return newRow;
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register("ate00002_quantidade_passageiros_por_classe_controller", ate00002_quantidade_passageiros_por_classe_controller);
});

// FILE: ./assets/js/controllers/ate00003_simulacao_de_geracao_de_planos_de_voo_controller.js
let ate00003_simulacao_de_geracao_de_planos_de_voo_controller = function(General, ScreenService, templateManager, restEngine, localStorageEngine, MessageService) {

    this.aplicaDefaultValue = function(widget) {
        widget.newRow();
        widget.currentRow.CDFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_CDFILIAL");
        widget.currentRow.NMFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_NMFILIAL");
        this.aplicaFiltroOnEnter(widget, ["NMCIA", "NRVOO"]);
    };

    this.aplicaFiltroOnEnter = function(widget, fields) {
        let currentRow = widget.currentRow;
        let filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": currentRow.CDFILIAL
			}
		];
        for (let field in fields) {
            widget.getField(fields[field]).dataSourceFilter = filtro;
        }
    };

    this.montaFiltroDependente = function(field, colunas, camposDependentes) {
        let currentRow = field.widget.currentRow;
        if (currentRow[field.name] != "") {
            for (let coluna in colunas) {
                let filtro = {
                    "name": colunas[coluna],
                    "operator": "=",
                    "value": currentRow[colunas[coluna]]
                };
                for (let campo in camposDependentes) {
                    field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                        return condicao.name != colunas[coluna];
                    });
                    field.widget.getField(camposDependentes[campo]).value();
                    currentRow[camposDependentes[campo]] = null;
                    field.widget.getField(camposDependentes[campo]).dataSourceFilter.push(filtro);
                    field.widget.getField(camposDependentes[campo]).reload();
                }
            }
        } else {
            for (let coluna in colunas) {
                for (let campo in camposDependentes) {
                    field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                        return condicao.name != colunas[coluna];
                    });
                    field.widget.getField(camposDependentes[campo]).value();
                    currentRow[camposDependentes[campo]] = null;
                }
            }
        }
    };

    this.montaFiltroDependenteMultiselect = function(field, coluna, camposDependentes) {

        let campo;

        let currentRow = field.widget.currentRow;
        if (currentRow[field.name] != "T") {
            let filtro = {
                "name": coluna,
                "operator": "IN",
                "value": currentRow[field.name]
            };
            for (campo in camposDependentes) {
                field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                    return condicao.name != coluna;
                });
                field.widget.getField(camposDependentes[campo]).value();
                currentRow[camposDependentes[campo]] = null;
                field.widget.getField(camposDependentes[campo]).dataSourceFilter.push(filtro);
                field.widget.getField(camposDependentes[campo]).reload();
            }
        } else {
            for (campo in camposDependentes) {
                field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                    return condicao.name != coluna;
                });
                field.widget.getField(camposDependentes[campo]).value();
                currentRow[camposDependentes[campo]] = null;
                field.widget.getField(camposDependentes[campo]).reload();
            }
        }
    };

    this.montaFiltroCheck = function(field, coluna, camposDependentes) {

        let campo;

        let currentRow = field.widget.currentRow;
        if (currentRow[field.name] != "T") {
            for (campo in camposDependentes) {
                field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                    return condicao.name != coluna;
                });
                field.widget.getField(camposDependentes[campo]).value();
                currentRow[camposDependentes[campo]] = null;
            }
        } else {
            for (campo in camposDependentes) {
                field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                    return condicao.name != coluna;
                });
                field.widget.getField(camposDependentes[campo]).value();
                currentRow[camposDependentes[campo]] = null;
                field.widget.getField(camposDependentes[campo]).reload();
            }
        }
    };

    this.verificaFiltroVooTrecho = function(args, filtros) {

        let condicao;

        let field = args.owner.field;
        let currentRow = args.owner.field.widget.currentRow;
        let filtrosValidados = 0;
        for (condicao in field.dataSourceFilter) {
            if (validaFiltro(field.dataSourceFilter[condicao], filtros))
                filtrosValidados++;
        }
        if (filtrosValidados < 2) {
            if (filtrosValidados == 1 && currentRow.TNMCIA == "N") {
                MessageService.showMessageByCode("ALE_EMPTY_FIELDS_FLY");
                args.e.preventDefault();
            } else if (filtrosValidados < 1) {
                MessageService.showMessageByCode("ALE_EMPTY_FIELDS_FLY");
                args.e.preventDefault();
            }
        }
    };

    this.verificaFiltroCia = function(args, filtros) {

        let condicao;

        let field = args.owner.field;
        let currentRow = args.owner.field.widget.currentRow;
        let filtrosValidados = 0;
        for (condicao in field.dataSourceFilter) {
            if (validaFiltro(field.dataSourceFilter[condicao], filtros))
                filtrosValidados++;
        }
        if (filtrosValidados < 1) {
            ScreenService.showMessage("É necessário informar Unidade");
            args.e.preventDefault();
        }
    };

    let validaFiltro = function(condicao, filtros) {

        let filtro;

        for (filtro in filtros) {
            if (condicao.name == filtros[filtro] && condicao.value != "" && condicao.value.length > 0)
                return true;
        }
    };

    this.habilitaFieldData = function(field) {
        const widget = field.widget;
        const row = widget.currentRow;
        let {
            DTINICIAL,
            DTFINAL
        } = row;
        const fieldDtEnd = widget.getField('DTFINAL');
        habilitaFields(row, field, ["DTFINAL"], !!DTINICIAL);
        if (!isValidPeriod(DTINICIAL, DTFINAL) && DTINICIAL && DTFINAL) {
            fieldDtEnd.clearValue(fieldDtEnd);
        }
    };

    function isValidPeriod(DTINICIAL, DTFINAL) {
        return DTINICIAL && DTFINAL && !moment(DTFINAL, 'DD/MM/YYYY').isBefore(moment(DTINICIAL, 'DD/MM/YYYY'));
    }

    this.onChangeEndDate = function(field) {
        let {
            DTINICIAL,
            DTFINAL
        } = field.widget.currentRow;
        if (!isValidPeriod(DTINICIAL, DTFINAL) && DTINICIAL && DTFINAL) {
            field.clearValue(field);
            MessageService.showMessageByCode("ATE00002_PERIODO_INVALIDO");
        }
    };

    let habilitaFields = function(row, field, fieldsDependentes, habilita) {

        let filho;

        if (habilita) {
            for (filho in fieldsDependentes) {
                field.widget.getField(fieldsDependentes[filho]).readOnly = false;
            }
        } else {
            for (filho in fieldsDependentes) {
                field.widget.getField(fieldsDependentes[filho]).readOnly = true;
                field.widget.getField(fieldsDependentes[filho]).value("");
            }
        }
    };

    this.relatorio = function(widget, formato) {
        if (widget.isValid()) {
            let row = ajustaRowParaRelatorio(widget.currentRow, formato);
            if (moment(row.DTFINAL, "DD/MM/YYYY").isBefore(moment(row.DTINICIAL, "DD/MM/YYYY"))) {
                MessageService.showMessageByCode("ATE00002_PERIODO_INVALIDO");
            } else {
                General.openReport("ate#/simulacaogeracaoplanovoo", row.REPORTNAME, row).then(function(callback) {
                    ScreenService.closePopup();
                    widget.activate();
                    widget.reload();
                }, function(error) {
                    let errorMessage = "Timeout";
                    if (error.data)
                        errorMessage = error.data.error;
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
    };

    let ajustaRowParaRelatorio = function(row, formato) {

        let voo;

        let newRow = angular.copy(row);

        newRow.REPORTFORMAT = formato;

        if (row.TNMCIA == "T") {
            newRow.CDCIA = row.TNMCIA;
        } else {
            newRow.CDCIA = "_" + row.NMCIA.join("_") + "_";
        }

        if (row.TVOO == "T") {
            newRow.NRVOO = row.TVOO;
        } else {
            let newNRVOO = "";
            for (voo in newRow.NRVOO) {
                newRow.NRVOO[voo] = newRow.NRVOO[voo].CDCIA + "|" + newRow.NRVOO[voo].NRVOO + "|" + newRow.NRVOO[voo].CDTRECHO;
            }
            newRow.NRVOO = "_" + newRow.NRVOO.join("_") + "_";
        }

        return newRow;

    };

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate00003_simulacao_de_geracao_de_planos_de_voo_controller", ate00003_simulacao_de_geracao_de_planos_de_voo_controller);
});

// FILE: ./assets/js/controllers/ate00600_voo_periodoController.js
let ate00600_voo_periodoController = function(General, ScreenService, templateManager, localStorageEngine, MessageService) {

    let FILTROCLEAR = [
        {
            name: "NRORG",
            operator: "=",
            value: "-1"
		}
	];

    this.setFilialLogada = function(args) {
        args.owner.currentRow.CDFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_CDFILIAL");
        args.owner.currentRow.NMFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_NMFILIAL");
    };

    this.verificaPeriodo = function(field, args) {
        let dataInit = field.widget.container.getWidget("ate00600_voo_periodo").getField("DTINICIAL").value();
        let maxDate = moment(dataInit, "DD/MM/YYYY").add(19, "days");
        if (maxDate < moment(field.value(), "DD/MM/YYYY")) {
            MessageService.showMessageByCode("ALE_DEADLINE_20_DAYS");
            field.clearValue(field);
        } else if (moment(dataInit, "DD/MM/YYYY") > moment(field.value(), "DD/MM/YYYY")) {
            MessageService.showMessageByCode("ALE_LOWER_END_DATE");
            field.clearValue(field);
        }
    };

    this.limpaField = function(field) {

        if (field.name == "NMFILIAL") {
            field.widget.currentRow.NMCIA = "";
            field.widget.currentRow.NRVOO = "";
            field.widget.currentRow.DSCLASSECIA = "";
        }

        if (field.name == "NMCIA") {
            field.widget.currentRow.NRVOO = "";
            field.widget.currentRow.DSCLASSECIA = "";
        }

        if (field.name == "DTFINAL") {
            field.widget.currentRow.NRVOO = "";
        }
    };

    this.onChangeUnit = function(field) {

        let cdfilial = field.widget.currentRow.CDFILIAL;
        const fieldCia = field.widget.getField('NMCIA');
        let filterUnit = fieldCia.dataSourceFilter.find(filter => filter.name == 'CDFILIAL');

        if (filterUnit) {
            filterUnit.value = cdfilial;
        } else {
            fieldCia.dataSourceFilter.push({
                name: "CDFILIAL",
                operator: "=",
                value: cdfilial
            });
        }

    };

    this.filtraTrecho = function(field) {

        let msg;
        let cdfilial = field.widget.currentRow.CDFILIAL;
        let cdcia = field.widget.currentRow.CDCIA;

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": cdcia
			},
            {
                "name": "DTFIM",
                "operator": "=",
                "value": field.widget.currentRow.DTFINAL
			},
            {
                "name": "DTINICIO",
                "operator": "=",
                "value": field.widget.currentRow.DTINICIAL
			}
		];

        if (!field.widget.currentRow.CDCIA) {
            field.dataSourceFilter = FILTROCLEAR;
            field.reload();
            MessageService.showMessageByCode("ALE_FLIGHT_COMPANY");
            return;
        }

        if (!field.widget.currentRow.DTINICIAL || !field.widget.currentRow.DTFINAL) {
            field.dataSourceFilter = FILTROCLEAR;
            field.reload();
            MessageService.showMessageByCode("ALE_FLIGHT_PERIOD");
            return;
        }

        field.widget.getField("NRVOO").dataSourceFilter = filter;
        field.widget.getField("NRVOO").reload();
    };

    this.filtraClasse = function(field) {

        let msg;
        let cdfilial = field.widget.currentRow.CDFILIAL;
        let cdcia = field.widget.currentRow.CDCIA;

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
	        },
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": cdcia
			}
		];

        if (!field.widget.currentRow.CDCIA) {
            field.dataSourceFilter = FILTROCLEAR;
            field.reload();
            MessageService.showMessageByCode("ALE_SELECT_COMPANY");
            return;
        }

        field.widget.getField("DSCLASSECIA").dataSourceFilter = filter;
        field.widget.getField("DSCLASSECIA").reload();
    };

    let validaDias = function(widget) {

        let dataInicial = widget.currentRow.DTINICIAL;
        dataInicial = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").currentDate = widget.getField("DTINICIAL").currentDate;
        widget.getField("DTFINAL").maxDate = moment(dataInicial, "DD/MM/YYYY").add(19, "days");
        widget.getField("DTFINAL").minDate = moment(dataInicial, "DD/MM/YYYY");
    };

    this.habilitaFieldData = function(widget) {
        const fieldEndDate = widget.getField('DTFINAL');
        fieldEndDate.clearValue(fieldEndDate);
        widget.currentRow.NRVOO = "";
        widget.getField("DTFINAL").readOnly = true;
        widget.getField("DTFINAL").reload();

        if (widget.currentRow.DTINICIAL) {
            widget.getField("DTFINAL").readOnly = false;
            // validaDias(widget);
        }
    };

    this.report = function(widget) {

        if (widget.isValid()) {
            if (widget.currentRow.TNRVOO != "T") {
                let voo = listaVoo(widget.getField("NRVOO"));
                widget.currentRow.VOO = voo;
            } else {
                widget.currentRow.VOO = "T";
            }

            if (widget.currentRow.TCDCLASSE != "T") {
                let classe = listaClasse(widget.getField("DSCLASSECIA"));
                widget.currentRow.CDCLASSE = classe;
            } else {
                widget.currentRow.CDCLASSE = "T";
            }

            General.openReport("ate#/relatorioFaturamentoVooPeriodo", null, widget.currentRow).then(function(callback) {
                widget.activate();
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data)
                    errorMessage = error.data.error;
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    let listaVoo = function(field) {

        let lista = "";
        let rows = field.selectWidget.getCheckedRows();

        for (let i = 0; i < rows.length; i++) {
            if (lista == "") {
                lista = "_" + rows[i].CDVOOTRECHO + "_";
            } else {
                lista = lista + rows[i].CDVOOTRECHO + "_";
            }
        }
        return lista;
    };

    let listaTrecho = function(field) {

        let lista = "";
        let rows = field.selectWidget.getCheckedRows();

        for (let i = 0; i < rows.length; i++) {
            if (lista == "") {
                lista = rows[i].CDTRECHO;
            } else {
                lista = lista + "_" + rows[i].CDTRECHO;
            }
        }
        return lista;
    };

    let listaClasse = function(field) {

        let lista = "";
        let rows = field.selectWidget.getCheckedRows();

        for (let i = 0; i < rows.length; i++) {
            if (lista == "") {
                lista = rows[i].CDCLASSE;
            } else {
                lista = lista + "_" + rows[i].CDCLASSE;
            }
        }
        return lista;
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate00600_voo_periodoController", ate00600_voo_periodoController);
});

// FILE: ./assets/js/controllers/ate00900_configura_servico_vooController.js
function ate00900_configura_servico_vooController(InflightorGeneral, ate00900_configura_servico_vooService, templateManager, ScreenService, ZHPromise, ZhFilterPreferences, General, metaDataFactory, maskEngine, ZhUtil, localStorageEngine, MessageService) {

    /* global Constants */
    let self = this;
    let cdcia, nmfilial, nmcia, cdtrecho, dstrecho, sgequip, nrvoo, unidade, cdequip;

    function getWidget(widgetName) {
        return templateManager.container.getWidget(widgetName);
    }

    this.setStripe = function(widgetName, row) {
        getWidget(widgetName).currentRow = angular.copy(row);
    };

    this.filterOnEnter = function(args, tab) {
        let widgetServicos = getWidget("widgetVigencia");
        InflightorGeneral.openFilterOnEnter(widgetServicos, ['CDFILIAL', 'NMFILIAL']);
    };

    this.verificaStatus = function(widget) {
        const mainWidget = templateManager.container.getWidget('widgetVigencia');
        const filterRow = mainWidget.appliedFilter.FILTER_ROW;
        const CDFILIAL = filterRow.CDFILIAL;
        const CDCIA = filterRow.CDCIA;
        const fieldEquip = widget.getField('DSEQUIP');
        const filterUnit = fieldEquip.dataSourceFilter.find(filter => filter.name === 'CDFILIAL');
        const filterCia = fieldEquip.dataSourceFilter.find(filter => filter.name === 'CDCIA');
        filterUnit.value = CDFILIAL || '';
        filterCia.value = CDCIA || '';

        if (filterRow.IDATIVO == "S") {
            ScreenService.openPopup(widget).then(function(success) {
                widget.newRow();
                widget.activate();
            });
        } else {
            MessageService.showMessageByCode("ERR_INACTIVE_EQUIPMENT");
        }
    };

    this.filtraSubgrupos = function(widget) {
        const parentRow = widget.getParent().currentRow;
        let filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": parentRow.CDFILIAL
			},
            {
                "name": "NRSEQPRECO",
                "operator": "=",
                "value": parentRow.NRSEQPRECO
			},
            {
                "name": "NRTABPRECO",
                "operator": "=",
                "value": parentRow.NRTABPRECO
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": parentRow.CDCIA
			},
            {
                "name": "NRSERVICOCIAFILIPRECO",
                "operator": "=",
                "value": parentRow.NRSERVICOCIAFILI
			},
            {
                "name": "CDCLASSE",
                "operator": "=",
                "value": parentRow.CDCLASSE
			},
            {
                "name": "CDCICLO",
                "operator": "=",
                "value": parentRow.CDCICLO
			},
            {
                "name": "CDMANCIA",
                "operator": "=",
                "value": parentRow.CDMANCIA
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];

        widget.dataSourceFilter = filtro;
        widget.reload().then(function() {
            self.setStripeFooter(widget);
            widget.activate();
        });
    };
    //cria o filtro do grid composicao
    this.filtraComposicao = function(widget) {
        const parentRow = widget.getParent().currentRow;
        let filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": parentRow.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": parentRow.CDCIA
			},
            {
                "name": "CDMANCIA",
                "operator": "=",
                "value": parentRow.CDMANCIA
			},
            {
                "name": "NRSERVICOCIAFILI",
                "operator": "=",
                "value": parentRow.NRSERVICOCIAFILI
			},
            {
                "name": "CDCLASSE",
                "operator": "=",
                "value": parentRow.CDCLASSE
			},
            {
                "name": "CDCICLO",
                "operator": "=",
                "value": parentRow.CDCICLO
			},
            {
                "name": "CDSUBGRU",
                "operator": "=",
                "value": parentRow.CDSUBGRU
			},
            {
                "name": "NRSEQSUBGRUSEMAM",
                "operator": "=",
                "value": parentRow.NRSEQSUBGRUSEMAM
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];
        widget.dataSourceFilter = filtro;
        widget.reload();
    };

    this.filtraCiaFilter = function(widgetServicos) {
        if (!widgetServicos.currentRow.CDCIA) {
			[widgetServicos.getField("NMCIA"), widgetServicos.getField("NRVOO"), widgetServicos.getField("DSTRECHO"), widgetServicos.getField("SGCLASSE"), widgetServicos.getField("IDCICLO"), widgetServicos.getField("DSEQUIP")].forEach(function(field) {
                if (field) {
                    field.setValue("");
                    field.readOnly = true;
                }
            });
        } else {
        	[widgetServicos.getField("NMCIA"), widgetServicos.getField("NRVOO"), widgetServicos.getField("SGCLASSE"), widgetServicos.getField("IDCICLO"), widgetServicos.getField("DSEQUIP")].forEach(function(field) {
                if (field) {
                    field.setValue("");
                    field.readOnly = false;
                }
            });
        }
    };

    this.filtraFilhosUnidade = function(widgetServicos) {
        if (!widgetServicos.currentRow.CDFILIAL) {
            let fields = [widgetServicos.getField("NMCIA"), widgetServicos.getField("NRVOO"), widgetServicos.getField("DSTRECHO"), widgetServicos.getField("SGCLASSE"), widgetServicos.getField("IDCICLO")];
            fields.forEach(function(field, index) {
                if (field) {
                    field.setValue("");
                    field.readOnly = true;
                    if (index === 0) {
                        if (field.dataSourceFilter) {
                            let filter = field.dataSourceFilter.find(cFilter => cFilter.name == 'CDFILIAL');
                            if (filter) filter.value = '';
                        }
                    } else {
                        if (field.dataSourceFilter) {
                            let filter = field.dataSourceFilter.find(cFilter => cFilter.name == fields[index - 1].name);
                            if (filter) filter.value = '';
                        }
                    }
                }
            });
        } else {
        	[widgetServicos.getField("NMCIA"), widgetServicos.getField("NRVOO"), widgetServicos.getField("SGCLASSE"), widgetServicos.getField("IDCICLO")].forEach(function(field, index) {
                if (field) {
                    field.setValue("");
                    field.readOnly = false;
                    if (index == 0 && field.dataSourceFilter) {
                        let filter = field.dataSourceFilter.find(cFilter => cFilter.name == 'CDFILIAL');
                        filter.value = widgetServicos.currentRow.CDFILIAL;
                    }
                }
            });
        }
    };

    this.filtraFilhosCia = function(widgetServicos) {
        cdcia = widgetServicos.currentRow.CDCIA;
        nmcia = widgetServicos.currentRow.NMCIA;
        const fieldCia = widgetServicos.getField('NMCIA');
        if (isInactiveCia(widgetServicos.currentRow)) {
            MessageService.showMessageByCode("MSG_ATE_CIA_INATIVA");
            fieldCia.clearValue();
        }
        if (!widgetServicos.currentRow.CDCIA) {
			[widgetServicos.getField("NRVOO"), widgetServicos.getField("DSTRECHO"), widgetServicos.getField("SGCLASSE"), widgetServicos.getField("IDCICLO"), widgetServicos.getField("DSEQUIP")].forEach(function(field) {
                if (field) {
                    field.setValue("");
                    field.readOnly = true;
                }
            });
        } else {
        	[widgetServicos.getField("NRVOO"), widgetServicos.getField("SGCLASSE"), widgetServicos.getField("IDCICLO"), widgetServicos.getField("DSEQUIP")].forEach(function(field) {
                if (field) {
                    field.setValue("");
                    field.readOnly = false;
                }
            });

            let descricaoTrecho = widgetServicos.getField("DSTRECHO");

            if (Boolean(descricaoTrecho)) {
                descricaoTrecho.setValue("");
            }

        }
        this.setDataSourceFilterVoo(widgetServicos);
        this.filtraEquipamentoCia(widgetServicos);
    };

    this.alteraVooTrecho = function(widgetServicos) {
        if (widgetServicos.currentRow.CDTRECHO) {
            unidade = widgetServicos.currentRow.CDFILIAL;
            widgetServicos.currentRow.DSTRECHO = widgetServicos.currentRow.SGBASEORI + "-" + widgetServicos.currentRow.SGBASEDES;
            nrvoo = widgetServicos.currentRow.NRVOO;
            cdtrecho = widgetServicos.currentRow.CDTRECHO;
            dstrecho = widgetServicos.currentRow.DSTRECHO;
            sgequip = widgetServicos.currentRow.SGEQUIP;
            cdequip = widgetServicos.currentRow.CDEQUIP;
        } else widgetServicos.currentRow.DSTRECHO = "";
    };

    this.setStripeFooter = function(widgetServicos) {
        let ref = 0,
            misc = 0,
            hand = 0,
            fat = 0;
        let fieldRef = widgetServicos.widgets[0].getField("ref");
        let fieldMisc = widgetServicos.widgets[0].getField("misc");
        let fieldHand = widgetServicos.widgets[0].getField("hand");
        let fieldFat = widgetServicos.widgets[0].getField("fat");

        widgetServicos.dataSource.data.forEach(function(row) {
            if (row.IDSERVICO == 1) ref++;
            if (row.IDSERVICO == 2) misc++;
            if (row.IDSERVICO == 3) hand++;
            if (row.IDSERVICO == 4) fat++;
        });
        if (fieldRef)
            fieldRef.setValue(ref);
        if (fieldMisc)
            fieldMisc.setValue(misc);
        if (fieldHand)
            fieldHand.setValue(hand);
        if (fieldFat)
            fieldFat.setValue(fat);
    };

    this.adicionarServico = function(widget) {

        widget.newRow();
        widget.container.getWidget("grid_subgrupos").isVisible = false;
        widget.currentRow.CDFILIAL = unidade;
        widget.currentRow.CDCIA = cdcia;
        widget.currentRow.NMFILIAL = nmfilial;
        widget.currentRow.NMCIA = nmcia;
        widget.currentRow.NRVOO = nrvoo;
        widget.currentRow.CDTRECHO = cdtrecho;
        widget.currentRow.DSTRECHO = dstrecho;
        widget.currentRow.IDPROPORCAO = "1";
        widget.currentRow.SGEQUIP = sgequip;
        widget.currentRow.CDEQUIP = cdequip;

        widget.getField("DSSERVICOCIAFILIADD").dataSourceFilter = [{
                name: "CDFILIAL",
                operator: "=",
                value: widget.currentRow.CDFILIAL
		}, {
                name: "CDCIA",
                operator: "=",
                value: widget.currentRow.CDCIA
		}, {
                name: "NRVOO",
                operator: "=",
                value: widget.currentRow.NRVOO
		}, {
                name: "CDTRECHO",
                operator: "=",
                value: widget.currentRow.CDTRECHO
		}, {
                name: "DATAREF",
                operator: "=",
                value: widget.container.getWidget("widgetVigencia").currentRow.DTINIVIGENCIA.slice(0, 10)
		},
            {
                name: "NRORG",
                operator: "=",
                value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
		}];
        if (widget.name == "widgetHandling" && widget.getField("DSSERVICOCIAFILIADD").dataSourceFilter.length == 5) {
            widget.getField("DSSERVICOCIAFILIADD").dataSourceFilter.push({
                name: "IDSERVICO",
                operator: "=",
                value: 3
            });
        }
        widget.getField("DSSERVICOCIAFILIADD").reload();
        widget.getField("DSSERVICOCIAFILIADD").isVisible = true;
        widget.getField("IDSERVICO").showOnForm = false;
        widget.getField("DSSERVICOCIAFILI").showOnForm = false;
        widget.getField("SGCLASSE").showOnForm = false;
        widget.getField("IDCICLO").showOnForm = false;
        widget.getField("IDPROPORCAO").showOnForm = false;
        widget.getField("QTPROPORCAO").showOnForm = false;
    };

    this.deleteHandling = function(widget) {
        MessageService.confirmMessageByCode('ALE_CONFIRM_REMOVE_REGISTER').then(function() {
            General.callRestEngine("ate#/crud/padequipm/remove", "DataSet", widget.getCheckedRows()).then(function(sucesso) {
                widget.reload().then(function() {
                    widget.activate();
                    widget.unSelectAll();
                    MessageService.successNotificationByCode("MSG_ATE_EXCLUIDO_COM_SUCESSO");
                });
            }, function(erro) {
                MessageService.showMessageByCode('ERR_INVALID_SERVICE_REMOVE');
            });
        });
    };

    this.salvaServicoEquip = function(widgetServicosEquipamento) {
        if (widgetServicosEquipamento.currentRow.__is_new) {
            return self.salvaServicoEquipamento(widgetServicosEquipamento);
        } else {
            InflightorGeneral.saveCrud(widgetServicosEquipamento).then(function() {
                ScreenService.closeSwipe();
                widgetServicosEquipamento.reload();
                widgetServicosEquipamento.list();
                widgetServicosEquipamento.activate();
                MessageService.successNotificationByCode("MSG_ATE_SALVO_COM_SUCESSO");
            });
        }
    };

    this.salvaServicoEquipamento = function(widgetServicosEquipamento) {
        const mainWidget = templateManager.container.getWidget('widgetVigencia');
        const currentRowMainWidget = mainWidget.currentRow;
        const filterRow = mainWidget.appliedFilter.FILTER_ROW;
        if (widgetServicosEquipamento.currentRow.DSSERVICOCIAFILIADD.length) {
            if (widgetServicosEquipamento.inEditMode()) {
                let data = [],
                    flag = true;

                widgetServicosEquipamento.getField("DSSERVICOCIAFILIADD").selectWidget.getCheckedRows().forEach(function(row) {
                    row.__is_new = true;
                    row.CDEQUIP = filterRow.CDEQUIP;
                    row.NRSEQPADEQUIPMDATA = currentRowMainWidget.NRSEQPADEQUIPMDATA;
                    data.push(row);
                    if (!verificaServicoEquipamentoToSave(row)) {
                        flag = false;
                    }
                });

                if (flag) {
                    ate00900_configura_servico_vooService.saveItensHandling(data).then(function(sucesso) {
                        ScreenService.closeSwipe();
                        widgetServicosEquipamento.reload();
                        widgetServicosEquipamento.list();
                        MessageService.successNotificationByCode("MSG_ATE_SALVO_COM_SUCESSO");
                    }, function(erro) {
                        MessageService.showMessageByCode('ERR_SAVE_SERVICE');
                    });
                }
            } else {
                widgetServicosEquipamento.dataSource.data.forEach(function(row) {
                    if (row.IDPROPORCAO == "1" || row.IDPROPORCAO == "3")
                        row.changed = false;
                });

                InflightorGeneral.saveCrud(widgetServicosEquipamento).then(function() {
                    widgetServicosEquipamento.list();
                    widgetServicosEquipamento.activate();
                    widgetServicosEquipamento.reload();
                    MessageService.successNotificationByCode("MSG_ATE_SALVO_COM_SUCESSO");
                });
            }
        } else {
            MessageService.showMessageByCode('ERR_SERVICE_NOT_FILLED');
        }
    };

    this.openSwipe = function(widget) {
        let widgetSwipe = widget.container.getWidget("widgetHandling");
        ScreenService.openSwipe(widgetSwipe);
        widgetSwipe.activate();
        widgetSwipe.reload();
    };

    function validateToClearCheckedRows(field) {
        let valid = false;
        if (field.dataSource) {
            let checkedRows = field.dataSource.getCheckedRows();
            if (checkedRows && Array.isArray(checkedRows) && checkedRows.length) {
                valid = true;
            }
        }
        return valid;
    }

    this.adicionarVigencia = function(widget) {
        if (widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.IDATIVO == "S") {
            ScreenService.openPopup(widget).then(function(success) {
                widget.fields.forEach(function(field) {
                    if (field.defaultValue) {
                        field.applyDefaultValue();
                    } else {
                        field.clearValue(field);
                    }
                    if (validateToClearCheckedRows(field)) {
                        field.dataSource.unSelectAll();
                    }
                });
                widget.activate();
                if (widget.getField("NRVOO") != undefined) {
                    widget.getField("NRVOO").validations = {};
                } else if (widget.getField("DSEQUIP") != undefined) {
                    widget.getField("DSEQUIP").validations = {};
                }
                widget.getField("VIGENCIA").validations = {};

            });
        } else {
            MessageService.showMessageByCode("ERR_INACTIVE_EQUIPMENT");
        }
    };

    this.cancelaServicoEquipamento = function(args) {
        let widgetServicosEquipamento = args.owner.widget;
        if (widgetServicosEquipamento.inEditMode()) {
            ScreenService.closeSwipe();
            args.owner.widget.list();
            args.owner.widget.activate();
        } else {
            widgetServicosEquipamento.list();
            widgetServicosEquipamento.activate();
            widgetServicosEquipamento.reload();
        }
    };

    this.alteraProporcao = function(widget, tab) {
        let idproporcao = widget.currentRow.IDPROPORCAO;
        let idpropsevoo = widget.currentRow.IDPROPSEVOO;
        let qtservooField = widget.getField("QTSERVOO");
        let qtproporcaoField = widget.getField("QTPROPORCAO");
        qtproporcaoField.label = "Configuração";
        qtproporcaoField.isVisible = true;
        qtservooField.isVisible = false;

        switch (idproporcao) {
            case "2": {
                qtproporcaoField.label = "Configuração (V)";
                break;
            }
            case "4": {
                qtproporcaoField.label = "Configuração (%)";
                break;
            }
            case "5": {
                qtproporcaoField.isVisible = false;
                qtproporcaoField.validations = null;
                qtservooField.isVisible = true;
                qtservooField.readOnly = false;
                qtservooField.validations = {
                    required: true
                };
                qtservooField.label = "Configuração Padrão (S)";
                break;
            }
        }

        if (!widget.currentRow.__is_new) {
            widget.container.getWidget("grid_subgrupos").isVisible = true;
            widget.getField("DSSERVICOCIAFILIADD").isVisible = false;
            widget.getField("IDSERVICO").showOnForm = true;
            widget.getField("DSSERVICOCIAFILI").showOnForm = true;
            widget.getField("SGCLASSE").showOnForm = true;
            widget.getField("IDCICLO").showOnForm = true;
            widget.getField("IDPROPORCAO").showOnForm = true;
            widget.getField("QTPROPORCAO").showOnForm = true;
            if (widget.currentWidget && widget.currentWidget.name == "grid_subgrupos") {
                self.filtraSubgrupos(widget.currentWidget);
            }
        }
    };

    this.filtraEquipamentos = function(widgetHandling, filterPopup) {
        updateFilterUsingFilterPopUp(filterPopup, widgetHandling);
        widgetHandling.reload();
    };

    this.filtraItens = function(field, widget) {
        field.dataSourceFilter.push({
            "name": "CDEQUIP",
            "operator": "=",
            "value": widget.currentRow.CDEQUIP
        });
    };

    this.filtraEquipamentoCia = function(widget) {
        const fieldEquip = widget.getField('DSEQUIP');
        if (!fieldEquip) return;
        const row = widget.currentRow;
        const CDFILIAL = row.CDFILIAL;
        const CDCIA = row.CDCIA;
        let filterUnit = fieldEquip.dataSourceFilter.find(filter => filter.name === 'CDFILIAL');
        let filterCia = fieldEquip.dataSourceFilter.find(filter => filter.name === 'CDCIA');
        filterUnit.value = CDFILIAL || '';
        filterCia.value = CDCIA || '';
    };

    this.onChangeUnit = function(fieldUnit) {
        const widget = fieldUnit.widget;
        let row = widget.currentRow;
        const CDFILIAL = row.CDFILIAL;
        const fieldCia = widget.getField("NMCIA");
        let filterUnit = fieldCia.dataSourceFilter.find(filter => filter.name === 'CDFILIAL');
        filterUnit.value = CDFILIAL ? CDFILIAL : '';
        if (CDFILIAL) {
            fieldCia.readOnly = false;
        } else {
            fieldCia.readOnly = true;
            row.CDCIA = "";
            row.NMCIA = "";
        }
    };

    this.filtraEquipamentosWidget = function(widget) {
        let data;
        let dataVig = widget.getParent().currentRow.DTINIVIGENCIA;
        let filtroWidget = widget.getParent().appliedFilter;

        dataVig = dataVig.split(" ");
        dataVig = dataVig[0];

        if (moment(dataVig, 'DD/MM/YYYY').isAfter(moment())) {
            data = moment(dataVig, 'DD/MM/YYYY').format('DD/MM/YYYY');
        } else {
            data = moment().format('DD/MM/YYYY');
        }

        let filtro = [
            {
                name: "CDCIA",
                operator: "=",
                value: filtroWidget.FILTER_ROW.CDCIA
			}, {
                name: "CDFILIAL",
                operator: "=",
                value: filtroWidget.FILTER_ROW.CDFILIAL
			}, {
                name: "CDEQUIP",
                operator: "=",
                value: filtroWidget.FILTER_ROW.CDEQUIP
			}, {
                name: "NRSEQPADEQUIPMDATA",
                operator: "=",
                value: widget.container.getWidget("widgetVigencia").currentRow.NRSEQPADEQUIPMDATA
			}, {
                name: "DATAREF",
                operator: "=",
                value: data
			},
            {
                name: "NRORG",
                operator: "=",
                value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];

        widget.dataSourceFilter = filtro;
        widget.reload().then(function() {
            self.setStripeFooter(widget);
        });
        widget.activate();
    };

    let updateFilterUsingFilterPopUp = function(filterPopup, component) {
        let currentFilter = filterPopup.currentFilter.filters;
        component.dataSourceFilter.forEach(function(filter) {
            for (let i in currentFilter) {
                if (filter.name == currentFilter[i].name) {
                    filter.value = currentFilter[i].value;
                    break;
                }
            }
        });
    };

    this.setFilterServico = function(widget, widgetFilterPopup) {
        let widgetHandling = widget.container.getWidget("widgetHandling");
        widget.getField("DSSERVICOCIAFILIADD").dataSourceFilter = [{
                name: "CDFILIAL",
                operator: "=",
                value: widgetHandling.currentRow.CDFILIAL
		}, {
                name: "CDCIA",
                operator: "=",
                value: widgetHandling.currentRow.CDCIA
		}, {
                name: "IDSERVICO",
                operator: "IN",
                value: [
	           "2",
	           "3"
	         ]
		},
            {
                name: "NRORG",
                operator: "=",
                value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
		}];
    };

    this.filtraServicosEquipamento = function(widgetHandling, filterPopup, widgetServicosEquipamento) {
        updateFilterUsingFilterPopUp(filterPopup, widgetServicosEquipamento);
        widgetServicosEquipamento.dataSourceFilter[widgetServicosEquipamento.dataSourceFilter.length - 1].value = widgetHandling.currentRow.CDEQUIP;
        widgetServicosEquipamento.reload();
        ScreenService.openSwipe(widgetServicosEquipamento.getParent());
    };

    this.filtraServicosEquipamentoAdicionar = function(widget, field) {
        const mainWidget = templateManager.container.getWidget('widgetVigencia');
        const filterRow = mainWidget.appliedFilter.FILTER_ROW;
        const row = mainWidget.currentRow;
        let filtro = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: filterRow.CDFILIAL
			}, {
                name: "CDCIA",
                operator: "=",
                value: filterRow.CDCIA
			}, {
                name: "DTINIVIGENCIA",
                operator: "=",
                value: row.DTINIVIGENCIA.slice(0, 10)
			}, {
                name: "IDSERVICO",
                operator: "IN",
                value: [
		           "2",
		           "3"
		         ]
	        },
            {
                name: "CDEQUIP",
                operator: "=",
                value: filterRow.CDEQUIP
			}
		];
        field.dataSourceFilter = filtro;
        field.reload();
    };

    this.adicionarServicoEquipamento = function(widget) {
        let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter;
        self.setFilterServico(widget, filterPopup);
        widget.getField("DSSERVICOCIAFILIADD").isVisible = true;
        widget.getField("DSSERVICOCIAFILIADD").value("");
        widget.currentRow.DSSERVICOCIAFILIADD = "";
        widget.getField("DSSERVICOCIAFILI").showOnForm = false;
        widget.getField("IDSERVICO").showOnForm = false;
        widget.getField("SGCLASSE").showOnForm = false;
        widget.getField("IDCICLO").showOnForm = false;
        widget.getField("IDPROPORCAO").showOnForm = false;
        widget.getField("QTSERVOO").showOnForm = false;
        widget.currentRow.CDEQUIP = widget.getParent().currentRow.CDEQUIP;
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        widget.currentRow.CDCIA = widget.getParent().currentRow.CDCIA;
        widget.newRow();
    };

    this.filterGrid = function(widget) {
        if (widget.mode == "list") {
            let rows;
            let widgetVigencia = widget.container.getWidget("widgetVigencia");
            let filtroWidget = widget.container.getWidget("widgetVigencia").appliedFilter;

            widget.dataSourceFilter = [
                {
                    name: "NRVOO",
                    operator: "=",
                    value: widgetVigencia.currentRow.NRVOO
	            },
                {
                    name: "CDTRECHO",
                    operator: "=",
                    value: widgetVigencia.currentRow.CDTRECHO
	            },
                {
                    name: "DATAREF",
                    operator: "=",
                    value: moment(widget.container.getWidget("widgetVigencia").currentRow.DTINIVIGENCIA, "DD/MM/YYYY").unix() >= moment().unix() ? moment(widget.container.getWidget("widgetVigencia").currentRow.DTINIVIGENCIA, "DD/MM/YYYY").format("DD/MM/YYYY") : moment().format("DD/MM/YYYY")
	            },
                {
                    name: "CDCIA",
                    operator: "=",
                    value: widgetVigencia.currentRow.CDCIA
	            },
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: widgetVigencia.currentRow.CDFILIAL
	            },
                {
                    name: "NRSEQPADVOOTREMDATA",
                    operator: "=",
                    value: widgetVigencia.currentRow.NRSEQPADVOOTREMDATA
				},
                {
                    name: "NRORG",
                    operator: "=",
                    value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
				}
			];
            widget.reload().then(function(callback) {
                rows = callback.dataset.padvootrem_servicociafili_servicogen_vootrecho_voo_equipamento_data_referencia;
                for (let i = 0; i < rows.length; i++) {
                    rows[i].REFERENCIA = widget.dataSourceFilter[2].value;
                }
            });
        }
    };

    this.salvaServico = function(widgetServicos) {
        let seqVigencia;

        if (widgetServicos.container.getWidget("widgetVigencia").currentRow.NRSEQPADVOOTREMDATA) {
            seqVigencia = widgetServicos.container.getWidget("widgetVigencia").currentRow.NRSEQPADVOOTREMDATA;
        } else if (widgetServicos.container.getWidget("widgetVigencia").currentRow.NRSEQPADEQUIPMDATA) {
            seqVigencia = widgetServicos.container.getWidget("widgetVigencia").currentRow.NRSEQPADEQUIPMDATA;
        }

        if (!widgetServicos.isValid()) {
            MessageService.showMessageByCode("CAMPOSOBRIGATORIOS");
        } else {
            if (widgetServicos.currentRow.__is_new) {
                let data = [],
                    flag = true;

                widgetServicos.getField("DSSERVICOCIAFILIADD").selectWidget.getCheckedRows().forEach(function(row) {
                    row.QTSESTBYVOO = widgetServicos.currentRow.QTSESTBYVOO;
                    row.QTSESTBYVOO = widgetServicos.currentRow.QTSESTBYVOO;
                    row.NRSEQPADVOOTREMDATA = seqVigencia;
                    row.QTSERVOO = widgetServicos.currentRow.QTSERVOO ? General.valueToFloat(widgetServicos.currentRow.QTSERVOO) : "";
                    row.__is_new = true;
                    data.push(row);
                    if (!verificaServicoToSave(row)) {
                        flag = false;
                    }
                });
                if (flag) {
                    ate00900_configura_servico_vooService.saveItensFaturamento(data).then(function(sucesso) {
                        ScreenService.closeSwipe();
                        widgetServicos.reload();
                        widgetServicos.list();
                        MessageService.successNotificationByCode("MSG_ATE_SALVO_COM_SUCESSO");
                    }, function(erro) {
                        MessageService.showMessageByCode('ERR_SAVE_SERVICE');
                    });
                }
            } else {
                widgetServicos.currentRow.QTSERVOO = widgetServicos.currentRow.QTSERVOO ? General.valueToFloat(widgetServicos.currentRow.QTSERVOO) : "";
                if (verificaServicoToSave(widgetServicos.currentRow)) {
                    General.saveCrud(widgetServicos).then(function(sucesso) {
                        widgetServicos.getField("NRVOO").showOnForm = true;
                        widgetServicos.getField("SGEQUIP").showOnForm = true;
                        widgetServicos.getField("DSSERVICOCIAFILI").showOnForm = true;
                        MessageService.successNotificationByCode("MSG_ATE_SALVO_COM_SUCESSO");
                    }, function(erro) {
                        MessageService.showMessageByCode('ERR_SAVE_SERVICE');
                    });
                }
            }
        }
    };

    this.afterMoveRowServicoEquipamento = function(widgetServicosEquipamento) {
        alteraProporcaoEquipamento(widgetServicosEquipamento);
        if (!widgetServicosEquipamento.currentRow.__is_new) {
            widgetServicosEquipamento.getField("DSSERVICOCIAFILIADD").isVisible = false;
            widgetServicosEquipamento.getField("DSSERVICOCIAFILI").showOnForm = true;
            widgetServicosEquipamento.getField("IDSERVICO").showOnForm = true;
            widgetServicosEquipamento.getField("SGCLASSE").showOnForm = true;
            widgetServicosEquipamento.getField("IDCICLO").showOnForm = true;
            widgetServicosEquipamento.getField("IDPROPORCAO").showOnForm = true;
            widgetServicosEquipamento.getField("QTSERVOO").showOnForm = true;
        }
    };

    this.servicoEquipamentoOnChange = function(widgetServicosEquipamento) {
        if (widgetServicosEquipamento.currentRow.NRSERVICOCIAFILI) {
            verificaServicoEquipamentoToSave(widgetServicosEquipamento.currentRow);
            alteraProporcaoEquipamento(widgetServicosEquipamento);
        }
    };

    this.fechaSwipe = function(args) {
        args.owner.widget.dataSource.clearCheckedRows();
        ScreenService.closeSwipe();
        //args.owner.widget.container.getWidget('widgetVigencia').activate();
    };

    let alteraProporcaoEquipamento = function(widgetServicosEquipamento) {
        let qtServoo = widgetServicosEquipamento.getField("QTSERVOO");
        if (widgetServicosEquipamento.currentRow.IDPROPORCAO == "5") {
            qtServoo.readOnly = false;
            qtServoo.validations = {
                required: true
            };
        } else {
            qtServoo.readOnly = true;
            qtServoo.validations = null;
        }
    };

    this.servicoOnChange = function(widgetServicos) {
        if (!widgetServicos.currentRow.__is_new) {
            let currentRow = widgetServicos.currentRow;
            if (verificaServicoToSave(currentRow)) {
                self.alteraProporcao(widgetServicos);
            }
        }
    };

    let verificaServicoEquipamentoToSave = function(currentRow) {
        //@todo verificar com Douglas se servico deve ser do tipo 'AMBOS' ou 'ITEMFATURAMENTO'
        return verificaServicoAtivo(currentRow.IDSITSERVICO) && verificaServicoHandMisc(currentRow.IDSERVICO);
    };

    let verificaServicoToSave = function(currentRow) {
        return verificaServicoAtivo(currentRow.IDSITSERVICO) && verificaServicoItemFaturamento(currentRow.IDTIPOSERVICO);
    };

    let verificaServicoHandMisc = function(IDSERVICO) {
        if (IDSERVICO != 2 && IDSERVICO != 3) {
            MessageService.showMessageByCode("ERR_SERVICE_TYPE_SELECTION");
            return false;
        }
        return true;
    };

    let verificaServicoItemFaturamento = function(IDTIPOSERVICO) {
        if (IDTIPOSERVICO != "AMBOS" && IDTIPOSERVICO != "ITEMFATURAMENTO") {
            MessageService.showMessageByCode("ALE_SERVICE_BILLING");
            return false;
        }
        return true;
    };

    let verificaServicoAtivo = function(IDSITSERVICO) {
        if (IDSITSERVICO != 1) {
            MessageService.showMessageByCode("ALE_SERVICE_INACTIVE");
            return false;
        }
        return true;
    };

    this.editar = function(widgetServicos) {
        General.edit(widgetServicos);
    };

    this.editEquipamento = function(widgetServicos) {
        widgetServicos.getField('DSSERVICOCIAFILI').readOnly = true;
        widgetServicos.__is_new = false;

        if (widgetServicos.currentRow.IDPROPORCAO == '5') {
            widgetServicos.getField('QTSERVOO').readOnly = false;
        } else {
            widgetServicos.getField('QTSERVOO').readOnly = true;
        }
        General.edit(widgetServicos);
        General.justInteger('#QTSERVOO');
    };

    this.cancelarEdit = function(args) {
        General.backOrCancel(args);
    };

    this.deletaServico = function(widgetServicos) {
        MessageService.confirmMessageByCode('ALE_CONFIRM_REMOVE_REGISTER').then(function() {
            General.callRestEngine("ate#/crud/padvootrem/remove", "DataSet", widgetServicos.getCheckedRows()).then(function(sucesso) {
                widgetServicos.reload();
                widgetServicos.activate();
                widgetServicos.unSelectAll();
                MessageService.successNotificationByCode("MSG_ATE_EXCLUIDO_COM_SUCESSO");
            }, function(erro) {
                MessageService.showMessageByCode('ERR_INVALID_SERVICE_REMOVE');
            });
        });
    };

    this.deletaVigencia = function(args, widgetServicos = args.owner.widget) {
        MessageService.confirmMessageByCode('ALE_CONFIRM_REMOVE_REGISTER').then(function() {
            General.callRestEngine("ate#/crud/padvootremdata/remove", "DataSet", widgetServicos.getCheckedRows()).then(function(sucesso) {
                let mainWidget = widgetServicos.container.getWidget("widgetVigencia");
                widgetServicos.unSelectAll();
                MessageService.showMessageByCode("MSG_ATE_VIGENCIA_EXCLUIDA", null, Constants.successMessage);
                mainWidget.reload().then(function(sucesso) {
                    mainWidget.activate();
                });
            }, function(erro) {
                if (erro.data && erro.data.error.indexOf("ORA-02292") !== -1) {
                    MessageService.showMessageByCode('ERR_INVALID_SERVICE_REMOVE_FATURAMENTO');
                } else {
                    ScreenService.showMessage(erro.data.error);
                }
            });
        });
    };

    this.deletaVigenciaEquipamento = function(widget) {
        MessageService.confirmMessageByCode('ALE_DELETE_VALIDITY').then(function() {
            General.callRestEngine("ate#/crud/padequipmdata/remove", "DataSet", widget.getCheckedRows()).then(function(sucesso) {
                let mainWidget = widget.container.getWidget("widgetVigencia");
                widget.unSelectAll();
                MessageService.successNotificationByCode('MSG_ATE_EXCLUIDO_COM_SUCESSO');
                mainWidget.reload().then(function(sucesso) {
                    mainWidget.activate();
                });
            }, function(erro) {
                if (erro.data && erro.data.error.indexOf("ORA-02292") !== -1) {
                    MessageService.showMessageByCode('MSG_DELETE_NOT_PERMITTED');
                } else {
                    MessageService.showMessageByCode('GENERIC_ERROR_ITEM_REMOVE');
                }
            });
        });
    };

    this.moveRowServicosHandling = function(widget) {
        let widgetProporcao = widget.container.getWidget("proporcaoVariavel");
        let tabbedProporcao = widget.container.getWidget("tabbedProporcaoVariavel");
        let row = widget.currentRow;
        let filter = {
            CDFILIAL: row.CDFILIAL,
            CDCIA: row.CDCIA,
            CDCICLO: row.CDCICLO,
            CDCLASSE: row.CDCLASSE,
            NRSERVICOCIAFILI: row.NRSERVICOCIAFILI
        };
        General.buildDataSourceFilter(widgetProporcao.dataSourceFilter, filter);
        if (tabbedProporcao.open) {
            widgetProporcao.reload();
        } else {
            ScreenService.openSwipe(tabbedProporcao).then(
                function() {
                    widgetProporcao.activate();
                    widgetProporcao.reload();
                }
            );
        }
    };

    this.carregaUrlFoto = function(widget) {
        widget.currentRow.FGFOTOSUBSEMAM = widget.getParent().currentRow.FGFOTOSUBSEMAM;
        if (!widget.currentRow.FGFOTOSUBSEMAM) {
            widget.currentRow.FGFOTOSUBSEMAM = window.undefinedImage;
        }
    };

    this.applyInactiveStyle = function(field) {
        field.selectWidget.styles = [
            {
                "condition": "row.IDATIVO == 'N'",
                "cssClass": "coc-inactive"
	        }
	    ];
        field.selectWidget.events[0].code = "ate00900_configura_servico_vooController.inactiveBranchWarning(args);";
    };

    this.inactiveBranchWarning = function(args) {
        const row = args.owner.currentRow;
        if (isInactiveCia(row)) {
            MessageService.showMessageByCode("MSG_ATE_CIA_INATIVA");
        } else {
            args.owner.setSelected(args);
        }
    };

    function isInactiveCia(row) {
        return row.IDATIVO === "N";
    }

    this.importaConfiguracaoVoo = function(widget) {
        let data = '';
        if (widget.currentRow.VIGENCIA) {
            data = widget.container.getWidget("widgetVigencia").currentRow.DTINIVIGENCIA;
            data = data.split(" ");
            data = data[0];
        }

        if (widget.isValid()) {
            MessageService.confirmMessageByCode('CONF_FLIGHT_IMPORT').then(function() {
                let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                let cdfilial = filterPopup.CDFILIAL;
                let cdcia = filterPopup.CDCIA;
                let nrvoodes = filterPopup.NRVOO;
                let cdtrechodes = filterPopup.CDTRECHO;
                let nrvooori = widget.currentRow.NRVOO;
                let cdtrechoori = widget.currentRow.CDTRECHO;
                let vigencia = data;
                let sequencial = widget.currentRow.NRSEQPADVOOTREMDATA;

                ate00900_configura_servico_vooService.importaConfiguracaoVoo(cdfilial, cdcia, nrvooori, cdtrechoori, sequencial, nrvoodes, cdtrechodes, vigencia)
                    .then(function(callback) {
                        MessageService.notificationMessageByCode("SUC_SAVED_FLIGHT_IMPORT", null, Constants.successNotification);
                        ScreenService.closePopup();
                        widget.container.getWidget("widgetServicos").activate();
                        widget.container.getWidget("widgetServicos").reload();
                    }).catch(function(erro) {
                        ScreenService.showMessage(erro, "erro");
                    });
            });
        }
    };

    this.exportaConfiguracaoVoo = function(widget) {
        if (widget.isValid()) {
            MessageService.confirmMessageByCode('ALE_EXPORT_CONFIGURATION').then(function() {
                let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                let cdfilial = filterPopup.CDFILIAL;
                let cdcia = filterPopup.CDCIA;
                let nrvooori = filterPopup.NRVOO;
                let nrvoodes = widget.currentRow.NRVOO;
                let cdtrechoori = filterPopup.CDTRECHO;
                let vigencia = widget.currentRow.DTINIVIGENCIA.slice(0, 10);
                let sequencial = widget.container.getWidget("widgetVigencia").currentRow.NRSEQPADVOOTREMDATA;

                ate00900_configura_servico_vooService.exportaConfiguracaoVoo(cdfilial, cdcia, nrvooori, cdtrechoori, sequencial, nrvoodes, vigencia)
                    .then(function(callback) {
                        MessageService.notificationMessageByCode("SUC_CONFIG_EXPORTED", null, Constants.successNotification);
                        widget.currentRow = {};
                        ScreenService.closePopup();
                        widget.container.getWidget("widgetServicos").activate();
                    }).catch(function(erro) {
                        ScreenService.showMessage(erro, "erro");
                    });
            });
        }
    };

    this.importaConfiguracaoEquipamento = function(widget) {
        let data = "";
        if (widget.container.getWidget("widgetHandling").getParent().currentRow.DTINIVIGENCIA) {
            let DTINIVIGENCIA = widget.container.getWidget("widgetHandling").getParent().currentRow.DTINIVIGENCIA;
            DTINIVIGENCIA = DTINIVIGENCIA.split(" ");
            data = DTINIVIGENCIA[0];
        }

        if (widget.isValid()) {
            MessageService.confirmMessageByCode('ALE_CONFIG_EQUIPMENT').then(function() {
                let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                let cdfilial = filterPopup.CDFILIAL;
                let cdcia = filterPopup.CDCIA;
                let cdequipdes = filterPopup.CDEQUIP;
                let sequencial = widget.currentRow.NRSEQPADEQUIPMDATA;
                let cdequipori = widget.currentRow.CDEQUIP;
                let vigencia = data;

                ate00900_configura_servico_vooService.importaConfiguracaoEquipamento(cdfilial, cdcia, cdequipori, cdequipdes, sequencial, vigencia)
                    .then(function(callback) {
                        MessageService.notificationMessageByCode("CONFIGURATION_IMPORTED_SUCCESSFULLY", null, Constants.successNotification);
                        ScreenService.closePopup();
                        widget.container.getWidget("widgetHandling").activate();
                        widget.container.getWidget("widgetHandling").reload();
                    }).catch(function(erro) {
                        ScreenService.showMessage(erro, "erro");
                    });
            });
        }
    };

    this.exportaConfiguracaoEquipamento = function(widget) {
        let data = widget.currentRow.VIGENCIA;
        data = data.split(" ");
        data = data[0];

        if (widget.isValid()) {
            MessageService.confirmMessageByCode('ALE_CONFIG_EXPORTED_EQUIPMENT').then(function() {
                let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;
                let cdfilial = filterPopup.CDFILIAL;
                let cdcia = filterPopup.CDCIA;
                let cdequipdes = widget.currentRow.CDEQUIP;
                let sequencial = widget.container.getWidget("widgetVigencia").currentRow.NRSEQPADEQUIPMDATA;
                let cdequipori = filterPopup.CDEQUIP;
                let vigencia = data;

                ate00900_configura_servico_vooService.exportaConfiguracaoEquipamento(cdfilial, cdcia, cdequipori, cdequipdes, sequencial, vigencia)
                    .then(function(callback) {
                        MessageService.notificationMessageByCode("CONFIGURATION_EXPORTED_SUCCESSFULLY", null, Constants.successNotification);
                        ScreenService.closePopup();
                        widget.container.getWidget('widgetVigencia').reload([], false);
                        widget.container.getWidget("widgetHandling").activate();
                        widget.container.getWidget("widgetHandling").reload();
                    }).catch(function(erro) {
                        ScreenService.showMessage(erro, "erro");
                    });
            });
        }
    };

    this.filtraVooExportacao = function(fieldNrvoo) {
        fieldNrvoo.dataSourceFilter = [
            {
                name: "CDCIA",
                operator: "=",
                value: fieldNrvoo.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDCIA
			},
            {
                name: "CDFILIAL",
                operator: "=",
                value: fieldNrvoo.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDFILIAL
			},
            {
                name: "NRORG",
                operator: "=",
                value: "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
	        }
		];

        fieldNrvoo.reload();
    };

    this.openPopupImport = function() {
        const widgetImport = templateManager.container.getWidget('importaConfiguracaoVoo');
        const fieldVig = widgetImport.getField('VIGENCIA');
        const mainWidget = templateManager.container.getWidget('widgetVigencia');
        const row = mainWidget.currentRow;
        const filterRow = mainWidget.appliedFilter.FILTER_ROW;
        ['NRORG', 'CDFILIAL', 'CDCIA'].forEach(filterName => {
            ['NRVOO', 'VIGENCIA'].forEach(fieldName => {
                let field = widgetImport.getField(fieldName);
                if (field) {
                    let filter = field.dataSourceFilter.find(cFilter => cFilter.name === filterName);
                    if (filter) {
                        filter.value = filterRow[filterName];
                    }
                }
            });
        });
        const filterSeq = fieldVig.dataSourceFilter.find(filter => filter.name === 'NRSEQPADVOOTREMDATA');
        filterSeq.value = row.NRSEQPADVOOTREMDATA || '';
        ScreenService.openPopup(widgetImport);
    };

    this.onChangeVooImport = function() {
        const widgetImport = templateManager.container.getWidget('importaConfiguracaoVoo');
        const fieldVig = widgetImport.getField('VIGENCIA');
        const filterVoo = fieldVig.dataSourceFilter.find(filter => filter.name === 'NRVOO');
        const filterTrecho = fieldVig.dataSourceFilter.find(filter => filter.name === 'CDTRECHO');
        filterVoo.value = widgetImport.currentRow.NRVOO || '';
        filterTrecho.value = widgetImport.currentRow.CDTRECHO || '';
    };

    this.filtraVooVigencia = function(field) {
        field.dataSourceFilter = [
            {
                name: "NRVOO",
                operator: "=",
                value: field.widget.container.getWidget("importaConfiguracaoVoo").currentRow.NRVOO
			},
            {
                name: "NRSEQPADVOOTREMDATA",
                operator: "!=",
                value: field.widget.container.getWidget("widgetVigencia").currentRow.NRSEQPADVOOTREMDATA
			},
            {
                name: "CDTRECHO",
                operator: "=",
                value: field.widget.container.getWidget("importaConfiguracaoVoo").currentRow.CDTRECHO
			},
            {
                name: "CDCIA",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDCIA
			},
            {
                name: "CDFILIAL",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDFILIAL
			},
            {
                name: "NRORG",
                operator: "=",
                value: "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
			}
		];
    };

    this.filtraVooVigenciaAdicionar = function(field) {
        field.dataSourceFilter = [
            {
                name: "NRVOO",
                operator: "=",
                value: field.widget.currentRow.NRVOO
			},
            {
                name: "CDTRECHO",
                operator: "=",
                value: field.widget.currentRow.CDTRECHO
			},
            {
                name: "CDCIA",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDCIA
			},
            {
                name: "CDFILIAL",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDFILIAL
			},
            {
                name: "NRORG",
                operator: "=",
                value: "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
			}
		];
        field.reload();
    };

    this.filtraEquipamentoVigencia = function(field) {
        field.dataSourceFilter = [
            {
                name: "CDCIA",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDCIA
			},
            {
                name: "CDFILIAL",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDFILIAL
			},
            {
                name: "NRORG",
                operator: "=",
                value: "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
			}
		];
        field.reload();
    };

    this.filtraEquipamentoVigenciaImportacao = function(field) {
        field.dataSourceFilter = [
            {
                name: "CDCIA",
                operator: "=",
                value: field.widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDCIA
			},
            {
                name: "NRORG",
                operator: "=",
                value: "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
			}
		];
        field.reload();
    };

    this.filtraEquipamentoVigenciaReplicar = function(field) {
        const widget = field.widget;
        const row = widget.currentRow;
        const CDEQUIP = row.CDEQUIP || '';
        const fieldVig = widget.getField('VIGENCIA');
        let filterEquip = fieldVig.dataSourceFilter.find(filter => filter.name === 'CDEQUIP');
        filterEquip.value = CDEQUIP || '';
    };

    this.formataTrecho = function(widget, currentRow) {
        currentRow.DSTRECHO = currentRow.SGBASEORI + "-" + currentRow.SGBASEDES;
        widget.getField("VIGENCIA").value("");
        currentRow.VIGENCIA = "";
    };

    this.changeVoo = function(widget) {
        if (widget.currentRow.NRVOO) {
            widget.getField("NRVOO").validations = {
                required: true
            };
            widget.getField("VIGENCIA").validations = {
                required: true
            };
        } else {
            widget.getField("NRVOO").validations = {};
            widget.getField("VIGENCIA").validations = {};
        }
    };

    this.changeEquip = function(widget) {

        widget.getField("VIGENCIA").value("");
        widget.currentRow.VIGENCIA = "";

        if (widget.currentRow.DSEQUIP) {
            widget.getField("DSEQUIP").validations = {
                required: true
            };
            widget.getField("VIGENCIA").validations = {
                required: true
            };
        } else {
            widget.getField("DSEQUIP").validations = {};
            widget.getField("VIGENCIA").validations = {};
        }
    };

    this.limpaVigencia = function(widget) {
        widget.getField("VIGENCIA").value("");
        widget.currentRow.VIGENCIA = "";
    };

    this.validaDataVoo = function(widget) {
        return General.callRestEngine("ate#/crud/padvootremdata", "FilterData", widget.container.getWidget("widgetVigencia").dataSourceFilter).then(function(callback) {
            let vigencias = callback.dataset.padvootremdata;
            vigencias.filter(function(vigencia) {
                if (moment(vigencia.DTINIVIGENCIA, "DD/MM/YYYY").unix() == moment(widget.currentRow.DTINIVIGENCIA, "DD/MM/YYYY").unix()) {
                    const fieldDate = widget.getField('DTINIVIGENCIA');
                    fieldDate.clearValue(fieldDate);
                    widget.currentRow.DTINIVIGENCIA = "";
                    throw "REGISTRATION_ALREADY_EXISTS";
                }
            });
        });
    };

    this.validaDataEquipamento = function(widget) {
        let filtro = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDFILIAL
			},
            {
                name: "CDCIA",
                operator: "=",
                value: widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDCIA
			},
            {
                name: "CDEQUIP",
                operator: "=",
                value: widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW.CDEQUIP
			}
		];
        let filter = widget.container.getWidget("widgetVigencia").dataSourceFilter ? widget.container.getWidget("widgetVigencia").dataSourceFilter : filtro;
        General.callRestEngine("ate#/crud/padequipmdata", "FilterData", filter).then(function(callback) {
            let vigencias = callback.dataset.padequipmdata;
            vigencias.filter(function(vigencia) {
                if (moment(vigencia.DTINIVIGENCIA, "DD/MM/YYYY").unix() == moment(widget.currentRow.DTINIVIGENCIA, "DD/MM/YYYY").unix()) {
                    widget.currentRow.DTINIVIGENCIA = "";
                    return MessageService.showMessageByCode("REGISTRATION_ALREADY_EXISTS");
                }
            });
        });
    };

    this.setaFiltroAoAdicionarVigencia = function(field, filterRow) {
        let filtro = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: filterRow.CDFILIAL
	        },
            {
                name: "CDCIA",
                operator: "=",
                value: filterRow.CDCIA
	        },
            {
                name: "NRVOO",
                operator: "=",
                value: filterRow.NRVOO
	        },
            {
                name: "CDTRECHO",
                operator: "=",
                value: filterRow.CDTRECHO
	        },
            {
                name: "NRORG",
                operator: "=",
                value: "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
	        }
		];

        field.dataSourceFilter = filtro;
        field.reload();
    };

    this.salvaNovaVigencia = function(args, widget = args.owner.widget) {
        if (widget.isValid()) {
            if (typeof widget.currentRow.NRVOO != "undefined" && widget.currentRow.NRVOO != "" && widget.currentRow.NRVOO != null) {
                let voo = angular.copy(widget.currentRow.NRVOO);
                let cdtrecho = angular.copy(widget.currentRow.CDTRECHO);
                replicaConfiguracaoVoo(widget, voo, cdtrecho);
            } else {
                this.validaDataVoo(widget).then(() => {

                    let filterWidget = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                    widget.currentRow.CDFILIAL = filterWidget.CDFILIAL;
                    widget.currentRow.CDCIA = filterWidget.CDCIA;
                    widget.currentRow.NRVOO = filterWidget.NRVOO;
                    widget.currentRow.CDTRECHOORI = filterWidget.CDTRECHO;
                    widget.currentRow.CDTRECHO = filterWidget.CDTRECHO;
                    widget.currentRow.NRSEQPADVOOTREMDATA = null;
                    widget.currentRow.__is_new = true;

                    General.callRestEngine("ate#/salva_vigencia_voo", "Row", widget.currentRow).then(function(success) {
                        ScreenService.closePopup();
                        widget.currentRow.NRVOO = null;
                        let mainWidget = widget.container.getWidget("widgetVigencia");
                        widget.container.getWidget("widgetVigencia").activate();
                        widget.container.getWidget("widgetVigencia").reload();
                        //TODO sem necessidade.
                        //self.changeFilter(args, mainWidget);
                    }, function(error) {
                        MessageService.showMessageByCode('ERR_SAVE_VALIDITY');
                    });
                }).catch((exception) => {
                    MessageService.showMessageByCode(exception);
                });
            }
        }
    };

    let replicaConfiguracaoVoo = function(widget, voo, cdtrecho) {
        let data = widget.currentRow.DTINIVIGENCIA;
        data = data.split(" ");
        data = data[0];

        if (widget.isValid()) {
            MessageService.confirmMessageByCode('CONF_FLIGHT_IMPORT').then(function() {
                let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                widget.currentRow.CDFILIAL = filterPopup.CDFILIAL;
                widget.currentRow.CDCIA = filterPopup.CDCIA;
                widget.currentRow.NRVOO = filterPopup.NRVOO;
                widget.currentRow.CDTRECHODES = filterPopup.CDTRECHO;
                widget.currentRow.NRVOODES = filterPopup.NRVOO;
                widget.currentRow.NRVOOORI = voo;
                widget.currentRow.CDTRECHOORI = cdtrecho;
                widget.currentRow.DTINIVIGENCIA = data;
                widget.currentRow.CDOPERADOR = localStorageEngine.getLocalVar("CDOPERADOR");
                widget.currentRow.NRORG = localStorageEngine.getLocalVar("NRORG");
                widget.currentRow.NRSEQPADVOOTREMDATAORI = widget.currentRow.NRSEQPADVOOTREMDATA;
                widget.currentRow.__is_new = true;

                General.callRestEngine("ate#/replica_vigencia", "Row", widget.currentRow).then(function(success) {
                    ScreenService.closePopup();
                    widget.container.getWidget("widgetVigencia").activate();
                    widget.container.getWidget("widgetVigencia").reload();
                }, function(error) {
                    MessageService.showMessageByCode('ERR_SAVE_VALIDITY');
                });
            });
        }
    };

    this.salvaNovaVigenciaEquipamento = function(widget) {
        if (widget.isValid()) {
            if (widget.getField("DSEQUIP").validations !== undefined && !angular.equals(widget.getField("DSEQUIP").validations, {})) {
                let equip = angular.copy(widget.currentRow.CDEQUIP);
                replicaConfiguraçãoEquipamento(widget, equip);
            } else {
                let filterWidget = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                widget.currentRow.CDFILIAL = filterWidget.CDFILIAL;
                widget.currentRow.CDCIA = filterWidget.CDCIA;
                widget.currentRow.CDEQUIP = filterWidget.CDEQUIP;
                let isActive = filterWidget.IDATIVO;
                widget.currentRow.NRSEQPADEQUIPMDATA = null;
                widget.currentRow.__is_new = true;

                if (isActive == "S") {
                    General.callRestEngine("ate#/salva_vigencia_equipamento", "Row", widget.currentRow).then(function(success) {
                        ScreenService.closePopup();
                        widget.currentRow.CDEQUIP = null;
                        let mainWidget = widget.container.getWidget("widgetVigencia");
                        mainWidget.reload().then(function(sucess) {
                            mainWidget.activate();
                        });
                    }, function(erro) {
                        widget.currentRow.CDEQUIP = null;
                        MessageService.showMessageByCode('ERR_SAVE_VALIDITY');
                    });
                } else {
                    MessageService.showMessageByCode('ALE_REVENGE_INACTIVE_EQUIPMENT');
                }
            }
        }
    };

    let replicaConfiguraçãoEquipamento = function(widget, equip) {
        let data = widget.currentRow.DTINIVIGENCIA;
        data = data.split(" ");
        data = data[0];

        if (widget.isValid()) {
            MessageService.confirmMessageByCode('ALE_CONFIG_EXPORTED_EQUIPMENT').then(function() {
                let filterPopup = widget.container.getWidget("widgetVigencia").appliedFilter.FILTER_ROW;

                widget.currentRow.CDFILIAL = filterPopup.CDFILIAL;
                widget.currentRow.CDCIA = filterPopup.CDCIA;
                widget.currentRow.CDEQUIP = equip;
                widget.currentRow.CDEQUIPORI = widget.currentRow.CDEQUIP;
                widget.currentRow.CDEQUIPDES = filterPopup.CDEQUIP;
                widget.currentRow.DTINIVIGENCIA = data;
                widget.currentRow.CDOPERADOR = localStorageEngine.getLocalVar("CDOPERADOR");
                widget.currentRow.NRORG = localStorageEngine.getLocalVar("NRORG");
                widget.currentRow.NRSEQPADEQUIPMDATAORI = widget.currentRow.NRSEQPADEQUIPMDATA;
                widget.currentRow.__is_new = true;

                General.callRestEngine("ate#/replica_vigencia_equip", "Row", widget.currentRow).then(function(success) {
                    ScreenService.closePopup();
                    // self.changeFilterEquip(widget.container.getWidget("widgetVigencia"));
                    widget.container.getWidget("widgetVigencia").activate();
                    widget.container.getWidget("widgetVigencia").reload();
                }, function(erro) {
                    MessageService.showMessageByCode('ERR_SAVE_VALIDITY');
                });
            });
        }
    };

    this.abrePopupImportacaoExportacao = function(widget, nameWidget) {
        const widgetImportExport = templateManager.container.getWidget(nameWidget);
        const mainWidget = templateManager.container.getWidget('widgetVigencia');
        const filterRow = mainWidget.appliedFilter.FILTER_ROW;
        const CDFILIAL = filterRow.CDFILIAL;
        const CDCIA = filterRow.CDCIA;
        widgetImportExport.newRow();
        const fieldEquip = widgetImportExport.getField('DSEQUIP');
        const filterUnit = fieldEquip.dataSourceFilter.find(filter => filter.name === 'CDFILIAL');
        const filterCia = fieldEquip.dataSourceFilter.find(filter => filter.name === 'CDCIA');
        filterUnit.value = CDFILIAL || '';
        filterCia.value = CDCIA || '';
        ScreenService.openPopup(widgetImportExport);
    };

    this.setDataSourceFilterVoo = function(widget) {
        const row = widget.currentRow;
        const fieldVoo = widget.getField('NRVOO');
        if (!fieldVoo) return;
        const filterCia = fieldVoo.dataSourceFilter.find(filter => filter.name == 'CDCIA');
        const filterUnit = fieldVoo.dataSourceFilter.find(filter => filter.name == 'CDFILIAL');
        let defaultFilter = {
            name: "",
            operator: "=",
            value: ""
        };
        fieldVoo.clearValue();
        if (filterUnit) {
            filterUnit.value = row.CDFILIAL;
        } else {
            defaultFilter.name = 'CDFILIAL';
            defaultFilter.value = row.CDFILIAL;
            fieldVoo.push(defaultFilter);
        }
        if (filterCia) {
            filterCia.value = row.CDCIA;
        } else {
            defaultFilter.name = 'CDCIA';
            defaultFilter.value = row.CDCIA;
            fieldVoo.push(defaultFilter);
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register("ate00900_configura_servico_vooController", ate00900_configura_servico_vooController);
});

// FILE: ./assets/js/controllers/ate01100_previsao_de_passageiros_Controller.js
let ate01100_previsao_de_passageiros_Controller = function(ScreenService, PrevisaoPAXService, General, localStorageEngine, templateManager, MessageService) {

    let filtro = [];
    let cdfilial, nmfilial;

    this.habilitaFieldData = function(widget) {

        const fieldDataFinal = widget.getField('DTFINAL');
        fieldDataFinal.clearValue(fieldDataFinal);
        fieldDataFinal.readOnly = true;
        fieldDataFinal.reload();

        if (widget.currentRow.DTINICIAL) {
            fieldDataFinal.readOnly = false;
            validaDias(widget);
        }
    };

    this.onEnterPrevisaoPassageiros = function(args) {
        args.owner.getField('REPORTNAME').applyDefaultValue();
        if (!cdfilial) {
            args.owner.getField('CDFILIAL').applyDefaultValue();
            args.owner.getField('NMFILIAL').applyDefaultValue();
        }
    };

    this.limpaField = function(fieldDataFinal) {
        let {
            DTINICIAL,
            DTFINAL
        } = fieldDataFinal.widget.currentRow;
        if (DTINICIAL && DTFINAL && moment(DTFINAL, 'DD/MM/YYYY').isBefore(moment(DTINICIAL, 'DD/MM/YYYY'))) {
            fieldDataFinal.clearValue(fieldDataFinal);
            MessageService.showMessageByCode("ALE_LARGEST_END_DATE");
        }
    };

    let validaDias = function(widget) {

        let dataInicial = widget.currentRow.DTINICIAL;
        dataInicial = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").minDate = moment(dataInicial, "DD/MM/YYYY");
    };

    this.report = function(widget) {

        widget.currentRow.NRORG = localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB");
        cdfilial = widget.currentRow.CDFILIAL;
        nmfilial = widget.currentRow.NMFILIAL;

        let row = {};

        if (widget.currentRow.TNRVOOTRECHO == "T") {

            row = {
                "CDFILIAL": widget.currentRow.CDFILIAL,
                "DTINICIAL": widget.currentRow.DTINICIAL,
                "DTFINAL": widget.currentRow.DTFINAL,
                "NRVOO": "",
                "TNRVOO": "T"
            };

        } else if (widget.currentRow.TNRVOOTRECHO == "N") {

            let lista = listaVooTrecho(widget);

            row = {
                "CDFILIAL": widget.currentRow.CDFILIAL,
                "DTINICIAL": widget.currentRow.DTINICIAL,
                "DTFINAL": widget.currentRow.DTFINAL,
                "NRVOO": lista,
                "TNRVOO": ""
            };
        }

        if (widget.isValid()) {

            filtro = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": row.CDFILIAL
				},
                {
                    "name": "DTINICIAL",
                    "operator": "=",
                    "value": row.DTINICIAL
				},
                {
                    "name": "DTFINAL",
                    "operator": "=",
                    "value": row.DTFINAL
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": row.NRVOO
				},
                {
                    "name": "TNRVOO",
                    "operator": "=",
                    "value": row.TNRVOO
				}
			];

            ScreenService.openWindow("ate#/ate01100_previsao_de_passageiros_relatorio");

        } else {

            MessageService.showMessageByCode("ALE_REPORT_UNAVAILABLE");
        }
    };

    this.onEnter = function(widget) {

        let stripe = widget.container.getWidget('widgetDescription');
        let labelFilial = stripe.getField('NMFILIAL').setValue(cdfilial + "  -  " + nmfilial);
        stripe.reload();

        widget.activate();
        widget.dataSourceFilter = filtro;
        widget.reload();

    };

    let listaVooTrecho = function(widget) {

        let listaVoos = "";
        let rowVoos = widget.getField("NRVOO").selectWidget.getCheckedRows();

        for (let i = 0; i < rowVoos.length; i++) {
            listaVoos = listaVoos + rowVoos[i].LISTAVOOTRECHO;
        }
        return listaVoos;
    };

    this.filtraVoo = function(widget) {
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar("NRORGTRAB")
			}
		];

        widget.getField("NRVOO").dataSourceFilter = filter;
        widget.getField("NRVOO").reload();
    };

    this.clearField = function(widget) {
        widget.currentRow.NRVOO = "";
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate01100_previsao_de_passageiros_Controller", ate01100_previsao_de_passageiros_Controller);
});

// FILE: ./assets/js/controllers/ate01300_espelho_delivery_controller.js
let ate01300_espelho_delivery_controller = function(General, ScreenService, templateManager, MessageService) {

    this.habilitaFieldData = function(field) {
        let row = field.widget.currentRow;
        if (field.widget.currentRow.DTINICIAL) {
            habilitaFields(row, field, ["DTFINAL"], true);
            field.widget.getField("DSDELIVERY").dataSourceFilter = field.widget.getField("DSDELIVERY").dataSourceFilter.filter(function(condicao) {
                return condicao.name != "DTINICIAL";
            });
            field.widget.getField("DSDELIVERY").dataSourceFilter.push({
                "name": "DTINICIAL",
                "operator": "=",
                "value": field.widget.getField("DTINICIAL").value()
            });
            field.widget.getField("DSDELIVERY").value("");
        } else {
            habilitaFields(row, field, ["DTFINAL", "NMFILIAL"], false);
            field.widget.getField("NMCIA").value("");
            field.widget.getField("DSDELIVERY").value("");
        }

    };

    this.habilitaFieldUnidade = function(field) {
        let row = field.widget.currentRow;
        if (row.DTINICIAL != "" && row.DTFINAL != "") {
            field.widget.getField("DSDELIVERY").dataSourceFilter = field.widget.getField("DSDELIVERY").dataSourceFilter.filter(function(condicao) {
                return condicao.name != "DTFINAL";
            });
            field.widget.getField("DSDELIVERY").dataSourceFilter.push({
                "name": "DTFINAL",
                "operator": "=",
                "value": field.widget.getField("DTFINAL").value()
            });
            field.widget.getField("DSDELIVERY").value("");
        } else {
            field.widget.getField("DSDELIVERY").value("");
            limpaFiltros(field, ["DSDELIVERY"]);
        }

    };

    this.habilitaFieldCompanhia = function(field) {
        let row = field.widget.currentRow;
        let filtro;
        let condicaoTCdcia = {
            "name": "CDCIA",
            "operator": "=",
            "value": row.TNMCIA
        };
        if (row.DTFINAL != "" && row.CDFILIAL != "") {
            filtro = constroiFiltro(row, ["CDFILIAL"]);
            field.widget.getField("NMCIA").dataSourceFilter = filtro;
            field.widget.getField("NMCIA").reload();
            field.widget.getField("NMCIA").value("");
            filtro = constroiFiltro(row, ["CDFILIAL", "DTINICIAL", "DTFINAL"]);
            filtro.push(condicaoTCdcia);
            field.widget.getField("DSDELIVERY").dataSourceFilter = filtro;
            field.widget.getField("DSDELIVERY").reload();
            field.widget.getField("DSDELIVERY").value("");
        } else {
            field.widget.getField("NMCIA").value("");
            field.widget.getField("DSDELIVERY").value("");
            limpaFiltros(field, ["NMCIA", "DSDELIVERY"]);
        }

    };

    this.constroiFiltroFieldDelivery = function(field) {
        let row = field.widget.currentRow;
        let filtro;
        let condicaoCdcia = {
            "name": "CDCIA",
            "operator": "=",
            "value": row.NMCIA.join("_")
        };
        let condicaoTCdcia = {
            "name": "CDCIA",
            "operator": "=",
            "value": "T"
        };

        if (row.CDFILIAL != "" && row.NMCIA.length > 0) {
            filtro = constroiFiltro(row, ["CDFILIAL", "DTINICIAL", "DTFINAL"]);
            filtro.push(condicaoCdcia);
            field.widget.getField("DSDELIVERY").value("");
            field.widget.getField("DSDELIVERY").dataSourceFilter = filtro;
            field.widget.getField("DSDELIVERY").reload();
        } else {
            field.widget.getField("DSDELIVERY").value("");
            field.widget.getField("DSDELIVERY").dataSourceFilter = field.widget.getField("DSDELIVERY").dataSourceFilter.filter(function(condicao) {
                return condicao.name != "CDCIA";
            });
            field.widget.getField("DSDELIVERY").dataSourceFilter.push(condicaoTCdcia);
            field.widget.getField("DSDELIVERY").reload();
        }

    };

    this.limpaFiltroDeliveryEBloqueiaCia = function(field) {
        let row = field.widget.currentRow;
        let filtro;
        if (field.value() == "T") {
            let condicaoTCdcia = {
                "name": "CDCIA",
                "operator": "=",
                "value": "T"
            };
            field.widget.getField("DSDELIVERY").value("");
            if (typeof row.CDFILIAL != "undefined" || row.CDFILIAL != "" || row.CDFILIAL != null) {
                filtro = constroiFiltro(row, ["CDFILIAL", "DTINICIAL", "DTFINAL"]);
                filtro.push(condicaoTCdcia);
                field.widget.getField("DSDELIVERY").dataSourceFilter = filtro;
            } else {
                field.widget.getField("DSDELIVERY").value("");
                limpaFiltros(field, ["DSDELIVERY"]);
            }
        } else {
            field.widget.getField("DSDELIVERY").value("");
        }
        General.toggleReadOnlySelect(field, field.widget.getField("NMCIA"));
    };

    this.verificaDataSourceFilter = function(args) {
        if (typeof args.owner.field.dataSourceFilter == "undefined" || args.owner.field.dataSourceFilter.length == 0 || args.row.NMFILIAL == "") {
            MessageService.showMessageByCode("ALE_SELECT_COMPANY_OR_UNIT");
            args.e.preventDefault();
        }
    };

    this.verificaCompanhia = function(args) {
        if (typeof args.owner.field.dataSourceFilter == "undefined" || args.owner.field.dataSourceFilter.length == 0 || args.row.NMFILIAL == "") {
            MessageService.showMessageByCode("ALE_SELECT_COMPANY_OR_UNIT");
            args.e.preventDefault();
        }
        if (args.row.NMCIA.length == 0 && args.row.TNMCIA == "N") {
            MessageService.showMessageByCode("ALE_SELECT_COMPANY");
            args.e.preventDefault();
        }
    };

    this.relatorio = function(widget, formato) {
        if (widget.isValid()) {
            let row = ajustaRowParaRelatorio(widget.currentRow, formato);
            if (moment(row.DTFINAL, "DD/MM/YYYY").isBefore(moment(row.DTINICIAL, "DD/MM/YYYY"))) {
                MessageService.showMessageByCode("ATE00002_PERIODO_INVALIDO");
            } else {
                General.openReport("ate#/espelhodelivery", row.REPORTNAME, row).then(function(callback) {
                    ScreenService.closePopup();
                    widget.activate();
                    widget.reload();
                }, function(error) {
                    let errorMessage = "Timeout";
                    if (error.data)
                        errorMessage = error.data.error;
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
    };

    let ajustaRowParaRelatorio = function(row, formato) {

        let newRow = angular.copy(row);

        newRow.REPORTFORMAT = formato;

        if (row.TNMCIA == "T") {
            newRow.CDCIA = "T";
        } else {
            newRow.CDCIA = row.NMCIA.join("_");
        }
        if (row.TDSDELIVERY == "T") {
            newRow.NRDELIVERY = "T";
        } else {
            newRow.NRDELIVERY = row.DSDELIVERY.join("_");
        }

        return newRow;

    };

    let validaDias = function(widget) {
        let dataInicial = widget.currentRow.DTINICIAL;
        dataInicial = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").minDate = moment(dataInicial, "DD/MM/YYYY");
    };

    let constroiFiltro = function(row, fieldsPai) {
        let filtro = [];
        for (let parametro in fieldsPai) {
            filtro.push({
                "name": fieldsPai[parametro],
                "operator": "=",
                "value": row[fieldsPai[parametro]]
            });
        }
        return filtro;
    };

    let limpaFiltros = function(field, fieldsFilhos) {
        for (let filho in fieldsFilhos) {
            let filter = field.widget.getField(fieldsFilhos[filho]).dataSourceFilter.find(cFilter => cFilter.name === field.valueField);
            if (filter) {
                filter.value = "";
            }
        }
    };

    let habilitaFields = function(row, field, fieldsDependentes, habilita) {

        let filho;

        if (habilita) {
            for (filho in fieldsDependentes) {
                field.widget.getField(fieldsDependentes[filho]).readOnly = false;
            }
        } else {
            for (filho in fieldsDependentes) {
                field.widget.getField(fieldsDependentes[filho]).readOnly = true;
                field.widget.getField(fieldsDependentes[filho]).value("");
            }
        }
    };

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate01300_espelho_delivery_controller", ate01300_espelho_delivery_controller);
});

// FILE: ./assets/js/controllers/ate01800_faturamento_por_empresa_controller.js
let ate01800_faturamento_por_empresa_controller = function(General, templateManager, localStorageEngine, MessageService) {

    let FILTROCLEAR = [
        {
            name: "NRORG",
            operator: "=",
            value: "-1"
		}
	];

    this.limpaField = function(field) {
        field.widget.currentRow.NMCIA = "";
    };

    this.unidadeToCompanhia = function(field) {

        let cdfilial = field.widget.currentRow.CDFILIAL;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];

        if (!field.widget.currentRow.CDFILIAL && field.name === "NMCIA") {
            field.dataSourceFilter = FILTROCLEAR;
            field.reload();
            MessageService.showMessageByCode("ALE_SELECT_BRANCH");
            return;
        }

        field.widget.getField("NMCIA").dataSourceFilter = filter;
        field.widget.getField("NMCIA").reload();
    };

    let validaDias = function(widget) {

        let dataInicial = widget.currentRow.DTINICIAL;
        dataInicial = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").minDate = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").reload();
    };

    this.habilitaFieldData = function(widget) {

        widget.currentRow.DTFINAL = "";
        widget.getField("DTFINAL").readOnly = true;
        widget.getField("DTFINAL").reload();

        if (widget.currentRow.DTINICIAL) {
            widget.getField("DTFINAL").readOnly = false;
            validaDias(widget);
        }
    };

    let listaCompanhia = function(field) {
        let lista = "";
        let rows = field.selectWidget.getCheckedRows();
        for (let i = 0; i < rows.length; i++) {
            if (lista == "") {
                lista = rows[i].CDCIA;
            } else {
                lista = lista + "_" + rows[i].CDCIA;
            }
        }
        return lista;
    };

    this.geraRelatorio = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.NRORG = localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB");
            if (widget.currentRow.TCIA != "S") {
                let companhia = listaCompanhia(widget.getField("NMCIA"));
                widget.currentRow.CDCIA = companhia;
            } else {
                widget.currentRow.CDCIA = "T";
            }
            General.openReport("ate#/ate01800", null, widget.currentRow);
        }
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate01800_faturamento_por_empresa_controller", ate01800_faturamento_por_empresa_controller);
});

// FILE: ./assets/js/controllers/ate02000_total_refeicoesController.js
let ate02000_total_refeicoesController = function(General, ScreenService, templateManager, localStorageEngine) {

    this.setFilialLogada = function(args) {
        args.owner.currentRow.CDFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_CDFILIAL");
        args.owner.currentRow.NMFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_NMFILIAL");
    };

    let validaDias = function(widget) {
        let dataInicial = widget.currentRow.DTINICIAL;

        dataInicial = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").minDate = moment(dataInicial, "DD/MM/YYYY");
    };

    this.habilitaFieldData = function(widget) {
        widget.currentRow.DTFINAL = "";
        widget.getField("DTFINAL").readOnly = true;
        widget.getField("DTFINAL").reload();

        if (widget.currentRow.DTINICIAL) {
            widget.getField("DTFINAL").readOnly = false;
            validaDias(widget);
        }
    };

    this.configuraIntervaloDatas = function(widget) {
        widget.getField("DTFINAL").readOnly = true;
        widget.getField("DTFINAL").reload();

        if (widget.currentRow.DTINICIAL) {
            widget.getField("DTFINAL").readOnly = false;
            validaDias(widget);
        }
    };

    this.report = function(widget) {
        if (widget.isValid()) {
            General.openReport("ate#/relatorioTotalRefeicoes", null, widget.currentRow).then(function(callback) {
                widget.activate();
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data)
                    errorMessage = error.data.error;
                ScreenService.showMessage(errorMessage);
            });
        }
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate02000_total_refeicoesController", ate02000_total_refeicoesController);
});

// FILE: ./assets/js/controllers/ate02500_frequencia_voo_global_controller.js
let ate02500_frequencia_voo_global_controller = function(templateManager, General, ZhFilterPreferences, InflightorGeneral) {

    let self = this;
    let flag;

    this.openFilter = function() {
        const row = {
            CDFILIAL: getLocalVar('CDFILIAL'),
            NMFILIAL: getLocalVar('NMFILIAL'),
            DATAREF: moment().format('DD/MM/YYYY')
        };
        ZhFilterPreferences.openFilterWidget(getMainWidget(), row);
    };

    function getWidget(widgetName) {
        return templateManager.container.getWidget(widgetName);
    }

    this.setStripe = function(widgetName, row) {
        getWidget(widgetName).currentRow = angular.copy(row);
    };

    this.filterOnEnter = function(args, tab) {
        let widgetServicos = getWidget("ate02500_frequencia_voo_global_diarios");
        InflightorGeneral.openFilterOnEnter(widgetServicos, ['CDFILIAL', 'NMFILIAL', 'DATAREF']);
    };

    this.setFilterTabs = function(args, widget) {
        let dataSourceFilter = widget.dataSourceFilter;
        let tabbed = widget.parent.widgets;
        for (let key = 0; key < tabbed.length; key++) {
            tabbed[key].dataSourceFilter = [];
            tabbed[key].dataSourceFilter[0] = {
                "name": "FREQUENCIA",
                "operator": "=",
                "value": key
            };
            for (let filter = 1; filter < dataSourceFilter.length; filter++) {
                tabbed[key].dataSourceFilter[filter] = dataSourceFilter[filter];
                if (tabbed[key].dataSourceFilter[filter].name == "HRDECOLVOO" ||
                    tabbed[key].dataSourceFilter[filter].name == "HRPOUSOVOO")
                    tabbed[key].dataSourceFilter[filter].value = tabbed[key].dataSourceFilter[filter].value.replace(":", "");
            }
        }
        self.afterLoadDataSource(widget);
    };

    this.afterLoadDataSource = function(widget) {
        if (widget.dataSource && widget.dataSource.data) {
            widget.dataSource.data.forEach(function(row) {
                row.HRDECOLVOO = row.HRDECOLVOO ? row.HRDECOLVOO.slice(0, 2) + ":" + row.HRDECOLVOO.slice(2, 4) : "";
                row.HRPOUSOVOO = row.HRPOUSOVOO ? row.HRPOUSOVOO.slice(0, 2) + ":" + row.HRPOUSOVOO.slice(2, 4) : "";
            });
        }
    };

    function getMainWidget() {
        return templateManager.container.getWidget('ate02500_frequencia_voo_global_diarios');
    }

    this.afterFilterAplly = function(args) {
        const mainWidget = getMainWidget();
        let filterRow = args.e.preference.FILTER_ROW;
        filterRow.DSCLASSECIA = args.owner.DSCLASSECIA_backup;
        args.owner.DSCLASSECIA_backup = [];
        args.owner._filterInfo = args.owner._filterInfo.filter(f => f.label !== 'Decolagem' && f.label !== 'Pouso');
        const actionReport = mainWidget.getAction('report');
        actionReport.isVisible = true;
    };

    this.beforeFilterApply = function(args) {
        // widget.dataSourceFilter;
        let widget = args.owner;
        let CUSTOM_FILTER_ROW = angular.copy(args.e.preference.FILTER_ROW);
        if (CUSTOM_FILTER_ROW.HRDECOLVOO) {
            CUSTOM_FILTER_ROW.HRDECOLVOO = CUSTOM_FILTER_ROW.HRDECOLVOO.replace(":", "");
        }
        if (CUSTOM_FILTER_ROW.HRPOUSOVOO) {
            CUSTOM_FILTER_ROW.HRPOUSOVOO = CUSTOM_FILTER_ROW.HRPOUSOVOO.replace(":", "");
        }
        args.e.preference.CUSTOM_FILTER_ROW = CUSTOM_FILTER_ROW;
    };

    this.unidadeToCompanhia = function(field) {
        let cdfilial = field.widget.currentRow.CDFILIAL;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];
        field.widget.getField("NMCIA").dataSourceFilter = filter;
        field.widget.getField("NMCIA").reload();
    };

    this.setFilialLogada = function(args) {
        args.owner.currentRow.CDFILIAL = getLocalVar("INFLIGHTOR_CDFILIAL");
        args.owner.currentRow.NMFILIAL = getLocalVar("INFLIGHTOR_NMFILIAL");
    };

    this.filtraVoo = function(field) {
        let cdfilial = field.widget.currentRow.CDFILIAL;
        let companhia = field.widget.currentRow.CDCIA;
        let obj = {
            "CDFILIAL": cdfilial,
            "CDCIA": companhia ? companhia : "T"
        };
        General.onClickDependentField(field, obj);
        field.reload();

    };

    this.limpaCiaVoo = function(field) {
        let vooCompanhia = field.widget.getField('NMCIA');
        let vooField = field.widget.getField('NRVOO');
        vooCompanhia.setValue('');
        vooField.setValue('');
        field.widget.currentRow.NRVOO = '';
        field.widget.currentRow.NMCIA = '';
    };

    this.limpaVoo = function(field) {
        let vooField = field.widget.getField('NRVOO');
        vooField.setValue('');
        field.widget.currentRow.NRVOO = '';
    };

    this.setFilterClass = function(widget) {
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
    		},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": widget.currentRow.NRVOO
    		},
            {
                "name": "CDEQUIP",
                "operator": "=",
                "value": widget.currentRow.CDEQUIP
    		},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": widget.currentRow.CDTRECHO
    		},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widget.currentRow.CDCIA
    		}
    	];
        if (widget.currentRow.SGPREFIXO)
            filter.push({
                "name": "SGPREFIXO",
                "operator": "=",
                "value": widget.currentRow.SGPREFIXO
            });
        widget.widgets[0].dataSourceFilter = filter;
        widget.widgets[0].reload();
    };

    this.setValueStripeFooter = function(widget) {
        let totalpax = 0;
        widget.dataSource.data.forEach(function(row) {
            totalpax += row.QT;
        });
        let stripeFooter = widget.widgets[0];
        stripeFooter.currentRow.QT_TOTAL = totalpax;
        stripeFooter.getField("QT_TOTAL").setValue(totalpax);
        stripeFooter.reload();
    };

    this.report = function(widget) {
        let row = {
            "CDFILIAL": widget.appliedFilter.FILTER_ROW.CDFILIAL,
            "DATAREF": widget.appliedFilter.FILTER_ROW.DATAREF
        };
        General.openReport("ate#/relatorioFreqVooGlobal", "ATE02500", row);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("ate02500_frequencia_voo_global_controller", ate02500_frequencia_voo_global_controller);
});

// FILE: ./assets/js/controllers/ate03600_tabelaprecos_manualController.js
// FILE: bower_components/ate/assets/js/controllers/ate03600_tabelaprecos_manualController.js
let ate03600_tabelaprecos_manualController = function(ScreenService, General, ate03600_tabelaprecos_manualService, ZHPromise, localStorageEngine, MessageService) {

    let self = this;

    this.antesDeAplicarFiltro = function(widget) {

        widget.dataSourceFilter.forEach(function(condicao) {
            if (condicao.name === "IDSERVICO") {
                condicao.operator = "=";
                condicao.value = widget.__filterPopup.currentRow.IDSERVICO;
            }
        });

    };

    this.setFilialLogadaRow = function(widget) {
        widget.__filterPopup.currentRow.CDFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_CDFILIAL");
        widget.__filterPopup.currentRow.NMFILIAL = localStorageEngine.getLocalVar("INFLIGHTOR_NMFILIAL");
    };

    this.desabilitaTodosFields = function(widget, field) {
        if (widget.currentRow[field.name] === "") {
            widget.fields.forEach(function(fieldDependente) {
                if (fieldDependente.name !== field.name) {
                    fieldDependente.readOnly = true;
                    fieldDependente.value("");
                }
            });
        }
    };

    this.habilitaField = function(widget, field, dependentes) {

        if (dependentes.length > 1) {
            habilitaVariosField(widget, field, dependentes);
        } else {
            habilitaUmField(widget, field, dependentes);
        }
    };

    let habilitaUmField = function(widget, field, dependentes) {
        if (widget.currentRow[field] === "") {
            widget.getField(dependentes[0]).readOnly = true;
            widget.getField(dependentes[0]).value("");
        } else {
            if (widget.currentRow[dependentes[0]] !== "") {
                widget.getField(dependentes[0]).value("");
            }
            widget.getField(dependentes[0]).readOnly = false;
        }
    };
    let habilitaVariosField = function(widget, field, dependentes) {
        dependentes.forEach(function(dependente) {
            if (widget.currentRow[field] === "") {
                widget.getField(dependente).readOnly = true;
                widget.getField(dependente).value("");
            } else {
                if (widget.currentRow[dependente] !== "") {
                    widget.getField(dependente).value("");
                }
                widget.getField(dependente).readOnly = false;
            }
        });
    };

    this.constroiFiltro = function(widget, fieldsDependente, parametros) {

        if (fieldsDependente.length > 1) {
            filtraVariosFields(widget, fieldsDependente, parametros);
        } else {
            filtraField(widget, fieldsDependente[0], parametros);
        }

    };

    let filtraField = function(widget, fieldsDependente, parametros) {

        let filtro = parametros.map(function(parametro) {
            return {
                name: parametro,
                operator: "=",
                value: widget.currentRow[parametro]
            };
        });

        widget.getField(fieldsDependente).dataSourceFilter = filtro;
        widget.getField(fieldsDependente).reload();

    };

    let filtraVariosFields = function(widget, fieldsDependente, parametros) {

        let filtro = parametros.map(function(parametro) {
            return {
                name: parametro,
                operator: "=",
                value: widget.currentRow[parametro]
            };
        });

        fieldsDependente.forEach(function(field) {
            widget.getField(field).dataSourceFilter = filtro;
            widget.getField(field).reload();
        });

    };

    this.preparaView = function(widget) {
        if (widget.name == "grid_servicos") {
            if (!ScreenService.isSwipeOpen()) {
                ScreenService.openSwipe(widget.container.getWidget("tabbed"));
            } else {
                widget.container.getWidget("grid_subgrupos").unSelectAll();
            }
            widget.container.getWidget("grid_subgrupos").activate();

            widget.container.getWidget("tabbed").getField("IDCICLO").dataSourceFilter = [
                {
                    name: "NRORG",
                    operator: "=",
                    value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
				},
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: widget.currentRow.CDFILIAL
				},
                {
                    name: "CDCIA",
                    operator: "=",
                    value: widget.currentRow.CDCIA
				},
                {
                    name: "CDMANCIA",
                    operator: "=",
                    value: widget.currentRow.CDMANCIA
				},
                {
                    name: "NRSERVICOCIAFILI",
                    operator: "=",
                    value: widget.currentRow.NRSERVICOCIAFILI
				},
                {
                    name: "CDCLASSE",
                    operator: "=",
                    value: widget.currentRow.CDCLASSE
				}
			];

            widget.container.getWidget("tabbed").getField("IDCICLO").reload().then(function(callback) {
                if (callback.dataset.ciclosubgrusemam_ciclos_existentes[0]) {
                    widget.container.getWidget("tabbed").currentRow.IDCICLO = callback.dataset.ciclosubgrusemam_ciclos_existentes[0].IDCICLO;
                    widget.container.getWidget("tabbed").currentRow.CDCICLO = callback.dataset.ciclosubgrusemam_ciclos_existentes[0].CDCICLO;
                }
                //Cuida da parte de filtros da aba de subgrupos
                widget.container.getWidget("grid_subgrupos").dataSourceFilter = [{
                    name: "NRORG",
                    operator: "=",
                    value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
				}, {
                    name: "CDFILIAL",
                    operator: "=",
                    value: widget.currentRow.CDFILIAL
				}, {
                    name: "CDCIA",
                    operator: "=",
                    value: widget.currentRow.CDCIA
				}, {
                    name: "CDCLASSE",
                    operator: "=",
                    value: widget.currentRow.CDCLASSE
				}, {
                    name: "CDMANCIA",
                    operator: "=",
                    value: widget.currentRow.CDMANCIA
				}, {
                    name: "CDCICLO",
                    operator: "=",
                    value: widget.container.getWidget("tabbed").currentRow.CDCICLO
				}, {
                    name: "NRSERVICOCIAFILI",
                    operator: "=",
                    value: widget.currentRow.NRSERVICOCIAFILI
				}];

                //cuida dos valores das outras tabs
                widget.container.getWidget("grid_subgrupos").getField("CDMANCIA").defaultValue = widget.currentRow.CDMANCIA;
                widget.container.getWidget("grid_subgrupos").getField("CDCLASSE").defaultValue = widget.currentRow.CDCLASSE;
                widget.container.getWidget("grid_subgrupos").getField("CDFILIAL").defaultValue = widget.currentRow.CDFILIAL;
                widget.container.getWidget("grid_subgrupos").getField("CDCIA").defaultValue = widget.currentRow.CDCIA;
                widget.container.getWidget("grid_subgrupos").getField("CDCICLO").defaultValue = widget.currentRow.CDCICLO;
                widget.container.getWidget("grid_subgrupos").getField("NRSERVICOCIAFILI").defaultValue = widget.currentRow.NRSERVICOCIAFILI;

                //da um reload para aplicar os filtros
                widget.container.getWidget("grid_subgrupos").reload();
            });
        }
        if (widget.name == "grid_subgrupos") {
            //isso vai ser utilizado caso seja necessário ter os itens de faturamento por composicao
            if (widget.currentRow.NRSERVICOCIAFILIPRECO && widget.currentRow.NRTABPRECO) {
                MessageService.confirmMessageByCode('ALE_CONFIRM_SUBGROUP_BILLING').then(function(success) {
                    widget.removeRow().then(function(sucess) {
                        self.abreComposicao(widget);
                    }, function(error) {
                        MessageService.showMessageByCode("ERR_CLEAR_ITEM_INVOICING");
                    });
                });
            } else {
                MessageService.confirmMessageByCode('ALE_CONFIRM_SUBGROUP_COMPOSITION').then(function(success) {
                    self.abreComposicao(widget);
                });
            }
        }
    };

    this.abreComposicao = function(widget) {
        ScreenService.openPopup(widget.container.getWidget("grid_composicao")).then(function() {
            self.carregaDataSourceComposicao(widget.container.getWidget("grid_composicao"));
            widget.container.getWidget("grid_composicao").activate();
        });
    };

    this.afterLoadDataSourceSubgru = function(widget) {
        widget.dataSource.data.forEach(function(row) {
            if (row.DTINIVGSUMA && row.DTFIMVGSUMA)
                row.VIGENCIA = moment(row.DTINIVGSUMA, "DD/MM/YYYY hh:ss:mm").format("DD/MM/YYYY") + " à " + moment(row.DTFIMVGSUMA, "DD/MM/YYYY hh:ss:mm").format("DD/MM/YYYY");
        });
    };

    this.fieldOnChangeFiltro = function(args, caso) {

        let msg;

        if (caso == "o Manual") {
            if (args.row.CDFILIAL) {
                args.owner.owner.widget.getField("DSMANUAL").dataSourceFilter[1].value = args.row.CDFILIAL;
                if (args.row.CDCIA) {
                    args.owner.owner.widget.getField("DSMANUAL").dataSourceFilter[2].value = args.row.CDCIA;
                    args.owner.owner.widget.getField("DSMANUAL").reload();
                } else {
                    args.owner.owner.widget.getField("DSMANUAL").dataSourceFilter[2].value = "";
                    args.owner.owner.widget.getField("DSMANUAL").reload();
                    msg = ScreenService.i18n("Escolha uma Companhia para definir " + caso + "!");
                    ScreenService.showMessage(msg);
                }
            } else {
                args.owner.owner.widget.getField("DSMANUAL").dataSourceFilter[1].value = "";
                args.owner.owner.widget.getField("DSMANUAL").reload();
                msg = ScreenService.i18n("Escolha uma Unidade para definir " + caso + "!");
                ScreenService.showMessage(msg);
            }
        } else if (caso == "a Classe") {
            if (args.row.CDFILIAL) {
                args.owner.owner.widget.getField("DSCLASSE").dataSourceFilter[1].value = args.row.CDFILIAL;
                if (args.row.CDCIA) {
                    args.owner.owner.widget.getField("DSCLASSE").dataSourceFilter[2].value = args.row.CDCIA;
                    args.owner.owner.widget.getField("DSCLASSE").reload();
                } else {
                    args.owner.owner.widget.getField("DSCLASSE").dataSourceFilter[2].value = "";
                    args.owner.owner.widget.getField("DSCLASSE").reload();
                    msg = ScreenService.i18n("Escolha uma Companhia para definir " + caso + "!");
                    ScreenService.showMessage(msg);
                }
            } else {
                args.owner.owner.widget.getField("DSCLASSE").dataSourceFilter[1].value = "";
                args.owner.owner.widget.getField("DSCLASSE").reload();
                msg = ScreenService.i18n("Escolha uma Unidade para definir " + caso + "!");
                ScreenService.showMessage(msg);
            }
        }
    };

    this.filtraSubgrupos = function(tabbed, gridSubgrupos) {

        gridSubgrupos.unSelectAll();
        gridSubgrupos.dataSourceFilter = [{
            name: "NRORG",
            operator: "=",
            value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
		}, {
            name: "CDFILIAL",
            operator: "=",
            value: gridSubgrupos.container.getWidget("grid_servicos").currentRow.CDFILIAL
		}, {
            name: "CDCIA",
            operator: "=",
            value: gridSubgrupos.container.getWidget("grid_servicos").currentRow.CDCIA
		}, {
            name: "CDCLASSE",
            operator: "=",
            value: gridSubgrupos.container.getWidget("grid_servicos").currentRow.CDCLASSE
		}, {
            name: "CDMANCIA",
            operator: "=",
            value: gridSubgrupos.container.getWidget("grid_servicos").currentRow.CDMANCIA
		}, {
            name: "CDCICLO",
            operator: "=",
            value: tabbed.currentRow.CDCICLO
		}, {
            name: "NRSERVICOCIAFILI",
            operator: "=",
            value: gridSubgrupos.container.getWidget("grid_servicos").currentRow.NRSERVICOCIAFILI
		}];

        //cuida dos valores das outras tabs
        gridSubgrupos.getField("CDCICLO").defaultValue = tabbed.currentRow.CDCICLO;

        //da um reload para aplicar os filtros
        gridSubgrupos.reload();

    };

    this.limpaItem = function(widget) {
        let rows = widget.getCheckedRows();
        let status = true;
        MessageService.confirmMessageByCode("ALE_CLEAR_REGISTRATION").then(function(success) {
            rows.forEach(function(row) {
                if (!row.NRSERVICOCIAFILIPRECO && !row.NRTABPRECO) {
                    status = false;
                }
            });
            if (status === false) {
                MessageService.showMessage("ERR_CLEAR_ITEM_WITHOUT_BILLING");
            } else {
                widget.removeCheckedRows();
            }
        });
    };

    this.adicionaItem = function(widget, caso) {
        let popupItem = widget.container.getWidget("popup_item");
        let rows = widget.getCheckedRows();
        let status = true;
        rows.forEach(function(row) {
            if (row.NRSERVICOCIAFILIPRECO) {
                status = false;
            }
        });

        if (status) {
            popupItem.currentRow = {};
            popupItem.dataSourceFilter = [{
                name: "NRORG",
                operator: "=",
                value: localStorageEngine.getLocalVar("INFLIGHTOR_NRORGTRAB")
			}, {
                name: "CDCIA",
                operator: "=",
                value: widget.container.getWidget("grid_servicos").currentRow.CDCIA
			}, {
                name: "CDFILIAL",
                operator: "=",
                value: widget.container.getWidget("grid_servicos").currentRow.CDFILIAL
			}, {
                name: "CDCLASSE",
                operator: "=",
                value: widget.container.getWidget("grid_servicos").currentRow.CDCLASSE
			}, {
                name: "CDCICLO",
                operator: "=",
                value: widget.container.getWidget("tabbed").currentRow.CDCICLO
			}];

            //da um reload para aplicar os filtros
            popupItem.reload();
            ScreenService.openPopup(popupItem);
            popupItem.activate();

            popupItem.currentRow.caso = caso;
        } else {
            MessageService.showMessage("ALE_THERE_ARE_RECORDS_WITH_BILLING_ITEM");
        }
    };

    this.salvaItem = function(popup, caso) {
        caso = (popup.currentRow.caso) ? popup.currentRow.caso : caso;
        let paramsNewCode = popup.paramsNewCode;
        let widgetSubgru = popup.container.getWidget("grid_subgrupos");
        let widgetComposicao = popup.container.getWidget("grid_composicao");
        if (caso == "subgrupo") {
            ScreenService.confirmMessage(ScreenService.i18n("Vincular " + popup.currentRow.DSSERVICOCIAFILI + "?"), "question", function(success) {
                let rows = widgetSubgru.getCheckedRows();
                rows.forEach(function(row) {
                    row.NRSERVICOCIAFILIPRECO = popup.currentRow.NRSERVICOCIAFILI;
                    row.changed = true;
                    row.__is_new = true;
                    if (paramsNewCode && paramsNewCode.__is_new_code) {
                        row.__using_unit = paramsNewCode.__using_unit || false;
                        row.__new_code_pk = paramsNewCode.__new_code_pk;
                        row.__table_pk = paramsNewCode.__table_pk;
                        row.__new_code_length = paramsNewCode.__new_code_length || 5;
                        row.__cast_number = paramsNewCode.__cast_number || false;
                    }
                });

                General.callRestEngine("ate#/salvaItens", "DataSet", rows).then(function() {
                        widgetSubgru.unSelectAll();
                        ScreenService.closePopup();
                        widgetSubgru.activate();
                        widgetSubgru.reload();
                    },
                    function(error) {
                        ScreenService.showMessage(error.data.error);
                    }
                );
            });
        }
        if (caso == "composicao") {
            let dataSetToSave = [];
            widgetComposicao.getCheckedRows().forEach(function(row) {
                let rowToSave = {};
                rowToSave.CDCIA = angular.copy(row.CDCIA);
                rowToSave.CDCICLO = angular.copy(row.CDCICLO);
                rowToSave.CDCLASSE = angular.copy(row.CDCLASSE);
                rowToSave.CDFILIAL = angular.copy(row.CDFILIAL);
                rowToSave.CDMANCIA = angular.copy(row.CDMANCIA);
                rowToSave.CDOPERINCLUSAO = angular.copy(row.CDOPERINCLUSAO);
                rowToSave.CDOPERULTATU = angular.copy(row.CDOPERULTATU);
                rowToSave.CDPRODUTO = angular.copy(row.CDPRODUTO);
                rowToSave.CDRECEITA = angular.copy(row.CDRECEITA);
                rowToSave.CDSUBGRU = angular.copy(row.CDSUBGRU);
                rowToSave.ID = angular.copy(row.ID);
                rowToSave.NRORG = angular.copy(row.NRORG);
                rowToSave.NRSEQSUBGRUSEMAM = angular.copy(row.NRSEQSUBGRUSEMAM);
                rowToSave.NRSERVICOCIAFILI = angular.copy(row.NRSERVICOCIAFILI);

                rowToSave.NRTABPRECO = angular.copy(popup.currentRow.NRTABPRECO);
                rowToSave.NRSERVICOCIAFILIPRECO = angular.copy(popup.currentRow.NRSERVICOCIAFILI);
                rowToSave.NRSEQPRECO = angular.copy(popup.currentRow.NRSEQPRECO);

                rowToSave.changed = true;
                rowToSave.__is_new = true;
                rowToSave.__is_new_code = true;
                rowToSave.__new_code_pk = "PRECOSESUBGRU";
                rowToSave.__new_code_length = 25;
                rowToSave.__table_pk = "NRSEQPRECOSESUBGRU";

                dataSetToSave.push(rowToSave);
            });

            General.callRestEngine("ate#/salvaItens", "DataSet", dataSetToSave).then(function() {
                widgetComposicao.unSelectAll();
                ScreenService.closePopup();
                widgetComposicao.activate();
                widgetComposicao.reload();
            });
        }
    };

    //carrega os dados de produto e receitas para montar o grid de composição
    this.carregaDataSourceComposicao = function(widget) {

        //pega a current row de subgrupos para preencher os filtros do request
        let row = widget.container.getWidget("grid_subgrupos").currentRow;
        let cdfilial = row.CDFILIAL;
        let cdcia = row.CDCIA;
        let CDMANCIA = row.CDMANCIA;
        let nrservicociafili = row.NRSERVICOCIAFILI;
        let cdclasse = row.CDCLASSE;
        let cdciclo = row.CDCICLO;
        let cdsubgru = row.CDSUBGRU;

        //arrays para implantar os dados
        //solução para integrar duas tabelas em um mesmo grid
        //utilizando nomes genéricos
        let promises = [];
        let produtos = [];
        let receitas = [];
        let positions = {
            PRODUTOS: {
                CODIGO: "CDPRODUTO",
                NOME: "NMPRODUTO",
                VRPRESERV: "VRPRESERV",
                VRPRESERVD: "VRPRESERVD",
                UNIDADE: "SGUNIDADE",
                CDFILIAL: "CDFILIAL",
                CDCIA: "CDCIA",
                CDMANCIA: "CDMANCIA",
                NRSERVICOCIAFILI: "NRSERVICOCIAFILI",
                DSSERVICOCIAFILI: "DSSERVICOCIAFILI",
                CDCLASSE: "CDCLASSE",
                CDCICLO: "CDCICLO",
                CDSUBGRU: "CDSUBGRU",
                NRTABPRECO: "NRTABPRECO",
                NRSEQPRECO: "NRSEQPRECO",
                NRORG: "NRORG",
                ID: "P"
            },
            RECEITAS: {
                CODIGO: "CDRECEITA",
                NOME: "DSRECEITA",
                VRPRESERV: "VRPRESERV",
                VRPRESERVD: "VRPRESERVD",
                UNIDADE: "SGUNIDADE",
                CDFILIAL: "CDFILIAL",
                CDCIA: "CDCIA",
                CDMANCIA: "CDMANCIA",
                NRSERVICOCIAFILI: "NRSERVICOCIAFILI",
                DSSERVICOCIAFILI: "DSSERVICOCIAFILI",
                CDCLASSE: "CDCLASSE",
                CDCICLO: "CDCICLO",
                NRTABPRECO: "NRTABPRECO",
                NRSEQPRECO: "NRSEQPRECO",
                CDSUBGRU: "CDSUBGRU",
                NRORG: "NRORG",
                ID: "S"
            }
        };
        let data = [];

        promises.push(ate03600_tabelaprecos_manualService.returnProduto(cdfilial, cdcia, CDMANCIA, nrservicociafili, cdclasse, cdciclo, cdsubgru));
        promises.push(ate03600_tabelaprecos_manualService.returnReceita(cdfilial, cdcia, CDMANCIA, nrservicociafili, cdclasse, cdciclo, cdsubgru));

        ZHPromise.all(promises).then(function(callback) {

            produtos = callback[0].dataset.prodsubsemam_produto_precosesubgru_servicociafili_precoseciam;
            receitas = callback[1].dataset.recsubsemam_receita_precosesubgru_servicociafili_precoseciam;

            setRowByName(data, produtos, positions.PRODUTOS);
            setRowByName(data, receitas, positions.RECEITAS);

            widget.dataSource.data = data;

        }.bind(this), function(callback) {
            General.callbackError(callback);
        });

    };

    this.setFilterComposicao = function(widget) {
        let widgetSubgru = widget.container.getWidget("grid_subgrupos");
        let widgetComposicao = widget.container.getWidget("grid_composicao");

        let dataSourceFilter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widgetSubgru.currentRow.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widgetSubgru.currentRow.CDCIA
			},
            {
                "name": "CDMANCIA",
                "operator": "=",
                "value": widgetSubgru.currentRow.CDMANCIA
			},
            {
                "name": "NRSERVICOCIAFILI",
                "operator": "=",
                "value": widgetSubgru.currentRow.NRSERVICOCIAFILI
			},
            {
                "name": "CDCLASSE",
                "operator": "=",
                "value": widgetSubgru.currentRow.CDCLASSE
			},
            {
                "name": "CDSUBGRU",
                "operator": "=",
                "value": widgetSubgru.currentRow.CDSUBGRU
			},
            {
                "name": "NRSEQSUBGRUSEMAM",
                "operator": "=",
                "value": widgetSubgru.currentRow.NRSEQSUBGRUSEMAM
			},
            {
                "name": "CDCICLO",
                "operator": "=",
                "value": widgetSubgru.currentRow.CDCICLO
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": widgetSubgru.currentRow.NRORG
			}
		];
        widgetComposicao.dataSourceFilter = dataSourceFilter;
        widgetComposicao.reload();
    };

    //Seta as rows do dataSource gerado de composição
    function setRowByName(dataSource, array, position) {
        array.forEach(function(object) {
            let row = {
                "CODIGO": object[position.CODIGO],
                "NOME": object[position.NOME],
                "UNIDADE": object[position.UNIDADE],
                "VRPRESERV": object[position.VRPRESERV],
                "VRPRESERVD": object[position.VRPRESERVD],
                "CDFILIAL": object[position.CDFILIAL],
                "CDCIA": object[position.CDCIA],
                "CDMANCIA": object[position.CDMANCIA],
                "DSSERVICOCIAFILI": object[position.DSSERVICOCIAFILI],
                "NRSERVICOCIAFILI": object[position.NRSERVICOCIAFILI],
                "CDCLASSE": object[position.CDCLASSE],
                "CDCICLO": object[position.CDCICLO],
                "CDSUBGRU": object[position.CDSUBGRU],
                "NRTABPRECO": object[position.NRTABPRECO],
                "NRSEQPRECO": object[position.NRSEQPRECO],
                "NRORG": object[position.NRORG],
                "ID": position.ID
            };
            dataSource.push(row);
        });
    }

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate03600_tabelaprecos_manualController", ate03600_tabelaprecos_manualController);
});

// FILE: ./assets/js/controllers/ate12600_voos_ativos_controller.js
let ate12600_voos_ativos_controller = function(ScreenService, General, templateManager, MessageService) {

    this.mudaUnidadeDependentes = function(field, colunas, camposDependentes) {
        let currentRow = field.widget.currentRow;
        let coluna;
        let campo;
        if (currentRow[field.name] != "") {
            for (coluna in colunas) {
                let filtro = {
                    "name": colunas[coluna],
                    "operator": "=",
                    "value": currentRow[colunas[coluna]]
                };
                for (campo in camposDependentes) {
                    field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                        return condicao.name != colunas[coluna];
                    });
                    field.widget.getField(camposDependentes[campo]).value();
                    currentRow[camposDependentes[campo]] = null;
                    field.widget.getField(camposDependentes[campo]).dataSourceFilter.push(filtro);
                    field.widget.getField(camposDependentes[campo]).reload();
                }
            }
        } else {
            for (coluna in colunas) {
                for (campo in camposDependentes) {
                    field.widget.getField(camposDependentes[campo]).dataSourceFilter = field.widget.getField(camposDependentes[campo]).dataSourceFilter.filter(function(condicao) {
                        return condicao.name != colunas[coluna];
                    });
                    field.widget.getField(camposDependentes[campo]).value();
                    currentRow[camposDependentes[campo]] = null;
                }
            }
        }
    };

    this.verificaFiltroCia = function(args, filtros) {
        let field = args.owner.field;
        // let currentRow = args.owner.field.widget.currentRow;
        let filtrosValidados = 0;
        let condicao;
        for (condicao in field.dataSourceFilter) {
            if (validaFiltro(field.dataSourceFilter[condicao], filtros))
                filtrosValidados++;
        }
        if (filtrosValidados < 1) {
            MessageService.showMessageByCode("ALE_SELECT_UNIT");
            args.e.preventDefault();
        }
    };

    let validaFiltro = function(condicao, filtros) {
        let filtro;
        for (filtro in filtros) {
            if (condicao.name == filtros[filtro] && condicao.value != "" && condicao.value.length > 0)
                return true;
        }
    };

    let habilitaFields = function(row, field, fieldsDependentes, habilita) {
        if (habilita) {
            for (let filho in fieldsDependentes) {
                field.widget.getField(fieldsDependentes[filho]).readOnly = false;
            }
        } else {
            for (let child in fieldsDependentes) {
                field.widget.getField(fieldsDependentes[child]).readOnly = true;
                field.widget.getField(fieldsDependentes[child]).value("");
            }
        }
    };

    this.relatorio = function(widget, formato) {
        if (widget.isValid()) {
            let row = ajustaRowParaRelatorio(widget.currentRow, formato);
            General.openReport("ate#/voosativos", row.REPORTNAME, row).then(function(callback) {
                ScreenService.closePopup();
                widget.activate();
                widget.reload();
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data)
                    errorMessage = error.data.error;
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    this.onChangeDatafin = function(field) {
        let dataini = moment(field.widget.currentRow.DATAINI, "DD/MM/YYYY");
        let datafin = moment(field.widget.currentRow.DATAFIN, "DD/MM/YYYY");
        if (datafin.isBefore(dataini)) {
            field.clearValue(field);
            field.widget.currentRow.DATAFIN = null;
            MessageService.showMessageByCode("ALE_LOWER_END_DATE");
        }
    };

    this.onChangeDataini = function(field) {
        const fieldEndDate = field.widget.getField("DATAFIN");
        fieldEndDate.clearValue(fieldEndDate);
    };

    let ajustaRowParaRelatorio = function(row, formato) {

        let newRow = angular.copy(row);

        newRow.REPORTFORMAT = formato;

        if (row.TNMCIA == "T") {
            newRow.CDCIA = row.TNMCIA;
        } else {
            newRow.CDCIA = "_" + row.NMCIA.join("_") + "_";
        }

        return newRow;

    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register("ate12600_voos_ativos_controller", ate12600_voos_ativos_controller);
});

// FILE: ./assets/js/controllers/ate14000_deliveries_emitidosController.js
function ate14000_deliveries_emitidosController(InflightorGeneral, MessageService) {

    this.filterVoo = function(widget) {
        let fieldVoo = widget.getField("NRVOO");
        let filter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			},
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
			},
		];
        if (widget.currentRow.TCIA == "N")
            filter.push({
                "name": "CDCIA",
                "operator": "IN",
                "value": widget.currentRow.CDCIA
            });
        else {
            widget.currentRow.CDCIA = "T";
        }
        fieldVoo.dataSourceFilter = filter;
        fieldVoo.reload();
    };

    function concatValues(valueArray) {
        return valueArray.map(function(value) {
                return value;
            })
            .join("_");
    }

    let enableField = function(field, visibility) {

        if (visibility) {
            field.readOnly = !visibility;
            field.validations = {
                "required": visibility
            };
        } else {
            field.readOnly = !visibility;
            field.validations = {};
        }

    };

    this.createReport = function(args) {
        let widget = args.owner.widget;
        if (widget.isValid()) {
            try {
                let currentRow = widget.currentRow;

                let rowToReport = {};
                rowToReport.CDFILIAL = currentRow.CDFILIAL;
                rowToReport.DATAINI = currentRow.DTINICIAL;
                rowToReport.DATAFIM = currentRow.DTFINAL;
                rowToReport.IDCANCEL = currentRow.IDCANCEL;
                rowToReport.NRORG = getLocalVar("INFLIGHTOR_NRORGTRAB");

                if (currentRow.TCIA == "T") {
                    rowToReport.CDCIA = "T";
                } else {
                    let cdcia = currentRow.CDCIA;
                    rowToReport.CDCIA = typeof(cdcia) == "object" ? concatValues(cdcia) : cdcia;
                }

                if (currentRow.TVOO == "T") {
                    rowToReport.NRVOO = "T";
                } else {
                    let nrvoo = currentRow.NRVOO;
                    rowToReport.NRVOO = typeof(nrvoo) == "object" ? concatValues(nrvoo) : nrvoo;
                }

                InflightorGeneral.openReport("ate#/relatorioNotas", "ATE14000", rowToReport);

            } catch (error) {
                MessageService.showMessageByCode("ERR_GENERATING_REPORT");
            }
        }
    };

    let MAP_TFIELD = {
        "CDCIA": "TCIA",
        "NRVOO": "TVOO"
    };

    this.onChangeField = function(field, fieldsDependentes, fieldsDirRelacionados) {

        let widget = field.widget;
        if (fieldsDependentes.length > 0) {
            for (let i = 0; i < fieldsDependentes.length; i++) {

                widget.getField(fieldsDependentes[i]).readOnly = true;
                widget.getField(fieldsDependentes[i]).value('');

                if (typeof widget.getField(MAP_TFIELD[fieldsDependentes[i]]) !== "undefined") {

                    widget.getField(MAP_TFIELD[fieldsDependentes[i]]).value('T');
                    widget.currentRow[MAP_TFIELD[fieldsDependentes[i]]] = 'T';
                    widget.getField(fieldsDependentes[i]).validations = {};

                }
            }
        }
        for (let i = 0; i < fieldsDirRelacionados.length; i++) {
            if (field.value()) {
                if (typeof widget.getField(MAP_TFIELD[fieldsDirRelacionados[i]]) !== "undefined") {
                    widget.getField(fieldsDirRelacionados[i]).readOnly = true;
                    widget.getField(fieldsDirRelacionados[i]).value('');
                    widget.getField(fieldsDirRelacionados[i]).validations = {};
                    widget.getField(MAP_TFIELD[fieldsDirRelacionados[i]]).value('T');
                    widget.currentRow[MAP_TFIELD[fieldsDirRelacionados[i]]] = 'T';
                } else {
                    widget.getField(fieldsDirRelacionados[i]).readOnly = false;
                    widget.getField(fieldsDirRelacionados[i]).value('');
                    widget.getField(fieldsDirRelacionados[i]).reload();
                }
            } else {
                field.widget.getField(fieldsDirRelacionados[i]).value('');
                field.widget.getField(fieldsDirRelacionados[i]).readOnly = true;
                widget.getField(MAP_TFIELD[fieldsDirRelacionados[i]]).value('T');
                widget.currentRow[MAP_TFIELD[fieldsDirRelacionados[i]]] = 'T';
            }
        }

    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register("ate14000_deliveries_emitidosController", ate14000_deliveries_emitidosController);
});

// FILE: ./assets/js/controllers/ate21100_geracao_plano_vooController.js
let ate21100_geracao_plano_vooController = function(ZhFilterPreferences, ScreenService, Query, ate21100_geracao_plano_vooService, ZHPromise, General, EmissaoDeliveryService, templateManager, InflightorGeneral, MessageService) {

    let self = this;
    let tipoprevisao;
    let paramcomis;

    let FILTROCLEAR = [
        {
            name: "NRORG",
            operator: "=",
            value: "-1"
		}
	];

    let trataMensagem = function(mensagem) {
        if (mensagem && mensagem.length) {
            if (!InflightorGeneral.mensagemErroProcedure(mensagem)) {
                if (mensagem.indexOf("ATE21100_") >= 0) {
                    MessageService.showMessageByCode(mensagem);
                } else {
                    ScreenService.showMessage(mensagem);
                }
            }
        }
    };

    this.limpaFilhosUnidade = function(widget) {
        if (!widget.currentRow.CDFILIAL) {
			[widget.getField("SGCIA"), widget.getField("NRVOO")].forEach(function(field) {
                if (field) {
                    field.setValue("");
                    field.readOnly = true;
                }
            });
        } else {
        	[widget.getField("SGCIA"), widget.getField("NRVOO")].forEach(function(field) {
                if (field) {
                    field.setValue("");
                    field.readOnly = false;
                }
            });
        }
    };

    this.retornaParametrosUnidade = function(widget) {
        let row = widget.appliedFilter.FILTER_ROW;
        ate21100_geracao_plano_vooService.retornaParamcomis(row.CDFILIAL).then(function(paramcomis) {
            self.paramcomis = paramcomis.dataset.paramcomis[0];
            if (!self.paramcomis) {
                self.paramcomis = {
                    DTBLOQDEL: null
                };
            }
        });
    };

    function validaBloqueioDelivery(dataBloqueioDelivery, dataDecolagemVoo) {
        dataBloqueioDelivery = dataBloqueioDelivery ? moment(dataBloqueioDelivery, "DD/MM/YYYY") : null;
        dataDecolagemVoo = dataDecolagemVoo ? moment(dataDecolagemVoo, "DD/MM/YYYY") : null;

        if (dataDecolagemVoo > dataBloqueioDelivery) {
            return true;
        } else {
            MessageService.showMessageByCode("ATE21100_DTBLOQ", {
                0: dataBloqueioDelivery.format("DD/MM/YYYY")
            });
            return false;
        }
    }

    this.setFlagOnCurrentRow = function(action) {
        if (action.name == "report_emissao_delivery") {
            if (validaBloqueioDelivery(self.paramcomis.DTBLOQDEL, action.widget.container.getWidget("geracao_plano_voo_selecionados").appliedFilter.FILTER_ROW.DTDECOLVOO)) {
                if (action.widget.currentRow.IDSITABASPV == "3") {
                    MessageService.showMessageByCode('ATE21100_VOOCANCELADO');
                } else {
                    self.callProcedure(action.widget);
                }
            }
        } else {
            action.widget.currentRow.FLAG = true;
            let TELA_ANTERIOR = true;
            action.widget.getParent().defaultTab = action.widget.name;
            ScreenService.openWindow("ate#ate01500_alteracao_plano_de_voo");
        }
    };

    this.verificaFiltro = function(args, widget) {
        if (widget.defaultTab != "geracao_plano_voo_gerados") {
            args.owner.container.getWidget("geracao_plano_voo_selecionados").activate();
            ZhFilterPreferences.openFilterWidget(args.owner.container.getWidget("geracao_plano_voo_selecionados"));
            args.owner.container.getWidget("geracao_plano_voo_selecionados").getField("CDFILIAL").applyDefaultValue();
            args.owner.container.getWidget("geracao_plano_voo_selecionados").getField("NMFILIAL").applyDefaultValue();
            args.owner.container.getWidget("geracao_plano_voo_selecionados").getField("DTDECOLVOO").applyDefaultValue();
        }
    };

    this.unidadeToCompanhia = function(field) {
        let cdfilial = field.widget.currentRow.CDFILIAL;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];
        field.widget.getField("SGCIA").dataSourceFilter = filter;
    };

    this.filtraFiltroVoo = function(field) {

        let cdfilial = field.widget.currentRow.CDFILIAL;
        let companhia = field.widget.currentRow.CDCIA;

        let filter = {
            CDCIA: companhia,
            CDFILIAL: cdfilial,
            NRORG: getLocalVar("INFLIGHTOR_NRORGTRAB")
        };
        General.onClickDependentField(field, filter);
        field.reload();
        if (field.widget.currentRow.CDFILIAL == "" || !field.widget.currentRow.CDFILIAL) {
            MessageService.showMessageByCode("ATE21100_ESCOLHA_UNIDADE");
            return;
        }

        if (field.widget.currentRow.CDFILIAL == "" || !field.widget.currentRow.CDCIA) {
            MessageService.showMessageByCode("ATE21100_ESCOLHA_CIA");
            return;
        }
    };

    this.openPopupVooDisponivel = function(widget) {
        let currentRow = widget.currentRow;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.dataSourceFilter[0].value
			},
            {
                "name": "DTDECOLVOO",
                "operator": "=",
                "value": widget.dataSourceFilter[1].value
			}
		];
        let widgetPopup = widget.container.getWidget("geracao_plano_voo_disponiveis");
        widgetPopup.dataSourceFilter = filter;
        ScreenService.openPopup(widgetPopup);
        widgetPopup.activate();
        widgetPopup.reload();
    };

    this.onEnterVooGerados = function(widget) {
        let widgetVooSelecionados = widget.container.getWidget("geracao_plano_voo_selecionados");
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widgetVooSelecionados.dataSourceFilter[0].value
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": widgetVooSelecionados.dataSourceFilter[1].value
			}
		];
        widget.dataSourceFilter = filter;
        widget.activate();
        widget.reload();
    };

    this.onEnterVooAtendidos = function(widget) {
        let widgetVooSelecionados = widget.container.getWidget("geracao_plano_voo_selecionados");
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widgetVooSelecionados.dataSourceFilter[0].value
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": widgetVooSelecionados.dataSourceFilter[1].value
			}
		];
        widget.dataSourceFilter = filter;
        widget.activate();
        widget.reload();
    };

    this.filterDataServicos = function(widget) {
        if (!widget.currentRow.__is_new) {
            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
				},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": widget.currentRow.CDCIA
				},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": widget.currentRow.NRVOO
				},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": widget.currentRow.CDTRECHO
				},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": widget.currentRow.DTHRPLAVOOPV
				}
			];
            let widgetServicos = widget.container.getWidget("geracao_plano_voo_gerado_servicos");
            widgetServicos.dataSourceFilter = filter;
            ScreenService.openSwipe(widgetServicos.getParent()).then(
                function() {
                    widgetServicos.reload();
                }
            );
        }
    };

    this.orderWidgetbyFilter = function(widget) {
        let filterRow = widget.appliedFilter.FILTER_ROW;
        if (filterRow.ORDEM == 0) {
            widget.order = "SGCIA";
        } else if (filterRow.ORDEM == 1) {
            widget.order = "HRDECOLVOO";
        } else {
            throw "order is not defined";
        }
    };

    this.afterMoveRowClasse = function(widget) {
        let widgetClasse = widget.container.getWidget("geracao_plano_voo_classes");
        let currentRow = widget.currentRow;
        let data = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": currentRow.CDFILIAL
			},
            {
                "name": "CDCIAPPT",
                "operator": "=",
                "value": currentRow.CDCIA
			},
            {
                "name": "NRVOOPPT",
                "operator": "=",
                "value": currentRow.NRVOO
			},
            {
                "name": "CDTRECHOPPT",
                "operator": "=",
                "value": currentRow.CDTRECHO
			},
            {
                "name": "DTHRPLAPPT",
                "operator": "=",
                "value": moment(currentRow.DTDECOLVOO, "DD/MM/YYYY").format("DD/MM/YYYY")
			}
		];
        widgetClasse.dataSourceFilter = data;
        widgetClasse.reload().then(function() {

            let dataRows = widgetClasse.dataSource.data;

            if (dataRows.length) {
                widget.getField("DSEQUIP").setValue(dataRows[0].DSEQUIP);
                widget.getField("SGEQUIP").setValue(dataRows[0].SGEQUIP);
            }
            if (!widget.container.getWidget("geracao_plano_voo_classes").dataSource.data.length) {
                self.widgetOnEnter(widget.container.getWidget("geracao_plano_voo_classes"));
            }
        });
    };

    this.widgetOnEnter = function(widget) {
        let currentRow = widget.container.getWidget("geracao_plano_voo_selecionados").currentRow;
        if (!widget.dataSource.data.length) {
            ate21100_geracao_plano_vooService.getClasse(currentRow).then(function(callback) {
                let classes = callback.dataset.gerar_plano_voo_classe_not_instr;
                if (!classes.length) {
                    let dataClass = [];
                    dataClass.push(currentRow);
                    let dataPrevpax = self.fillsData(dataClass, 1, 0);
                    ate21100_geracao_plano_vooService.executeProcedureClasse(dataPrevpax).then(function() {
                        widget.reload();
                    }, function(error) {
                        if (error.data) {
                            trataMensagem(error.data.error);
                        } else
                            MessageService.showMessageByCode('ERRO_INESPERADO');
                    });
                }
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data)
                    trataMensagem(error.data.error);
                else
                    MessageService.showMessageByCode('ERRO_INESPERADO');
            });
        }
    };
    this.alterAllEquipamento = function(widget) {
        //geracao_plano_voo_equipamento
        let currentRow = widget.currentRow;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": currentRow.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": currentRow.CDCIA
			}
		];
        let widgetEquip = widget.container.getWidget("geracao_plano_voo_equipamento");
        widgetEquip.dataSourceFilter = filter;
        ScreenService.openPopup(widgetEquip);
        widgetEquip.activate();
        widgetEquip.reload();
    };
    this.openPopupMedia = function(widget) {
        ScreenService.openPopup(widget.container.getWidget("popupMedia")).then(function() {});
    };

    this.selectedVoo = function(widget) {
        let currentVoo = widget.getCheckedRows();
        if (!currentVoo.length) {
            MessageService.showMessageByCode("ATE21100_SELECIONE_1_VOO");
        } else {
            //Executa procedure GERA_PREVISAO_PAX
            let data = [];
            currentVoo.forEach(function(voo) {
                let row = {
                    "P_CDFILIAL": voo.CDFILIAL,
                    "P_DTRELPLANPAX": moment().format("DD/MM/YYYY"), //Fixed Today
                    "P_NRRELPLANPAX": null, //Fixed
                    "P_CDCIA": voo.CDCIA,
                    "P_NRVOO": voo.NRVOO,
                    "P_CDTRECHO": voo.CDTRECHO,
                    "P_DTHRPLAVOOPV": moment(voo.DTDECOLVOO, "DD/MM/YYYY").format("DD/MM/YYYY"),
                    "P_TIPPREVISAO": "1", //Fixed
                    "P_IDTPGERPPT": "P", //Fixed
                    "P_VRPEROCUPACAO": null, //Fixed
                    "P_SIMULACAO": "9", //Fixed
                    "P_NRDIAS": "0", //Fixed
                    "P_CDEQUIP": null, //Fixed
                    "P_SGPREFIXO": null //Fixed
                };
                data.push(row);
            });
            ate21100_geracao_plano_vooService.executeProcedure(data).then(function(success) {
                //Success
                let widgetVooSelecionados = widget.container.getWidget("geracao_plano_voo_selecionados");
                ScreenService.closePopup();
                widgetVooSelecionados.reload();
                widgetVooSelecionados.activate();
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data)
                    trataMensagem(error.data.error);
                else
                    MessageService.showMessageByCode('ERRO_INESPERADO');
            });
        }
    };
    this.newPlanoVooCancelado = function(widget) {
        MessageService.confirmMessageByCode("ATE21100_CONFIRM_GER_VOO_CANCEL").then(function(yes) {
            let maxPrevWidget = widget.container.getWidget("geracao_plano_voo_selecionados");
            // self.alterClasse(maxPrevWidget, 3, 0, 2);
            self.newPlanoVoo(widget, 1);
        });
    };

    this.oldNewPlanoVoo = function(widget, idoper) {
        if (validaBloqueioDelivery(self.paramcomis.DTBLOQDEL, widget.appliedFilter.FILTER_ROW.DTDECOLVOO)) {
            let checkedRows = widget.getCheckedRows();
            let procedureData = [];
            let promisesGetClasse = [];
            for (let index in checkedRows) {
                let currentRow = checkedRows[index];
                let row = {
                    "P_CDOPERADOR": null, //Fixed - login
                    "P_TIPPREVISAO": tipoprevisao, //Fixed
                    "P_CDFILIAL": currentRow.CDFILIAL, //Fixed
                    "P_CDCIA": currentRow.CDCIA,
                    "P_NRVOO": currentRow.NRVOO,
                    "P_CDTRECHO": currentRow.CDTRECHO,
                    "P_DTHRPLAVOOPV": moment(currentRow.DTDECOLVOO, "DD/MM/YYYY").format("DD/MM/YYYY").slice(0, 10),
                    "P_TIPOOPER": idoper, //PLANOVOO = NULL or PLANOVOOCANCELADO = 1
                    "CIAVOO": currentRow.CIAVOO
                };
                procedureData.push(row);
                promisesGetClasse.push(self.getClasses(currentRow));
            }
            ZHPromise.all(promisesGetClasse).then(
                function(classes) {
                    MessageService.getMessageByCode("ATE21100_PREVPAX_ZERO").then(function(msg) {
                        let promisesValidate = [];
                        let errorMessages = [];
                        for (let index in classes) {
                            if (!classes[index].length) {
                                let message = widget.getCheckedRows()[index].CIAVOO + " -> " + msg;
                                errorMessages.push(message);
                            } else {
                                classes[index].forEach(function(classe) {
                                    if (!classe.QTTOTPAXATPPT) {
                                        let message = widget.getCheckedRows()[index].CIAVOO + " -> " + msg;
                                        errorMessages.push(message);
                                    }
                                });
                            }
                        }
                        if (errorMessages.length == 0) {
                            ate21100_geracao_plano_vooService.executeProcedureGerados(procedureData).then(function(success) {

                                ScreenService.closePopup(true);
                                widget.activate();
                                widget.dataSource.clearCheckedRows();
                                widget.unSelectAll();

                                if (success.dataset !== undefined) {
                                    InflightorGeneral.mensagensErroProcedure(success.dataset.ListaErros);
                                    widget.reload();
                                } else {
                                    ScreenService.closePopup();
                                    MessageService.showMessageByCode("ATE21100_PLANVOO_SUCCESS");
                                    widget.reload();
                                }

                            }, function(error) {
                                let errorMessage = "Timeout";
                                if (error.data)
                                    trataMensagem(error.data.error);
                                else
                                    MessageService.showMessageByCode('ERRO_INESPERADO');
                            });
                        } else {
                            InflightorGeneral.mensagensErroProcedure(errorMessages);
                        }
                    });
                }
            );
        }
    };

    this.newPlanoVoo = function(widget, idoper) {
        if (validaBloqueioDelivery(self.paramcomis.DTBLOQDEL, widget.appliedFilter.FILTER_ROW.DTDECOLVOO)) {
            let previouslyCheckedRows = Object.assign(widget.getCheckedRows(), {});
            let procedureData = [];
            let promisesGetClasse = [];
            let currentRow;
            tipoprevisao = 2;

            if (widget.name == "geracao_plano_voo_classes") {
                let array = [];
                array.push(widget.container.getWidget("geracao_plano_voo_selecionados").currentRow);
                currentRow = array;
            } else {
                currentRow = widget.getCheckedRows();
            }
            let data = self.fillsData(currentRow, 3, 0);
            data.forEach(function(rowData) {
                let row = {
                    "P_CDOPERADOR": null,
                    "P_TIPPREVISAO": tipoprevisao,
                    "P_CDFILIAL": rowData.P_CDFILIAL,
                    "P_CDCIA": rowData.P_CDCIA,
                    "P_NRVOO": rowData.P_NRVOO,
                    "P_CDTRECHO": rowData.P_CDTRECHO,
                    "P_CDEQUIP": rowData.P_CDEQUIP,
                    "P_DTRELPLANPAX": rowData.P_DTRELPLANPAX,
                    "P_IDTPGERPPT": rowData.P_IDTPGERPPT,
                    "P_NRDIAS": rowData.P_NRDIAS,
                    "P_NRORG": rowData.P_NRORG,
                    "P_NRRELPLANPAX": rowData.P_NRRELPLANPAX,
                    "P_SGPREFIXO": rowData.P_SGPREFIXO,
                    "P_SIMULACAO": rowData.P_SIMULACAO,
                    "P_DTHRPLAVOOPV": rowData.P_DTHRPLAVOOPV,
                    "P_VRPEROCUPACAO": rowData.P_VRPEROCUPACAO,
                    "P_TIPOOPER": idoper,
                    "CIAVOO": rowData.CIAVOO
                };
                procedureData.push(row);
                promisesGetClasse.push(self.getClasses(rowData));
            });
            ZHPromise.all(promisesGetClasse).then(
                function(classes) {
                    ate21100_geracao_plano_vooService.executeProcedureCancelados(procedureData).then(function(success) {

                        ScreenService.closePopup(true);
                        widget.activate();
                        // widget.dataSource.clearCheckedRows();
                        // widget.unSelectAll();

                        if (success.dataset !== undefined) {
                            InflightorGeneral.mensagensErroProcedure(success.dataset.ListaErros);
                            widget.reload();
                            widget.dataSource.addCheckedRows(previouslyCheckedRows);
                        } else {
                            ScreenService.closePopup();
                            MessageService.showMessageByCode("ATE21100_PLANVOOCANCELADO_SUCCESS");
                            widget.reload();
                        }
                    }.bind(this), function(error) {
                        if (error.data)
                            trataMensagem(error.data.error);
                        else
                            MessageService.showMessageByCode('ERRO_INESPERADO');
                    });
                }
            );
        }
    };

    this.validateQtdPax = function(dataClasses, controll) {
        let deferred = ZHPromise.defer();
        if (!dataClasses.length) {
            let showMessage = "ATE21100_PREVPAX_ZERO";
            deferred.reject(showMessage);
            return deferred.promise;
        } else {
            dataClasses.forEach(function(classe) {
                if (!classe.QTTOTPAXATPPT) {
                    if (controll) {
                        let showMessage = "ATE21100_PREVPAX_ZERO";
                        deferred.reject(showMessage);
                    }
                    deferred.reject();
                    return deferred.promise;
                }
            });
            deferred.resolve();
            return deferred.promise;
        }
    };
    this.getClasses = function(currentRow) {
        return ate21100_geracao_plano_vooService.getClasse(currentRow).then(function(callback) {
            let classes = callback.dataset.gerar_plano_voo_classe_not_instr;
            return classes;
        });
    };

    function concatValues(currentRow, column) {
        return currentRow.map(function(row) {
                return row[column];
            })
            .join("_");
    }

    this.updateEquipamentoClasse = function(widget) {
        let dataClasses = widget.container.getWidget("geracao_plano_voo_classes").dataSource.data;
        let widgetDecolagens = widget.container.getWidget("geracao_plano_voo_selecionados");
        let mainWidgetEquip = widget.container.getWidget("tabbed_geracao_plano_voo");

        if (dataClasses.length) {
            dataClasses[0].CDALTER = widget.currentRow.CDEQUIP;
            dataClasses[0].DTHRPLAPPT = dataClasses[0].DTHRPLAPPT.slice(0, 10);
        } else {
            dataClasses.push({
                DTHRPLAPPT: widget.container.getWidget("geracao_plano_voo_selecionados").currentRow.DTDECOLVOO.slice(0, 10),
                CDFILIAL: widgetDecolagens.currentRow.CDFILIAL,
                CDTRECHOPPT: widgetDecolagens.currentRow.CDTRECHO,
                NRVOOPPT: widgetDecolagens.currentRow.NRVOO,
                CDCIAPPT: widget.currentRow.CDCIA,
                CDEQUIPPPT: widget.currentRow.CDEQUIP,
                CDALTER: widget.currentRow.CDEQUIP,
                __is_new: true
            });
        }

        ate21100_geracao_plano_vooService.executeTrocaEquipamento(dataClasses).then(function(success) {
            ScreenService.closePopup();
            self.afterMoveRowClasse(widget.container.getWidget("geracao_plano_voo_selecionados"));
            widget.container.getWidget("geracao_plano_voo_selecionados").view();
            widget.container.getWidget("geracao_plano_voo_selecionados").activate();
            widget.container.getWidget("geracao_plano_voo_selecionados").reload();
        }, function(error) {
            let errorMessage = "Timeout";
            if (error.data)
                trataMensagem(error.data.error);
            else
                MessageService.showMessageByCode('ERRO_INESPERADO');
        });
    };

    this.alterClasse = function(widget, valueType, valueDay, P_TIPPREVISAO) {
        let previouslyCheckedRows = Object.assign(widget.getCheckedRows(), {});
        let selected;
        let currentRow;
        tipoprevisao = P_TIPPREVISAO;
        if (widget.name == "geracao_plano_voo_classes") {
            selected = 1;
            let array = [];
            array.push(widget.container.getWidget("geracao_plano_voo_selecionados").currentRow);
            currentRow = array;
        } else {
            selected = 2;
            currentRow = widget.getCheckedRows();
        }
        let data = self.fillsData(currentRow, valueType, valueDay);
        self.executePromiseService(data, widget, selected).then(() => {
            widget.dataSource.addCheckedRows(previouslyCheckedRows);
        });
    };

    this.alterMediaClasse = function(widget) {
        let previouslyCheckedRows = Object.assign(widget.getCheckedRows(), {});
        tipoprevisao = 5;
        if (widget.isValid()) {
            let currentRow;
            let selected;
            let widgetSelected = widget.container.getWidget("geracao_plano_voo_selecionados");
            if (widgetSelected.getCheckedRows().length) {
                selected = 3;
                currentRow = widgetSelected.getCheckedRows();
            } else {
                selected = 4;
                let array = [];
                array.push(widget.container.getWidget("geracao_plano_voo_selecionados").currentRow);
                currentRow = array;
            }
            let data = self.fillsData(currentRow, 5, widget.currentRow.DIAS_MEDIA);
            self.executePromiseService(data, widget, selected).then(() => {
                widget.dataSource.addCheckedRows(previouslyCheckedRows);
            });
        }
    };

    this.fillsData = function(currentRow, P_TIPPREVISAO, P_NRDIAS) {
        let data = [];
        currentRow.forEach(function(rows) {
            let row = {
                "P_CDFILIAL": rows.CDFILIAL,
                "P_DTRELPLANPAX": moment().format("DD/MM/YYYY"), //Fixed Today
                "P_NRRELPLANPAX": null, //Fixed
                "P_CDCIA": rows.CDCIA,
                "P_NRVOO": rows.NRVOO,
                "P_CDEQUIP": rows.CDEQUIP,
                "P_CDTRECHO": rows.CDTRECHO,
                "P_NRORG": rows.NRORG,
                "P_DTHRPLAVOOPV": moment(rows.DTDECOLVOO, "DD/MM/YYYY").format("DD/MM/YYYY"),
                "P_TIPPREVISAO": P_TIPPREVISAO, //Fixed
                "P_IDTPGERPPT": "P", //Fixed
                "P_VRPEROCUPACAO": null, //Fixed
                "P_SIMULACAO": "9", //Fixed
                "P_NRDIAS": P_NRDIAS, //Fixed or value by Media
                "P_SGPREFIXO": null,
                "CIAVOO": rows.CIAVOO
            };
            data.push(row);
        });
        return data;
    };
    this.executePromiseService = function(data, widget, selected) {
        return ate21100_geracao_plano_vooService.executeProcedureHistorico(data).then(function(success) {
            if (selected == 1) {
                // return widget.reload().then(() => widget);
                widget.reload();
                widget.activate();
            } else if (selected == 2 || selected == 3) {
                let widgetVooSelecionados = widget.container.getWidget("geracao_plano_voo_selecionados");
                widgetVooSelecionados.getAction("GERAR_PLANO").isVisible = true;
                widgetVooSelecionados.getAction("GERAR_PLANO_CANCELADO").isVisible = true;
                let oldCheckedRows = angular.copy(widgetVooSelecionados.getCheckedRows());
                configReloadMethod(widgetVooSelecionados).then(function() {
                    widgetVooSelecionados.dataSource.addCheckedRows(oldCheckedRows);
                    widgetVooSelecionados.dataSource.updateCheckedRows();
                });
                if (selected == 3)
                    ScreenService.closePopup();
                widgetVooSelecionados.activate();
            } else {
                ScreenService.closePopup();
                let widgetClasse = widget.container.getWidget("geracao_plano_voo_classes");
                widgetClasse.reload();
                widgetClasse.activate();
            }
            if (success.dataset && success.dataset.ListaErros && success.dataset.ListaErros.length) {
                MessageService.getMessageByCode("ATE21100_ERRO_GER_PASSAGEIROS").then(function(msg) {
                    InflightorGeneral.mensagensErroProcedure(success.dataset.ListaErros, msg);
                });
            } else {
                MessageService.showMessageByCode("ATE21100_PREVPAXCLASSE_GER_SUCES");
            }
            return success;
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
            else
                MessageService.showMessageByCode("ERRO_INESPERADO");
            return error;
        });
    };

    this.deleteClasse = function(widget) {

        MessageService.confirmMessageByCode("CONFIRM_DEL").then(function(success) {
            widget.removeCheckedRows().then(function() {
                widget.reload();
                widget.activate();
            });
        });
    };

    getMaxQtpax = function(row) {
        let filter = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: row.CDFILIAL
			},
            {
                name: "CDCIA",
                operator: "=",
                value: row.CDCIAPPT
			},
            {
                name: "NRVOO",
                operator: "=",
                value: row.NRVOOPPT
			},
            {
                name: "CDTRECHO",
                operator: "=",
                value: row.CDTRECHOPPT
			},
            {
                name: "CDCLASSE",
                operator: "=",
                value: row.CDCLASSEPPT
			}
		];

        return General.callRestEngine("ate#/crud/config_pax_voo", "FilterData", filter).then(
            function(success) {
                return success.dataset.config_pax_voo[0];
            }
        );
    };

    this.saveClass = function(widget) {
        let msgError = [];
        let dataSave = [];
        let data = widget.dataSource.data;
        for (let index in data) {
            if (data[index].changed) {
                if (data[index].QTTOTPAXATPPT == "") {
                    data[index].QTTOTPAXATPPT = 0;
                    data[index].QTTOTPAXATPPT_inline = 0;
                }
                if (data[index].QTPAXSBYPPT == "") {
                    data[index].QTPAXSBYPPT = 0;
                    data[index].QTPAXSBYPPT_inline = 0;
                }
                General.setFloatAttrOnCurrentRow(data[index], "QTPAXSBYPPT");
                General.setFloatAttrOnCurrentRow(data[index], "QTTOTPAXATPPT");
                dataSave.push(data[index]);
            }
        }
        General.callRestEngine("ate#/saveClassInlineEdit", "DataSet", dataSave).then(
            function(success) {
                widget.list();
                widget.activate();
                widget.reload();
                if (success.dataset.listaErros.length) {
                    MessageService.getMessageByCode("ATE21100_MAXIMOS_CLASSE").then(function(msg) {
                        for (let i = 0; i < success.dataset.listaErros.length; i++) {
                            let params = success.dataset.listaErros[i].split("#_#");
                            success.dataset.listaErros[i] = ScreenService.i18n(msg, {
                                "0": params[0],
                                "1": params[1],
                                "2": params[2]
                            });
                        }
                        InflightorGeneral.showErrorMessages(widget, success.dataset.listaErros);
                    });
                }
            },
            function(error) {
                if (error.data)
                    trataMensagem(error.data.error);
                else
                    MessageService.showMessageByCode("ERRO_INESPERADO");
            }
        );
    };

    function configReloadMethod(widget) {
        if (widget.searchList) {
            return widget.reload(self.getLikeAllFilter(widget));
        } else {
            return widget.reload();
        }
    }
    //ListController.js -- Correção provisória para reload
    //levando em consideração o filtro do floating button
    this.getLikeAllFilter = function(widget) {
        let filter = [];
        let columns = widget.fields
            .filter(function(field) {
                return field.isVisible && field.aclIsVisible && field.showOnList && !field.skipSearch;
            })
            .map(function(field) {
                return field.name;
            })
            .join("|");
        filter = Query.build().where(columns);
        if (!Array.isArray(filter))
            filter = filter.likeAll("%" + widget.searchList + "%").where();
        return filter;
    };

    this.callProcedure = function(widget) {
        let mainData = widget;
        let widgetCurrentRow = angular.copy(widget.currentRow);

        widgetCurrentRow.DTHRPLAVOOPV = widget.currentRow.DTHRPLAVOOPV;
        widgetCurrentRow.CDFILIAL = widget.currentRow.CDFILIAL;
        widgetCurrentRow.NRVOO = widget.currentRow.NRVOO;
        widgetCurrentRow.CDTRECHO = widget.currentRow.CDTRECHO;
        widgetCurrentRow.CDCIA = widget.currentRow.CDCIA;

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": widget.currentRow.DTHRPLAVOOPV
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widget.currentRow.CDCIA
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": widget.currentRow.NRVOO
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": widget.currentRow.CDTRECHO
			}
		];

        General.callRestEngine("ate#/agrdelivery_obsdelivtmp_servplano", "FilterData", filter).then(
            function(success) {

                let dataList = success.dataset.agrdelivery_obsdelivtmp_servplano;
                let cdagrdeco = null;
                cdagrdeco = [];
                for (let linha in dataList) {
                    cdagrdeco.push(dataList[linha].CDAGRDECO);
                }
                widgetCurrentRow.CDAGRDECO = cdagrdeco;
                EmissaoDeliveryService.findOperador().then(function(callback) {
                    if (callback.dataset.operador[0].NMOPERADOR && callback.dataset.operador[0].NMOPERADOR !== undefined) {
                        widgetCurrentRow.NMOPERADOR = callback.dataset.operador[0].NMOPERADOR;
                        EmissaoDeliveryService.findServplanom(mainData).then(function(success) {
                                let valorServico = success.dataset.servplanom;
                                for (let valor in valorServico) {
                                    if (valorServico[valor].VRPRURESESP < 0) {
                                        MessageService.showMessageByCode("ATE21100_PRECO_NEGATIVO_SERVICO");
                                        return false;
                                    }
                                }
                                EmissaoDeliveryService.findNrservicociafili(mainData).then(function(success) {
                                    let nrservicociafili = success.dataset.emissao_delivery_servplanom_nrservicociafili;
                                    if (nrservicociafili.length != 0) {
                                        MessageService.showMessageByCode("ATE21100_SERV_SEM_AGRUP");
                                        return false;
                                    } else {
                                        EmissaoDeliveryService.findVerificaNac(mainData).then(function(success) {
                                            let verificaNac = success.dataset.emissao_delivery_servplanom_verifica_nac;
                                            if (verificaNac != 0) {
                                                MessageService.showMessageByCode("ATE21100_SERV_NAC_AND_INTERNAC_DELIVERY");
                                                return false;
                                            } else {

                                                EmissaoDeliveryService.callProcedure(widgetCurrentRow, 2).then(function(callback) {
                                                    if (callback.dataset.deliveries_emitidos.length) {
                                                        let rowMontada = {};
                                                        rowMontada.NRORG = getLocalVar("INFLIGHTOR_NRORGTRAB");
                                                        rowMontada.DTHRPLAVOOPV = widgetCurrentRow.DTHRPLAVOOPV.slice(0, 10);
                                                        rowMontada.CDFILIAL = widgetCurrentRow.CDFILIAL;
                                                        rowMontada.NRVOO = widgetCurrentRow.NRVOO;
                                                        rowMontada.CDCIA = widgetCurrentRow.CDCIA;
                                                        rowMontada.CDTRECHO = widgetCurrentRow.CDTRECHO;
                                                        rowMontada.NRDELIVERY = callback.dataset.deliveries_emitidos.join("_");
                                                        General.openReport("ate#/relatorio_delivery", "ATE02200", rowMontada);
                                                        widget.reload();
                                                        MessageService.showMessageByCode("ATE21100_DELIVERY_EMITIDO");
                                                    } else {
                                                        MessageService.showMessageByCode("ATE21100_ERRO_INESPERADO_DELIVERY");
                                                    }
                                                }, function(error) {
                                                    if (error.data)
                                                        trataMensagem(error.data.error);
                                                    else
                                                        MessageService.showMessageByCode("ERRO_INESPERADO");
                                                });
                                            }
                                        });
                                    }
                                });
                            },
                            function(error) {
                                if (error.data)
                                    trataMensagem(error.data.error);
                                else
                                    MessageService.showMessageByCode("ERRO_INESPERADO");
                            });
                    } else {
                        MessageService.showMessageByCode("ERRO_INESPERADO");
                        console.log("Falha ao encontrar operador!");
                    }
                });

            }
        );

    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate21100_geracao_plano_vooController", ate21100_geracao_plano_vooController);
});

// FILE: ./assets/js/controllers/ate22000_justificativa_no_periodoCotroller.js
let ate22000_justificativa_no_periodoController = function(General, MessageService) {

    this.onChangeUnit = function(widget) {
        widget.getField("NMCIA").setValue([]);
    };

    this.onChangeDataini = function(field) {
        const fieldEndDate = field.widget.getField("DATAFIN");
        const {
            DATAINI,
            DATAFIN
        } = field.widget.currentRow;
        if (!isValidInterval(DATAINI, DATAFIN)) {
            fieldEndDate.clearValue(fieldEndDate, false);
        }
    };

    this.onChangeDatafin = function(field) {
        const {
            DATAINI,
            DATAFIN
        } = field.widget.currentRow;
        if (!isValidInterval(DATAINI, DATAFIN)) {
            field.clearValue(field);
        }
        if (!isValidInterval(DATAINI, DATAFIN)) {
            field.clearValue(field);
        }
    };

    function isValidInterval(DATA_START, DATA_END, showMessage = true) {
        let dataini = moment(DATA_START, "DD/MM/YYYY");
        let datafin = moment(DATA_END, "DD/MM/YYYY");
        if (datafin.isBefore(dataini)) {
            if (showMessage) {
                MessageService.showMessageByCode("ALE_BIGGER_END_DATE");
            }
            return false;
        }
        return true;
    }

    this.printReport = function(widget, format) {
        if (widget.isValid()) {
            if (widget.currentRow.TCIA === "S") {
                widget.currentRow.CDCIA = "T";
            } else {
                widget.currentRow.CDCIA = widget.currentRow.NMCIA.join("_");
            }
            widget.currentRow.REPORTFORMAT = format;
            General.openReport("ate#/relatorioPlanoVoo", widget.currentRow.REPORTNAME, widget.currentRow);
        } else {
            MessageService.showMessageByCode("ENTER_DATA_CORRECTLY");
        }
    };

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate22000_justificativa_no_periodoController", ate22000_justificativa_no_periodoController);
});

// FILE: ./assets/js/controllers/ate26005_CancelamentoExportacaoSAP_Controller.js
let ate26005_CancelamentoExportacaoSAP_Controller = function(General, templateManager, MessageService) {
    this.confirm = function(widget) {
        if (widget.isValid() && validDate(widget.currentRow)) {
            General.callRestEngine("ate#/ate26005_cancel_export_sap", "Row", widget.currentRow).then(
                function() {
                    MessageService.showMessageByCode("ATE26005_EXPORT_CANCELADAS");
                }, General.callbackError
            );
        }
    };

    function validDate(row) {
        let dtIni = moment(row.DTINICIAL, "DD/MM/YYYY");
        let dtFim = moment(row.DTFINAL, "DD/MM/YYYY");

        let valid = dtIni <= dtFim;
        if (!valid) {
            MessageService.showMessageByCode("DTINIMAIORDTFIN");
        }
        return valid;
    }
};

Configuration(function(ContextRegister) {
    ContextRegister.register("ate26005_CancelamentoExportacaoSAP_Controller", ate26005_CancelamentoExportacaoSAP_Controller);
});

// FILE: ./assets/js/controllers/ate41000_parametrosgerais_controller.js
var ate41000_parametrosgerais_controller = function(templateManager, ScreenService, General) {

    this.validateFilter = function(args) {
        let filterRow = args.e.preference.FILTER_ROW;
        if (filterRow.CDFILIAL && filterRow.CDFILIAL.indexOf("@") > -1) {
            delete filterRow.CDFILIAL;
            delete filterRow.NMFILIAL;
        }
    };

    this.aplicaStylesGridSelect = function(fieldSelect) {

        fieldSelect.selectWidget.styles = [
            {
                condition: "row.IDPRODATIVPR === 'N'",
                cssClass: "coc-inactive"
			}
		];
        fieldSelect.selectWidget.reload();
    };

    this.filtraUnidade = function(widget, widgetFiltro) {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widgetFiltro.currentRow.CDFILIAL
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			},
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_CDOPERADOR")
			}
		];

        widget.dataSourceFilter = filter;
        widget.activate();
        widget.reload();
    };

    this.selectInativo = function(field) {

        if (field.selectWidget.currentRow.IDPRODATIVPR == "N") {

            ScreenService.showMessage("Não é permitido adicionar um produto inativo");

            field.widget.currentRow.CDPRODUTO = "";
            field.widget.currentRow.SGUNIDADE = "";
            field.widget.currentRow.NMPRODUTO = "";
        }
    };

    this.adicionar = function(widget) {

        widget.getField("NMFILIAL").readOnly = false;
        widget.newRow();
    };

    this.salvar = function(widget) {
        //widget.currentRow.NRULTDELIVERY = undefined;
        if (!widget.isValid()) return;
        var rowToSave = angular.copy(widget.currentRow);
        rowToSave.NRULTDELIVERY = undefined;
        rowToSave.NRULTFATURA = undefined;
        var dataSetToSave = [rowToSave];
        General.callRestEngine("ate#/crud/paramcomis_filioper_filial_produto/save", "DataSet", dataSetToSave).then(function(success) {
            widget.currentRow.__is_new = false;
            widget.view();
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register("ate41000_parametrosgerais_controller", ate41000_parametrosgerais_controller);
});

// FILE: ./assets/js/controllers/ate42000_parametro_de_companhia_controller.js
let ate42000_parametro_de_companhia_controller = function(templateManager, ScreenService, InflightorGeneral, MessageService) {

    let self = this;

    this.backOrCancel = function(args) {
        InflightorGeneral.backOrCancel(args).then(() => {
            args.owner.widget.redraw();
        });
    };

    this.createBackupRow = function(widget) {
        widget.backupRow = angular.copy(widget.currentRow);
    };

    this.editWidget = function(widget) {
        if (widget.mode !== ViewMode.EDIT) {
            widget.edit();
            widget.activate();
        }
    };

    this.filterOnEnter = function(widgetParam) {
        widgetParam.getField("CDFILIAL").applyDefaultValue();
        widgetParam.getField("NMFILIAL").applyDefaultValue();
    };

    this.setFieldCiaReadOnly = function(widgetParam) {
        let fieldCia; // only get the actual field if the value of CDFILIAL exists on the currentRow for performance purposes 
        if (widgetParam.currentRow.CDFILIAL && (fieldCia = widgetParam.getField('NMCIA')).readOnly) {
            fieldCia.readOnly = false;
        }
    };

    this.filtraCiaFilter = function(widgetParam) {
        let fieldCia = widgetParam.getField('NMCIA');
        let cdfilial = widgetParam.currentRow.CDFILIAL;

        if (widgetParam.currentRow.CDFILIAL) {
            fieldCia.readOnly = false;
            fieldCia.dataSourceFilter = [
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: cdfilial
                },
                {
                    name: "NRORG",
                    operator: "=",
                    value: getLocalVar('INFLIGHTOR_NRORGTRAB')
                }
            ];
            delete widgetParam.currentRow.NMCIA; // clear children value
            fieldCia.reload();
        } else {
            fieldCia.setValue('');
            fieldCia.readOnly = true;
        }
    };

    this.setCurrentRow = function(widget) {
        widget.currentRow = widget.dataSource.data[0];
        widget.currentRow.NRVOO = widget.dataSource.data[0].NRVOORETROBILL;
        let filterIndice = [
            {
                "name": "CDINDICE",
                "operator": "=",
                "value": widget.currentRow.CDINDICE
			},
            {
                "name": "IDPERVALOR",
                "operator": "=",
                "value": widget.currentRow.IDPERVALOR
			}
		];

        let requestPromises = [];

        requestPromises.push(
            InflightorGeneral.callRestEngine("ate#/crud/indice", "FilterData", filterIndice).then(function(callback) {
                if (callback.dataset.indice.length) {
                    widget.currentRow.NMINDICE = callback.dataset.indice[0].NMINDICE;
                } else {
                    widget.currentRow.NMINDICE = null;
                }
                widget.getField("NMINDICE").dataSourceFilter[0].value = widget.currentRow.CDTPINDICE;
            }));

        let filterCodigoMoeda = [
            {
                "name": "CDINDICE",
                "operator": "=",
                "value": widget.currentRow.CDMOEEXP
			}
		];
        requestPromises.push(
            InflightorGeneral.callRestEngine("ate#/crud/indice", "FilterData", filterCodigoMoeda).then(function(callback) {
                if (callback.dataset.indice.length) {
                    widget.currentRow.NMOEDA = callback.dataset.indice[0].NMINDICE;
                } else {
                    widget.currentRow.NMOEDA = null;
                }
                widget.getField("NMOEDA").dataSourceFilter[0].value = widget.currentRow.CDTPINDICE;
            }));

        let filterFiscal = [
            {
                "name": "CDTIPEMNF",
                "operator": "=",
                "value": widget.currentRow.CDTIPEMNF
			}
		];
        requestPromises.push(
            InflightorGeneral.callRestEngine("ate#/crud/formemisnf", "FilterData", filterFiscal).then(function(callback) {
                if (callback.dataset.formemisnf.length) {
                    widget.currentRow.DSTIPEMNF = callback.dataset.formemisnf[0].DSTIPEMNF;
                } else {
                    widget.currentRow.DSTIPEMNF = null;
                }
            }));
        let filterAgr = [
            {
                "name": "CDAGRDEL",
                "operator": "=",
                "value": widget.currentRow.CDAGRDELRETROBILL
			}
		];
        requestPromises.push(
            InflightorGeneral.callRestEngine("ate#/crud/agrdelivery", "FilterData", filterAgr).then(function(callback) {
                if (callback.dataset.agrdelivery.length) {
                    widget.currentRow.DSDELIVERY = callback.dataset.agrdelivery[0].DSDELIVERY;
                } else {
                    widget.currentRow.DSDELIVERY = null;
                }
            }));

        return Promise.all(requestPromises).then(() => {
            widget.view();
        });
    };

    this.setFilterMoeda = function(widget) {
        let fieldMoeda = widget.getField("NMINDICE");
        fieldMoeda.clearValue();
        fieldMoeda.dataSourceFilter[0].value = widget.currentRow.CDTPINDICE;
        fieldMoeda.reload();
    };

    this.setFilterNrvoo = function(widget) {
        let fieldVoo = widget.getField("NRVOO");
        fieldVoo.dataSourceFilter = widget.dataSourceFilter;
        fieldVoo.reload();
    };

    this.setFilterCodigoMoeda = function(widget) {
        let fieldCodigoMoeda = widget.getField("NMOEDA");
        fieldCodigoMoeda.dataSourceFilter[0].value = widget.currentRow.CDTPINDICE;
        fieldCodigoMoeda.reload();
    };

    this.save = function(widget) {
        if (widget.isValid()) {
            InflightorGeneral.setFloatAttrOnCurrentRow(widget.currentRow, "VRPERSBYUT");
            InflightorGeneral.setFloatAttrOnCurrentRow(widget.currentRow, "VRPERSBYNUT");
            InflightorGeneral.setFloatAttrOnCurrentRow(widget.currentRow, "VRALTXPORT");
            if (widget.currentRow.NRHRLIMPREV) {
                widget.currentRow.NRHRLIMPREV = widget.currentRow.NRHRLIMPREV.replace(':', '');
            }
            widget.currentRow.NRVOORETROBILL = widget.currentRow.NRVOO;
            widget.saveRow().then(function(success) {
                widget.view();
                widget.backupRow = angular.copy(widget.currentRow);
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    this.setFilterTabDesconto = function(widget) {
        widget.dataSourceFilter = widget.container.getWidget("ate42000_parametro_de_companhia").dataSourceFilter;
        if (widget.mode == "list")
            widget.reload();
    };

    this.setFilterTabDescontoContratual = function(widget) {
        widget.dataSourceFilter = widget.container.getWidget("ate42000_parametro_de_companhia").dataSourceFilter;
        if (widget.mode == "list")
            widget.reload();
    };
    this.saveDesconto = function(widget) {
        widget.currentRow.CDFILIAL = widget.dataSourceFilter[0].value;
        widget.currentRow.CDCIA = widget.dataSourceFilter[1].value;
        widget.currentRow.VRPERDESCCIA = widget.currentRow.VRPERDESCCIA ? InflightorGeneral.valueToFloat(widget.currentRow.VRPERDESCCIA) : "";
        widget.currentRow.DTDESCCIA = "01/" + widget.currentRow.DTDESCCIAAUX;
        InflightorGeneral.saveCrud(widget);
    };
    this.saveDescontoContratual = function(widget) {
        let momentDataIni = moment(widget.currentRow.DTINIDESC, "DD/MM/YYYY");
        let momentDataFim = moment(widget.currentRow.DTFIMDESC, "DD/MM/YYYY");
        if (momentDataIni > momentDataFim) {
            MessageService.showMessageByCode("ALE_LOWER_CONTRACTUAL_DATE");
        } else {
            if (widget.isValid()) {
                widget.currentRow.CDFILIAL = widget.dataSourceFilter[0].value;
                widget.currentRow.CDCIA = widget.dataSourceFilter[1].value;
                widget.currentRow.VRPERDESC = InflightorGeneral.valueToFloat(widget.currentRow.VRPERDESC);
                widget.currentRow.VRTOTDESC = InflightorGeneral.valueToFloat(widget.currentRow.VRTOTDESC);

                if (widget.currentRow.VRUTIDESC >= 0) {
                    delete widget.currentRow.VRUTIDESC;
                } else if (!widget.currentRow.VRUTIDESC) {
                    widget.currentRow.VRUTIDESC = 0;
                }
                if (!widget.currentRow.__is_new && widget.currentRow.DTFIMDESC.slice(0, 10) == widget.backupRow.DTFIMDESC.slice(0, 10))
                    InflightorGeneral.saveCrud(widget);
                else {
                    InflightorGeneral.callRestEngine("ate#/saveDesconto", "Row", widget.currentRow).then(function(callback) {
                        widget.activate();
                        if (widget.currentRow.__is_new) {
                            widget.list(true);
                            ScreenService.goBack();
                            widget.reload();
                        } else
                            widget.view();
                    }, function(error) {
                        let errorMessage = "Timeout";
                        if (error.data) {
                            MessageService.showMessageByCode(error.data.error);
                            return;
                        }
                        ScreenService.showMessage(errorMessage);
                    });
                }
            }
        }
    };

    //Metodo do InflightorGeneral.js com a possibilidade de digitar o caracter '-'
    this.justInteger = function(selector) {
        if (selector) {
            setTimeout(function() {
                let elem = $(selector);
                elem.keypress(function(e) {
                    let integerNumbers = [45, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57];
                    let numberCode = e.which;
                    if (integerNumbers.indexOf(numberCode) < 0) {
                        e.preventDefault();
                    }
                });

            }, 500);
        } else {
            throw {
                "message": "Selector is not defined!"
            };
        }
    };

    this.applyInactiveStyle = function(field) {
        field.selectWidget.styles = [
            {
                "condition": "row.IDATIVO == 'N'",
                "cssClass": "coc-inactive"
	        }
	    ];
        field.selectWidget.events[0].code = "ate42000_parametro_de_companhia_controller.inactiveBranchWarning(args);";
    };

    this.inactiveBranchWarning = function(args) {
        if (args.owner.currentRow.IDATIVO === "N") {
            MessageService.showMessageByCode("MSG_ATE_CIA_INATIVA");
            args.owner.setSelected(args);
        } else {
            args.owner.setSelected(args);
        }
    };

    this.openFilter = function(filterPopup) {
        let gridWidget = filterPopup.container.getWidget('ate42000_parametro_de_companhia');
        let filterRow = gridWidget.filterRow || {};
        gridWidget.view();
        if (Util.isEmptyObject(filterRow)) {
            filterPopup.newRow();
        } else {
            filterPopup.currentRow = angular.copy(filterRow);
        }
        ScreenService.openPopup(filterPopup);
    };

    this.filter = function(widget) {
        if (widget.isValid()) {
            let paramsWidget = widget.container.getWidget('ate42000_parametro_de_companhia');
            let tabbedWidget = widget.container.getWidget('ate42000_parametro_de_companhia_tabbed');
            let row = widget.currentRow;
            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": row.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": row.CDCIA
                }
            ];
            let informacoesParaStripe = [
                {
                    "label": "Unidade",
                    "value": row.NMFILIAL
                    },
                {
                    "label": "Companhia",
                    "value": row.NMCIA
                    }
                ];
            paramsWidget.filterRow = angular.copy(row);
            paramsWidget.dataSourceFilter = filter;
            InflightorGeneral.callRestEngine("ate#/crud/companhia_serienf_ciafili_grupoper", "FilterData", filter).then(function(callback) {
                let data = Util.getNestedProperty(callback, ['dataset', 'companhia_serienf_ciafili_grupoper']);
                paramsWidget.dataSource.data = data;
                this.setCurrentRow(paramsWidget).then(() => {
                    this.createBackupRow(paramsWidget);
                    paramsWidget.getAction('ZH_EDIT').isVisible = true;
                    paramsWidget.activate();
                    paramsWidget.redraw();
                });
                tabbedWidget._filterInfo = informacoesParaStripe;
                ScreenService.closePopup();
                InflightorGeneral.updateStripe(tabbedWidget);
            }.bind(this));
            self.initPurchaseOrderWidget(widget.container.getWidget("purchaseOrder"), row);
        }
    };

    this.initPurchaseOrderWidget = function(purchaseOrderWidget, filterRow) {
        let purchaseOrderFilter = purchaseOrderWidget.dataSourceFilter;
        for (let i = 0; i < purchaseOrderFilter.length; i++) {
            let filterObj = purchaseOrderFilter[i];
            if (filterObj.name == "CDFILIAL") {
                filterObj.value = filterRow.CDFILIAL;
            }
            if (filterObj.name == "CDCIA") {
                filterObj.value = filterRow.CDCIA;
            }
        }
        purchaseOrderWidget.reload();
        purchaseOrderWidget.__filterRow = filterRow;
    };

    this.updatePurchaseOrder = function(widget) {
        InflightorGeneral.callRestEngine("ate#/updatePurchaseOrder", "Row", widget.currentRow).then(() => {
            widget.computeDescriptionOrder();
            widget.view();
            widget.reload();
        }).catch((error) => {
            let errorMessage = 'Timeout';
            if (error.data) {
                errorMessage = error.data.error;
            }
            ScreenService.showMessage(errorMessage);
        });
    };

    this.savePurchaseOrder = function(purchaseOrderWidget) {
        if (purchaseOrderWidget.isValid() && InflightorGeneral.validateInterval(purchaseOrderWidget, 'DTINIVIGENCIA', 'DTFIMVIGENCIA')) {
            purchaseOrderWidget.currentRow.CDFILIAL = purchaseOrderWidget.__filterRow.CDFILIAL;
            purchaseOrderWidget.currentRow.CDCIA = purchaseOrderWidget.__filterRow.CDCIA;
            let paramsNewCode = purchaseOrderWidget.paramsNewCode;
            if (paramsNewCode && paramsNewCode.__is_new_code) {
                InflightorGeneral.applyParamsNewCodeToRow(purchaseOrderWidget);
            }
            purchaseOrderWidget.currentRow.__fieldsToValidateDuplication = purchaseOrderWidget.fieldsToValidateDuplication;
            purchaseOrderWidget.currentRow.changed = true;
            if (purchaseOrderWidget.currentRow.__is_new) {
                InflightorGeneral.callRestEngine("ate#/crud/purchaseorder/save", "Row", purchaseOrderWidget.currentRow).then(function(success) {
                    purchaseOrderWidget.activate();
                    if (purchaseOrderWidget.currentRow.__is_new) {
                        purchaseOrderWidget.list(true);
                        ScreenService.goBack();
                    } else {
                        purchaseOrderWidget.computeDescriptionOrder();
                        purchaseOrderWidget.view();
                    }
                    purchaseOrderWidget.reload();
                }, function(error) {
                    let errorMessage = 'Timeout';
                    if (error.data) {
                        if (error.data.error.includes("O valor informado para o campo de número já foi cadastrado.")) {
                            MessageService.showMessageByCode("NUMBER_FIELD_EXISTS");
                            return;
                        }
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            } else {
                this.updatePurchaseOrder(purchaseOrderWidget);
            }
        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("ate42000_parametro_de_companhia_controller", ate42000_parametro_de_companhia_controller);
});

// FILE: ./assets/js/controllers/ate42000_tipo_emissao_deliveryController.js
var ate42000_tipo_emissao_deliveryController = function(ScreenService, General) {

    /*this.fixFilter = function(args) {
        if (args.owner.appliedFilter && args.owner.appliedFilter.FILTER_ROW.IDLOCDELIFAT != "")
            args.owner.appliedFilter.FILTER_ROW.IDLOCDELIFAT = args.owner.appliedFilter.FILTER_ROW.IDLOCDELIFAT === "Faturado" ? "S" : "N";
    };

    this.clearFilter = function(args) {
        if (args.owner.appliedFilter.FILTER_ROW.IDLOCDELIFAT != "")
            args.owner.appliedFilter.FILTER_ROW.IDLOCDELIFAT = args.owner.appliedFilter.FILTER_ROW.IDLOCDELIFAT === "S" ? "Faturado" : "Não Faturado";
    };*/
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate42000_tipo_emissao_deliveryController", ate42000_tipo_emissao_deliveryController);
});

// FILE: ./assets/js/controllers/ate43000_calculo_retrobill_controller.js
let ate43000_calculo_retrobill_controller = function(ScreenService, CalculoRetrobillService, General, templateManager, metaDataFactory, MessageService, InflightorGeneral) {

    let self = this;
    let retrobill;

    let trataMensagem = function(mensagem) {
        if (mensagem && mensagem.length) {
            if (!InflightorGeneral.mensagemErroProcedure(mensagem)) {
                if (mensagem.indexOf("ATE43000_") >= 0) {
                    MessageService.showMessageByCode(mensagem);
                } else {
                    ScreenService.showMessage(mensagem);
                }
            }
        }
    };

    this.onChangeUnitFilter = function(args) {
        const widget = args.owner.owner.widget;
        const fieldCia = widget.getField('NMCIA');
        fieldCia.widget.currentRow.NMCIA = "";
        const filterUnit = fieldCia.dataSourceFilter.find(filter => filter.name == 'CDFILIAL');
        if (filterUnit) {
            filterUnit.value = widget.currentRow.CDFILIAL;
        } else {
            fieldCia.dataSourceFilter.push({
                name: "CDFILIAL",
                operator: "=",
                value: widget.currentRow.CDFILIAL
            });
        }
    };

    this.setDefaultFilial = function(widgetFilter) {
        CalculoRetrobillService.findFilial().then(function(callback) {

            let filial = callback.dataset.unidades;
            let widget = widgetFilter.container.getWidget("calculoretrobill");
            let widgetPopup = ScreenService.getPopupOpen();

            widgetPopup.currentRow.CDFILIAL = filial[0].CDFILIAL;
            widgetPopup.currentRow.NMFILIAL = filial[0].NMFILIAL;
        });
    };

    this.atualizaSwipe = function(widget) {
        if (ScreenService.isSwipeOpen(1) && (widget.name == "calculoretrobill")) {
            ScreenService.closeSwipe();
        }
        this.filtraItens(widget);
    };

    this.verificaRetrobill = function(widget) {
        if (widget.parent.currentRow.IDSITUACAO === "A") {
            widget.getField('VRDESCONTO').readOnly = true;
        } else {
            widget.getField('VRDESCONTO').readOnly = false;
        }
    };

    this.validaDesconto = function(widget) {
        if (widget.parent.currentRow.IDSITUACAO === "A") {
            MessageService.showMessageByCode("ATE43000_RETROBILL_APROV");
        } else {
            let vrRetrobill = General.valueToFloat(widget.currentRow.VRRETROBILL);
            let desconto = General.valueToFloat(widget.currentRow.VRDESCONTO);

            if (vrRetrobill > desconto) {

                widget.currentRow.VRFINALRETROBILL = ((vrRetrobill) - (desconto));
                widget.currentRow.VRDESCONTO = desconto;
                General.saveCrud(widget).then(function() {
                    widget.activate();
                    widget.reload();
                });

            } else {
                MessageService.showMessageByCode("ATE43000_DESCONTO_MAIOR_RETROBILL");
            }
        }
    };

    this.filtraItens = function(widget) {
        let itensTabela = widget.container.getWidget("itensTabela");
        let consolidadoTabela = widget.container.getWidget("consolidadoTabela");
        let filter = [{
            "name": "NRRETROBILL",
            "operator": "=",
            "value": widget.container.getWidget("calculoretrobill").currentRow.NRRETROBILL
		}];

        itensTabela.dataSourceFilter = filter;
        consolidadoTabela.dataSourceFilter = filter;
    };

    this.fieldOnChangeFiltro = function(args) {
        let field = args.owner.owner;
        let widget = field.widget;
        let msg = "";
        if (field.name == "NMCIA") {
            if (args.row.CDFILIAL) {
                field.dataSourceFilter[0].value = args.row.CDFILIAL;
                field.reload();
            } else {
                field.dataSourceFilter[0].value = "";
                field.reload();
                MessageService.showMessageByCode("ATE43000_ESCOLHA_UNIDADE");
            }
        }
    };

    this.gerarRetroBill = function(widget) {

        periodoRetrobillWidget.container = widget.container;
        periodoRetrobillWidget.fields = retrobillFields;
        periodoRetrobillWidget.actions = retrobillActions;

        let periodoRetrobillWidgetInitialized = metaDataFactory.widgetFactory(periodoRetrobillWidget);

        ScreenService.openPopup(periodoRetrobillWidgetInitialized);

    };

    this.calculaRetrobill = function(widget) {
        if (widget.isValid()) {
            let dtinicial = moment(widget.currentRow.DTINICIAL, "DD/MM/YYYY");
            let dtfinal = moment(widget.currentRow.DTFINAL, "DD/MM/YYYY");
            if (dtfinal.isBefore(dtinicial)) {
                MessageService.showMessageByCode("ATE43000_DATAFIN_MENOR_DATAINI");
            } else {
                let mainWidget = widget.container.getWidget("calculoretrobill");

                let data = [];
                let row = {
                    "CDFILIAL": mainWidget.appliedFilter.FILTER_ROW.CDFILIAL,
                    "DTINICIAL": moment(widget.currentRow.DTINICIAL, "DD/MM/YYYY").format("DD/MM/YYYY"),
                    "DTFINAL": moment(widget.currentRow.DTFINAL, "DD/MM/YYYY").format("DD/MM/YYYY"),
                    "CDCIA": mainWidget.appliedFilter.FILTER_ROW.CDCIA
                };
                data.push(row);

                CalculoRetrobillService.executeProcedure(data).then(function(callback) {
                    if (!callback.dataset.response.P_NRRETROBILL) {
                        MessageService.showMessageByCode("ATE43000_N_DADOS_RETROBILL");
                    }
                    ScreenService.closePopup();
                    mainWidget.activate();
                    mainWidget.reload();
                }, function(error) {
                    let errorMessage = "Timeout";
                    if (error.data) {
                        if (error.data.error.includes("APP-00021")) {
                            MessageService.showMessageByCode("ATE43000_N_DADOS_RETROBILL");
                        } else {
                            trataMensagem(error.data.error);
                        }

                    } else
                        console.log(error);
                });
            }
        } else {
            MessageService.showMessageByCode("ATE43000_PREENCHA_CORRETAMENTE");
        }
    };

    this.gerarPlanoVooRetrobill = function(widget) {

        let mainWidget = widget.container.getWidget("calculoretrobill");

        let dataRetrobill = mainWidget.currentRow.DTRETROBILL.split(" ");
        dataRetrobill = dataRetrobill[0];

        let data = [];
        let row = {
            "CDFILIAL": mainWidget.currentRow.CDFILIAL,
            "NRRETROBILL": mainWidget.currentRow.NRRETROBILL,
            "DTHRPLAVOOPV": dataRetrobill
        };
        data.push(row);

        MessageService.confirmMessageByCode("ATE43000_CONF_OPERAC").then(function(success) {

            if (mainWidget.currentRow.IDSITUACAO == "A") {
                MessageService.showMessageByCode("ATE43000_RETROBILL_APROV");
            } else {
                CalculoRetrobillService.executePlanoVooProcedure(data).then(function(callback) {
                    ScreenService.closeSwipe();
                    mainWidget.activate();
                    mainWidget.reload();
                }, function(error) {
                    let errorMessage = "Timeout";
                    if (error.data)
                        trataMensagem(error.data.error);
                    else
                        console.log(error);
                });
            }
        });
    };

    this.apagaRetrobill = function(widget) {
        MessageService.confirmMessageByCode("ATE43000_CONF_OPERAC").then(function(success) {
            let mainWidget = widget.container.getWidget("calculoretrobill");

            let data = [];
            let row = {
                "NRRETROBILL": mainWidget.currentRow.NRRETROBILL,
                "CDFILIAL": mainWidget.currentRow.CDFILIAL
            };
            data.push(row);

            CalculoRetrobillService.deleteProcedure(data).then(function(callback) {
                ScreenService.closeSwipe();
                mainWidget.activate();
                mainWidget.reload();
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data)
                    trataMensagem(error.data.error);
                else
                    console.log(error);
            });
        });
    };

    this.geraRelatorio = function(widget) {

        let mainWidget = widget.container.getWidget("calculoretrobill");

        let data = [];
        let row = {
            "NRRETROBILL": mainWidget.currentRow.NRRETROBILL,
            "CDFILIAL": mainWidget.currentRow.CDFILIAL,
            "NRORG": mainWidget.currentRow.NRORG
        };

        CalculoRetrobillService.relatorioRetrobill(row).then(function(callback) {
            mainWidget.activate();
            mainWidget.reload();
        }, function(error) {
            let errorMessage = "Timeout";
            if (error.data)
                trataMensagem(error.data.error);
            else
                console.log(error);
        });
    };

    this.atribuirDesconto = function(widget) {
        if (widget.parent.currentRow.IDSITUACAO === "A") {
            MessageService.showMessageByCode("ATE43000_RETROBILL_APROV_N_APLICA_DESCONTO");
        } else {
            DescontoWidget.container = widget.container;
            DescontoWidget.fields = DescontoFields;
            DescontoWidget.actions = DescontoActions;

            let DescontoWidgetInitialized = metaDataFactory.widgetFactory(DescontoWidget);

            ScreenService.openPopup(DescontoWidgetInitialized);
        }
    };

    this.aplicaDesconto = function(widget) {

        if (widget.currentRow.IDDESCONTO == null || widget.currentRow.VALORDESCONTO == null) {
            MessageService.showMessageByCode("ATE43000_PREENCHA_CORRETAMENTE");
        } else {
            let consWidget = widget.container.getWidget("consolidadoTabela");
            let mainWidget = widget.container.getWidget("calculoretrobill");
            let vrDesconto = General.valueToFloat(widget.currentRow.VALORDESCONTO);
            let vrRetrobill = General.valueToFloat(mainWidget.currentRow.VRRETROBILL);

            consWidget.currentRow.__is_new = false;
            consWidget.currentRow.changed = true;

            MessageService.confirmMessageByCode("ATE43000_CONF_APLIC_DESC").then(function(success) {

                if (widget.currentRow.IDDESCONTO == "A") {

                    if (vrDesconto < vrRetrobill) {

                        let data = [];
                        let row = {
                            "CDFILIAL": mainWidget.currentRow.CDFILIAL,
                            "NRRETROBILL": mainWidget.currentRow.NRRETROBILL,
                            "IDTIPO": widget.currentRow.IDDESCONTO,
                            "DESCONTO": vrDesconto,
                            "NRORG": mainWidget.currentRow.NRORG
                        };
                        data.push(row);

                        CalculoRetrobillService.descontoProcedure(data).then(function(callback) {
                            MessageService.showMessageByCode("ATE43000_SUCES");
                            ScreenService.closePopup();
                            mainWidget.activate();
                            consWidget.activate();
                            mainWidget.reload();
                            consWidget.reload();
                        }, function(error) {
                            let errorMessage = "Timeout";
                            if (error.data)
                                trataMensagem(error.data.error);
                            else
                                console.log(error);
                        });

                    } else {
                        MessageService.showMessageByCode("ATE43000_DESCONTO_MAIOR_RETROBILL");
                    }

                } else if (widget.currentRow.IDDESCONTO == "P") {

                    if (vrDesconto <= 100) {

                        let data = [];
                        let row = {
                            "CDFILIAL": mainWidget.currentRow.CDFILIAL,
                            "NRRETROBILL": mainWidget.currentRow.NRRETROBILL,
                            "IDTIPO": widget.currentRow.IDDESCONTO,
                            "DESCONTO": vrDesconto,
                            "NRORG": mainWidget.currentRow.NRORG
                        };
                        data.push(row);

                        CalculoRetrobillService.descontoProcedure(data).then(function(callback) {
                            MessageService.showMessageByCode("ATE43000_SUCES");
                            ScreenService.closePopup();
                            mainWidget.activate();
                            consWidget.activate();
                            mainWidget.reload();
                            consWidget.reload();
                        }, function(error) {
                            let errorMessage = "Timeout";
                            if (error.data)
                                trataMensagem(error.data.error);
                            else
                                console.log(error);
                        });

                    } else {
                        MessageService.showMessageByCode("ATE43000_DESCONTO_MAIOR_RETROBILL");
                    }
                }
            });
        }
    };

    this.applyInactiveStyle = function(field) {
        field.selectWidget.styles = [
            {
                "condition": "row.IDATIVO == 'N'",
                "cssClass": "coc-inactive"
	        }
	    ];
        field.selectWidget.events[0].code = "ate43000_calculo_retrobill_controller.inactiveBranchWarning(args);";
    };

    this.inactiveBranchWarning = function(args) {
        if (args.owner.currentRow.IDATIVO === "N") {
            args.owner.setSelected(args);
        } else {
            args.owner.setSelected(args);
        }
    };

    this.validaDataInicialFinal = function(args) {
        let dtinicial = moment(args.owner.appliedFilter.FILTER_ROW.DTINICIAL, "DD/MM/YYYY");
        let dtfinal = moment(args.owner.appliedFilter.FILTER_ROW.DTFINAL, "DD/MM/YYYY");
        if (dtfinal.isBefore(dtinicial)) {
            MessageService.showMessageByCode("ATE43000_DATAFIN_MENOR_DATAINI");
            args.e.preventDefault();
        }
    };

    let periodoRetrobillWidget = {
        "id": 0,
        "name": "periodoRetrobillWidget",
        "label": "Calcular Retrobill",
        "template": "widget/form.html",
        "container": {},
        "isVisible": true,
        "popupNoBlock": false,
        "fields": [],
        "actions": [],
        "events": []
    };
    let retrobillFields = [{
        "name": "DTINICIAL",
        "label": "Data Inicial",
        "template": "field/calendar.html",
        "isVisible": true,
        "class": 6,
        "descriptionOrder": true,
        "readOnly": false,
        "showOnView": true,
        "showOnForm": true,
        "showOnList": true,
        "dateField": "DATE",
        "titleField": "TITLE",
        "dateFormat": "DD/MM/YYYY",
        "dataSource": {},
        "validations": {
            "required": true
        },
        "events": [],
        "filterProperties": {
            "isVisible": true,
            "showOnForm": true,
            "validations": {
                "required": true
            }
        }
	}, {
        "name": "DTFINAL",
        "label": "Data Final",
        "template": "field/calendar.html",
        "isVisible": true,
        "readOnly": false,
        "class": 6,
        "descriptionOrder": true,
        "showOnView": true,
        "showOnForm": true,
        "showOnList": true,
        "dateField": "DATE",
        "titleField": "TITLE",
        "dateFormat": "DD/MM/YYYY",
        "dataSource": {},
        "validations": {
            "required": true
        },
        "events": [],
        "filterProperties": {
            "isVisible": true,
            "showOnForm": true,
            "validations": {
                "required": true
            }
        }
	}];
    let retrobillActions = [{
        "name": "cancelar",
        "label": "Cancelar",
        "idVisible": true,
        "hideIcon": true,
        "showAsAction": "back",
        "events": [{
            "name": "ActionEvent",
            "code": "ScreenService.closePopup();"
		}]
	}, {
        "name": "confirmar",
        "label": "Confirmar",
        "idVisible": true,
        "hideIcon": true,
        "showAsAction": "never",
        "events": [{
            "name": "ActionEvent",
            "code": "ate43000_calculo_retrobill_controller.calculaRetrobill(args.owner.widget);"
		}]
	}];

    let DescontoWidget = {
        "id": 0,
        "name": "DescontoWidget",
        "label": "Desconto",
        "template": "widget/form.html",
        "container": {},
        "isVisible": true,
        "popupNoBlock": false,
        "fields": [],
        "actions": [],
        "events": [{
            "name": "WidgetOnEnter",
            "code": "args.owner.getField('IDSERVICO').applyDeafultValue();"
		}]
    };
    let DescontoFields = [{
        "name": "IDDESCONTO",
        "label": "Tipo de Desconto",
        "isVisible": true,
        "readOnly": false,
        "class": 6,
        "showOnList": true,
        "showOnView": true,
        "showOnForm": true,
        "validations": {
            "required": true
        },
        "template": "field/select-native.html",
        "valueField": "value",
        "descriptionField": "label",
        "translate": true,
        "dataSource": {
            "data": [{
                "label": "Desconto Percentual",
                "value": "P"
			}, {
                "label": "Desconto Absoluto",
                "value": "A"
			}]
        },
        "events": [{
            "name": "FieldOnChange",
            "code": "ate43000_calculo_retrobill_controller.changeLabel(args.owner.field);"
		}]
	}, {
        "name": "VALORDESCONTO",
        "label": "Desconto",
        "template": "field/text-edit.html",
        "isVisible": true,
        "readOnly": false,
        "class": 6,
        "showOnView": true,
        "showOnForm": true,
        "showOnList": true,
        "mask": {
            "type": "currency",
            "params": {
                "symbol": "",
                "precision": 2,
                "thousands": ".",
                "decimal": ","
            }
        },
        "validations": {
            "required": true
        },
        "dataSource": {},
        "events": []
	}];
    let DescontoActions = [{
        "name": "cancelar",
        "label": "Cancelar",
        "idVisible": true,
        "hideIcon": true,
        "showAsAction": "back",
        "events": [{
            "name": "ActionEvent",
            "code": "ScreenService.closePopup();"
		}]
	}, {
        "name": "confirmar",
        "label": "Confirmar",
        "idVisible": true,
        "hideIcon": true,
        "showAsAction": "never",
        "events": [{
            "name": "ActionEvent",
            "code": "ate43000_calculo_retrobill_controller.aplicaDesconto(args.owner.widget);"
		}]
	}];
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate43000_calculo_retrobill_controller", ate43000_calculo_retrobill_controller);
});

// FILE: ./assets/js/controllers/ate44000_faturamento_retrobill_controller.js
let ate44000_faturamento_retrobill_controller = function(ScreenService, FaturamentoRetrobillService, General, templateManager, MessageService, InflightorGeneral) {

    let self = this;
    let cdcia, cdfilial, retrobill;

    let trataMensagem = function(mensagem) {
        if (mensagem && mensagem.length) {
            if (!InflightorGeneral.mensagemErroProcedure(mensagem)) {
                if (mensagem.indexOf("ATE44000_") >= 0) {
                    MessageService.showMessageByCode(mensagem);
                } else {
                    ScreenService.showMessage(mensagem);
                }
            }
        }
    };

    this.setDefaultFilial = function(widgetFilter) {
        FaturamentoRetrobillService.findFilial().then(function(callback) {

            let filial = callback.dataset.unidades;
            let widget = widgetFilter.container.getWidget("calculoretrobill");
            let widgetPopup = ScreenService.getPopupOpen();

            widgetPopup.currentRow.CDFILIAL = filial[0].CDFILIAL;
            widgetPopup.currentRow.NMFILIAL = filial[0].NMFILIAL;
        });
    };

    this.atualizaSwipe = function(widget) {
        if (ScreenService.isSwipeOpen(1) && (widget.name == "faturamentoretrobill")) {
            ScreenService.closeSwipe();
        }
        if ((widget.container.getWidget("itensTabela").isActive()) || (widget.container.getWidget("DeliveryTabela").isActive())) {
            this.filtraItens(widget);
        }
    };

    this.filtraItens = function(widget) {

        let itensTabela = widget.container.getWidget("itensTabela");
        let DeliveryTabela = widget.container.getWidget("DeliveryTabela");
        let filter = [{
            "name": "NRRETROBILL",
            "operator": "=",
            "value": widget.container.getWidget("faturamentoretrobill").currentRow.NRRETROBILL
		}];

        if (widget.container.getWidget("itensTabela").isActive()) {
            itensTabela.dataSourceFilter = filter;
        } else {
            DeliveryTabela.dataSourceFilter = filter;
        }

    };

    this.faturarPlanoVooRetrobill = function(widget) {
        if (widget.currentRow.IDSITRETROBILL === "F") {
            MessageService.showMessageByCode("ATE44000_RETROBILL_JA_FAT");
        } else {
            let mainWidget = widget.container.getWidget("faturamentoretrobill");
            let filtro = [
                {
                    "name": "NRRETROBILL",
                    "operator": "=",
                    "value": mainWidget.currentRow.NRRETROBILL
    			},
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": mainWidget.currentRow.CDFILIAL
    			}
    		];
            MessageService.confirmMessageByCode("ATE44000_CONF_OPERAC").then(function(success) {
                FaturamentoRetrobillService.validaFaturamento(filtro).then(function(callback) {
                    let situacao = callback.dataset.faturamento_faturamentoretrobill[0];
                    if (typeof situacao === "undefined" || situacao.IDSITDEL != "2") {
                        MessageService.showMessageByCode("ATE44000_AINDA_HA_DELIV_A_FAT");
                    } else {
                        if (widget.currentRow.IDSITRETROBILL == "A") {
                            widget.currentRow.IDSITRETROBILL = "F";

                            General.saveCrud(widget).then(function() {
                                widget.activate();
                                widget.reload();
                                MessageService.showMessageByCode("ATE44000_OPERAC_SUCES");
                            });
                        }
                    }
                });
            });
        }
    };

    this.geraRelatorio = function(widget) {

        let data = [];
        let row = {
            "NRRETROBILL": widget.currentRow.NRRETROBILL,
            "CDFILIAL": widget.currentRow.CDFILIAL,
            "NRORG": widget.currentRow.NRORG
        };

        FaturamentoRetrobillService.relatorioRetrobill(row).then(function(callback) {
            widget.activate();
            widget.reload();
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
        });
    };

    this.fieldOnChangeFiltro = function(args) {
        let field = args.owner.owner;
        let widget = field.widget;
        let msg = "";
        if (field.name == "NMCIA") {
            if (args.row.CDFILIAL) {
                field.dataSourceFilter[0].value = args.row.CDFILIAL;
            } else {
                field.dataSourceFilter[0].value = "";
                MessageService.showMessageByCode("ATE44000_ESCOLHA_UNIDADE");
            }
        }
    };

    this.calculaRetrobill = function(widget) {
        if (widget.isValid()) {
            let mainWidget = widget.container.getWidget("calculoretrobill");

            let data = [];
            let row = {
                "CDFILIAL": cdfilial,
                "DTINICIAL": moment(widget.currentRow.DTINICIAL, "DD/MM/YYYY").format("DD/MM/YYYY"),
                "DTFINAL": moment(widget.currentRow.DTFINAL, "DD/MM/YYYY").format("DD/MM/YYYY"),
                "CDCIA": cdcia
            };
            data.push(row);

            FaturamentoRetrobillService.executeProcedure(data).then(function(callback) {
                if (!callback.dataset.response.P_NRRETROBILL) {
                    MessageService.showMessageByCode("ATE44000_DADOS_N_ENCONTRADOS_RETROBILL");
                }
                ScreenService.closePopup();
                mainWidget.activate();
                mainWidget.reload();
            }, function(error) {
                if (error.data)
                    trataMensagem(error.data.error);
            });
        } else {
            MessageService.showMessageByCode("ATE44000_PREENCHA_CORRETAMENTE");
        }
    };

    this.applyInactiveStyle = function(field) {
        field.selectWidget.styles = [
            {
                "condition": "row.IDATIVO == 'N'",
                "cssClass": "coc-inactive"
	        }
	    ];
        field.selectWidget.events[0].code = "ate44000_faturamento_retrobill_controller.inactiveBranchWarning(args);";
    };

    this.inactiveBranchWarning = function(args) {
        if (args.owner.currentRow.IDATIVO === "N") {
            args.owner.setSelected(args);
        } else {
            args.owner.setSelected(args);
        }
    };

    this.validaDataInicialFinal = function(args) {
        let dtinicial = moment(args.owner.appliedFilter.DTINICIAL, "DD/MM/YYYY");
        let dtfinal = moment(args.owner.appliedFilter.DTFINAL, "DD/MM/YYYY");
        if (dtfinal.isBefore(dtinicial)) {
            MessageService.showMessageByCode("ATE43000_DATAFIN_MENOR_DATAINI");
            args.e.preventDefault();
        }
    };
};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register("ate44000_faturamento_retrobill_controller", ate44000_faturamento_retrobill_controller);
});

// FILE: ./assets/js/controllers/BaseAereaController.js
function BaseAereaController() {

    this.filtraSelectFilho = function(selectPai, selectFilho, abreSelect) {
        if (selectPai.value()) {
            var filtro = {
                "name": selectPai.valueField,
                "operator": "=",
                "value": selectPai.widget.getField(selectPai.valueField).value()
            };

            if (abreSelect) {
                selectFilho.readOnly = false;
            }
            if (selectFilho.dataSourceFilter) {
                let filter = selectFilho.dataSourceFilter.find(currentFilter => {
                    return currentFilter.name === selectPai.valueField;
                });

                if (filter) {
                    filter.value = filtro.value;
                } else {
                    selectFilho.dataSourceFilter.push(filtro);
                }
            } else {
                selectFilho.dataSourceFilter = [filtro];
            }

        } else {
            selectFilho.setValue("");
            selectFilho.readOnly = true;
        }
    };

    this.validaHorarioDeVerao = function(widget) {

        if (widget.currentRow.DTINIHRVER) {
            widget.getField("DTFIMHRVER").readOnly = false;
        } else {
            widget.getField("DTFIMHRVER").readOnly = true;
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register("BaseAereaController", BaseAereaController);
});

// FILE: ./assets/js/controllers/ConfigPassageirosController.js
function ConfigPassageirosController(ScreenService, General, MessageService) {
    let self = this;

    this.carregaConfigPassageiros = function(widget) {
        if (widget.container.getActiveWidget().name != "tipodeVoo") {
            let widgetConfigPassageiros = widget.container.getWidget("configPassageiros");
            switch (widget.name) {
                case "tabTrechos":
                    widgetConfigPassageiros.dataSource.name = "ate#/crud/configvoo_classe_agrdelivery";
                    widgetConfigPassageiros.dataSourceFilter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": widget.currentRow.CDFILIAL
					},
                        {
                            "name": "CDCIA",
                            "operator": "=",
                            "value": widget.currentRow.CDCIA
					},
                        {
                            "name": "NRVOO",
                            "operator": "=",
                            "value": widget.currentRow.NRVOO
					},
                        {
                            "name": "CDTRECHO",
                            "operator": "=",
                            "value": widget.currentRow.CDTRECHO
					},
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": widget.currentRow.NRORG
					}
				];
                    break;

                case "tabPrefixo":
                    widgetConfigPassageiros.dataSource.name = "ate#/crud/configpref_classe_agrdelivery";
                    widgetConfigPassageiros.dataSourceFilter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": widget.currentRow.CDFILIAL
					},
                        {
                            "name": "CDCIA",
                            "operator": "=",
                            "value": widget.currentRow.CDCIA
					},
                        {
                            "name": "SGPREFIXO",
                            "operator": "=",
                            "value": widget.currentRow.SGPREFIXO
					},
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": widget.currentRow.NRORG
					}
				];
                    break;

                case "tabEquipamento":
                    widgetConfigPassageiros.dataSource.name = "ate#/crud/configequi_classe_agrdelivery";
                    widgetConfigPassageiros.dataSourceFilter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": widget.currentRow.CDFILIAL
					},
                        {
                            "name": "CDCIA",
                            "operator": "=",
                            "value": widget.currentRow.CDCIA
					},
                        {
                            "name": "CDEQUIP",
                            "operator": "=",
                            "value": widget.currentRow.CDEQUIP
					},
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": widget.currentRow.NRORG
					}
				];
                    break;
            }

            widgetConfigPassageiros.reload();
            widgetConfigPassageiros.getField("SGCLASSE").dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
	            },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": widget.currentRow.CDCIA
	            },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
	       		}
	        ];
            ScreenService.openSwipe(widgetConfigPassageiros.parent);
            widgetConfigPassageiros.activate();

        } else {
            self.moveRowTipoDeVoo(widget);
        }
    };

    let dataSourceByTabbed = {
        "tabTrechos": {
            "grid": "distinct_agrdelivery_tipovooconfigvoo",
            "popup": "tipovoo_not_in_tipovooconfigvoo"
        },
        "tabPrefixo": {
            "grid": "distinct_agrdelivery_tipovooconfigpref",
            "popup": "tipovoo_not_in_tipovooconfigpref"
        },
        "tabEquipamento": {
            "grid": "distinct_agrdelivery_tipovooconfigequip",
            "popup": "tipovoo_not_in_tipovooconfigequip"
        }
    };

    let filterByTabbed = {
        "tabTrechos": [
            {
                "name": "NRVOO",
                "operator": "=",
                "value": ""
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": ""
			}
		],
        "tabPrefixo": [
            {
                "name": "SGPREFIXO",
                "operator": "=",
                "value": ""
			}
		],
        "tabEquipamento": [
            {
                "name": "CDEQUIP",
                "operator": "=",
                "value": ""
			}
		]
    };

    function getDataSourceByTabbed(tabbed, template) {
        return "ate#/crud/" + dataSourceByTabbed[tabbed.name][template];
    }

    function getFilterByTabbed(tabbed) {
        return filterByTabbed[tabbed.name];
    }

    function getFilterDefault() {
        return [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "@getLocalVar('INFLIGHTOR_CDFILIAL')@"
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": ""
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": "@getLocalVar('INFLIGHTOR_NRORGTRAB')@"
			}
		];
    }

    this.moveRowTipoDeVoo = function(widget) {
        var defaultFilter = getFilterDefault();
        var widgetTipoVoo = widget.container.getWidget("tipodeVoo");
        widgetTipoVoo.dataSource.name = getDataSourceByTabbed(widget, "grid");
        widgetTipoVoo.dataSourceFilter = defaultFilter.concat(getFilterByTabbed(widget));
        widgetTipoVoo.dataSourceFilter.forEach(function(filter) {
            if (widget.currentRow[filter.name]) {
                filter.value = widget.currentRow[filter.name];
            }
        });
        ScreenService.openSwipe(widgetTipoVoo.parent).then(function() {
            widgetTipoVoo.reload().then(function() {
                widgetTipoVoo.unSelectAll();
                widgetTipoVoo.activate();
            });
        });
    };

    this.openPopupTipoVoo = function(widget) {
        let widgetOrigin = widget.container.getWidget("filtroTabbed").currentWidget;
        let widgetPopup = widget.container.getWidget("popup_tipovoo");
        // let defaultFilter = getFilterDefault();
        // widgetPopup.dataSource.name = getDataSourceByTabbed(widgetOrigin, 'popup');
        // widgetPopup.dataSourceFilter = defaultFilter.concat(getFilterByTabbed(widgetOrigin));
        // widgetPopup.dataSourceFilter.forEach(function(filter){
        // 	if(widget.currentRow[filter.name]){
        // 		filter.value = widget.currentRow[filter.name];
        // 	}
        // });
        ScreenService.openPopup(widgetPopup).then(function() {
            widgetPopup.reload().then(function() {
                widgetPopup.activate();
            });
        });
    };

    this.onEnterTipodeVoo = function(widget) {
        if (widget.container.getWidget("filtroTabbed").currentWidget) {
            self.moveRowTipoDeVoo(widget.container.getWidget("filtroTabbed").currentWidget);
        }
    };

    this.ativaEquipamento = function(widget) {
        let rows = widget.getCheckedRows();
        let dataset = [];
        rows.forEach(function(row) {
            row.IDATIVO = "S";
            row.changed = true;
            dataset.push(row);
        });

        General.callRestEngine("ate#/crud/equipcia_equipamento_inativos/save", "DataSet", dataset).then(function(callback) {
            widget.reload();
            widget.activate();
            widget.unSelectAll();
        });
    };

    this.inativaEquipamento = function(widget) {
        let rows = widget.getCheckedRows();
        let dataset = [];
        rows.forEach(function(row) {
            row.IDATIVO = "N";
            row.changed = true;
            dataset.push(row);
        });

        General.callRestEngine("ate#/crud/equipcia_equipamento_inativos/save", "DataSet", dataset).then(function(callback) {
            widget.reload();
            widget.activate();
            widget.unSelectAll();
        });
    };

    this.saveVinculoTipoVoo = function(widget, action) {
        let widgetOrigin = widget.container.getWidget("filtroTabbed").currentWidget;
        let dataSource = getDataSourceByTabbed(widgetOrigin, "grid");
        let rows;

        let afterRestEngine = function(widget) {
            ScreenService.closePopup();
            widget.unSelectAll();
            MessageService.showMessageByCode("ALE_CHANGED_INDICATOR_SUCCESS");
            widget.reload().then(function() {
                widget.activate();
            });
        };

        let widgetPopup = widget.container.getWidget("popup_tipovoo");
        rows = widget.container.getWidget("tipodeVoo").getCheckedRows();
        General.callRestEngine(dataSource + "/remove", "DataSet", rows).then(function(success) {
            if (action == "vincular") {
                rows.forEach(function(row) {
                    row.CDEXPTIPOVOO = widgetPopup.currentRow.CDEXPTIPOVOO;
                    row.__is_new = true;
                });
                General.callRestEngine(dataSource + "/save", "DataSet", rows).then(function(success) {
                    afterRestEngine(widget.container.getWidget("tipodeVoo"));
                }, General.callbackError);
            } else {
                afterRestEngine(widget);
            }
        }, General.callbackError);
    };

    function validateValue(widget) {
        let value = General.valueToFloat(widget.currentRow.VRPERCOCUPACAO);
        let id = widget.currentRow.IDTIPOCALCULO;
        if (id == "2" && value == 0) {
            MessageService.showMessageByCode("ERR_OCCUPANCY_PERCENTAGE");
            return false;
        }
        return true;
    }

    this.saveRow = function(widgetConfigPassageiros) {
        if (widgetConfigPassageiros.isValid() && validateValue(widgetConfigPassageiros)) {
            let qtpax = widgetConfigPassageiros.getField("QTPAX").value();
            let qtpaxsby = widgetConfigPassageiros.getField("QTPAXSBY").value();
            General.setFloatAttrOnCurrentRow(widgetConfigPassageiros.currentRow, "VRPERCOCUPACAO");

            switch (widgetConfigPassageiros.dataSource.name) {

                case "ate#/crud/configvoo_classe_agrdelivery":
                    widgetParent = widgetConfigPassageiros.container.getWidget("tabTrechos");
                    widgetConfigPassageiros.currentRow.CDFILIAL = widgetParent.currentRow.CDFILIAL;
                    widgetConfigPassageiros.currentRow.CDCIA = widgetParent.currentRow.CDCIA;
                    widgetConfigPassageiros.currentRow.NRVOO = widgetParent.currentRow.NRVOO;
                    widgetConfigPassageiros.currentRow.CDTRECHO = widgetParent.currentRow.CDTRECHO;
                    widgetConfigPassageiros.currentRow.QTPAXVOO = qtpax;
                    widgetConfigPassageiros.currentRow.QTPAXSBYVOO = qtpaxsby;
                    widgetConfigPassageiros.getField("DTULTATUCFVO").applyDefaultValue();
                    break;

                case "ate#/crud/configpref_classe_agrdelivery":

                    widgetParent = widgetConfigPassageiros.container.getWidget("tabPrefixo");
                    widgetConfigPassageiros.currentRow.CDFILIAL = widgetParent.currentRow.CDFILIAL;
                    widgetConfigPassageiros.currentRow.CDCIA = widgetParent.currentRow.CDCIA;
                    widgetConfigPassageiros.currentRow.SGPREFIXO = widgetParent.currentRow.SGPREFIXO;
                    widgetConfigPassageiros.currentRow.QTPAXPREFIXO = qtpax;
                    widgetConfigPassageiros.currentRow.QTPAXSBYPREF = qtpaxsby;
                    widgetConfigPassageiros.getField("DTULTATUCPRE").applyDefaultValue();
                    break;

                case "ate#/crud/configequi_classe_agrdelivery":

                    widgetParent = widgetConfigPassageiros.container.getWidget("tabEquipamento");
                    widgetConfigPassageiros.currentRow.CDFILIAL = widgetParent.currentRow.CDFILIAL;
                    widgetConfigPassageiros.currentRow.CDCIA = widgetParent.currentRow.CDCIA;
                    widgetConfigPassageiros.currentRow.CDEQUIP = widgetParent.currentRow.CDEQUIP;
                    widgetConfigPassageiros.currentRow.QTPAXEQUI = qtpax;
                    widgetConfigPassageiros.currentRow.QTPAXSBYEQUI = qtpaxsby;
                    widgetConfigPassageiros.getField("DTULTATUCEQU").applyDefaultValue();
                    break;
            }
            widgetConfigPassageiros.currentRow.CDFILIAL = widgetParent.currentRow.CDFILIAL;
            widgetConfigPassageiros.currentRow.CDCIA = widgetParent.currentRow.CDCIA;

            General.saveCrud(widgetConfigPassageiros);
        }
    };

    this.fechaSwipeConfigPassageiros = function(widgetConfigPassageiros) {
        ScreenService.closeSwipe();
        switch (widgetConfigPassageiros.dataSource.name) {
            case "ate#/crud/configvoo_classe_agrdelivery":
                widgetConfigPassageiros.container.getWidget("tabTrechos").activate();
                break;

            case "ate#/crud/configpref_classe_agrdelivery":
                widgetConfigPassageiros.container.getWidget("tabPrefixo").activate();
                break;

            case "ate#/crud/configequi_classe_agrdelivery":
                widgetConfigPassageiros.container.getWidget("tabEquipamento").activate();
                break;
        }
    };

    this.filtraPorCompanhia = function(widgetFiltro) {
        widgetFilho = widgetFiltro.container.getWidget("filtroTabbed");

        let dataSourceFilter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_CDFILIAL")
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widgetFiltro.currentRow.CDCIA
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORGTRAB")
			}
		];

        widgetFilho.widgets.forEach(function(filho, index) {
            filho.dataSourceFilter = dataSourceFilter;
            filho.reload();
        });

        ScreenService.openSwipe(widgetFilho);
        if (!widgetFilho.hasActive()) {
            widgetFilho.widgets[0].activate();
        }
    };

    //this.changeVisibleOcupacao = function(widget){
    //	var idtipooper = widget.currentRow.IDTIPOCALCULO;
    //	var fieldValor = widget.getField('VRPERCOCUPACAO');
    //	if(idtipooper == '2'){
    //		fieldValor.readOnly = false;
    //		fieldValor.validations = {required : true, denyNegative : true};
    //	} else {
    //		fieldValor.readOnly = true;
    //		fieldValor.validations = {};
    //		fieldValor.value('');
    //	}
    //};

    this.alertCompanhiaInativa = function(widgetFiltro) {
        if (widgetFiltro.currentRow.IDATIVO === "N")
            MessageService.showMessageByCode("MSG_ATE_CIA_INATIVA");
        this.filtraPorCompanhia(widgetFiltro);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("ConfigPassageirosController", ConfigPassageirosController);
});

// FILE: ./assets/js/controllers/EmissaoDeliveryController.js
function EmissaoDeliveryController(ScreenService, InflightorGeneral, EmissaoDeliveryService, ZhFilterPreferences, templateManager, MessageService) {

    let paramcomis;
    let self = this;

    let trataMensagem = function(mensagem) {
        if (mensagem && mensagem.length) {
            if (!InflightorGeneral.mensagemErroProcedure(mensagem)) {
                if (mensagem.indexOf("ATE02200_") >= 0) {
                    MessageService.showMessageByCode(mensagem);
                } else {
                    ScreenService.showMessage(mensagem);
                }
            }
        }
    };

    this.retornaParametrosUnidade = function(row) {
        EmissaoDeliveryService.findComissaria(row.CDFILIAL).then(function(comissaria) {
            self.paramcomis = comissaria.dataset.paramcomis[0];
        });
    };

    this.gridFilterAfterApply = function(args, widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let widgetDeliveries = widget.container.getWidget("emissao_delivery_agrupamento");
        let filtro = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: widget.appliedFilter.FILTER_ROW.CDFILIAL
            },
            {
                name: "CDCIA",
                operator: "=",
                value: widget.appliedFilter.FILTER_ROW.CDCIA
            },
            {
                name: "DTHRPLAVOOPV",
                operator: "=",
                value: widget.appliedFilter.FILTER_ROW.DTHRPLAVOOPV
            },
            {
                name: "NRVOO",
                operator: "=",
                value: widget.appliedFilter.FILTER_ROW.NRVOO
            },
            {
                name: "CDTRECHO",
                operator: "=",
                value: widget.appliedFilter.FILTER_ROW.CDTRECHO
            }
        ];
        widgetDeliveries.dataSourceFilter = filtro;
        widgetDeliveries.reload();
        let row = args.row;
        EmissaoDeliveryService.findComissaria(row.CDFILIAL).then(function(comissaria) {
            self.calcDesc(args).then(function() {
                self.paramcomis = comissaria.dataset.paramcomis[0];
            });
        });
    };

    this.voltaTela = function(widget) {
        ScreenService.goBack();
        widget.getAction("VOLTARTELA").isVisible = false;
    };

    this.verifyOnEnter = function(args, widget) {
        let lastWidget;
        let widget_gerados;
        let widget_selecionados;
        let flag;
        try {
            lastWidget = templateManager.containers[getLocalVar("lastWidgetDelivery")];
            if (lastWidget.name == "ate01500_alteracao_plano_de_voo") {
                widget_gerados = lastWidget.getWidget("previsaodepax");
            } else if (lastWidget.name == "ate21100_geracao_plano_voo") {
                widget_selecionados = templateManager.currentWidget.container.getWidget("geracao_plano_voo_selecionados");
                widget_gerados = lastWidget.getWidget("geracao_plano_voo_gerados");
            }
            flag = widget_gerados.currentRow.FLAG || false;
        } catch (error) {
            flag = false;
        }
        let widgetPred = widget.container.getWidget("emissao_delivery_agrupamento");
        if (flag) {
            widgetPred.getAction("VOLTARTELA").isVisible = true;
            // ZhFilterPreferences.openFilterWidget(widgetPred);
            InflightorGeneral.openFilterOnEnter(widgetPred, ['CDFILIAL', 'NMFILIAL', 'REPORT_NAME', 'DTHRPLAVOOPV']);
            // args.e.preference.FILTER_ROW.NMFILIAL = widget_gerados.appliedFilter.FILTER_ROW.NMFILIAL;
            let widgetPredFilterRow = {};
            widgetPredFilterRow.NMFILIAL = widget_gerados.appliedFilter.FILTER_ROW.NMFILIAL;
            widgetPredFilterRow.CDFILIAL = widget_gerados.appliedFilter.FILTER_ROW.CDFILIAL;
            widgetPredFilterRow.CDCIA = widget_gerados.currentRow.CDCIA;
            widgetPredFilterRow.NRVOO = widget_gerados.currentRow.NRVOO;
            widgetPredFilterRow.CDTRECHO = widget_gerados.currentRow.CDTRECHO;
            widgetPredFilterRow.DTHRPLAVOOPV = widget_gerados.currentRow.DTHRPLAVOOPV.slice(0, 10);
            widgetPredFilterRow.NMCIA = widget_gerados.currentRow.NMCIA;
            widgetPredFilterRow.SGTRECHO = widget_gerados.currentRow.SGBASEORI + " - " + widget_gerados.currentRow.SGBASEDES;
            ZhFilterPreferences.setOriginalFilter(widgetPred.id, widgetPredFilterRow);
            ZhFilterPreferences.openFilterWidget(widgetPred, widgetPredFilterRow);
            setTimeout(function() {
                let action_filtro = $(".zh-footer-right ul li")[0];
                action_filtro.click();
            }, 300);
        } else {
            // ZhFilterPreferences.openFilterWidget(widgetPred);
            InflightorGeneral.openFilterOnEnter(widgetPred, ['CDFILIAL', 'NMFILIAL', 'REPORT_NAME', 'DTHRPLAVOOPV']);
            widgetPred.activate();
        }
    };

    this.limpaFields = function(field) {

        let widget = field.widget;

        if (field.name == "DTHRPLAVOOPV" || field.name == "NMFILIAL") {

            widget.getField("NMCIA").setValue("");
            widget.getField("NRVOO").setValue("");
            widget.getField("SGTRECHO").setValue("");

            self.filterCia(widget);
        } else if (field.name == "NMCIA") {

            widget.getField("NRVOO").setValue("");
            widget.getField("SGTRECHO").setValue("");
            self.filterVoo(widget.getField("NRVOO"));
        }
        templateManager.updateTemplate();
    };

    this.filterCia = function(widget) {
        let filterCurrentRow = widget.currentRow;
        let fieldCia = widget.getField("NMCIA");
        let fieldData = widget.getField("DTHRPLAVOOPV");
        let fieldFilial = widget.getField("NMFILIAL");

        if (fieldFilial.value() && fieldFilial.value() != "" &&
            fieldData.value() && fieldData.value() != "") {
            fieldCia.readOnly = false;
        } else {
            fieldCia.readOnly = true;
        }

        let filter = {
            DTHRPLAVOOPV: filterCurrentRow.DTHRPLAVOOPV,
            CDFILIAL: filterCurrentRow.CDFILIAL
        };
        InflightorGeneral.buildDataSourceFilter(fieldCia.dataSourceFilter, filter);
        self.filterVoo(widget.getField("NRVOO"));
    };

    this.blockField = function(widget) {
        if (widget.getField("SGCIA").value() == "") {

            widget.getField("NRVOO").value("");
            widget.getField("SGTRECHO").value("");
            widget.getField("NRVOO").readOnly = true;
        }
    };

    this.filterVoo = function(field) {
        let widget = field.widget;
        let fieldCia = widget.getField("NMCIA");
        if (fieldCia.value() && fieldCia.value() != "") {
            widget.getField("NRVOO").readOnly = false;
        } else {
            widget.getField("NRVOO").readOnly = true;
        }

        let filterCurrentRow = field.widget.currentRow;
        let filter = {
            CDFILIAL: filterCurrentRow.CDFILIAL,
            CDCIA: filterCurrentRow.CDCIA,
            DTHRPLAVOOPV: filterCurrentRow.DTHRPLAVOOPV
        };
        InflightorGeneral.onClickDependentField(field, filter);
    };

    this.filterAgrup = function(args) {
        let widget = args.owner;
        widget.reload().then(function() {
            self.calcDesc(args);
            self.findObs(widget);
            self.calculaDeliverymCheck(widget);
        });
    };

    this.filterServ = function(args) {
        let widget = args.owner;
        let widgetServ = widget.container.getWidget("emissao_delivery_servicos");

        if (widget.mode == "list") {
            widgetServ.reload();
        }
    };

    this.findObs = function(widget) {
        widget = templateManager.container.getWidget('emissao_delivery_agrupamento');
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let filtroAplicado = null;
        if (widget.name === 'emissao_delivery_agrupamento') {
            filtroAplicado = widget.appliedFilter.FILTER_ROW;
        } else {
            filtroAplicado = widget.container.getWidget('previsaodepax').appliedFilter.FILTER_ROW;
        }
        let filterObs = [
            {
                "name": "DTHRPLAVOTMP",
                "operator": "=",
                "value": filtroAplicado.DTHRPLAVOOPV
			},
            {
                "name": "CDTRECHOTMP",
                "operator": "=",
                "value": filtroAplicado.CDTRECHO
			},
            {
                "name": "NRVOOTMP",
                "operator": "=",
                "value": filtroAplicado.NRVOO
			},
            {
                "name": "CDAGRDECOTMP",
                "operator": "=",
                "value": widget.currentRow.CDAGRDECO
			},
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filtroAplicado.CDFILIAL
			},
            {
                "name": "CDCIATMP",
                "operator": "=",
                "value": filtroAplicado.CDCIA
			}
		];
        EmissaoDeliveryService.findObs(filterObs).then(
            function(success) {
                let dataObs = success.dataset.obsdelivtmpm;
                if (dataObs.length) {
                    widget.currentRow.__is_new_obs = false;
                    widget.currentRow.TXOBSDELTMP = dataObs[0].TXOBSDELTMP;
                } else {
                    widget.currentRow.__is_new_obs = true;
                }
            },
            function(error) {
                if (error.data)
                    trataMensagem(error.data.error);
            }
        );
    };

    this.setFilialLogada = function(args) {
        args.owner.currentRow.CDFILIAL = getLocalVar("INFLIGHTOR_CDFILIAL");
        args.owner.currentRow.NMFILIAL = getLocalVar("INFLIGHTOR_NMFILIAL");
    };

    this.saveRowObs = function(widget) {
        let currentRow = widget.currentRow;

        let row = {
            TXOBSDELTMP: currentRow.TXOBSDELTMP,
            __is_new: currentRow.__is_new_obs,
            DTHRPLAVOTMP: currentRow.DTHRPLAVOOPV,
            CDTRECHOTMP: currentRow.CDTRECHO,
            NRVOOTMP: currentRow.NRVOO,
            CDAGRDECOTMP: currentRow.CDAGRDECO,
            CDFILIAL: currentRow.CDFILIAL,
            CDCIATMP: currentRow.CDCIA,
            changed: true
        };
        EmissaoDeliveryService.saveRowObs(row).then(function(sucesso) {
            ScreenService.closeSwipe();
            widget.container.getWidget("emissao_delivery_servicos").showAsTab = true;
        }, function(erro) {
            if (erro.data)
                trataMensagem(erro.data.error);
        });
    };

    this.habilitaFieldData = function(widget) {

        widget.currentRow.DTFINAL = "";
        widget.getField("DTFINAL").readOnly = true;
        widget.getField("DTFINAL").reload();

        if (widget.currentRow.DTINICIAL) {
            widget.getField("DTFINAL").readOnly = false;
            validaDias(widget);
        }
    };

    let validaDias = function(widget) {

        let dataInicial = widget.currentRow.DTINICIAL;
        dataInicial = moment(dataInicial, "DD/MM/YYYY");
        widget.getField("DTFINAL").minDate = moment(dataInicial, "DD/MM/YYYY");
    };

    this.setSumFilter = function(widget) {
        if (widget.mode == "view") {
            this.findObs(widget);
            this.calculaDeliverymCheck(widget);
        }

        let swipeDelivery = widget.widgets[0];
        let filter = [
            {
                "name": "CDAGRDECO",
                "operator": "=",
                "value": widget.currentRow.CDAGRDECO
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widget.currentRow.CDCIA
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": widget.currentRow.NRVOO
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": widget.currentRow.CDTRECHO
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": widget.currentRow.DTHRPLAVOOPV
			},
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
			},
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar("INFLIGHTOR_NRORG")
			}
		];

        swipeDelivery.dataSourceFilter = filter;
        if (swipeDelivery.active) {
            swipeDelivery.reload();
        }
    };

    //salva a modificacao do agrupamento do serviço
    this.saveRow = function(widget) {
        let widgetServ = widget.container.getWidget("emissao_delivery_servicos");
        let qtServ = parseFloat(widgetServ.currentRow.QTSERFATSP);
        let qtSbyUtil = parseFloat(widgetServ.currentRow.QTSESBYUTSP);
        if (!qtServ || qtServ < 0) {
            MessageService.showMessageByCode("ATE02200_QTSERV_NEGATIVO");
            return;
        }
        if (!qtSbyUtil || qtSbyUtil < 0) {
            MessageService.showMessageByCode("ATE02200_QTSBYUTIL_NEGATIVO");
            return;
        }

        EmissaoDeliveryService.saveRow(widget.currentRow).then(function(success) {
            ScreenService.closeSwipe().then(function(success) {
                widget.container.getWidget("emissao_delivery_agrupamento").reload().then(function(success) {
                    widgetServ.reload().then(function(success) {
                        let stripeFooter = widget.container.getWidget("stripefooter_totais");
                        stripeFooter.reload().then(function(success) {
                            self.calculaDeliverym(widget);
                        });

                        if (widgetServ.dataSource.data.length == 0) {
                            ScreenService.closeSwipe();
                        }
                    });
                });
            });
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
        });

    };

    //metodo para guardar os principais dados caso o usuario tire algum do filtro
    this.saveMainRow = function(args) {
        if (!args.owner.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let widget = args.owner.container.getWidget("widgetStripe");
        let filterpopupRow = args.owner.appliedFilter.FILTER_ROW;

        widget.currentRow.CDFILIAL = filterpopupRow.CDFILIAL;
        widget.currentRow.CDCIA = filterpopupRow.CDCIA;
        widget.currentRow.CDTRECHO = filterpopupRow.CDTRECHO;
        widget.currentRow.NRVOO = filterpopupRow.NRVOO;
        widget.currentRow.DTHRPLAVOOPV = filterpopupRow.DTHRPLAVOOPV;
    };

    //calcula os descontos e pega o resultado da procedure e mostra na tela
    this.calculaDeliverymCheck = function(widget) {
        if (widget.mode == "view") {
            this.calculaDeliverym(widget);
        } else {
            this.findObs(widget);
        }
    };

    this.calculaDeliverym = function(widget) {
        if (!widget.container.getWidget("emissao_delivery_agrupamento").appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        let stripeFooter = widget.container.getWidget("stripefooter_totais");
        let appliedFilterRow = widget.container.getWidget("emissao_delivery_agrupamento").appliedFilter.FILTER_ROW;

        if (widget.currentRow.CDFILIAL) {
            appliedFilterRow.CDFILIAL = widget.currentRow.CDFILIAL;
        } else {
            if (appliedFilterRow.CDFILIAL) {
                widget.currentRow.CDFILIAL = appliedFilterRow.CDFILIAL;
            } else {
                if (widget.dataSource.data && widget.dataSource.data[0] && widget.dataSource.data[0].CDFILIAL) {
                    widget.currentRow.CDFILIAL = widget.dataSource.data[0].CDFILIAL;
                    appliedFilterRow.CDFILIAL = widget.currentRow.CDFILIAL;
                }
            }
        }

        EmissaoDeliveryService.calculaDeliverym(widget.currentRow, 1).then(
            function(success) {
                let result = success.dataset.calcula_delivery[0];

                widget.currentRow.VRDESCDESV = result.VRDESCDESV;
                widget.currentRow.DESCDESV = result.PEDESCDESV;
                widget.currentRow.VRDESCFIXO = result.VRDESCFIXO;
                widget.currentRow.DESCFIXO = result.PEDESCFIXO;
                widget.currentRow.VRDESCCOND = result.VRDESCCOND;
                widget.currentRow.DESCCOND = result.PEDESCCOND;
                widget.currentRow.VRTOTDESC = result.VRTOTDESC;
                widget.currentRow.VRUTIDESC = result.VRUTIDESC;
                stripeFooter.currentRow.VRTXAEROR = result.VRTAXA;
                stripeFooter.currentRow.TOTALSERV = result.TOTALGERALSERV;

                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRTAXA");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "DESCNOTA");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "DESCSERV");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRDESCDESV");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRDESCFIXO");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "VRDESCCOND");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "PEDESCDESV");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "PEDESCFIXO");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "PEDESCCOND");
                InflightorGeneral.setFloatAttrOnCurrentRow(result, "TOTALGERALSERV");

                // widget.currentRow.VRDESCCOND = result["VRTOTDESC"] - result["VRUTIDESC"];
                let totalDelivery = ((result.TOTALGERALSERV + result.VRTAXA) - result.DESCNOTA - result.DESCSERV - result.VRDESCDESV - result.VRDESCFIXO - result.VRDESCCOND);
                totalDelivery = ("" + totalDelivery);
                totalDelivery = totalDelivery.substr(0, totalDelivery.indexOf(".") + 3);
                stripeFooter.currentRow.TOTALDELIVERY = totalDelivery;
                // stripeFooter.currentRow.TOTALSREV = totalDelivery;

                self.findObs(widget);
            },
            function(error) {
                self.findObs(widget);
            }
        ).catch(function(error) {
            if (error.data)
                trataMensagem(error.data.error);

            widget.currentRow.VRDESCDESV = "0";
            widget.currentRow.DESCDESV = "0";
            widget.currentRow.VRDESCFIXO = "0";
            widget.currentRow.DESCFIXO = "0";
            widget.currentRow.VRDESCCOND = "0";
            widget.currentRow.DESCCOND = "0";
            widget.currentRow.VRTOTDESC = "0";
            widget.currentRow.VRUTIDESC = "0";

            stripeFooter.currentRow.VRTXAEROR = "0";
            stripeFooter.currentRow.TOTALSERV = "0";
            stripeFooter.currentRow.TOTALDELIVERY = "0";

            this.findObs(widget);
        });
    };

    //chama a procedure CALC_DESC_PROP_DELIVERYM apos a filtragem
    this.calcDesc = function(args) {
        let widget = null;
        if (args.owner.name === 'emissao_delivery_agrupamento') {
            widget = args.owner;
        } else {
            widget = args.owner.container.getWidget('previsaodepax');
        }
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        if (typeof widget.appliedFilter != 'undefined') {
            widget.appliedFilter.FILTER_ROW.CDFILIAL = widget.currentRow.CDFILIAL || widget.appliedFilter.FILTER_ROW.CDFILIAL;
            let dataList = widget.appliedFilter.FILTER_ROW;
            return EmissaoDeliveryService.calcDesc(dataList);
        }
    };

    //chama a procedure para emitir o delivery
    this.callProcedure = function(popupWidget, widget) {
        if (!widget.appliedFilter) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }

        let mainData = widget.appliedFilter.FILTER_ROW;

        if (widget.currentRow.CDFILIAL) {
            mainData.CDFILIAL = widget.currentRow.CDFILIAL;
        } else {
            if (mainData.CDFILIAL) {
                widget.currentRow.CDFILIAL = mainData.CDFILIAL;
            } else {
                if (widget.dataSource.data && widget.dataSource.data[0] && widget.dataSource.data[0].CDFILIAL) {
                    widget.currentRow.CDFILIAL = widget.dataSource.data[0].CDFILIAL;
                    mainData.CDFILIAL = widget.currentRow.CDFILIAL;
                }
            }
        }

        EmissaoDeliveryService.findComissaria(widget.currentRow.CDFILIAL).then(function(comissaria) {

            let dtbloqdel = null;

            if (comissaria.dataset.paramcomis.length > 0)
                dtbloqdel = comissaria.dataset.paramcomis[0].DTBLOQDEL;

            if (validaBloqueioDelivery(dtbloqdel, mainData.DTHRPLAVOOPV)) {

                let widgetCurrentRow = angular.copy(widget.currentRow);

                widgetCurrentRow.DTHRPLAVOOPV = widget.appliedFilter.FILTER_ROW.DTHRPLAVOOPV;
                widgetCurrentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
                widgetCurrentRow.NRVOO = widget.appliedFilter.FILTER_ROW.NRVOO;
                widgetCurrentRow.CDTRECHO = widget.appliedFilter.FILTER_ROW.CDTRECHO;
                widgetCurrentRow.CDCIA = widget.appliedFilter.FILTER_ROW.CDCIA;

                let dataList = angular.copy(widget.dataSource.data);
                let cdagrdeco = null;
                cdagrdeco = [];
                for (let linha in dataList) {
                    cdagrdeco.push(dataList[linha].CDAGRDECO);
                }
                widgetCurrentRow.CDAGRDECO = cdagrdeco;
                EmissaoDeliveryService.findOperador().then(function(callback) {
                    if (callback.dataset.operador[0].NMOPERADOR && callback.dataset.operador[0].NMOPERADOR !== undefined) {
                        widgetCurrentRow.NMOPERADOR = callback.dataset.operador[0].NMOPERADOR;
                        EmissaoDeliveryService.findServplanom(mainData).then(function(success) {
                            let valorServico = success.dataset.servplanom;
                            for (let valor in valorServico) {
                                if (valorServico[valor].VRPRURESESP < 0) {
                                    MessageService.showMessageByCode("ATE02200_SERV_PRECO_NEGATIVO");
                                    return false;
                                }
                            }
                            EmissaoDeliveryService.findNrservicociafili(mainData).then(function(success) {
                                let nrservicociafili = success.dataset.emissao_delivery_servplanom_nrservicociafili;
                                if (nrservicociafili.length != 0) {
                                    MessageService.showMessageByCode("ATE02200_SERV_SEM_AGRUP");
                                    return false;
                                } else {
                                    EmissaoDeliveryService.findVerificaNac(mainData).then(function(success) {
                                        let verificaNac = success.dataset.emissao_delivery_servplanom_verifica_nac;
                                        if (verificaNac != 0) {
                                            MessageService.showMessageByCode("ATE02200_SERV_INT_NAC");
                                            return false;
                                        } else {
                                            EmissaoDeliveryService.callProcedure(widgetCurrentRow, 2).then(function(callback) {
                                                if (callback.dataset.deliveries_emitidos.length) {
                                                    let rowMontada = {};
                                                    rowMontada.NRORG = getLocalVar("INFLIGHTOR_NRORGTRAB");
                                                    rowMontada.DTHRPLAVOOPV = widgetCurrentRow.DTHRPLAVOOPV;
                                                    rowMontada.CDFILIAL = widgetCurrentRow.CDFILIAL;
                                                    rowMontada.NRVOO = widgetCurrentRow.NRVOO;
                                                    rowMontada.CDCIA = widgetCurrentRow.CDCIA;
                                                    rowMontada.CDTRECHO = widgetCurrentRow.CDTRECHO;
                                                    rowMontada.NRDELIVERY = callback.dataset.deliveries_emitidos.join("_");
                                                    rowMontada.REPORT = popupWidget.currentRow.REPORT_VALUE;
                                                    InflightorGeneral.openReport("ate#/relatorio_delivery", rowMontada.REPORT, rowMontada);
                                                    widget.reload().then(function() {
                                                        MessageService.showMessageByCode("ATE02200_DELIVERY_SUCES");
                                                        ScreenService.closePopup(true);
                                                        widget.activate();
                                                    });
                                                } else {
                                                    MessageService.showMessageByCode("ATE02200_DELIVERY_ERR");
                                                }
                                            }, function(error) {
                                                if (error.data)
                                                    trataMensagem(error.data.error);
                                            });
                                        }
                                    });
                                }
                            });

                        }, function(error) {
                            if (error.data)
                                trataMensagem(error.data.error);
                        });
                    } else {
                        MessageService.showMessageByCode("ATE02200_FALHA_ENCONTRAR_OPER");
                    }
                });
            }
        });
    };

    this.editVoo = function(widget) {
        widget.edit();
        widget.container.getWidget("emissao_delivery_servicos").showAsTab = false;
    };

    this.cancelEditVoo = function(args) {
        InflightorGeneral.backOrCancel(args);
        args.owner.widget.container.getWidget("emissao_delivery_servicos").showAsTab = true;
    };

    this.cancelOptionsReport = function(widget) {
        ScreenService.closePopup();
        widget.container.getWidget('emissao_delivery_agrupamento').activate();
    };

    this.openOptionsReport = function(widget) {
        let popupOptions = widget.container.getWidget('popup_relatorios');
        ScreenService.openPopup(popupOptions).then(function() {
            popupOptions.activate();
        });
    };

    function validaBloqueioDelivery(dataBloqueioDelivery, dataDecolagemVoo) {
        dataBloqueioDelivery = dataBloqueioDelivery ? moment(dataBloqueioDelivery, "DD/MM/YYYY") : null;
        dataDecolagemVoo = dataDecolagemVoo ? moment(dataDecolagemVoo, "DD/MM/YYYY") : null;

        if (dataDecolagemVoo > dataBloqueioDelivery) {
            return true;
        } else {
            MessageService.showMessageByCode("ATE02200_DATA_BLOQ_DEL", {
                "0": dataBloqueioDelivery.format("DD/MM/YYYY")
            });
            return false;
        }
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register("EmissaoDeliveryController", EmissaoDeliveryController);
});

// FILE: ./assets/js/controllers/ManutencaoDelivery.js
let ManutencaoDelivery = function(ManutencaoDeliveryService, Colors, templateManager, ScreenService, restEngine, InflightorGeneral, ZHPromise, MessageService, ZhFilterPreferences) {

    let retornoPermissao, retornoOperador, validaParamsVar;
    let self = this;

    let trataMensagem = function(mensagem) {
        if (mensagem && mensagem.length) {
            if (!InflightorGeneral.mensagemErroProcedure(mensagem)) {
                if (mensagem.indexOf("ATE25200_") >= 0) {
                    MessageService.showMessageByCode(mensagem);
                } else {
                    ScreenService.showMessage(mensagem);
                }
            }
        }
    };

    this.validaParams = function(widget) {
        let deferred = ZHPromise.defer();
        let filtro = widget.appliedFilter.FILTER_ROW;
        let cdfilial = filtro.CDFILIAL;
        let cdcia = filtro.CDCIA;
        let dt = filtro.DTHRPLAVOOPV;
        let nrvoo = filtro.NRVOO;
        let cdtrecho = filtro.CDTRECHO;
        let nrorg = getLocalVar("INFLIGHTOR_NRORGTRAB");

        return ManutencaoDeliveryService.paramsPax(cdfilial, cdcia, dt, nrvoo, cdtrecho, nrorg).then(function(success) {

            deferred.resolve(success.dataset.planovoom_equipamento_vootrecho);
            validaParamsVar = success.dataset.planovoom_equipamento_vootrecho[0];
            return deferred.promise;
        }, function(error) {});

    };

    this.validaOperador = function(widget) {
        let deferred = ZHPromise.defer();
        let cdgrupoaltdel = retornoPermissao.CDGRUPOPALTDEL;
        let nrorg = getLocalVar("INFLIGHTOR_NRORGTRAB");
        let cdoperador = getLocalVar("INFLIGHTOR_CDOPERADOR");
        /*Validação de Grupo de Operadores retirada 09/01/2018 */
        // return ManutencaoDeliveryService.validaOperador(cdoperador, cdgrupoaltdel, nrorg).then(function(callback){

        // deferred.resolve(callback.dataset.opergrupop);
        // retornoOperador = callback.dataset.opergrupop[0];

        // return deferred.promise;
        // });

        deferred.resolve();

        return deferred.promise;
    };

    this.validaParamDelivery = function(widget) {
        let deferred = ZHPromise.defer();
        let cdfilial = widget.appliedFilter.FILTER_ROW.CDFILIAL;
        let nrorg = getLocalVar("INFLIGHTOR_NRORGTRAB");

        ManutencaoDeliveryService.validaParamDelivery(cdfilial, nrorg).then(function(callback) {

            deferred.resolve(callback.dataset.paramcomis);
            retornoPermissao = callback.dataset.paramcomis[0];

            return deferred.promise;
        }, function() {
            return deferred.reject();
        });
        return deferred.promise;
    };

    this.propostaMenu = function(widget) {
        if (widget.isValid()) {
            let user = widget.currentRow.user;
            let senha = widget.currentRow.senha;
            ManutencaoDeliveryService.autenticar(user, senha).then(function(callback) {
                ScreenService.closePopup();
                self.alteraStatusMenu(widget.container.getWidget("grid_manual"));
            }, function(callback) {
                InflightorGeneral.callbackError(callback);
            });
        }
    };

    this.validaPermissao = function(dataVoo) {
        let dataBloqueioDelivery = retornoPermissao.DTBLOQDEL ? moment(retornoPermissao.DTBLOQDEL, "DD/MM/YYYY") : null;
        dataVoo = dataVoo ? moment(dataVoo, "DD/MM/YYYY") : null;

        if (dataVoo > dataBloqueioDelivery) {
            return true;
        } else {
            MessageService.showMessageByCode("ATE25200_DATA_BLOQ_DEL", {
                "0": dataBloqueioDelivery.format("DD/MM/YYYY")
            });
            return false;
        }
    };

    this.setaDTEMISDEL = function(widget) {
        widget.currentRow.DTEMISDEL = moment().format("DD/MM/YYYY HH:mm:ss");
    };

    this.editarDelivery = function(widget) {
        let isAllowed = self.validaPermissao(widget.currentRow.DTHRPLAVOOPV);

        if (isAllowed) {
            if (widget.currentRow.IDSITDEL != "1") {
                MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
                return;
            }

            InflightorGeneral.widgetEdit(widget);
        }
    };

    this.salvarDelivery = function(widget) {

        InflightorGeneral.saveCrud(widget);
        widget.reload();
    };

    this.cancelarInclusao = function(args) {
        InflightorGeneral.backOrCancel(args);
        args.owner.widget.reload();
    };

    this.cancelarEdicao = function(args) {
        InflightorGeneral.backOrCancel(args);
        args.owner.widget.reload();
    };

    this.selectActionServicos = function(widget) {
        let deliveryWidget = widget.container.getWidget("deliveriesvoo");
        let servicosWidget = widget.container.getWidget("servicosdelivery");

        this.carregaQTTOTPAX_PAXSBY(servicosWidget, widget);

        if (servicosWidget.currentRow.QTSESBYNUTSP < 0) {
            servicosWidget.currentRow.QTSESBYNUTSP = 0;
        }
    };

    this.carregaQTTOTPAX_PAXSBY = function(widget, mainWidget) {
        let row = widget.getParent().currentRow;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": row.CDCIA
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": row.NRVOO
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": row.CDTRECHO
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": row.DTHRPLAVOOPV
			},
            {
                "name": "CDCLASSE",
                "operator": "=",
                "value": mainWidget.currentRow.CDCLASSE
			}
		];

        InflightorGeneral.callRestEngine("ate#/previsaopaxm_max", "FilterData", filter).then(function(success) {
            if (success.dataset && success.dataset.previsaopaxm_max && success.dataset.previsaopaxm_max.length) {
                widget.currentRow.QTTOTPAX_PAXSBY = success.dataset.previsaopaxm_max[0].QTTOTPAXAT;
            } else {
                widget.currentRow.QTTOTPAX_PAXSBY = null;
            }
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
        });
    };

    this.loadQTTOTPAX_PAXSBY = function(widget, mainWidget) {
        let row = widget.getParent().currentRow;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": row.CDCIA
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": row.NRVOO
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": row.CDTRECHO
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": row.DTHRPLAVOOPV
			},
            {
                "name": "CDCLASSE",
                "operator": "=",
                "value": mainWidget.currentRow.CDCLASSE
			}
		];

        return InflightorGeneral.callRestEngine("ate#/previsaopaxm_max", "FilterData", filter).then(function(success) {
            if (success.dataset && success.dataset.previsaopaxm_max && success.dataset.previsaopaxm_max.length) {
                return success.dataset.previsaopaxm_max[0].QTTOTPAXAT;
            } else {
                return null;
            }
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
        });
    };

    this.validaQtd = function(field) {
        if (parseInt(field.value()) < 0) {
            MessageService.showMessageByCode("ATE25200_VALOR_NEG");
            field.setValue("0");
        }
        field.reload();
    };

    this.fecharDelivery = function(widget) {
        let isAllowed = self.validaPermissao(widget.currentRow.DTHRPLAVOOPV);

        if (isAllowed) {
            let sit = widget.currentRow.IDSITDEL;

            if (sit == "1") {
                MessageService.confirmMessageByCode("ATE25200_CONF_FECHA_DEL").then(
                    function(success) {
                        widget.currentRow.IDSITDEL = "4";
                        InflightorGeneral.saveCrud(widget).then(function() {
                            MessageService.showMessageByCode("ATE25200_DEL_FECH_SUCES");

                        });
                        ScreenService.closePopup();
                        widget.getParent().reload();
                    },
                    function(error) {
                        ScreenService.closePopup();
                    }
                );
            } else {
                MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
            }
            widget.getParent().reload();
        }
    };

    this.cancFecharDelivery = function(widget) {
        let isAllowed = self.validaPermissao(widget.currentRow.DTHRPLAVOOPV);

        if (isAllowed) {
            if (widget.currentRow.IDSITDEL == "4") {
                MessageService.confirmMessageByCode("ATE25200_CONF_CANCEL_FECHA_DEL").then(
                    function(success) {
                        widget.currentRow.IDSITDEL = "1";
                        InflightorGeneral.saveCrud(widget).then(function() {
                            MessageService.showMessageByCode("ATE25200_FECH_DEL_CANCEL");
                        });
                        ScreenService.closePopup();
                        widget.getParent().reload();
                    }
                );
            } else {
                MessageService.showMessageByCode("ATE25200_BLOQ_CANCEL_FECH");
            }
            widget.getParent().reload();
        }
    };

    this.cancelarDelivery = function(widget) {
        let isAllowed = self.validaPermissao(widget.currentRow.DTHRPLAVOOPV);

        if (isAllowed) {
            let sit = widget.currentRow.IDSITDEL;
            let sit2 = widget.currentRow.IDDELIEXPSAP;
            let sit3 = widget.currentRow.NRDELIVERYFA;

            let popupCancelamento = widget.container.getWidget("popupCancelamento");

            if (sit == "1") {
                if (sit2 == "N") {
                    if (sit3) {
                        MessageService.showMessageByCode("ATE25200_EXISTE_DEL_VALORIZADA");
                    } else {
                        MessageService.confirmMessageByCode("ATE25200_CONF_CANCEL_DEL").then(
                            function(success) {
                                popupCancelamento.isVisible = true;
                                ScreenService.openPopup(popupCancelamento);
                            },
                            function(error) {
                                if (error.data)
                                    trataMensagem(error.data.error);
                            });
                    }
                } else {
                    MessageService.showMessageByCode("ATE25200_DEL_EXPORT_SAP");
                }
            } else {
                MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
            }
        }
    };

    this.reimprimirDelivery = function(widget) {
        if (self.validaPermissao(widget.currentRow.DTHRPLAVOOPV)) {
            let popupReemissao = widget.container.getWidget("reemissaoDelivery");
            let sit = widget.currentRow.IDSITDEL;
            if (sit === "3") {
                MessageService.showMessageByCode("ATE25200_DEL_CANCEL_N_REIMP");
            } else {
                popupReemissao.isVisible = true;
                ScreenService.openPopup(popupReemissao);
            }
        }
    };

    this.cancelarMotivo = function(widget) {
        widget.getParent().activate();
        ScreenService.closePopup();
        widget.isVisible = false;
    };

    this.cancelarRel = function(widget) {
        widget.getParent().activate();
        ScreenService.closePopup();
        widget.isVisible = false;
    };

    this.enterMotivo = function(widget) {
        widget.newRow();
        widget.currentRow.TXOBSDEL = widget.getParent().currentRow.TXOBSDEL;
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        widget.currentRow.NRDELIVERY = widget.getParent().currentRow.NRDELIVERY;
        widget.currentRow.CDCIA = widget.getParent().currentRow.CDCIA;
        widget.currentRow.CDOPERADOR = getLocalVar("INFLIGHTOR_CDOPERADOR");
    };

    this.salvarMotivo = function(widgetAutenticacao) {
        let nomeUsuario = widgetAutenticacao.currentRow.usuario;
        let senha = widgetAutenticacao.currentRow.senha;

        ManutencaoDeliveryService.autenticar(nomeUsuario, senha).then(function(sucesso) {
            let deliveriesvoo = widgetAutenticacao.getParent();
            let widget = widgetAutenticacao.container.getWidget("popupCancelamento");
            deliveriesvoo.currentRow.CDOPERADOR = getLocalVar("INFLIGHTOR_CDOPERADOR");

            if (deliveriesvoo.currentRow.TXOBSDEL) {
                widget.currentRow.__is_new = false;
            } else {
                widget.currentRow.__is_new = true;
            }

            deliveriesvoo.currentRow.TXOBSDEL = widget.currentRow.TXOBSDEL;

            //Salva observação para o Cancelamento
            InflightorGeneral.callRestEngine("ate#/deliverym_obsdeliverym_paramcomis/save", "DataSet", [widget.currentRow]).then(function() {

                // });
                // widget.saveRow().then(function() {
                //Cancela a Delivery
                ManutencaoDeliveryService.cancela_delivery(deliveriesvoo.currentRow).then(function(success) {
                        //Delivery cancelado -> IDSITDEL = 3
                        deliveriesvoo.currentRow.IDSITDEL = "3";
                        deliveriesvoo.reload().then(function() {
                            ScreenService.closePopup(true);
                            deliveriesvoo.activate();
                        });
                    },
                    function(error) {
                        if (error.data)
                            trataMensagem(error.data.error);
                        ScreenService.closePopup(true);
                    });
            }, function(error) {
                let errorMessage = "Timeout";
                if (error.data) {
                    trataMensagem(error.data.error);
                }
                ScreenService.closePopup(true);
            });
        }).catch(function(erro) {
            if (erro.data)
                trataMensagem(erro.data.error);
        });
    };

    this.printRel = function(widget) {
        let row = widget.getParent().currentRow;
        let relatorio = widget.currentRow.relatorio;
        row.NRDELIVERY = widget.getParent().currentRow.NRDELIVERY;

        row.DTHRPLAVOOPV = row.DTHRPLAVOOPV.slice(0, 10);

        switch (relatorio) {
            case "ATE02200": {
                InflightorGeneral.openReport("ate#/relatorio_delivery", "ATE02200", row);
            }
            break;
            case "ATE02201": {
                InflightorGeneral.openReport("ate#/relatorio_delivery", "ATE02201", row);
            }
            break;
            case "ATE02202": {
                InflightorGeneral.openReport("ate#/relatorio_delivery", "ATE02202", row);
            }
            break;
            case "ATE02203": {
                InflightorGeneral.openReport("ate#/relatorio_delivery", "ATE02203", row);
            }
            break;
        }
    };

    this.recalcularDelivery = function(widget) {
        let deliveryWidget = widget.container.getWidget("deliveriesvoo");
        let cancelDelivery = widget.container.getWidget("popupCancelamento");
        let sit = widget.currentRow.IDSITDEL;
        let sit2 = widget.currentRow.IDALTERDELIV;
        let sit3 = widget.currentRow.IDCALCPROPDLCOM;

        if (self.validaPermissao(widget.currentRow.DTHRPLAVOOPV)) {
            if (sit != "1") {
                MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
                return;
            }
            if (sit3 === "S") {
                MessageService.showMessageByCode("ATE25200_BLOQ_EDIT_PARAM_PROP");
            } else {
                ManutencaoDeliveryService.calcula_delivery(widget.currentRow).then(function(success) {
                        MessageService.showMessageByCode("ATE25200_DEL_RECALC_SUCES");
                        ScreenService.closePopup();
                        ScreenService.closeSwipe();
                        deliveryWidget.reload();
                    },
                    function(error) {
                        if (error.data)
                            trataMensagem(error.data.error);
                    });
            }
        }
    };

    function autenticacaoUsuario(widget) {
        let deferred = ZHPromise.defer();
        if (widget.isValid()) {
            let grupoCancelaExpSap = retornoPermissao.CDGROPCANDELEXPSAP;
            let nomeUsuario = widget.currentRow.usuario;
            let senha = widget.currentRow.senha;
            let nrorg = getLocalVar("INFLIGHTOR_NRORGTRAB");

            // ManutencaoDeliveryService.retornaOperador(nomeUsuario, nrorg).then(function(operador){
            // operador = operador.dataset.retornaOperadorNmacesso;
            // if(operador.length) {
            /*09/01/2018*/
            // ManutencaoDeliveryService.validaOperador(operador[0].CDOPERADOR, grupoCancelaExpSap, nrorg).then(function(situacaoOperador){
            ManutencaoDeliveryService.autenticar(nomeUsuario, senha).then(function(sucesso) {
                deferred.resolve(sucesso);
            }).catch(function(error) {
                deferred.reject(error.data.error);
            });
            // });
            // } else{
            // deferred.reject('Operador não cadastrado.');
            // }
            // });
        }
        return deferred.promise;
    }

    this.validarMotivo = function(widgetAutenticacao) {

        let widgetCancelamento = widgetAutenticacao.container.getWidget("popupCancelamento");

        if (widgetCancelamento.isValid())
            ScreenService.openPopup(widgetAutenticacao);

    };

    this.confirmaAutenticacao = function(widgetAutenticacao) {

        if (widgetAutenticacao.isValid()) {

            if (widgetAutenticacao.lastActiveWidget.name === "popupCancelamento") {
                this.salvarMotivo(widgetAutenticacao);
            } else {
                autenticacaoUsuario(widgetAutenticacao).then(function() {
                    let widget = widgetAutenticacao.container.getWidget("deliveriesvoo");

                    widget.currentRow.IDDELIEXPSAP = "N";
                    InflightorGeneral.callRestEngine("ate#/deliverym_obsdeliverym_paramcomis/save", "DataSet", [widget.currentRow]).then(
                        function(success) {
                            widget.activate();
                            widget.computeDescriptionOrder();
                            widget.view();
                            MessageService.showMessageByCode("ATE25200_CANCEL_EXPORT_SUCES");
                            ScreenService.closePopup(true);
                            widget.getParent().reload().then(function() {
                                widget.getParent().activate();
                            });
                        },
                        function(error) {
                            widget.currentRow.IDDELIEXPSAP = "S";
                            InflightorGeneral.callbackError(error);
                        }
                    );
                }).catch(function(erro) {
                    if (erro.data)
                        trataMensagem(erro.data.erro);
                    else
                        ScreenService.showMessage(erro, "error");
                });
            }

        }

    };

    this.cancExpSap = function(widget) {
        if (self.validaPermissao(widget.currentRow.DTHRPLAVOOPV)) {
            let sit = widget.currentRow.IDDELIEXPSAP;

            if ((sit != "S")) {
                MessageService.showMessageByCode("ATE25200_DEL_N_EXPORT_SAP");
            } else {
                MessageService.confirmMessageByCode("ATE25200_CONF_EXPORT_SAP").then(
                    function(success) {
                        ScreenService.openPopup(widget.container.getWidget("widget_autenticar"));
                    });
            }
        }
    };

    this.carregaServico = function(field) {
        let row = field.widget.currentRow;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": row.CDCIA
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": row.NRVOO
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": row.CDTRECHO
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": row.DTHRPLAVOOPV
			},
            {
                "name": "CDCLASSE",
                "operator": "=",
                "value": row.CDCLASSE
			}
		];

        InflightorGeneral.callRestEngine("ate#/previsaopaxm_max", "FilterData", filter).then(function(success) {
            if (success.dataset && success.dataset.previsaopaxm_max && success.dataset.previsaopaxm_max.length) {
                field.widget.currentRow.QTTOTPAX_PAXSBY = success.dataset.previsaopaxm_max[0].QTTOTPAXAT;
            } else {
                field.widget.currentRow.QTTOTPAX_PAXSBY = null;
            }
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
        });
    };

    this.validaSave = function(widget) {
        let row = widget.currentRow;
        let valida = validaParamsVar;
        widget.currentRow.CDEQUIP = valida.CDEQUIP;
        widget.currentRow.SGPREFIXO = valida.SGPREFIXO;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": row.CDCIA
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": row.NRVOO
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": row.CDTRECHO
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": row.DTHRPLAVOOPV
			}
		];

        if ((widget.currentRow.DSSERVICOGEN === "") || (widget.currentRow.DSSERVICOGEN === null) ||
            !(widget.currentRow.DSSERVICOGEN)) {
            MessageService.showMessageByCode("ATE25200_ITEM_N_SELECIONADO");
        } else if ((widget.currentRow.QTATUAPRODSP < 1) || (isNaN(widget.currentRow.QTATUAPRODSP))) {
            MessageService.showMessageByCode("ATE25200_QT_ITEM_INV");
        } else {
            widget.currentRow.CDAGRDEDE = widget.currentRow.CDCLASSE;
            InflightorGeneral.callRestEngine("ate#/servplanom_nritemplansp", "FilterData", filter).then(function(success) {
                    var data = success.dataset.servplanom_nritemplansp[0];

                    if (widget.currentRow.__is_new === true) {
                        widget.currentRow.NRITEMPLANSP = data.NRITEMPLANSP;
                    }

                    widget.currentRow.DTHRABASTPV = widget.getParent().currentRow.DTEMISDEL;
                    widget.currentRow.IDCALCPROPDLCOM = widget.getParent().currentRow.IDCALCPROPDLCOM;
                    widget.currentRow.CDUSRRESPSP = getLocalVar("INFLIGHTOR_CDOPERADOR");
                    var dataAtual = moment().format("DD/MM/YY hh:mm:ss");
                    widget.currentRow.DTHRINCSESP = dataAtual;
                    var servicosWidget = widget.container.getWidget("servicosdelivery");

                    self.loadQTTOTPAX_PAXSBY(servicosWidget, widget).then(function(QTTOTPAX_PAXSBY) {
                        widget.currentRow.QTTOTPAX_PAXSBY = QTTOTPAX_PAXSBY;
                        ManutencaoDeliveryService.calcula_precom(widget.currentRow).then(function(success) {
                                widget.currentRow.VRPRURESESP = success.dataset.response.VRPRECORRENTE;
                                widget.currentRow.VRPRUDOLSESP = success.dataset.response.VRPREDOLAR;

                                if (widget.currentRow.QTSESBYPRSP > 0) {
                                    if (widget.currentRow.IDTIPMANUAL == "1") {
                                        widget.currentRow.VRPRUSBYSP = success.dataset.response.VRPRECORRENTE;
                                    } else {
                                        widget.currentRow.VRPRUSBYSP = success.dataset.response.VRPREDOLAR;
                                    }
                                } else {
                                    widget.currentRow.VRPRUSBYSP = 0;
                                }
                                ManutencaoDeliveryService.calcula_delivery(widget.currentRow).then(function(success) {
                                    if (widget.currentRow.__is_new === true) {
                                        ManutencaoDeliveryService.retorna_agrupamento(widget.currentRow).then(function(success) {
                                            widget.currentRow.CDAGRDECO = success.dataset.response.CDAGRDECO;
                                            widget.currentRow.VRPESOSESP = widget.currentRow.VRPESOSE;
                                            widget.currentRow.IDTIPMANUALSP = widget.currentRow.IDTIPMANUAL;
                                            widget.currentRow.IDFATSESP = widget.currentRow.IDFATSE;

                                            widget.currentRow.QTSESOLICSP = widget.currentRow.QTATUAPRODSP;
                                            widget.currentRow.QTREALPROD = widget.currentRow.QTATUAPRODSP;
                                            widget.currentRow.IDTPPRECOSP = widget.currentRow.IDTPPRECO;
                                            widget.currentRow.QTSERVFIXSP = 0;
                                            widget.currentRow.IDTPMANUTSP = "1A";
                                            widget.currentRow.QTSESBYNUTSP = 0;

                                            self.salvarItem(widget);

                                        }, function(error) {
                                            if (error.data)
                                                trataMensagem(error.data.error);
                                        });
                                    } else {
                                        self.salvarItem(widget);
                                    }
                                }, function(error) {
                                    if (error.data)
                                        trataMensagem(error.data.error);
                                });
                            },
                            function(error) {
                                if (error.data)
                                    trataMensagem(error.data.error);
                            });
                    });
                }.bind(widget),
                function(error) {
                    if (error.data)
                        trataMensagem(error.data.error);
                });
        }
    };

    this.salvarItem = function(widget) {
        InflightorGeneral.callRestEngine("ate#/crud/servplanom/save", "Row", widget.currentRow).then(function(success) {
            ScreenService.closeSwipe();
            self.recalcularDelivery(templateManager.container.getWidget("deliveriesvoo"));
        }, function(error) {
            if (error.data)
                trataMensagem(error.data.error);
        });
    };

    this.editarItem = function(widget) {
        let exportado = widget.getParent().currentRow.IDDELIEXPSAP;
        if (exportado == "N") {
            if (widget.getParent().currentRow.IDCALCPROPDLCOM === "S") {
                MessageService.showMessageByCode("ATE25200_BLOQ_EDIT_PARAM_PROP");
            } else {
                let isAllowed = self.validaPermissao(widget.container.getWidget("deliveriesvoo").currentRow.DTHRPLAVOOPV);
                if (isAllowed) {
                    let permissao = retornoPermissao;
                    let IDSITDEL = widget.getParent().currentRow.IDSITDEL;
                    let IDALTERDELIV = retornoPermissao.IDALTERDELIV;
                    let IDSITSERSP = widget.currentRow.IDSITSERSP;

                    if ((IDSITDEL == "1") && (IDALTERDELIV == "S")) {
                        widget.getAction("cancelarInclusao").isVisible = false;
                        widget.getAction("cancelarEdicao").isVisible = true;

                        widget.getField("DSSERVICOGEN").readOnly = true;
                        widget.getField("IDSITSERSP").isVisible = true;
                        InflightorGeneral.edit(widget);

                        widget.getField("QTSERFATSP").readOnly = false;
                        widget.getField("QTATUAPRODSP").readOnly = false;
                        widget.getField("QTSESBYUTSP").readOnly = false;
                        widget.getField("QTSESBYNUTSP").readOnly = false;

                        InflightorGeneral.justInteger("#QTSERFATSP");
                        InflightorGeneral.justInteger("#QTATUAPRODSP");
                        InflightorGeneral.justInteger("#QTSESBYUTSP");
                        InflightorGeneral.justInteger("#QTSESBYNUTSP");
                    } else {
                        MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
                        return;
                    }
                }
            }
        } else {
            MessageService.showMessageByCode("ATE25200_DEL_EXPORT_SAP");
        }
    };

    this.incluirItem = function(widget) {
        let exportado = widget.getParent().currentRow.IDDELIEXPSAP;
        if (exportado == "N") {
            if (widget.getParent().currentRow.IDCALCPROPDLCOM === "S") {
                MessageService.showMessageByCode("ATE25200_BLOQ_EDIT_PARAM_PROP");
            } else {
                let isAllowed = self.validaPermissao(widget.container.getWidget("deliveriesvoo").currentRow.DTHRPLAVOOPV);
                if (isAllowed) {
                    let permissao = retornoPermissao;
                    let IDSITDEL = widget.getParent().currentRow.IDSITDEL;
                    let IDALTERDELIV = retornoPermissao.IDALTERDELIV;

                    if ((IDSITDEL != "1") || (IDALTERDELIV != "S")) {
                        MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
                        return;
                    }

                    widget.getAction("cancelarInclusao").isVisible = true;
                    widget.getAction("cancelarEdicao").isVisible = false;

                    widget.getField("DSSERVICOGEN").readOnly = false;
                    widget.getField("IDSITSERSP").isVisible = false;

                    widget.newRow();

                    widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
                    widget.currentRow.CDCIA = widget.getParent().currentRow.CDCIA;
                    widget.currentRow.NRVOO = widget.getParent().currentRow.NRVOO;
                    widget.currentRow.CDTRECHO = widget.getParent().currentRow.CDTRECHO;
                    widget.currentRow.DTHRPLAVOOPV = widget.getParent().currentRow.DTHRPLAVOOPV;
                    widget.currentRow.NRDELIVERY = widget.getParent().currentRow.NRDELIVERY;

                    widget.currentRow.QTSERFATSP = 0;
                    widget.currentRow.QTANTAPRODSP = 0;
                    widget.currentRow.QTSESBYPRSP = 0;
                    widget.currentRow.QTSESBYUTSP = 0;
                    widget.currentRow.QTSESBYNUTSP = 0;
                    widget.currentRow.VRPRUSBYSP = 0;
                    widget.currentRow.QTCORTSERVSP = 0;
                    widget.currentRow.IDTIPSCBOSP = 5;
                    widget.currentRow.IDSITSERSP = 2;
                    widget.currentRow.IDSEREXTSP = 1;
                    widget.currentRow.IDSTKDTSP = 1;

                    InflightorGeneral.justInteger("#QTSERFATSP");
                    InflightorGeneral.justInteger("#QTATUAPRODSP");
                    InflightorGeneral.justInteger("#QTSESBYUTSP");
                    InflightorGeneral.justInteger("#QTSESBYNUTSP");

                    widget.edit();
                }
            }
        } else {
            MessageService.showMessageByCode("ATE25200_DEL_EXPORT_SAP");
        }
    };

    this.excluirItem = function(widget) {
        let exportado = widget.getParent().currentRow.IDDELIEXPSAP;
        if (exportado == "N") {
            if (widget.getParent().currentRow.IDCALCPROPDLCOM === "S") {
                MessageService.showMessageByCode("ATE25200_BLOQ_EDIT_PARAM_PROP");
            } else {
                let isAllowed = self.validaPermissao(widget.container.getWidget("deliveriesvoo").currentRow.DTHRPLAVOOPV);
                if (isAllowed) {
                    let listServico = widget.dataSource.data;
                    let permissao = retornoPermissao;
                    let IDSITDEL = widget.getParent().currentRow.IDSITDEL;
                    let IDALTERDELIV = retornoPermissao.IDALTERDELIV;
                    let IDSITSERSP = widget.currentRow.IDSITSERSP;

                    if ((IDSITDEL == "1") || (IDALTERDELIV == "S") || (IDSITSERSP != "3")) {
                        if (listServico.length < 2) {
                            MessageService.showMessageByCode("ATE25200_EXCL_BLOQ_1_ITEM");
                        } else {
                            MessageService.confirmMessageByCode("ATE25200_CONF_EXCL_ITEM").then(
                                function(success) {
                                    InflightorGeneral.callRestEngine("ate#/crud/servplanom/remove", "Row", widget.currentRow).then(function(success) {
                                        ScreenService.closeSwipe();
                                        MessageService.showMessageByCode("ATE25200_EXCL_ITEM_SUCES");
                                        self.recalcularDelivery(templateManager.container.getWidget("deliveriesvoo"));
                                    }, function(error) {
                                        if (error.data)
                                            trataMensagem(error.data.error);
                                    });
                                },
                                function(error) {}
                            );
                        }
                    } else {
                        MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
                        return;
                    }
                }
            }
        } else {
            MessageService.showMessageByCode("ATE25200_DEL_EXPORT_SAP");
        }
    };

    this.cancelarItem = function(widget) {
        let exportado = widget.getParent().currentRow.IDDELIEXPSAP;
        if (exportado == "N") {
            if (widget.getParent().currentRow.IDCALCPROPDLCOM === "S") {
                MessageService.showMessageByCode("ATE25200_BLOQ_EDIT_PARAM_PROP");
            } else {
                let isAllowed = self.validaPermissao(widget.container.getWidget("deliveriesvoo").currentRow.DTHRPLAVOOPV);

                if (isAllowed) {
                    let permissao = retornoPermissao;
                    let IDSITDEL = widget.getParent().currentRow.IDSITDEL;
                    let IDALTERDELIV = retornoPermissao.IDALTERDELIV;
                    let IDSITSERSP = widget.currentRow.IDSITSERSP;

                    if ((IDSITDEL == "1") || (IDALTERDELIV == "S") || (IDSITSERSP != "3")) {
                        MessageService.confirmMessageByCode("ATE25200_CONF_CANCEL_ITEM").then(
                            function(success) {
                                widget.currentRow.IDSITSERSP = "3";
                                self.salvarItem(widget);
                            },
                            function(error) {
                                ScreenService.closePopup();
                            }
                        );
                    } else {
                        MessageService.showMessageByCode("ATE25200_SIT_ATUAL_BLOQ");
                        return;
                    }
                }
            }
        } else {
            MessageService.showMessageByCode("ATE25200_DEL_EXPORT_SAP");
        }
    };

    this.changeData = function(args) {
        args.owner.field.widget.getField('NMCIA').value("");
        args.owner.field.widget.getField('NRVOO').value("");
        args.owner.field.widget.getField('SGTRECHO').value("");
    };

    this.filterFieldItem = function(field) {
        let row = field.widget.container.getWidget("deliveriesvoo").appliedFilter.FILTER_ROW;
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": row.CDCIA
			},
            {
                "name": "NRDELIVERY",
                "operator": "=",
                "value": field.widget.currentRow.NRDELIVERY
			}
		];
        field.dataSourceFilter = filter;
        field.reload();
    };

    this.filterItem = function() {
        let widget = templateManager.container.getWidget("deliveriesvoo");
        let widgetServ = templateManager.container.getWidget("servicosdelivery");
        self.validaOperador(widget);
        self.validaParams(widget);
        let nr = widget.currentRow.NRDELIVERY;
        let cdfilial = widget.currentRow.CDFILIAL;
        let cdcia = widget.currentRow.CDCIA;
        let dtplanovoo = widget.currentRow.DTHRPLAVOOPV.substr(0, 10);
        let voo = widget.currentRow.NRVOO;
        let trecho = widget.currentRow.CDTRECHO;

        let filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
			},
            {
                "name": "CDCIA",
                "operator": "=",
                "value": cdcia
			},
            {
                "name": "NRVOO",
                "operator": "=",
                "value": voo
			},
            {
                "name": "CDTRECHO",
                "operator": "=",
                "value": trecho
			},
            {
                "name": "DTHRPLAVOOPV",
                "operator": "=",
                "value": dtplanovoo
			},
            {
                "name": "NRDELIVERY",
                "operator": "=",
                "value": nr
			}
		];

        widgetServ.dataSourceFilter = filtro;
    };

    this.atualizaQtdeFaturar = function(field) {
        if (field.value() > 0) {
            field.widget.currentRow.QTSERFATSP = field.value();
        }
    };

    this.filterCia = function(widget) {
        let filterCurrentRow = widget.currentRow;
        let fieldCia = widget.getField("NMCIA");
        let fieldData = widget.getField("DTHRPLAVOOPV");
        let fieldFilial = widget.getField("NMFILIAL");

        if (fieldFilial.value() && fieldFilial.value() != "" &&
            fieldData.value() && fieldData.value() != "") {
            fieldCia.readOnly = false;
            let filter = {
                DTHRPLAVOOPV: filterCurrentRow.DTHRPLAVOOPV,
                CDFILIAL: filterCurrentRow.CDFILIAL
            };
            InflightorGeneral.buildDataSourceFilter(fieldCia.dataSourceFilter, filter);
        } else {
            fieldCia.readOnly = true;
        }
        self.filterVoo(widget.getField("NRVOO"));
    };

    this.changeCia = function(args) {
        let nrvoo = args.owner.field.widget.getField("NRVOO");
        args.owner.field.widget.getField('NRVOO').value("");
        args.owner.field.widget.getField('SGTRECHO').value("");

        if (args.owner.field.widget.getField('NMCIA') != "") {
            nrvoo.readOnly = false;
        } else {
            nrvoo.readOnly = true;
        }
        nrvoo.reload();
    };

    this.filterVoo = function(field) {
        let widget = field.widget;
        let fieldCia = widget.getField("NMCIA");
        if (fieldCia.value() && fieldCia.value() != "") {
            widget.getField("NRVOO").readOnly = false;
            let filterCurrentRow = field.widget.currentRow;
            let filter = {
                CDFILIAL: filterCurrentRow.CDFILIAL,
                CDCIA: filterCurrentRow.CDCIA,
                DTHRPLAVOOPV: filterCurrentRow.DTHRPLAVOOPV
            };
            InflightorGeneral.onClickDependentField(field, filter);
        } else {
            widget.getField("NRVOO").readOnly = true;
        }
    };

    this.filterDeliveries = function(widget) {
        if (widget.appliedFilter) {
            let filtro = widget.appliedFilter.FILTER_ROW;
            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": filtro.CDFILIAL
    			},
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": filtro.CDCIA
    			},
                {
                    "name": "DTHRPLAVOOPV",
                    "operator": "=",
                    "value": filtro.DTHRPLAVOOPV
    			},
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": filtro.NRVOO
    			},
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": filtro.CDTRECHO
    			}
    		];
            widget.dataSourceFilter = filter;
            widget.reload();
            let widgetServ = widget.container.getWidget('servicosvoo');
            widgetServ.dataSourceFilter = filter;

            self.validaParamDelivery(widget);
        }
    };

    this.reload = function(widgetName, addictionalFilters) {
        let widget = templateManager.container.getWidget(widgetName);
        let modeList = "list";
        if (widget.dataSource) {
            if (widget.mode == modeList) {
                widget.reload(addictionalFilters);
            } else {

                let currentRow = widget.currentRow;
                let dataSource = widget.dataSource;

                let VO = dataSource.getVO();

                if (!VO) throw "Frontend dataSource not found!";
                if (!VO.localKey || !VO.localKey.length)
                    throw "LocalKey not found in frontend dataSource!";

                let localKey = VO.localKey;

                let filter = addictionalFilters || [];
                for (let i = 0; i < localKey.length; i++) {
                    filter.push({
                        "name": localKey[i],
                        "operator": "=",
                        "value": currentRow[localKey[i]]
                    });
                }

                return restEngine.post(dataSource.name, {
                    "requestType": "FilterData",
                    "filter": filter
                }).then(function(callback) {
                    let dataSourceSplit = dataSource.name.split("/");
                    let dataSourceName = dataSourceSplit[dataSourceSplit.length - 1];

                    let currentRow = callback.dataset[dataSourceName][0];

                    for (let i in widget.currentRow) {
                        widget.currentRow[i] = currentRow[i];
                    }
                });
            }
        } else {
            return {
                then: function(fullfil) {
                    return fullfil ? fullfil() : this;
                }
            };
        }
    };

    this.limpaEAplicaFiltros = function(args) {
        let field = args.owner.field;
        let widget = field.widget;
        if (field.name == "DTHRPLAVOOPV" || field.name == "NMFILIAL") {

            widget.getField("NMCIA").setValue("");
            widget.getField("NRVOO").setValue("");
            widget.getField("SGTRECHO").setValue("");

            self.filterCia(widget);
        } else if (field.name == "NMCIA") {

            widget.getField("NRVOO").setValue("");
            widget.getField("SGTRECHO").setValue("");
            self.filterVoo(widget.getField("NRVOO"));
        }
        templateManager.updateTemplate();

    };

    this.iniciaTela = function() {
        let widget = templateManager.container.getWidget('deliveriesvoo');
        widget.activate();
        InflightorGeneral.openFilterOnEnter(widget, ['CDFILIAL', 'NMFILIAL', 'DTHRPLAVOOPV', 'CDOPERADOR']);
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register("ManutencaoDelivery", ManutencaoDelivery);
});

// FILE: ./assets/js/controllers/VooTrechoController.js
/* global Util */
function VooTrechoController(ScreenService, ZHPromise, InflightorGeneral, ZhFilterPreferences, templateManager, MessageService) {

    let self = this;
    let cdfilial, cdcia, nmfilial, nmcia;
    let arrayFrequencia = [
        "IDVOOSAB",
        "IDVOOSEX",
        "IDVOOQUI",
        "IDVOOQUA",
        "IDVOOTER",
        "IDVOOSEG",
        "IDVOODOM"
    ];

    this.fixUselessFilterFields = function(field) {
        if (field.dataSourceFilter) {
            delete field.dataSourceFilter;
            let filtro = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": field.widget.currentRow.CDFILIAL
                }
            ];
            field.dataSourceFilter = filtro;
            field.reload();
        }
    };

    this.initCompanyFilterOnFilterPopup = function(widget) {

        let field = widget.getField("NMCIA");
        let fieldFilter = field.dataSourceFilter;
        let branchFilterIndex = this.getObjectPositionInArrayByName(fieldFilter, "CDFILIAL");

        fieldFilter[branchFilterIndex].value = getLocalVar("INFLIGHTOR_CDFILIAL");

    };

    /**
     * Procedimento para recuperar a posição
     * de um objeto dentro de um array.
     * 
     * @param {object} array array onde será feito
     * a varredura.
     * 
     * @param {object} objectName nome do objeto a ser
     * buscado.
     */
    this.getObjectPositionInArrayByName = function(array, objectName) {

        let indexFieldObject;

        array.forEach(function(value, i) {
            if (value.name === objectName) {
                indexFieldObject = i;
            }
        });

        return indexFieldObject;

    };

    function _applyDefaultConfigVoo(widget) {
        let widgetTrecho = widget.container.getWidget('widgetTrecho');
        InflightorGeneral.callRestEngine("ate#/crud/voo", "FilterData", filter).then(function(callback) {
            if (callback.dataset && callback.dataset.voo) {
                let oldRow = widget.currentRow;
                Object.assign(widget.currentRow, callback.dataset.voo[0], oldRow);
                arrayFrequencia.forEach(function(id) {
                    widget.currentRow[id] = widget.currentRow[id] == '1' ? "S" : "N";
                });
                widget.currentRow.HRETD = widgetTrecho.currentRow.HRDECOLVOO;
                widget.currentRow.HRETA = widgetTrecho.currentRow.HRPOUSOVOO;
                widget.currentRow.__is_new = true;
                if (widget.dataSource.data.length > 1) {
                    widget.currentRow.HRETD = widget.dataSource.data[widget.dataSource.data.length - 2].HRETD;
                    widget.currentRow.HRETA = widget.dataSource.data[widget.dataSource.data.length - 2].HRETA;
                    widget.currentRow.HRKDT = widget.dataSource.data[widget.dataSource.data.length - 2].HRKDT;
                    widget.currentRow.HRKRT = widget.dataSource.data[widget.dataSource.data.length - 2].HRKRT;
                    widget.currentRow.CDEQUIP = widget.dataSource.data[widget.dataSource.data.length - 2].CDEQUIP;
                    widget.currentRow.SGEQUIP = widget.dataSource.data[widget.dataSource.data.length - 2].SGEQUIP;
                }
            }
        });
    }

    this.verificaSwipeAberto = function(args) {
        if (ScreenService.isSwipeOpen(2)) {
            ScreenService.closeSwipe();
        }
    };

    this.formatFieldTime = function(widget) {
        if (widget.dataSource) {
            widget.dataSource.data.forEach(function(row) {
                converteFieldTime(row, ["HRETA", "HRETD", "HRKDT", "HRKRT"], 'hh:mm');
            });
        }
    };

    this.checkVooCode = function(widget) {

        let row = {
            "nrvoo": widget.currentRow.NRVOO,
            "cdfilial": widget.currentRow.CDFILIAL,
            "cdcia": widget.currentRow.CDCIA,
            "nrorg": getLocalVar('INFLIGHTOR_NRORGTRAB')
        };

        InflightorGeneral.callRestEngine('ate#/checkVooCode', "Row", row).then(function(sucesso) {

        }, function(erro) {
            widget.getField('NRVOO').value("");
            ScreenService.showMessage(erro.data.error);
        });

    };

    this.aplicaFilter = function(widget) {
        cdfilial = widget.appliedFilter.FILTER_ROW.CDFILIAL;
        cdcia = widget.appliedFilter.FILTER_ROW.CDCIA;
        nmfilial = widget.appliedFilter.FILTER_ROW.NMFILIAL;
        nmcia = widget.appliedFilter.FILTER_ROW.NMCIA;

        widget.dataSourceFilter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            },
            {
                "name": "CDCIA",
                "operator": "=",
                "value": cdcia
            }
        ];
        widget.reload();
    };

    this.cancelaEdit = function(widget) {
        let cancel = true;
        let vefificaNovo;

        if (widget.name == "widgetTrechoVoo") {
            vefificaNovo = !widget.currentRow.trechoPreCadastrado;
        } else {
            if (widget.currentRow.__is_new === undefined) {
                ScreenService.closeSwipe(0);
                widget.container.getWidget('widgetVoo').activate();
                cancel = false;
            } else {
                vefificaNovo = widget.currentRow.__is_new;
                widget.container.getWidget('widgetTrecho').isVisible = true;
            }
        }
        if (cancel) {
            if (vefificaNovo) {
                widget.list();
                widget.dataSource.data.pop();
                ScreenService.closeSwipe();
            } else {
                widget.view();
                Object.assign(widget.currentRow, widget.backupRow);
                widget.currentRow.changed = false;
                for (let i = 0; i < widget.dataSource.data.length; i++) {
                    if (widget.dataSource.data[i].changed) {
                        widget.dataSource.data[i].changed = false;
                    }
                }
            }
            widget.activate();
            widget.widgets[0].isVisible = true;
            widget.widgets[0].showAsTab = true;
            if (widget.name === 'widgetTrecho') {
                const widgetConfig = widget.container.getWidget('widgetConfig');
                widgetConfig.isVisible = true;
                widgetConfig.showAsTab = true;
            }
        }
    };

    this.cancelNewVigencia = function(widget) {
        InflightorGeneral.widgetCancelForm(widget).then(function() {
            widget.container.getWidget('widgetVigencia').dataSource.data.pop();
        });
    };

    this.cancelaNovoMultiplicador = function(widget) {

        let widgetConfig = widget.container.getWidget("widgetConfig");

        ScreenService.closeSwipe();
        widgetConfig.activate();

    };

    this.voltaSwipe = function(widget) {
        if (widget.mode !== "view") {
            if (widget.getParent().template == "widget/tabbedWidget.html") {
                widget = widget.getParent();
            }
            widget = widget.getParent();
        }
        ScreenService.closeSwipe();
        widget.list();
        widget.reload();
        widget.activate();
    };

    this.closeSwipeTrecho = function(widget) {
        const mainWidget = getMainWidget();
        if (!widget.inViewMode()) {
            widget = mainWidget;
        }
        ScreenService.closeSwipe();
        widget.list();
        widget.reload();
        widget.activate();
    };

    this.voltaSwipeVigencia = function(widget) {
        ScreenService.closeSwipe();
        widget.container.getWidget('decolagemVigencia').isVisible = true;
        widget.list();
        widget.reload();
        widget.activate();
    };

    this.voltaVigencia = function(widget) {
        let widgetTrecho = widget.container.getWidget('widgetTrecho');
        ScreenService.closeSwipe();
        widgetTrecho.mode = 'edit';
        widgetTrecho.getAction('ADICIONAR_VIGENCIA').isVisible = true;
        widgetTrecho.activate();
    };

    let converteFieldTime = function(row, fields, formato) {
        fields.forEach(function(field) {
            let strHora = row[field];
            if (strHora && formato && (strHora.length != formato.length)) {
                switch (formato) {
                    case 'hh:mm':
                        row[field] = strHora[0] + strHora[1] + ':' + strHora[2] + strHora[3];
                        break;
                    case 'hhmm':
                        row[field] = strHora[0] + strHora[1] + strHora[3] + strHora[4];
                        break;
                }
            }
        });
    };

    this.validadeTimeField = function(field) {
        if (!!field.value()) {
            let valueArr = field.value().split(':');
            if (valueArr[0] > 23) {
                valueArr[0] = "23";
                valueArr[1] = "59";
                MessageService.notificationMessageByCode("INVALID_TIME");
            } else if (valueArr[1] > 59) {
                valueArr[1] = "59";
                MessageService.notificationMessageByCode("INVALID_TIME");
            }
            field.setValue(valueArr.join(':'));
        }
    };

    this.filtraCiaFilter = function(widgetVoo) {
        let fieldCia = widgetVoo.getField('NMCIA');
        if (widgetVoo.currentRow.CDFILIAL) {
            cdfilial = widgetVoo.currentRow.CDFILIAL;
            fieldCia.readOnly = false;
            fieldCia.dataSourceFilter = [{
                name: "CDFILIAL",
                operator: "=",
                value: cdfilial
            }, {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('INFLIGHTOR_NRORGTRAB')
            }];
            fieldCia.reload();
            fieldCia.setValue('');
        } else {
            fieldCia.setValue('');
            fieldCia.readOnly = true;
        }
    };

    function setEnabledWidgetCreateVoo(status) {
        templateManager.container.getWidget('widgetCreateVoo').enabled = status;
    }

    function getMainWidget() {
        return templateManager.container.getWidget('widgetVoo');
    }

    this.cancelNewVoo = function(widget) {
        setEnabledWidgetCreateVoo(false);
        ScreenService.closeSwipe(0);
        widget.container.getWidget('widgetVoo').activate();
    };

    this.cancelNewTrecho = function(widget) {
        templateManager.container.getWidget('widgetCreateTrechoTrecho').enabled = false;
        ScreenService.closeSwipe().then(_ => {
            widget.container.getWidget('widgetTrecho').activate();
        });
    };

    this.criarVoo = function(args, widgetVoo) {
        const mainWidget = getMainWidget();
        const filterRow = mainWidget.appliedFilter ? mainWidget.appliedFilter.FILTER_ROW : null;
        if (!filterRow || Util.isEmptyObject(filterRow)) {
            MessageService.showMessageByCode("FILTRO_N_INF");
            return;
        }
        widgetVoo.container.getWidget('widgetCreateVoo').activate();
        widgetVoo.container.getWidget('widgetCreateVoo').newRow();
        widgetVoo.container.getWidget('widgetCreateVoo').enabled = true;
        widgetVoo.container.getWidget('tabbedCreateTrecho').isVisible = false;
        widgetVoo.container.getWidget('tabbedCreateTrecho').enabled = false;

        widgetVoo.container.getWidget('widgetCreateVoo').currentRow.CDFILIAL = widgetVoo.appliedFilter.FILTER_ROW.CDFILIAL;
        widgetVoo.container.getWidget('widgetCreateVoo').currentRow.CDCIA = widgetVoo.appliedFilter.FILTER_ROW.CDCIA;
        widgetVoo.container.getWidget('widgetCreateVoo').currentRow.NMFILIAL = widgetVoo.appliedFilter.FILTER_ROW.NMFILIAL;
        widgetVoo.container.getWidget('widgetCreateVoo').currentRow.NMCIA = widgetVoo.appliedFilter.FILTER_ROW.NMCIA;
        widgetVoo.container.getWidget('widgetCreateVoo').currentRow.NRORG = getLocalVar('INFLIGHTOR_NRORGTRAB');

        widgetVoo.container.getWidget('widgetCreateVoo').getField('SGPREFIXO').readOnly = true;
        widgetVoo.container.getWidget('widgetCreateVoo').getField('NRVOO').readOnly = false;
        self.filtraFieldEquipamento(widgetVoo.container.getWidget('widgetCreateVoo'));

        widgetVoo.container.getWidget('widgetCreateTrecho').alreadyEnter = false;
        widgetVoo.container.getWidget('widgetCreateVigencia').alreadyEnter = false;

        widgetVoo.container.getWidget('widgetTrecho').isVisible = false;
        let widgetTrechoVoo = widgetVoo.container.getWidget('widgetTrechoVoo');
        widgetTrechoVoo.dataSource.data = [];
        widgetTrechoVoo.getAction('SALVAR_TRECHOVOO').isVisible = false;
        widgetTrechoVoo.getAction('ADICIONAR_VIGENCIA').isVisible = true;
        setEnabledWidgetCreateVoo(false);
        ScreenService.openSwipe(widgetVoo.container.getWidget('tabbedCreateVoo')).then(() => {
            setEnabledWidgetCreateVoo(true);
        });
    };

    this.criarTrecho = function(widget) {

        // widget.container.getWidget('widgetCreateTrechoTrecho').activate();

        widget.container.getWidget('widgetCreateTrechoTrecho').currentRow.CDFILIAL = cdfilial;
        widget.container.getWidget('widgetCreateTrechoTrecho').currentRow.CDCIA = cdcia;
        widget.container.getWidget('widgetCreateTrechoTrecho').currentRow.NMFILIAL = nmfilial;
        widget.container.getWidget('widgetCreateTrechoTrecho').currentRow.NMCIA = nmcia;
        widget.container.getWidget('widgetCreateTrechoTrecho').currentRow.NRORG = getLocalVar('INFLIGHTOR_NRORGTRAB');
        widget.container.getWidget('widgetCreateTrechoTrecho').currentRow.NRVOO = widget.container.getWidget('widgetVoo').currentRow.NRVOO;

        widget.container.getWidget('widgetCreateTrechoTrecho').alreadyEnter = false;
        widget.container.getWidget('widgetCreateVigenciaTrecho').alreadyEnter = false;
        ScreenService.openSwipe(widget.container.getWidget('tabbedCreateTrecho')).then(_ => {
            widget.container.getWidget('widgetCreateTrechoTrecho').enabled = true;
            widget.container.getWidget('widgetCreateTrechoTrecho').newRow();
        });
    };

    this.saveCompleteVoo = function(widget) {
        if (!_booValidaData(widget))
            return;

        let origin = "voo";
        let widgetVoo = widget.container.getWidget('widgetCreateVoo');
        let widgetTrechoVoo = widget.container.getWidget('widgetCreateTrecho');
        let widgetTrecho = widget.container.getWidget('widgetTrecho');

        widgetTrechoVoo.currentRow.NRVOO = widgetVoo.currentRow.NRVOO;
        widgetTrechoVoo.currentRow.CDFILIAL = widgetVoo.currentRow.CDFILIAL;
        widgetTrechoVoo.currentRow.CDCIA = widgetVoo.currentRow.CDCIA;
        widgetTrechoVoo.currentRow.NRORG = getLocalVar('INFLIGHTOR_NRORGTRAB');

        let dataSetVooTrechos = _createDataToSave(widget, widgetVoo, widgetTrechoVoo, widgetTrecho, origin);
        InflightorGeneral.callRestEngine("ate#/voo/newvoo", "DataSet", dataSetVooTrechos).then(function(success) {
            if (success.dataset && success.dataset.novoVoo) {
                widgetTrechoVoo.currentRow.NRVOO = success.dataset.novoVoo[0].NRVOO;
                widgetTrechoVoo.currentRow.CDTRECHO = success.dataset.novoVoo[0].CDTRECHO;
            }
            saveVigenciaVoo(widgetVoo, origin);
        }, function(error) {
            let errorMessage = 'Timeout';
            if (error.data) {
                errorMessage = error.data.error;
            }
            ScreenService.showMessage(errorMessage);
        });
    };

    this.saveCompleteTrecho = function(widget) {
        if (!_booValidaData(widget))
            return;
        let origin = "trecho";
        let widgetVoo = widget.container.getWidget('widgetVoo');
        let widgetTrechoVoo = widget.container.getWidget('widgetCreateTrechoTrecho');
        let widgetTrecho = widget.container.getWidget('widgetTrecho');

        widgetTrechoVoo.currentRow.NRVOO = widgetVoo.currentRow.NRVOO;
        widgetTrechoVoo.currentRow.CDFILIAL = widgetVoo.currentRow.CDFILIAL;
        widgetTrechoVoo.currentRow.CDCIA = widgetVoo.currentRow.CDCIA;
        widgetTrechoVoo.currentRow.NRORG = getLocalVar('INFLIGHTOR_NRORGTRAB');

        let dataSetVooTrechos = _createDataToSave(widget, widgetVoo, widgetTrechoVoo, widgetTrecho, origin);
        InflightorGeneral.callRestEngine("ate#/voo/newvoo", "DataSet", dataSetVooTrechos).then(function(success) {
            if (success.dataset && success.dataset.novoVoo) {
                widgetTrechoVoo.currentRow.NRVOO = success.dataset.novoVoo[0].NRVOO;
                widgetTrechoVoo.currentRow.CDTRECHO = success.dataset.novoVoo[0].CDTRECHO;
            }
            saveVigenciaTrecho(widgetVoo, origin);
        }, InflightorGeneral.treatAndShowError);
    };

    let saveVigenciaTrecho = function(widgetVoo, origin) {
        let widgetTrecho = widgetVoo.container.getWidget('widgetTrecho');
        if (origin == "trecho") {
            templateManager.container.getWidget('widgetCreateVigenciaTrecho').enabled = false;
            templateManager.container.getWidget('widgetCreateTrechoTrecho').enabled = false;
            ScreenService.closeSwipe().then(function() {
                widgetTrecho.activate();
                widgetTrecho.list();
                widgetTrecho.reload();
            });
        }
    };

    let saveVigenciaVoo = function(widgetVoo, origin) {
        let widgetTrecho = widgetVoo.container.getWidget('widgetTrecho');
        let widgetTrechoVoo = widgetVoo.container.getWidget('widgetTrechoVoo');
        let widgetVigencia = widgetVoo.container.getWidget('widgetVigencia');
        let backupRow = {
            "widgetVoo": angular.copy(widgetVoo.currentRow),
            "widgetTrecho": angular.copy(widgetTrecho.currentRow)
        };
        widgetTrecho.dataSourceFilter = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: backupRow.widgetVoo.CDFILIAL
            },
            {
                name: "CDCIA",
                operator: "=",
                value: backupRow.widgetVoo.CDCIA
            },
            {
                name: "NRVOO",
                operator: "=",
                value: backupRow.widgetVoo.NRVOO
            }
        ];
        widgetVigencia.dataSourceFilter = angular.copy(widgetTrecho.dataSourceFilter);
        if (origin == "voo") {
            // widgetVoo.container.getWidget('widgetVoo').activate();
            // widgetVoo.container.getWidget('widgetVoo').view();
            widgetVoo.container.getWidget('widgetCreateTrecho').enabled = false;
            widgetVoo.container.getWidget('widgetCreateVigencia').enabled = false;
            ScreenService.closeSwipe(0).then(function() {
                widgetVoo.container.getWidget('widgetVoo').rowToSet = {
                    NRVOO: widgetVoo.currentRow.NRVOO
                };
                widgetVoo.container.getWidget('widgetVoo').reload().then(function() {
                    widgetTrecho.isVisible = true;
                    // widgetVoo.container.getWidget('widgetVoo').view();
                    // ScreenService.openSwipe(widgetVoo.container.getWidget('widgetVoo'));
                });
            });
        }
    };

    this.nextTrecho = function(widget) {
        if (validaVooSave(widget.container.getWidget('widgetCreateVoo'))) {
            let filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetCreateVoo').currentRow.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetCreateVoo').currentRow.CDCIA
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetCreateVoo').currentRow.NRORG
                },
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetCreateVoo').currentRow.NRVOO
                }
            ];
            InflightorGeneral.callRestEngine('ate#/crud/voo_filial_companhia_equipamento_operador', "FilterData", filter).then(function(callback) {
                if (callback.dataset.voo_filial_companhia_equipamento_operador) {
                    if (callback.dataset.voo_filial_companhia_equipamento_operador.length) {
                        ScreenService.showMessage('O voo ' + widget.container.getWidget('widgetCreateVoo').currentRow.NRVOO + ' já existe!');
                    } else {
                        widget.container.getWidget('widgetCreateVoo').enabled = false;
                        widget.container.getWidget('tabbedCreateVoo').currentWidget = widget.container.getWidget('widgetCreateTrecho');
                        widget.container.getWidget('widgetCreateTrecho').enabled = true;
                        widget.container.getWidget('widgetCreateTrecho').activate();
                        if (!widget.container.getWidget('widgetCreateTrecho').alreadyEnter) {
                            widget.container.getWidget('widgetCreateTrecho').newRow();
                            widget.container.getWidget('widgetCreateTrecho').getField('IDTIPAJUSFAT').applyDefaultValue();
                            widget.container.getWidget('widgetCreateTrecho').getField('IDNACIVOOTRE').applyDefaultValue();
                            widget.container.getWidget('widgetCreateTrecho').getField('IDSITVOOTRE').applyDefaultValue();
                            widget.container.getWidget('widgetCreateTrecho').alreadyEnter = true;
                        }
                    }
                }
            });
        }
    };

    let validaNewVoo = function(widget) {
        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            },
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widget.currentRow.CDCIA
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": widget.currentRow.NRORG
            },
            {
                "name": "NRVOO",
                "operator": "=",
                "value": widget.currentRow.NRVOO
            }
        ];
        InflightorGeneral.callRestEngine('ate#/crud/voo_filial_companhia_equipamento_operador', "FilterData", filter).then(function(callback) {
            if (callback.dataset.voo_filial_companhia_equipamento_operador) {
                if (callback.dataset.voo_filial_companhia_equipamento_operador.length) {
                    ScreenService.showMessage('O voo ' + widget.currentRow.NRVOO + ' já existe!');
                    return true;
                } else {
                    return false;
                }
            }
        });
    };

    this.backTrecho = function(widget) {
        widget.container.getWidget('widgetCreateTrecho').enabled = false;
        widget.container.getWidget('tabbedCreateVoo').currentWidget = widget.container.getWidget('widgetCreateVoo');
        widget.container.getWidget('widgetCreateVoo').enabled = true;
        widget.container.getWidget('widgetCreateVoo').activate();
    };

    this.nextVigencia = function(widget) {
        if (widget.isValid()) {
            widget.container.getWidget('widgetCreateTrecho').enabled = false;
            widget.container.getWidget('tabbedCreateVoo').currentWidget = widget.container.getWidget('widgetCreateVigencia');
            widget.container.getWidget('widgetCreateVigencia').enabled = true;
            widget.container.getWidget('widgetCreateVigencia').activate();
            if (!widget.container.getWidget('widgetCreateVigencia').alreadyEnter) {
                widget.container.getWidget('widgetCreateVigencia').newRow();
                widget.container.getWidget('widgetCreateVigencia').alreadyEnter = true;
            }
        }
    };

    this.nextVigenciaTrecho = function(widget) {
        if (widget.isValid()) {
            widget.container.getWidget('widgetCreateTrechoTrecho').enabled = false;
            widget.container.getWidget('tabbedCreateTrecho').currentWidget = widget.container.getWidget('widgetCreateVigenciaTrecho');
            widget.container.getWidget('widgetCreateVigenciaTrecho').enabled = true;
            widget.container.getWidget('widgetCreateVigenciaTrecho').activate();
            if (!widget.container.getWidget('widgetCreateVigenciaTrecho').alreadyEnter) {
                widget.container.getWidget('widgetCreateVigenciaTrecho').newRow();
                widget.container.getWidget('widgetCreateVigenciaTrecho').alreadyEnter = true;
            }
        }
    };

    this.backVigencia = function(widget) {
        widget.container.getWidget('widgetCreateTrecho').enabled = true;
        widget.container.getWidget('tabbedCreateVoo').currentWidget = widget.container.getWidget('widgetCreateTrecho');
        widget.container.getWidget('widgetCreateVigencia').enabled = false;
        widget.container.getWidget('widgetCreateTrecho').activate();
    };

    this.backVigenciaTrecho = function(widget) {
        widget.container.getWidget('widgetCreateTrechoTrecho').enabled = true;
        widget.container.getWidget('tabbedCreateTrecho').currentWidget = widget.container.getWidget('widgetCreateTrechoTrecho');
        widget.container.getWidget('widgetCreateVigenciaTrecho').enabled = false;
        widget.container.getWidget('widgetCreateTrechoTrecho').activate();
    };

    this.adicionarTrechos = function(widgetVoo) {
        if (validaVooSave(widgetVoo)) {
            let widgetTrechoVoo = widgetVoo.container.getWidget('widgetTrechoVoo');
            // widgetTrechoVoo.parent.isVisible = true;
            if (!widgetTrechoVoo.dataSource.data) {
                widgetTrechoVoo.dataSource.data = [];
            }
            ScreenService.openSwipe(widgetTrechoVoo.parent).then(function() {
                widgetTrechoVoo.list();
                widgetTrechoVoo.activate();
            });
        }
    };

    function compareRows(newRow, backupRow) {
        let modify = false;
        let fieldsDate = ["DTINIVIGENCIA", "DTFIMVIGENCIA"];
        fieldsDate.forEach(function(name) {
            let momentRow = moment(newRow[name], 'DD/MM/YYYY');
            let momentBackupRow = moment(backupRow[name], 'DD/MM/YYYY');
            if (momentRow.unix() != momentBackupRow.unix())
                modify = true;
        });
        return modify;
    }

    this.cancelarWizard = function() {
        ScreenService.closeSwipe();
    };

    this.adicionarVigencia = function(widget, origin) {
        if (origin == 'simple') {
            if (widget.isValid()) {
                let widgetVigencia = widget.container.getWidget('widgetNovaVigencia');
                // widgetVigencia.parent.isVisible = true;
                if (!widgetVigencia.dataSource.data) {
                    widgetVigencia.dataSource.data = [];
                }
                ScreenService.openSwipe(widgetVigencia.getParent()).then(function() {
                    widgetVigencia.list();
                    widgetVigencia.activate();
                    widgetVigencia.fields.forEach(function(field) {
                        if (field.defaultValue) {
                            field.applyDefaultValue();
                        } else if (field.template.indexOf('datetime.html') !== -1) {
                            field.setValue("");
                        }
                    });
                });
            }
        } else {
            widget.newRow();
            widget.activate();
            widget.getField('DTINIVIGENCIA').readOnly = false;
            widget.container.getWidget('decolagemVigencia').isVisible = false;
            widget.fields.forEach(function(field) {
                if (field.defaultValue)
                    field.applyDefaultValue();
            });
            // _applyDefaultConfigVoo(widget);
        }
    };

    this.editaVigencia = function(widget) {
        InflightorGeneral.edit(widget);
        widget.getField('DTINIVIGENCIA').readOnly = true;
        widget.container.getWidget('decolagemVigencia').isVisible = false;
    };

    function _booValidaData(widget) {
        let booDate = true;
        if (widget.currentRow.DTFIMVIGENCIA && widget.currentRow.DTINIVIGENCIA)
            booDate = moment(widget.currentRow.DTINIVIGENCIA, 'DD/MM/YYYY').unix() > moment(widget.currentRow.DTFIMVIGENCIA, 'DD/MM/YYYY').unix() ? false : true;
        if (!widget.isValid()) {
            return false;
        } else if (!booDate) {
            MessageService.showMessageByCode("INVALID_EXPIRY_PERIOD");
            return false;
        } else {
            let invalidFields = widget.fieldGroups.filter(fg => fg.name === "HORARIOS")[0].rows[0].fields.filter(
                f => f.value() && !moment(f.value(), "HH:mm").isValid()
            );
            if (invalidFields.length) {
                MessageService.showMessageByCode("INVALID_TIME");
                return false;
            }
        }
        return true;
    }

    this.salvarNovaVigencia = function(widget) {
        if (_booValidaData(widget)) {
            let widgetTrecho = widget.container.getWidget('widgetTrecho');
            let widgetVoo = widget.container.getWidget('widgetVoo');
            let oldRow = angular.copy(widget.currentRow);
            Object.assign(widget.currentRow, widgetTrecho.currentRow, widgetVoo.currentRow, widget.paramsNewCode, oldRow);
            widget.fields.forEach(function(field) {
                if (field.template.indexOf('datetime.html') !== -1)
                    widget.currentRow[field.name] = widget.currentRow[field.name].replace(":", "");
            });

            widget.currentRow.CHANGEDATE = true;

            this.calculaHora(widget);
            let camposDeHora = ["HRETA", "HRETD", "HRKDT", "HRKRT"];
            for (let i = 0; i < camposDeHora.length; i++) {
                if (typeof widget.currentRow[camposDeHora[i]] !== 'undefined' && widget.currentRow[camposDeHora[i]] !== null && widget.currentRow[camposDeHora[i]] !== '') {
                    if (!validaHora(widget.currentRow[camposDeHora[i]])) {
                        return false;
                    }
                }
            }
            converteFieldTime(widget.currentRow, camposDeHora, 'hhmm');
            InflightorGeneral.callRestEngine("ate#/voo/novaVigencia", "DataSet", [widget.currentRow]).then(function(success) {
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.computeDescriptionOrder();
                    widget.view();
                }
                widget.container.getWidget('decolagemVigencia').isVisible = true;
                converteFieldTime(widget.currentRow, camposDeHora, 'hh:mm');
            }, InflightorGeneral.callbackError);
        }
    };

    let validaVooSave = function(widgetVoo) {
        if (!widgetVoo.isValid()) {
            return false;
        } else {
            converteFieldTime(widgetVoo.currentRow, ["QTHRKDTCAR", "QTHRKDTDES"], 'hhmm');
            widgetVoo.currentRow.IDCARREGO = 1;
            widgetVoo.currentRow.IDDESCAR = 1;
            widgetVoo.currentRow.IDTRANSLADO = 1;
            widgetVoo.currentRow.IDCARGA = 1;
            return true;
        }
    };

    this.excluirVoo = function(widgetVoo) {
        widgetVoo.currentRow.NRORG = getLocalVar('INFLIGHTOR_NRORGTRAB');
        let widgetTrecho = widgetVoo.container.getWidget('widgetTrecho');
        if (widgetTrecho.dataSource.data && widgetTrecho.dataSource.data.length > 0) {
            const flightExcerpt = widgetTrecho.dataSource.data.length;
            let msg = "Este voo possui " + widgetTrecho.dataSource.data.length + " trecho(s) que também será(ão) excluído(s). Confirma exclusão?";
            MessageService.confirmMessageByCode("DEL_FLIGHT_EXCERPT", {
                "0": flightExcerpt
            }).then(() => {
                InflightorGeneral.callRestEngine('ate#/voo/remove', "Row", widgetVoo.currentRow).then(function(sucesso) {
                    ScreenService.closeSwipe().then(function() {
                        widgetVoo.reload();
                        widgetVoo.activate();
                    });
                }, function(erro) {
                    if (erro.data && erro.data.error.indexOf('ORA-02292') !== -1) {
                        MessageService.showMessageByCode('EXCLUSION_NOT_ALLOWED_FLIGHT');
                    } else {
                        ScreenService.showMessage(erro.data.error);
                    }
                });
            });
        } else {
            InflightorGeneral.deleteCrud(widgetVoo).then(function(callback) {
                widgetVoo.reload();
            });
        }
    };

    this.salvarVooEdit = function(widgetVoo) {
        if (validaVooSave(widgetVoo)) {

            this.defineDataVigencia(widgetVoo);

            converteFieldTime(widgetVoo.currentRow, ["HRDECOLVOO", "HRPOUSOVOO"], 'hhmm');
            InflightorGeneral.widgetSave(widgetVoo).then(function() {
                widgetVoo.view();
                widgetVoo.container.getWidget('widgetTrecho').isVisible = true;
            });
        }
    };

    this.defineDataVigencia = function(widget) {

        let currentRow = widget.currentRow;

        let ID_TIPO_VOO_EXIGE_DATA_VIGENCIA = 2;
        let dataVigenciaSelecionada = currentRow.DTVIGVOO;

        if (currentRow.IDTIPVOO == ID_TIPO_VOO_EXIGE_DATA_VIGENCIA) {

            currentRow.DTINIVIGVOO = dataVigenciaSelecionada.start;
            currentRow.DTFIMVIGVOO = dataVigenciaSelecionada.end;

        } else {

            currentRow.DTINIVIGVOO = "";
            currentRow.DTFIMVIGVOO = "";

        }

    };

    this.editarVoo = function(widgetVoo) {
        this.alteraTipoVoo(widgetVoo, 'DTVIGVOO');
        alternaActionsVoo(widgetVoo, 'editarVoo');
        widgetVoo.container.getWidget('widgetTrecho').isVisible = false;

        widgetVoo.backupRow = angular.copy(widgetVoo.currentRow);

        this.defineFiltroPrefixoPeloEquipamentoSelecionado(widgetVoo);

        widgetVoo.container.getWidget('widgetTrecho').isVisible = false;
        widgetVoo.edit();
    };

    this.vooAfterLoadDataSource = function(widgetVoo) {
        let rowToSet = null;
        widgetVoo.dataSource.data.forEach(function(row) {
            converteFieldTime(row, ["QTHRKDTCAR", "QTHRKDTDES"], 'hh:mm');
            if (widgetVoo.rowToSet && row.NRVOO == widgetVoo.rowToSet.NRVOO) {
                rowToSet = row;
            }
        });
        widgetVoo.activate();
        if (rowToSet && typeof widgetVoo.afterMoveRow == 'function') {
            widgetVoo.currentRow = rowToSet;
            delete widgetVoo.rowToSet;
            widgetVoo.afterMoveRow();
        }
    };

    this.vooAfterMoveRow = function(widgetVoo) {
        if (!widgetVoo.currentRow.__is_new) {
            validaVooParaView(widgetVoo);
        }
    };

    let validaVooParaView = function(widgetVoo) {
        widgetVoo.view();

        if (widgetVoo.currentRow.DTINIVIGVOO && widgetVoo.currentRow.DTFIMVIGVOO) {
            widgetVoo.currentRow.DTVIGVOO = {
                start: widgetVoo.currentRow.DTINIVIGVOO.slice(0, 10),
                end: widgetVoo.currentRow.DTFIMVIGVOO.slice(0, 10)
            };
        }

        let widgetTrecho = widgetVoo.container.getWidget('widgetTrecho');
        let widgetVigencia = widgetVoo.container.getWidget('widgetVigencia');
        widgetTrecho.dataSourceFilter = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: widgetVoo.currentRow.CDFILIAL
            },
            {
                name: "CDCIA",
                operator: "=",
                value: widgetVoo.currentRow.CDCIA
            },
            {
                name: "NRVOO",
                operator: "=",
                value: widgetVoo.currentRow.NRVOO
            },
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('INFLIGHTOR_NRORGTRAB')
            }
        ];
        widgetTrecho.list();
        widgetTrecho.reload();
        widgetTrecho.isVisible = true;
        widgetVoo.activate();
        ScreenService.closeSwipe(1);
    };

    this.filtraFieldEquipamento = function(widgetVoo) {
        const fieldEquip = widgetVoo.getField('SGEQUIP');
        const filterRow = getMainWidget().appliedFilter.FILTER_ROW;
        if (widgetVoo.currentRow.CDCIA) {
            fieldEquip.readOnly = false;
            let filterUnit = fieldEquip.dataSourceFilter.find(filter => filter.name == 'CDFILIAL');
            let filterCia = fieldEquip.dataSourceFilter.find(filter => filter.name == 'CDCIA');
            filterUnit.value = filterRow.CDFILIAL;
            filterCia.value = filterRow.CDCIA;
        } else {
            fieldEquip.setValue('');
            fieldEquip.readOnly = true;
        }
    };

    this.filtraFieldPrefixo = function(widgetVoo) {

        let currentRow = widgetVoo.currentRow;

        if (currentRow.CDEQUIP) {

            this.defineFiltroPrefixoPeloEquipamentoSelecionado(widgetVoo);

            widgetVoo.getField('SGPREFIXO').setValue('');
        } else {
            widgetVoo.getField('SGPREFIXO').setValue('');
            widgetVoo.getField('SGPREFIXO').readOnly = true;
        }

    };

    this.defineFiltroPrefixoPeloEquipamentoSelecionado = function(widgetVoo) {

        let currentRow = widgetVoo.currentRow;

        widgetVoo.getField('SGPREFIXO').readOnly = false;
        widgetVoo.getField('SGPREFIXO').dataSourceFilter = [{
            name: "CDEQUIP",
            operator: "=",
            value: currentRow.CDEQUIP
        }, {
            name: "CDFILIAL",
            operator: "=",
            value: currentRow.CDFILIAL
        }, {
            name: "CDCIA",
            operator: "=",
            value: currentRow.CDCIA
        }, {
            name: "NRORG",
            operator: "=",
            value: getLocalVar('INFLIGHTOR_NRORGTRAB')
        }];

        widgetVoo.getField('SGPREFIXO').reload();

    };

    var alternaActionsVoo = function(widgetVoo, acao) {
        let widgetTrecho = widgetVoo.container.getWidget('widgetTrecho');
        switch (acao) {
            case 'criarVoo':
                widgetVoo.getAction('ADICIONAR_TRECHOS').isVisible = true;
                widgetVoo.getAction('SALVAR_EDIT').isVisible = false;
                break;
            case 'editarVoo':
                widgetVoo.getAction('SALVAR_EDIT').isVisible = true;
                widgetVoo.getAction('ADICIONAR_TRECHOS').isVisible = false;
                break;
            default:
                break;
        }
    };

    this.novoTrecho = function(widgetTrecho) {
        widgetTrecho.newRow();

        widgetTrecho.container.getWidget('widgetConfigNew').isVisible = false;
        widgetTrecho.container.getWidget('widgetConfig').isVisible = false;
        widgetTrecho.container.getWidget('widgetVigencia').isVisible = false;
        let widgetVoo = widgetTrecho.container.getWidget('widgetVoo');
        widgetTrecho.currentRow.CDFILIAL = widgetVoo.currentRow.CDFILIAL;
        widgetTrecho.currentRow.CDCIA = widgetVoo.currentRow.CDCIA;
        widgetTrecho.currentRow.NRVOO = widgetVoo.currentRow.NRVOO;
        widgetTrecho.currentRow.NRORG = widgetVoo.currentRow.NRORG;
        widgetTrecho.getAction('SALVAR_TRECHO').isVisible = false;
        widgetTrecho.getAction('ADICIONAR_VIGENCIA').isVisible = true;
        ScreenService.openSwipe(widgetTrecho);
    };

    this.editTrecho = function(widget) {
        widget.currentRow.__is_new = false;
        widget.container.getWidget('widgetConfig').isVisible = false;
        widget.container.getWidget('widgetVigencia').isVisible = false;
        widget.container.getWidget('widgetConfig').isVisible = false;
        widget.getAction('SALVAR_TRECHO').isVisible = true;
        widget.getAction('ADICIONAR_VIGENCIA').isVisible = false;
        widget.widgets[0].showAsTab = false;
        InflightorGeneral.edit(widget);
    };

    let afterNewVooTrechoVigencia = function(widgetVoo, origin) {
        let widgetTrecho = widgetVoo.container.getWidget('widgetTrecho');
        let widgetTrechoVoo = widgetVoo.container.getWidget('widgetTrechoVoo');
        let widgetVigencia = widgetVoo.container.getWidget('widgetVigencia');
        let backupRow = {
            "widgetVoo": angular.copy(widgetVoo.currentRow),
            "widgetTrecho": angular.copy(widgetTrecho.currentRow)
        };
        widgetTrecho.dataSourceFilter = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: backupRow.widgetVoo.CDFILIAL
            },
            {
                name: "CDCIA",
                operator: "=",
                value: backupRow.widgetVoo.CDCIA
            },
            {
                name: "NRVOO",
                operator: "=",
                value: backupRow.widgetVoo.NRVOO
            },
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('INFLIGHTOR_NRORGTRAB')
            }
        ];
        widgetVigencia.dataSourceFilter = angular.copy(widgetTrecho.dataSourceFilter);
        if (origin == "voo") {
            widgetVoo.activate();
            widgetVoo.view();
            ScreenService.closeSwipe(0).then(function() {
                widgetVoo.reload().then(function() {
                    widgetVoo.currentRow = widgetVoo.dataSource.data.filter(function(row) {
                        return row.NRVOO == widgetTrechoVoo.currentRow.NRVOO;
                    })[0];
                    widgetTrecho.isVisible = true;
                    widgetVoo.currentWidget = widgetTrecho;
                    widgetVoo.view();
                    ScreenService.openSwipe(widgetVoo); //.then(function(){
                    //     widgetTrecho.reload().then(function(){
                    //         widgetTrecho.currentRow = widgetTrecho.dataSource.data.filter(function(row){
                    //             return row.CDTRECHO == widgetTrechoVoo.currentRow.CDTRECHO 
                    //             && row.NRVOO == widgetTrechoVoo.currentRow.NRVOO;
                    //         })[0];
                    //         widgetTrecho.list();
                    //         widgetTrecho.activate();
                    //         widgetTrecho.isVisible = true;
                    //         widgetVigencia.isVisible = true;
                    //         widgetVigencia.showAsTab = true;
                    //         widgetTrecho.container.getWidget('widgetConfig').showAsTab = true;
                    //         widgetTrecho.container.getWidget('widgetConfig').isVisible = true;
                    //         widgetTrecho.currentWidget = widgetVigencia;
                    //         ScreenService.openSwipe(widgetTrecho).then(function(){
                    //             widgetTrecho.view();
                    //             widgetVigencia.list();
                    //             widgetVigencia.dataSourceFilter.push({
                    //                     name: "CDTRECHO",
                    //                     operator: "=",
                    //                     value: widgetTrechoVoo.currentRow.CDTRECHO
                    //             });
                    //             widgetVigencia.reload().then(function(){
                    //                 widgetTrecho.reload();
                    //                 widgetVigencia.activate();
                    //             });
                    //         });
                    //     });
                    // });
                });
            });
            // widgetTrechoVoo.parent.isVisible = false;
        } else if (origin == "trecho") {
            ScreenService.closeSwipe().then(function() {
                widgetTrecho.view();
                widgetVigencia.isVisible = true;
                widgetTrecho.container.getWidget('widgetConfig').isVisible = true;
                widgetTrecho.currentWidget = widgetVigencia;
                ScreenService.closeSwipe().then(function() {
                    widgetVigencia.reload().then(function() {
                        widgetTrecho.reload();
                        widgetVigencia.list();
                        widgetVigencia.activate();
                    });
                });
            });
        }
    };

    this.salvarTrecho = function(widgetTrecho) {
        if (widgetTrecho.isValid()) {
            widgetTrecho.paramsNewCode.__new_code_pk = 'VOOTRECHO' + widgetTrecho.currentRow.CDCIA + widgetTrecho.currentRow.NRVOO;
            converteFieldTime(widgetTrecho.currentRow, ["HRDECOLVOO", "HRPOUSOVOO"], 'hhmm');
            InflightorGeneral.saveCrud(widgetTrecho).then(function() {
                ScreenService.closeSwipe().then(function() {
                    widgetTrecho.list();
                    widgetTrecho.activate();
                    widgetTrecho.reload();
                    widgetTrecho.widgets[0].isVisible = true;
                    widgetTrecho.widgets[1].isVisible = true;
                    widgetTrecho.widgets[0].showAsTab = true;
                    widgetTrecho.widgets[1].showAsTab = true;
                });
            });
        }
    };

    function _createDataToSave(widget, widgetVoo, widgetTrechoVoo, widgetTrecho, origin) {
        converteFieldTime(widget.currentRow, ["HRETA", "HRETD", "HRKDT", "HRKRT"], 'hhmm');
        widgetTrechoVoo.paramsNewCode.__new_code_pk = 'VOOTRECHO' + widgetTrechoVoo.dataSource.data[0].CDCIA + widgetTrechoVoo.dataSource.data[0].NRVOO;
        let oldRow = widget.currentRow;
        let oldRowVooTrecho = widgetTrechoVoo.currentRow;
        Object.assign(widget.currentRow, widget.paramsNewCode, widgetVoo.currentRow, oldRow);
        Object.assign(widgetTrechoVoo.currentRow, widgetTrechoVoo.paramsNewCode, oldRowVooTrecho);
        let dataSetVooTrechos = [];
        widgetTrechoVoo.currentRow.HRPOUSOVOO = widget.currentRow.HRETA;
        widgetTrechoVoo.currentRow.HRDECOLVOO = widget.currentRow.HRETD;
        widgetTrechoVoo.currentRow.__columns_to_return = widgetTrechoVoo.__columns_to_return;
        widgetTrechoVoo.currentRow.__is_new = true;
        widget.currentRow.__is_new = true;
        dataSetVooTrechos.push(widget.currentRow);
        dataSetVooTrechos.push(widgetTrechoVoo.currentRow);
        if (origin == "voo") {
            widgetVoo.currentRow.HRDECOLVOO = widget.currentRow.HRETD;
            widgetVoo.currentRow.HRPOUSOVOO = widget.currentRow.HRETA;
            arrayFrequencia.forEach(function(id) {
                widgetVoo.currentRow[id] = widget.currentRow[id] == 'S' ? "1" : "2";
            });
            dataSetVooTrechos.push(widgetVoo.currentRow);
        } else {
            dataSetVooTrechos.push([]);
        }
        return dataSetVooTrechos;
    }

    this.salvarVooVigencia = function(widget) {
        if (!_booValidaData(widget))
            return;
        let origin = "voo";
        let widgetVoo = widget.container.getWidget('widgetVoo');
        let widgetTrechoVoo = widget.container.getWidget('widgetTrechoVoo');
        let widgetTrecho = widget.container.getWidget('widgetTrecho');
        if (!Object.keys(widgetTrechoVoo.currentRow).length) {
            widgetTrechoVoo = widgetTrecho;
            origin = "trecho";
        }
        let dataSetVooTrechos = _createDataToSave(widget, widgetVoo, widgetTrechoVoo, widgetTrecho, origin);
        InflightorGeneral.callRestEngine("ate#/voo/newvoo", "DataSet", dataSetVooTrechos).then(function(success) {
            if (success.dataset && success.dataset.novoVoo) {
                widgetTrechoVoo.currentRow.NRVOO = success.dataset.novoVoo[0].NRVOO;
                widgetTrechoVoo.currentRow.CDTRECHO = success.dataset.novoVoo[0].CDTRECHO;
            }
            afterNewVooTrechoVigencia(widgetVoo, origin);
        }, function(error) {
            let errorMessage = 'Timeout';
            if (error.data) {
                errorMessage = error.data.error;
            }
            ScreenService.showMessage(errorMessage);
        });
    };

    this.salvarTrechoVoo = function(widgetTrechoVoo) {
        if (widgetTrechoVoo.isValid()) {
            widgetTrechoVoo.currentRow.changed = true;
            widgetTrechoVoo.currentRow.__is_new = true;
            widgetTrechoVoo.currentRow.trechoPreCadastrado = true;
            widgetTrechoVoo.getAction('SALVAR_VOO').isVisible = true;
            ScreenService.closeSwipe().then(function() {
                widgetTrechoVoo.list();
                widgetTrechoVoo.activate();
            });
        }
    };

    this.voltarVoo = function(widgetTrechoVoo) {
        let widgetVoo = widgetTrechoVoo.container.getWidget('widgetVoo');
        converteFieldTime(widgetVoo.currentRow, ["QTHRKDTCAR", "QTHRKDTDES"], 'hh:mm');
        widgetTrechoVoo.parent.isVisible = false;
        ScreenService.closeSwipe().then(function() {
            widgetVoo.activate();
        });
    };

    this.alteraTipoVoo = function(widgetVoo, fieldName = null) {
        if (widgetVoo.currentRow.IDTIPVOO == "2") {
            widgetVoo.getField('DTVIGVOO').isVisible = true;
            widgetVoo.getField('DTVIGVOO').validations = {
                "requiredIntervalEnd": true,
                "required": true
            };
            if (fieldName) {
                const row = widgetVoo.currentRow;
                const DTINI = row.DTINIVIGVOO.split(' ')[0];
                const DTFIN = row.DTFIMVIGVOO.split(' ')[0];
                widgetVoo.currentRow[fieldName] = {
                    start: DTINI,
                    end: DTFIN,
                    formattedStart: DTINI,
                    formattedEnd: DTFIN
                };
            }
        } else {
            widgetVoo.getField('DTVIGVOO').setValue("");
            widgetVoo.getField('DTVIGVOO').isVisible = false;
            widgetVoo.getField('DTVIGVOO').validations = {};
        }
    };

    this.excluirTrecho = function(widgetTrecho) {
        if (widgetTrecho.dataSource.data && widgetTrecho.dataSource.data.length > 1) {
            InflightorGeneral.deleteCrud(widgetTrecho);
        } else {
            MessageService.showMessageByCode("EXCLUSION_NOT_ALLOWED_FLIGHT_ONLY_THROUGH");
        }
    };

    this.excluirTrechoVoo = function(widgetTrechoVoo) {
        MessageService.confirmMessageByCode('REMOVE_EXCERPT').then(function(success) {
            let indice = -1;
            for (let i in widgetTrechoVoo.dataSource.data) {
                if (widgetTrechoVoo.dataSource.data[i] == widgetTrechoVoo.currentRow) {
                    indice = i;
                }
            }
            if (indice >= 0) {
                widgetTrechoVoo.dataSource.data.splice(indice, 1);
            }
            if (!widgetTrechoVoo.dataSource.data.length) {
                widgetTrechoVoo.getAction('SALVAR_VOO').isVisible = false;
            }
            ScreenService.closeSwipe();
            widgetTrechoVoo.list();
            widgetTrechoVoo.activate();
        });
    };

    this.validaBase = function(fieldBase) {
        if (fieldBase.widget.currentRow.CDBASEORI == fieldBase.widget.currentRow.CDBASEDES) {
            MessageService.showMessageByCode("BASE_DESTINATION_EQUAL_ORIGIN");
            fieldBase.setValue("");
        }
    };

    this.trechoOnEnter = function(widgetTrecho) {
        if (!(widgetTrecho.currentRow && widgetTrecho.currentRow.__is_new)) {
            widgetTrecho.container.getWidget('widgetConfig').isVisible = true;
            widgetTrecho.container.getWidget('widgetVigencia').isVisible = true;
            widgetTrecho.reload().then(function() {
                widgetTrecho.dataSource.data.forEach(function(row) {
                    converteFieldTime(row, ["HRDECOLVOO", "HRPOUSOVOO"], 'hh:mm');
                });
            });
        }
    };

    this.filtraEquipamento = function(widget, field) {
        field.dataSourceFilter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.CDFILIAL
            },
            {
                "name": "CDCIA",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.CDCIA
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.NRORG
            }
        ];
        field.reload();
    };

    this.loadDataSourceOnEnter = function(widget) {
        if (widget.name == "widgetVigencia") {
            self.importVisibility(widget);
        }
        if (widget.mode !== 'edit') {
            widget.dataSourceFilter = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.CDFILIAL
            }, {
                "name": "CDCIA",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.CDCIA
            }, {
                "name": "CDTRECHO",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.CDTRECHO
            }, {
                "name": "NRVOO",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.NRVOO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": widget.container.getWidget('widgetTrecho').currentRow.NRORG
            }];
            widget.reload();
        }
    };

    this.adicionaClasse = function(widget) {
        let widgetConfigNew = widget.container.getWidget('widgetConfigNew');
        widgetConfigNew.dataSource.data = [];
        widgetConfigNew.newRow();
        const row = templateManager.container.getWidget('widgetTrecho').currentRow;
        this.setFilterFieldClass(widgetConfigNew.getField('SGCLASSE'), row);
        ScreenService.openSwipe(widgetConfigNew);
        widgetConfigNew.activate();
    };

    this.saveClasseEdit = function(widget) {
        if (widget.name == "widgetConfig") {
            if (widget.currentRow.NRMULSERV < 0.0000001 || widget.currentRow.NRMULSERV_inline < 0.0000001) {
                MessageService.showMessageByCode("MIN_VALUE_MULTIPLIER");
                return;
            }
        }
        InflightorGeneral.saveCrud(widget).then(function() {
            widget.list();
            widget.activate();
            widget.reload();
        }).catch((error) => {
            let errorMessage = 'Timeout';
            if (error.data) {
                errorMessage = error.data.error;
            }
            ScreenService.showMessage(errorMessage);
        });
    };

    this.salvaDecolagem = function(widget) {
        let arrayToSave = [];
        let dias = [];
        dias = angular.copy(widget.currentRow.DTDIA);

        dias.forEach(function(dia) {
            let rowDecolagem = {};
            dia = dia.split(' ');
            dia = dia[0];

            rowDecolagem.DTDIA = dia;
            rowDecolagem.CDFILIAL = widget.container.getWidget('widgetVigencia').currentRow.CDFILIAL;
            rowDecolagem.CDCIA = widget.container.getWidget('widgetVigencia').currentRow.CDCIA;
            rowDecolagem.NRVOO = widget.container.getWidget('widgetVigencia').currentRow.NRVOO;
            rowDecolagem.CDTRECHO = widget.container.getWidget('widgetVigencia').currentRow.CDTRECHO;
            rowDecolagem.NRSEQVOOTRECHODATA = widget.container.getWidget('widgetVigencia').currentRow.NRSEQVOOTRECHODATA;
            rowDecolagem.__is_new = true;
            arrayToSave.push(rowDecolagem);
        });

        InflightorGeneral.callRestEngine('ate#/crud/vootrechodatadia/save', 'DataSet', arrayToSave).then(function(success) {
            // ScreenService.closeSwipe();
            widget.list();
            widget.activate();
            widget.reload();
        }).catch((error) => {
            let errorMessage = 'Timeout';
            if (error.data) {
                errorMessage = error.data.error;
            }
            ScreenService.showMessage(errorMessage);
        });
    };

    this.adicionaDecolagem = function(widget) {
        let fimVigencia = widget.container.getWidget('widgetVigencia').currentRow.DTFIMVIGENCIA;

        if (fimVigencia) {
            widget.newRow();
            widget.activate();
        } else {
            MessageService.showMessageByCode('EXPIRY_DATE_NOT_INFORMED');
        }
    };

    this.cancelDateSelection = function(widget) {
        widget.list();
        widget.reload();
    };

    this.insereDiasVigencia = function(field) {
        let dataSet = angular.copy(field.widget.dataSource.data);
        let notInDias = [];
        let filtro = [];
        let dia;

        dataSet.filter(function(row) {
            return !row.__is_new;
        }).forEach(function(row) {
            dia = row.DTDIA.split(' ');
            dia = dia[0];
            notInDias.push(dia);
        });

        let dataInicial = field.widget.container.getWidget('widgetVigencia').currentRow.DTINIVIGENCIA;
        dataInicial = dataInicial.split(' ');
        dataInicial = dataInicial[0];

        let dataFinal = field.widget.container.getWidget('widgetVigencia').currentRow.DTFIMVIGENCIA;
        dataFinal = dataFinal.split(' ');
        dataFinal = dataFinal[0];
        filtro = [
            {
                "name": "DTINICIAL",
                "operator": "=",
                "value": dataInicial
            },
            {
                "name": "DTFINAL",
                "operator": "=",
                "value": dataFinal
            }
        ];

        if (notInDias.length) {
            filtro.push({
                "name": "DTDIA",
                "operator": "NOT_IN",
                "value": notInDias
            });
        }

        field.dataSourceFilter = filtro;
        field.reload().then((response) => {
            console.log(field);
        });
    };

    this.changeDateTimeFormat = function(widget) {
        const {
            currentRow
        } = widget;
        // currentRow.DTDIA = currentRow.DTDIA.map((day) => {
        //     let dayToFormat = day.split(' ');
        //     return dayToFormat[0];
        // });
        console.log(widget);

    };

    this.importVisibility = function(widget) {
        let rowsMarcadas = widget.getCheckedRows();

        if (rowsMarcadas.length) {
            widget.getAction('importar').isVisible = false;
            widget.getAction('exportar').isVisible = true;
        } else if (!rowsMarcadas.length) {
            widget.getAction('importar').isVisible = true;
            widget.getAction('exportar').isVisible = false;
        }
    };

    this.filtraVoosDecolagem = function(widget) {
        if (!widget.currentRow.__is_new) {
            widget.container.getWidget('decolagemVigencia').unSelectAll();
            widget.container.getWidget('decolagemVigencia').dataSource.data = null;
            widget.container.getWidget('decolagemVigencia').dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetVigencia').currentRow.CDFILIAL
                },
                {
                    "name": "CDCIA",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetVigencia').currentRow.CDCIA
                },
                {
                    "name": "NRVOO",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetVigencia').currentRow.NRVOO
                },
                {
                    "name": "CDTRECHO",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetVigencia').currentRow.CDTRECHO
                },
                {
                    "name": "NRSEQVOOTRECHODATA",
                    "operator": "=",
                    "value": widget.container.getWidget('widgetVigencia').currentRow.NRSEQVOOTRECHODATA
                }
            ];
            widget.container.getWidget('decolagemVigencia').reload();
        }
    };

    this.beforeOpenClass = function(field) {
        let filter = [];
        filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": field.widget.container.getWidget('widgetTrecho').currentRow.CDFILIAL
        }, {
            "name": "CDCIA",
            "operator": "=",
            "value": field.widget.container.getWidget('widgetTrecho').currentRow.CDCIA
        }];
        field.dataSourceFilter = filter;
        field.reload();
    };

    this.setFilterFieldClass = function(field, row) {
        field.dataSourceFilter.forEach(filter => {
            if (row.hasOwnProperty(filter.name)) {
                filter.value = row[filter.name];
            }
        });
    };

    this.deletaVigenciaDecolagens = function(widget) {
        let paramsToRemove = {};

        paramsToRemove.CDFILIAL = widget.currentRow.CDFILIAL;
        paramsToRemove.CDCIA = widget.currentRow.CDCIA;
        paramsToRemove.NRVOO = widget.currentRow.NRVOO;
        paramsToRemove.CDTRECHO = widget.currentRow.CDTRECHO;
        paramsToRemove.NRSEQVOOTRECHODATA = widget.currentRow.NRSEQVOOTRECHODATA;
        paramsToRemove.NRORG = widget.currentRow.NRORG;

        MessageService.confirmMessageByCode('ALE_CONFIRM_REMOVE_REGISTER').then(function(success) {
            InflightorGeneral.callRestEngine('ate#/decolagens/remove', 'Row', paramsToRemove).then(function(callback) {
                widget.removeRow().then(function() {
                    ScreenService.closeSwipe().then(function() {
                        widget.container.getWidget('widgetVigencia').activate();
                        widget.container.getWidget('widgetVigencia').reload();
                    });
                }, function(error) {
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        MessageService.showMessageByCode('GENERIC_ERROR_ITEM_REMOVE');
                    } else {
                        ScreenService.showMessage(error.data.error);
                    }
                });
            });
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.validaClasse = function(widget) {
        let filter = angular.copy(widget.container.getWidget('widgetConfig').dataSourceFilter);
        if (widget.isValid() && widget.currentRow.SGCLASSE != "" && widget.currentRow.NRMULSERV != null && widget.currentRow.NRMULSERV >= 0.0000001) {
            filter.push({
                "name": "CDCLASSE",
                "operator": "=",
                "value": widget.currentRow.CDCLASSE
            });
            filter.push({
                "name": "IDATIVO",
                "operator": "=",
                "value": widget.currentRow.IDATIVO
            });
            InflightorGeneral.callRestEngine('ate#/crud/classevoo_classe', 'FilterData', filter).then(
                function(success) {
                    if (success.dataset.classevoo_classe.length === 0) {
                        let rowToSave = widget.container.getWidget('widgetConfig').dataSourceFilter;
                        rowToSave.forEach(function(obj) {
                            widget.currentRow[obj.name] = obj.name === 'IDATIVO' ? 'S' : obj.value;
                            widget.currentRow[obj.name] = obj.name === 'IDATIVO' ? 'S' : obj.value;
                        });
                        InflightorGeneral.widgetSave(widget).then(function() {
                            let widgetTop = widget.container.getWidget('widgetConfig');
                            widgetTop.dataSourceFilter = [{
                                "name": "CDFILIAL",
                                "operator": "=",
                                "value": widget.currentRow.CDFILIAL
                            }, {
                                "name": "CDCIA",
                                "operator": "=",
                                "value": widget.currentRow.CDCIA
                            }, {
                                "name": "CDTRECHO",
                                "operator": "=",
                                "value": widget.currentRow.CDTRECHO
                            }, {
                                "name": "NRVOO",
                                "operator": "=",
                                "value": widget.currentRow.NRVOO
                            }, {
                                "name": "NRORG",
                                "operator": "=",
                                "value": widget.currentRow.NRORG
                            }];
                            widgetTop.activate();
                            widgetTop.reload();
                        });
                    } else {
                        ScreenService.showMessage('Não foi possível cadastrar ' + success.dataset.classevoo_classe[0].SGCLASSE + '. Essa classe já foi cadastrada!');
                    }
                },
                function(err) {
                    ScreenService.showMessage(err.data.error);
                });
        } else if (widget.currentRow.NRMULSERV < 0.0000001) {
            MessageService.showMessageByCode("MIN_VALUE_MULTIPLIER");
            // widget.reload();
        } else {
            MessageService.showMessageByCode('ENTER_DATA_CORRECTLY');
        }
    };

    this.editaClasse = function(widget) {
        widget.getField('SGCLASSE').readOnly = true;
        InflightorGeneral.modEdit(widget);
    };

    this.applyInactiveStyle = function(field) {
        field.selectWidget.styles = [
            {
                "condition": "row.IDATIVO == 'N'",
                "cssClass": "coc-inactive"
	        }
	    ];
        field.selectWidget.events[0].code = 'VooTrechoController.inactiveBranchWarning(args);';
    };

    this.inactiveBranchWarning = function(args) {
        if (args.owner.currentRow.IDATIVO === 'N') {
            MessageService.showMessageByCode('MSG_ATE_CIA_INATIVA');
            args.owner.setSelected(args);
        } else {
            args.owner.setSelected(args);
        }
    };

    this.enableDisableVoo = function(widget) {
        let fieldVoo = widget.getField('NRVOO');
        if (widget.currentRow.NMCIA) {
            cdfilial = widget.currentRow.CDFILIAL;
            cdcia = widget.currentRow.CDCIA;
            fieldVoo.readOnly = false;
            fieldVoo.dataSourceFilter = [
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: cdfilial
                },
                {
                    name: "CDCIA",
                    operator: "=",
                    value: cdcia
                },
                {
                    name: "NRORG",
                    operator: "=",
                    value: getLocalVar('INFLIGHTOR_NRORGTRAB')
                }
            ];
            fieldVoo.setValue('');
        } else {
            fieldVoo.setValue('');
            fieldVoo.readOnly = true;
        }
    };

    this.enableDisableEquip = function(widget) {
        let fieldEquip = widget.getField('SGEQUIP');
        if (widget.currentRow.NMCIA) {
            cdfilial = widget.currentRow.CDFILIAL;
            cdcia = widget.currentRow.CDCIA;
            fieldEquip.readOnly = false;
            fieldEquip.dataSourceFilter = [
                {
                    name: "CDFILIAL",
                    operator: "=",
                    value: cdfilial
                },
                {
                    name: "CDCIA",
                    operator: "=",
                    value: cdcia
                },
                {
                    name: "NRORG",
                    operator: "=",
                    value: getLocalVar('INFLIGHTOR_NRORGTRAB')
                }
            ];
            fieldEquip.setValue('');
        } else {
            fieldEquip.setValue('');
            fieldEquip.readOnly = true;
        }
        widget.getField('SGPREFIXO').setValue('');
        widget.getField('SGPREFIXO').readOnly = true;
    };

    this.getCurrentField = function(fieldName, widgetName) {
        return InflightorGeneral.getFieldValue(fieldName, widgetName);
    };

    this.filtraVoo = function(widget) {
        let widgetTrecho = widget.container.getWidget('widgetTrecho').currentRow;
        let filtro = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: widgetTrecho.CDFILIAL
            },
            {
                name: "CDCIA",
                operator: "=",
                value: widgetTrecho.CDCIA
            },
            {
                name: "CHAVE",
                operator: "NOT IN",
                value: [widgetTrecho.NRVOO + '-' + widgetTrecho.CDTRECHO]
            }
        ];
        widget.getField('NRVOO').dataSourceFilter = filtro;
        widget.getField('NRVOO').reload();
    };

    this.filtraFieldVooExportVig = function(field) {
        const widget = field.widget;
        const row = widget.container.getWidget('widgetTrecho').currentRow;
        const filtro = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: row.CDFILIAL
            },
            {
                name: "CDCIA",
                operator: "=",
                value: row.CDCIA
            },
            {
                name: "CHAVE",
                operator: "NOT IN",
                value: [row.NRVOO + '-' + row.CDTRECHO]
            }
        ];
        field.dataSourceFilter = filtro;
        field.reload();
    };

    this.cancelaImportaExporta = function(widget) {
        ScreenService.closePopup();
        widget.container.getWidget('widgetVigencia').activate();
    };

    this.callProcedureImporta = function(widget) {
        if ((widget.getField('NRVOO').value() === '' || widget.getField('NRVOO').value() === undefined)) {
            MessageService.showMessageByCode('CAMPOSOBRIGATORIOS');
        } else {
            widget.currentRow.CDFILIAL = widget.container.getWidget('widgetTrecho').currentRow.CDFILIAL;
            widget.currentRow.CDCIA = widget.container.getWidget('widgetTrecho').currentRow.CDCIA;
            widget.currentRow.NRVOOORI = widget.currentRow.NRVOO;
            widget.currentRow.CDTRECHOORI = widget.currentRow.CDTRECHO;
            widget.currentRow.ORIGEM = 'I';
            widget.currentRow.NRSEQVOOTRECHODATA = widget.currentRow.NRSEQVOOTRECHODATA;
            widget.currentRow.VOOSDEST = widget.container.getWidget('widgetTrecho').currentRow.NRVOO + '|' + widget.container.getWidget('widgetTrecho').currentRow.CDTRECHO;
            MessageService.confirmMessageByCode("OVERLAPPED_DESTINY_REVENGE").then(function(success) {
                InflightorGeneral.callRestEngine('ate#/callProcedureImportaExporta', "Row", widget.currentRow).then(function(sucesso) {
                    if (sucesso.dataset && sucesso.dataset.ListaErros && sucesso.dataset.ListaErros.length) {
                        InflightorGeneral.showErrorMessages(widget, sucesso.dataset.ListaErros);
                    } else {
                        widget.getField('NRVOO').value('');
                        ScreenService.closePopup();
                        widget.container.getWidget('widgetVigencia').activate();
                        widget.container.getWidget('widgetVigencia').reload();
                    }
                }, function(erro) {
                    ScreenService.showMessage(erro.data.error);
                });
            });
        }
    };

    let listaVigencia = function(field) {

        let lista = '';
        let rows = field.widget.container.getWidget('widgetVigencia').getCheckedRows();

        for (let i = 0; i < rows.length; i++) {
            if (lista == '') {
                lista = rows[i].NRSEQVOOTRECHODATA;
            } else {
                lista = lista + '_' + rows[i].NRSEQVOOTRECHODATA;
            }
        }
        return lista;
    };

    this.callProcedureExporta = function(widget) {
        if ((widget.getField('NRVOO').value().length === 0 || widget.getField('NRVOO').value() === undefined)) {
            MessageService.showMessageByCode('CAMPOSOBRIGATORIOS');
        } else {
            MessageService.confirmMessageByCode("OVERLAPPED_DESTINY_REVENGE").then(function(success) {
                let voo = widget.getField('NRVOO');
                let sequencial = listaVigencia(voo);
                let widgetTrecho = widget.container.getWidget('widgetTrecho').currentRow;
                let widgetVigencia = widget.container.getWidget('widgetVigencia').currentRow;
                let nrvoo = [];

                widget.currentRow.CDFILIAL = widgetTrecho.CDFILIAL;
                widget.currentRow.CDCIA = widgetTrecho.CDCIA;
                widget.currentRow.NRVOOORI = widgetTrecho.NRVOO;
                widget.currentRow.CDTRECHO = widgetTrecho.CDTRECHO;
                widget.currentRow.NRVOOBKP = widget.currentRow.NRVOO;
                widget.currentRow.ORIGEM = 'E';
                widget.currentRow.NRSEQVOOTRECHODATA = sequencial;
                widget.currentRow.NRVOO.forEach(function(row) {
                    nrvoo.push(row.NRVOO + '|' + row.CDTRECHO);
                });
                widget.currentRow.NRVOO = nrvoo;

                InflightorGeneral.callRestEngine('ate#/callProcedureImportaExporta', "Row", widget.currentRow).then(function(sucesso) {
                    if (sucesso.dataset && sucesso.dataset.ListaErros && sucesso.dataset.ListaErros.length) {
                        widget.currentRow.NRVOO = widget.currentRow.NRVOOBKP;
                        InflightorGeneral.showErrorMessages(widget, sucesso.dataset.ListaErros);
                    } else {
                        widget.getField('NRVOO').value('');
                        widget.getField('DTINIVIGENCIA').value('');
                        widget.getField('DTFIMVIGENCIA').value('');
                        ScreenService.closePopup();
                        widget.container.getWidget('widgetVigencia').activate();
                        widget.container.getWidget('widgetVigencia').reload();
                        MessageService.showMessageByCode('EXPORT_SENT_SUCCESSFULLY');
                        ScreenService.closePopup();
                    }
                }, function(erro) {
                    ScreenService.showMessage(erro.data.error);
                });
            });
        }
    };

    this.validaData = function(widget) {
        widget.getField('DTFIMVIGENCIA').value('');
    };

    this.calculaHora = function(widget) {
        let widgetTrechoVoo = widget.container.getWidget('widgetTrecho').currentRow;
        let etdField = widget.currentRow.HRETD;
        let kdtField = widget.currentRow.HRKDT;
        let krtField = widget.currentRow.HRKRT;
        if (typeof etdField !== 'undefined' && etdField !== '') {
            if (validaHora(etdField)) {
                let difkdt = (widgetTrechoVoo.IDNACIVOOTRE == 1) ? 1.5 : 2.5;
                let difkrt = (widgetTrechoVoo.IDNACIVOOTRE == 1) ? 5.5 : 6.5;

                etdField = moment(etdField, 'HH:mm');
                let etcFieldToKDT = angular.copy(etdField); // fix para evitar que a subtração aconteça no mesmo elemento
                let etcFieldToKRT = angular.copy(etdField); // fix para evitar que a subtração aconteça no mesmo elemento
                let kdtTime = etcFieldToKDT.subtract(difkdt, 'hour');
                let krtTime = etcFieldToKRT.subtract(difkrt, 'hour');
                widget.currentRow.HRKDT = moment(kdtTime).format('HH:mm');
                widget.currentRow.HRKRT = moment(krtTime).format('HH:mm');
            }
        }
    };

    let validaHora = function(value) {
        let hora = parseInt(value.slice(0, 2));
        let minutos = parseInt(value.slice(3, 5));
        if (hora < 24 && minutos < 60) {
            return true;
        } else {
            MessageService.showMessageByCode('ATE01500_HORARIO_INVALIDO');
            return false;
        }
    };

    this.applyInactiveStyleEquip = function(field) {
        field.selectWidget.styles = [
            {
                "condition": "row.IDATIVO == 'N'",
                "cssClass": "coc-inactive"
	        }
	    ];
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('VooTrechoController', VooTrechoController);
});

// FILE: ./assets/js/utilities/ATEUtil.js
const ATEUtil = function(templateManager, MessageService, ZHPromise, InflightorGeneral, ScreenService) {

    this.deleteCrud = function(widget) {
        var deferred = ZHPromise.defer();
        MessageService.confirmMessageByCode("DEL_REGISTER").then(function(success) {
            widget.removeRow().then(function() {
                ScreenService.closeSwipe().then(function() {
                    widget.activate();
                    deferred.resolve();
                });
            }, function(error) {
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    MessageService.showMessageByCode("REGISTRO_POSSUI_FILHOS");
                } else {
                    ScreenService.showMessage(error.data.error);
                }
                deferred.reject();
            });
        });
        return deferred.promise;
    };

    this.deleteCrudCheckedRows = function(widget) {
        var deferred = ZHPromise.defer();
        MessageService.confirmMessageByCode("DEL_REGISTERS").then(function(success) {
            widget.removeCheckedRows().then(function() {
                widget.reload();
                widget.unSelectAll();
                deferred.resolve();
            }, function(error) {
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    MessageService.showMessageByCode("#REGISTRO_POSSUI_FILHOS");
                } else {
                    ScreenService.showMessage(error.data.error);
                }
                deferred.reject();
            });
        });
        return deferred.promise;
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register("ATEUtil", ATEUtil);
});
